<?php
// +----------------------------------------------------------------------
// +----------------------------------------------------------------------
// | Author: star xiong <875376798@qq.com>
// | QQ: 875376798
// +----------------------------------------------------------------------

namespace app\common\controller;

use think\App;
use think\Controller;

class HpjPay extends Controller
{

    public $hpjConfig;
    public function __construct($hpjConfig)
    {
        $this->hpjConfig = $hpjConfig;
    }

    public function notifyCheck($data){
        file_put_contents(realpath(dirname(__FILE__)) . "/log.txt",json_encode($data)."\r\n",FILE_APPEND);
        foreach ($data as $k=>$v){
            $data[$k] = stripslashes($v);
        }
        if(!isset($data['hash'])||!isset($data['trade_order_id'])){
            return false;
        }

        if($data['plugins']=='WeChat'){
            $appid              = $this->hpjConfig['hpj_wx_appid'];
            $appsecret          = $this->hpjConfig['hpj_wx_appsecret'];
        }else{
            $appid              = $this->hpjConfig['hpj_alipay_appid'];
            $appsecret          = $this->hpjConfig['hpj_alipay_appsecret'];
        }
//APP SECRET
        $appkey =$appsecret;
        $hash =$this->generate_xh_hash($data,$appkey);
        if($data['hash']!=$hash){
            //签名验证失败
            return false;
        }
        return true;
    }
    public function pay($param,$trade_order_id){
        $http_type = ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') || (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https')) ? 'https://' : 'http://';
        $recent_url=dirname($http_type.$_SERVER['HTTP_HOST'].$_SERVER["REQUEST_URI"]);
//        $param=$_POST;
        if($param){
            $title = '微信';
            if($param['type']=='WeChat'){
                $appid              = $this->hpjConfig['hpj_wx_appid'];
                $appsecret          = $this->hpjConfig['hpj_wx_appsecret'];
                $title = '微信';
            }else{
                $appid              = $this->hpjConfig['hpj_alipay_appid'];
                $appsecret          = $this->hpjConfig['hpj_alipay_appsecret'];
                $title = '支付宝';
            }
            $data=array(
                'version'   => '1.1',//固定值，api 版本，目前暂时是1.1
                'appid'     => $appid, //必须的，APPID
                'plugins'	=> $param['type'],
                'trade_order_id'=> $trade_order_id, //必须的，网站订单ID，唯一的，匹配[a-zA-Z\d\-_]+
                'total_fee' => $param['price'],//人民币，单位精确到分(测试账户只支持0.1元内付款)
                'title'     => '会员充值', //必须的，订单标题，长度32或以内
                'time'      => time(),//必须的，当前时间戳，根据此字段判断订单请求是否已超时，防止第三方攻击服务器
                'notify_url'=> $recent_url.'/notify_url', //必须的，支付成功异步回调接口
                'return_url'=> $recent_url.'/return_url', //支付成功返回地址
                'nonce_str' => str_shuffle(time())//必须的，随机字符串，作用：1.避免服务器缓存，2.防止安全密钥被猜测出来
            );
            if($param['type']=='WeChat' && $this->isWebApp()){
                $data['type'] = "WAP";
                $data['wap_url'] = $recent_url;
                $data['wap_name'] = $recent_url;
            }
            $hashkey =$appsecret;
            $data['hash']     = $this->generate_xh_hash($data,$hashkey);
            /**
             * 个人支付宝/微信官方支付，支付网关：https://api.xunhupay.com
             * 微信支付宝代收款，需提现，支付网关：https://pay.wordpressopen.com
             */
            $url              = 'https://api.xunhupay.com/payment/do.html';

            try {
                $response     = $this->http_post($url, json_encode($data));

                /**
                 * 支付回调数据
                 * @var array(
                 *      order_id,//支付系统订单ID
                 *      url//支付跳转地址
                 *  )
                 */
                $result       = $response?json_decode($response,true):null;
                if(empty($result)){
//                    exit($response);
                    throw new Exception("支付网关未返回!");
                }
                $retData['isWebApp']    = $this->isWebApp();
                if ($result['errcode'] != 0) {
//                    exit($result['errmsg']);
                    throw new Exception($result['errmsg']);
                }
                if ($this->isWebApp()) {
//                    var_dump("是否app");

                    $retData['url']    = $result['url'];
//                    return $pay_url;
//                    exit;
                }else{
                    $retData['url_qrcode']    = $result['url_qrcode'];
                }

                return $retData;
            } catch (Exception $e) {
                throw new Exception("errcode:{$e->getCode()},errmsg:{$e->getMessage()}");
                //TODO:处理支付调用异常的情况
            }
        }



    }

    public function isWebApp(){
        if(!isset($_SERVER['HTTP_USER_AGENT'])){
            return false;
        }

        $u=strtolower($_SERVER['HTTP_USER_AGENT']);
        if($u==null||strlen($u)==0){
            return false;
        }

        preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/',$u,$res);

        if($res&&count($res)>0){
            return true;
        }

        if(strlen($u)<4){
            return false;
        }

        preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/',substr($u,0,4),$res);
        if($res&&count($res)>0){
            return true;
        }

        $ipadchar = "/(ipad|ipad2)/i";
        preg_match($ipadchar,$u,$res);
        return $res&&count($res)>0;
    }

    public function  generate_xh_hash(array $datas,$hashkey){
        ksort($datas);
        reset($datas);
        $arg  = '';
        foreach ($datas as $key=>$val){
            if($key=='hash'||is_null($val)||$val===''){continue;}
            if($arg){$arg.='&';}
            $arg.="$key=$val";
        }
        return md5($arg.$hashkey);
    }

    public function http_post($url,$data){
        if(!function_exists('curl_init')){
            throw new Exception('php未安装curl组件',500);
        }

        $protocol = (! empty ( $_SERVER ['HTTPS'] ) && $_SERVER ['HTTPS'] !== 'off' || $_SERVER ['SERVER_PORT'] == 443) ? "https://" : "http://";
        $siteurl= $protocol.$_SERVER['HTTP_HOST'];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch,CURLOPT_URL, $url);
        curl_setopt($ch,CURLOPT_REFERER,$siteurl);
        curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
        curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,FALSE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $response = curl_exec($ch);
        $httpStatusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $error=curl_error($ch);
        curl_close($ch);
        if($httpStatusCode!=200){
            throw new Exception("invalid httpstatus:{$httpStatusCode} ,response:$response,detail_error:".$error,$httpStatusCode);
        }

        return $response;
    }
}
