<?php
namespace PHPMailer;

use PHPMailer\PHPMailer;
use PHPMailer\SMTP;
use PHPMailer\Exception;
use think\facade\Config;

class SendEmail
{
    protected $config = [
        'Host' => 'smtp.163.com',  //smtp服务器
        'From' => '***', //发送者的邮件地址
        'FromName' => 'xxx',  //发送邮件的用户昵称
        'Username' => '***',  //登录到邮箱的用户名
        'Password' => '*****',  //第三方登录的授权码，在邮箱里面设置
    ];
    public function __construct($config=[])
    {
		$config = Config::pull('mail') ?: [];
        $this->config = array_merge($this->config, $config);
    }
    /**
     * 使用 $this->name 获取配置
     * @param $name 配置名称
     * @return mixed 配置值
     */
    public function __get($name)
    {
        return $this->config[$name];
    }
    /**
     *
     * @access public
     * @param  string $name  配置名称
     * @param  string $value 配置值
     * @return void
     */
    /**
     * @desc 设置邮件配置
     * @param $name 配置名称
     * @param $value 配置值
     */
    public function __set($name, $value)
    {
        if (isset($this->config[$name])) {
            $this->config[$name] = $value;
        }
    }
    /**
     * 检查配置
     * @param $name 配置名称
     * @return bool
     */
    public function __isset($name)
    {
        return isset($this->config[$name]);
    }
    public function send($subject='Here is the subject',$message='This is the HTML message body <b>in bold!</b>', $emailAddress='875376798@qq.com')
    {
        $mail = new PHPMailer(true);
		
		
		try {
		    //Server settings
		    $mail->SMTPDebug = SMTP::DEBUG_SERVER;                      // Enable verbose debug output
		    $mail->isSMTP();                                            //告诉服务器使用smtp协议发送
		    $mail->Host       = $this->Host;							//告诉我们的服务器使用163的smtp服务器发送
		    $mail->SMTPAuth   = true;                                   //开启SMTP授权
		    $mail->Username   = $this->Username;						// SMTP username
		    $mail->Password   = $this->Password;						// SMTP password
			
			//QQ ENCRYPTION_SMTPS
		    $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;         // Enable TLS encryption; `PHPMailer::ENCRYPTION_SMTPS` also accepted
		    $mail->Port       = $this->Port;                                  // TCP port to connect to
		
		    //Recipients
		    $mail->setFrom($this->From, $this->FromName);
		    $mail->addAddress($emailAddress);     	// Add a recipient
		    //$mail->addAddress('ellen@example.com');               	// Name is optional
		    //$mail->addReplyTo('info@example.com', 'Information');
		    //$mail->addCC('cc@example.com');
		    //$mail->addBCC('bcc@example.com');
		
		    // Attachments
		    //$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
		    //$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name
		
		    // Content
		    $mail->isHTML(true);                                  // Set email format to HTML
		    $mail->Subject = $subject;
		    $mail->Body    = $message;
		    //$mail->AltBody = 'This is the body in plain text for non-HTML mail clients';
		
		    $mail->send();
		    return 0;
		} catch (Exception $e) {
		    return 1;
		}

    }
}