<?php
/**
 *
 * ------1. 数据库备份（导出）------------------------------------------------------------
 //分别是主机，用户名，密码，数据库名，数据库编码
 $db = new DBManage ( 'localhost', 'root', 'root', 'test', 'utf8' );
 // 参数：备份哪个表(可选),备份目录(可选，默认为backup),分卷大小(可选,默认2000，即2M)
 $db->backup ();
 * ------2. 数据库恢复（导入）------------------------------------------------------------
 //分别是主机，用户名，密码，数据库名，数据库编码
 $db = new DBManage ( 'localhost', 'root', 'root', 'test', 'utf8' );
 //参数：sql文件
 $db->restore ( './backup/2014072125.sql');
 *----------------------------------------------------------------------
 */
namespace database;

use think\Db;
use Hook;

class Backup
{
    public $db; // 数据库连接
	public $database; // 所用数据库
	public $sqldir; // 数据库备份文件夹
	public $record;
    // 换行符
    private $ds = "\n";
    // 存储SQL的变量
    public $sqlContent = "";
    // 每条sql语句的结尾符
    public $sqlEnd = ";";

    public function __construct($config=array())
    {
        $this ->config= count($config) ? $config : config('database.');

        $this->host = $this ->config['hostname'];
        $this->username = $this ->config['username'];
        $this->password = $this ->config['password'];
        $this->database = $this ->config['database'];
        $this->charset = $this ->config['charset'];
        // 连接数据库
        $this->db = mysqli_connect($this->host, $this->username, $this->password);
          
        if (!$this->db) {
            return -1;
        }
        // 选择使用哪个数据库
        mysqli_select_db($this->db, $this->database);
        // 数据库编码方式
        mysqli_query($this->db, 'SET NAMES ' . $this->charset);
    }

    /*
     * ------------------------------------------数据库备份start----------------------------------------------------------
     */

    /**
     * 数据库备份
     * 参数：备份哪个表(可选),备份目录(可选，默认为backup),分卷大小(可选,默认2000，即2M)
     *
     * @param $string $dir
     * @param int $size
     * @param $string $tablename
     */
    public function backup($tablename = '', $dir=null, $size=null)
    {
        $dir = $dir ? $dir : 'backup/';
        $size = $size ? $size : 2048;
        $sql = '';
        // 只备份某个表
        if (! empty($tablename)) {
            try {
                // 插入dump信息
                $sql = $this->_retrieve();
                // 插入表结构信息
                $sql .= $this->_insert_table_structure($tablename);
                // 插入数据
                $data = mysqli_query($this->db, "select * from " . $tablename);
            
                // 文件名前面部分
                $filename = date('YmdHis') . "_" . $tablename;
                // 字段数量
                $num_fields = mysqli_num_fields($data);
                $rowcount=mysqli_num_rows($data);
            
                // 第几分卷
                $p = 1;
                // 循环每条记录
                $key = 1;
                while ($record = mysqli_fetch_array($data)) {
                    // 单条记录
                    $sql .= $this->_insert_record($tablename, $num_fields, $record);
                    // 如果大于分卷大小，则写入文件
                    if (strlen($sql) >= $size * 1000) {
                        $file = $filename . "_v" . $p . ".sql";
                        if ($this->_write_file($sql, $file, $dir)) {
                            $params['filename'] = $file;
                            $params['table'] = $tablename;
                            $params['progress'] =$key / $rowcount;
                            cache('module_backup', $params);
                        }
                        // 下一个分卷
                        $p ++;
                        // 重置$sql变量为空，重新计算该变量大小
                        $sql = "";
                    }
                    $key++;
                }
				
                // sql大小不够分卷大小
                if ($sql != "") {
                    $filename .= "_v" . $p . ".sql";
                    $this->_write_file($sql, $filename, $dir) ;
                }
				
                $params['filename'] = $filename;
                $params['progress'] =1;
                cache('module_backup', $params);
                return 1;
            } catch (\Exception $e) {
                //Hook::listen('sql_err',$e);
                return 0;
            }
        } else { // 备份全部表
            try {
                // 插入dump信息
                $sql .= $this->_retrieve();
                // 文件名前面部分
                $filename = date('YmdHis') . "_all";
                // 查出所有表
                $tables = mysqli_query($this->db, 'SHOW TABLES');
                $tableCount=mysqli_num_rows($tables);
                // 第几分卷
                $p = 1;
                // 循环所有表
                $tableKey = 0;
                while ($table = mysqli_fetch_array($tables)) {
                    // 获取表名
                    $tablename = $table [0];
                    // 获取表结构
                    $sql .= $this->_insert_table_structure($tablename);
                    $data = mysqli_query($this->db, "select * from " . $tablename);
                    $num_fields = mysqli_num_fields($data);
                    $rowcount=mysqli_num_rows($data);
                    // 循环每条记录
                    $key = 1;
                    while ($record = mysqli_fetch_array($data)) {
                        // 单条记录
                        $sql .= $this->_insert_record($tablename, $num_fields, $record);
                        // 如果大于分卷大小，则写入文件
                        if (strlen($sql) >= $size * 1000) {
                            $file = $filename . "_v" . $p . ".sql";
                            // 写入文件
                            if ($this->_write_file($sql, $file, $dir)) {
                                $progressLength = 100 / $tableCount;
                                $params['filename'] = $file;
                                $params['table'] = $tablename;
                                $params['progress'] =$key / $rowcount * $progressLength + $tableKey * $progressLength;
                                cache('module_backup', $params);
                                //echo "-卷-" . $p . "-数据备份完成,生成备份文件<span style='color:#f00;'>$dir$file</span><br />";
                            }
                            // 下一个分卷
                            $p ++;
                            // 重置$sql变量为空，重新计算该变量大小
                            $sql = "";
                        }
                                                     
                        $key++;
                    }
                                            
                    $tableKey ++ ;
                }
                // sql大小不够分卷大小
                if ($sql != "") {
                    $filename .= "_v" . $p . ".sql";
                    $this->_write_file($sql, $filename, $dir);
                }
                                   
                $params['filename'] = $filename;
                $params['progress'] =1;
                cache('module_backup', $params);
                return 1;
            } catch (\Exception $e) {
                //Hook::listen('sql_err',$e);
                return 0;
            }
        }
        return 0;
    }

    /**
     * 插入数据库备份基础信息
     *
     * @return string
     */
    private function _retrieve()
    {
        $value = '';
        $value .= '--' . $this->ds;
        $value .= '-- MySQL database dump' . $this->ds;
        $value .= '-- Created by Backup class. ' . $this->ds;
        $value .= '-- http://www.mike.gd.cn ' . $this->ds;
        $value .= '--' . $this->ds;
        $value .= '-- 主机: ' . $this->host . $this->ds;
        $value .= '-- 生成日期: ' . date('Y') . ' 年  ' . date('m') . ' 月 ' . date('d') . ' 日 ' . date('H:i') . $this->ds;
        $value .= '-- MySQL版本: ' . mysqli_get_server_info($this->db) . $this->ds;
        $value .= '-- PHP 版本: ' . phpversion() . $this->ds;
        $value .= $this->ds;
        $value .= '--' . $this->ds;
        $value .= '-- 数据库: `' . $this->database . '`' . $this->ds;
        $value .= '--' . $this->ds . $this->ds;
        $value .= '-- -------------------------------------------------------';
        $value .= $this->ds . $this->ds;
        return $value;
    }

    /**
     * 插入表结构
     *
     * @param unknown_type $table
     * @return string
     */
    private function _insert_table_structure($table)
    {
        $sql = '';
        $sql .= "--" . $this->ds;
        $sql .= "-- 表的结构" . $table . $this->ds;
        $sql .= "--" . $this->ds . $this->ds;
        
        // 如果存在则删除表
        $sql .= "DROP TABLE IF EXISTS `" . $table . '`' . $this->sqlEnd . $this->ds;
        // 获取详细表信息
        $res = mysqli_query($this->db, 'SHOW CREATE TABLE `' . $table . '`');
        $row = mysqli_fetch_array($res);
        $sql .= $row [1];
        $sql .= $this->sqlEnd . $this->ds;
        // 加上
        $sql .= $this->ds;
        $sql .= "--" . $this->ds;
        $sql .= "-- 转存表中的数据 " . $table . $this->ds;
        $sql .= "--" . $this->ds;
        $sql .= $this->ds;
        return $sql;
    }

    /**
     * 插入单条记录
     *
     * @param string $table
     * @param int $num_fields
     * @param array $record
     * @return string
     */
    private function _insert_record($table, $num_fields, $record)
    {
        // sql字段逗号分割
        $comma = "";
        $insert = "";
        $insert .= "INSERT INTO `" . $table . "` VALUES(";
        // 循环每个子段下面的内容
        for ($i = 0; $i < $num_fields; $i ++) {
            $insert .= ($comma . "'" . mysqli_real_escape_string($this->db, $record [$i]) . "'");
            $comma = ",";
        }
        $insert .= ");" . $this->ds;
        return $insert;
    }

    /**
     * 写入文件
     *
     * @param string $sql
     * @param string $filename
     * @param string $dir
     * @return boolean
     */
    private function _write_file($sql, $filename, $dir)
    {
        $dir = $dir ? $dir : './backup/';
        // 不存在文件夹则创建
        if (! file_exists($dir)) {
            mkdir($dir, 0777, true);
        }
        $re = true;
        if (! @$fp = fopen($dir . $filename, "w+")) {
            $re = false;
            echo "打开文件失败！";
        }
        if (! @fwrite($fp, $sql)) {
            $re = false;
            echo "写入文件失败，请文件是否可写";
        }
        if (! @fclose($fp)) {
            $re = false;
            echo "关闭文件失败！";
        }
        return $re;
    }

    /*
     *
     * -------------------------------上：数据库导出-----------分割线----------下：数据库导入--------------------------------
     */

    /**
     * 导入备份数据
     * 说明：分卷文件格式2014072125.sql
     * 参数：文件路径(必填)
     *
     * @param string $sqlfile
     */
    public function restore($sqlfile)
    {
        // 检测文件是否存在
        if (! file_exists($sqlfile)) {
            exit("文件不存在！请检查");
        }
        $this->lock($this->database);
        // 获取数据库存储位置
        $sqlpath = pathinfo($sqlfile);
        $this->sqldir = $sqlpath ['dirname'];
        // 检测是否包含分卷，将类似2014072125.sql从_v分开,有则说明有分卷
        $volume = explode("_v", $sqlfile);
        $volume_path = $volume [0];
        echo "请勿刷新及关闭浏览器以防止程序被中止，如有不慎！将导致数据库结构受损<br />";
        echo "正在导入备份数据，请稍等！<br />";
        if (empty($volume [1])) {
            echo "正在导入sql：<span style='color:#f00;'>" . $sqlfile . '</span><br />';
            // 没有分卷
            if ($this->_import($sqlfile)) {
                echo "数据库导入成功！";
            } else {
                exit('数据库导入失败！');
            }
        } else {
            //$volume_id = array();
            // 存在分卷，则获取当前是第几分卷，循环执行余下分卷
            $volume_id = explode(".sql", $volume [1]);
            // 当前分卷为$volume_id
            $volume_id = 1;

            while ($volume_id) {
                $tmpfile = $volume_path . "_v" . $volume_id . ".sql";
                // 存在其他分卷，继续执行
                if (file_exists($tmpfile)) {
                    // 执行导入方法
                    echo "正在导入分卷".$volume_id."：<span style='color:#f00;'>" . $tmpfile . '</span><br />';
                    if ($this->_import($tmpfile)) {
                    } else {
                        exit("导入分卷$volume_id：<span style='color:#f00;'>" . $tmpfile . '</span>失败！可能是数据库结构已损坏！请尝试从分卷1开始导入');
                    }
                } else {
                    echo "此分卷备份全部导入成功！<br />";
                    return;
                }
                $volume_id++;
            }
        }
    }

    /**
     * 将sql导入到数据库（普通导入）
     *
     * @param string $sqlfile
     * @return boolean
     */
    private function _import($sqlfile)
    {
        // sql文件包含的sql语句数组
        $sqls = array();
        $f = fopen($sqlfile, "rb");
        // 创建表缓冲变量
        $create = '';
        while (! feof($f)) {
            // 读取每一行sql
            $line = fgets($f);
            // 如果包含'-- '等注释，或为空白行，则跳过
            if (trim($line) == '' || preg_match('/--.*?/', $line, $match)) {
                continue;
            }
            // 如果结尾包含';'(即为一个完整的sql语句，这里是插入语句)，并且不包含'ENGINE='(即创建表的最后一句)，
            if (! preg_match('/;/', $line, $match) || preg_match('/ENGINE=/', $line, $match)) {
                // 将本次sql语句与创建表sql连接存起来
                $create .= $line;
                // 如果包含了创建表的最后一句
                if (preg_match('/ENGINE=/', $create, $match)) {
                    // 则将其合并到sql数组
                    $sqls [] = $create;
                    // 清空当前，准备下一个表的创建
                    $create = '';
                }
                // 跳过本次
                continue;
            }
            $sqls [] = $line;
        }
        fclose($f);
        // 循环sql语句数组，分别执行
        foreach ($sqls as $sql) {
            str_replace("＼n", "", $sql);
            if (! mysqli_query($this->db, trim($sql))) {
                echo mysqli_error();
                return false;
            }
        }
        return true;
    }

    /*
     * -------------------------------数据库导入end---------------------------------
     */

//    查询所有数据表
    public function tables()
    {
        if (!$this->db) {
            echo 'Could not connect to mysql';
            exit;
        }
        $db_name=$this->config['database'];
        $sql = "SHOW TABLES FROM $db_name";
        $result = mysqli_query($this->db, $sql);

        if (!$result) {
            echo "DB Error, could not list tables\n";
            echo 'MySQL Error: ' . mysqli_error();
            exit;
        }

        //将这些表记录到一个数组
        $tabList = array();
        while ($row = mysqli_fetch_row($result)) {
            $tabList[] = $row[0];
        }
        return $tabList;
    }

    // 关闭数据库连接
    private function close()
    {
        mysqli_close($this->db);
    }

    // 锁定数据库，以免备份或导入时出错
    private function lock($tablename, $op = "WRITE")
    {
        if (mysqli_query($this->db, "lock tables " . $tablename . " " . $op)) {
            return true;
        } else {
            return false;
        }
    }

    // 解锁
    private function unlock()
    {
        if (mysqli_query($this->db, "unlock tables")) {
            return true;
        } else {
            return false;
        }
    }

    // 析构
    public function __destruct()
    {
        mysqli_query($this->db, "unlock tables");
        mysqli_close($this->db);
    }
}
