<?php
namespace database;
use think\Db;
use Hook;
class Model 
{
	public $connect =false;
    function __construct($config=array())  //析构函数
    {
		 
         if(count($config) > 0)
		 {
			    $this ->config= $config; 
			    $this -> db = Db::connect($config);
		 }
		 else
		 {     
		       $this ->config= config('database.'); 
			   $this -> db = Db::connect($config);
		 }
    } 
	
/*************************************************************
	isconnect 检测是否连接数据库成功
	@return  int 
*************************************************************/
    public function isconnect()
    {
           switch ($this ->config['type'])
		   {
					case 'mysql':
					  return $this ->mysql_isconnect();
					  break;  
					default:
					  return $this ->mysql_isconnect();
		   }
    }
	
/*************************************************************
	mysql_isconnect 检测MYSQL是否连接数据库成功
	@return  int 
*************************************************************/
    public function mysql_isconnect()
    {
		   $servername = $this ->config['hostname'] ? $this ->config['hostname'] : 'localhost';
		   $hostport = $this ->config['hostport'] ? $this ->config['hostport'] : '3306';
		   $username = $this ->config['username'] ? $this ->config['username'] : 'root';
		   $password = $this ->config['password'] ? $this ->config['password'] : '';
		   try{
                $this-> connect= $this-> connect ? $this-> connect : mysqli_connect($servername.":".$hostport,$username,$password);
				return $this-> connect ? 1 : 0;
            }catch(\Exception $e){
                return 0;
            }
    }	
	
/*************************************************************
	has 检测数据库是否存在
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function has($dbname='mkcms')
    {
		
		
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_has($dbname);
					break;  
				  default:
					return $this ->mysql_has($dbname);
		   }
    }
	
/*************************************************************
	mysql_has 检测MYSQL数据库是否存在
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function mysql_has($dbname='mkcms')
    {
           if($this->mysql_isconnect())
		   {
				 try{
					  $check = $this -> db ->query('SELECT * FROM information_schema.schemata WHERE schema_name="'.$dbname.'"');	 
				      return $check ? 1 : 0;
				  }catch(\Exception $e){
					  return 0;
				  }
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	create 创建数据库
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function create($dbname='mkcms')
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_create($dbname);
					break;  
				  default:
					return $this ->mysql_create($dbname);
		   }
    }
	
/*************************************************************
	mysql_create 创建MYSQL数据库
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function mysql_create($dbname='mkcms')
    {
           if($this->mysql_isconnect())
		   {
				   try{
					   
					    if($this->mysql_has($dbname))
						{
							  $this->delete($dbname);
						}
						
						$create = mysqli_query($this-> connect ,"CREATE DATABASE  IF NOT EXISTS `{$dbname}` DEFAULT CHARACTER SET utf8");	
						return $create ? 1 : 0;
					}catch(\Exception $e){
						return 0;
					}
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	create 删除数据库
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function delete($dbname='mkcms')
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_delete($dbname);
					break;  
				  default:
					return $this ->mysql_delete($dbname);
		   }
    }
	
/*************************************************************
	mysql_create 删除MYSQL数据库
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function mysql_delete($dbname='mkcms')
    {
           if($this->mysql_isconnect())
		   {
				   try{
					    if(!$this->mysql_has($dbname)) return 1;
						$delete = $this -> db ->execute("drop database `{$dbname}`;");	
						return $delete !==false ? 1 : 0;
						
					}catch(\Exception $e){
						return 0;
					}
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	table_has 检测数据表是否存在
	@param  tablename string  数据表名称
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function table_has($tablename='mkcms',$dbname=NULL)
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_table_has($tablename,$dbname);
					break;  
				  default:
					return $this ->mysql_table_has($tablename,$dbname);
		   }
    }
	
/*************************************************************
	mysql_table_has 检测MYSQL数据库
	@param  tablename string  数据表名称
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function mysql_table_has($tablename='mkcms',$dbname=NULL)
    {
           if($this->mysql_isconnect())
		   {
				   try{
					    $dbname  = $dbname ? $dbname : $this ->config['database'];
						$table = $this -> db ->query("select table_name from information_schema.tables where  table_name='".$this ->config['prefix']."{$tablename}' AND table_schema='{$dbname}'");	
						return $table ? 1 : 0;
					}catch(\Exception $e){
						return 0;
					}
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	get_table_names 获取数据库表名称集合
	@param  dbname string  数据库名称
	@return  array() 
*************************************************************/
    public function get_table_names($dbname=NULL)
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_get_table_names($dbname);
					break;  
				  default:
					return $this ->mysql_get_table_names($dbname);
		   }
    }
	
/*************************************************************
	mysql_get_table_names 获取MYSQL数据库表名称集合
	@param  dbname string  数据库名称
	@return  int 
*************************************************************/
    public function mysql_get_table_names($dbname=NULL)
    {
           if($this->mysql_isconnect())
		   {
				   try{
					    $dbname  = $dbname ? $dbname : $this ->config['database'];
						$tables = $this -> db ->query("select * from information_schema.tables where table_schema='{$dbname}'");	
						return $tables ? $tables : array();
					}catch(\Exception $e){
						return array();
					}
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	create_table 创建数据表
	@param  tablename string  数据表名称
	@param  cover bool  是否覆盖已有表 true 覆盖 false 不覆盖 默认为覆盖
	@return  array() 
*************************************************************/
    public function create_table($tablename='mkcms',$cover=true)
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_create_table($tablename,$cover);
					break;  
				  default:
					return $this ->mysql_create_table($tablename,$cover);
		   }
    }
	
/*************************************************************
	mysql_create_table 创建MYSQL数据表
	@param  tablename string  数据表名称
	@param  cover bool  是否覆盖已有表 true 覆盖 false 不覆盖 默认为覆
	@return  int 
*************************************************************/
    public function mysql_create_table($tablename='mkcms',$cover=true)
    {
           if($this->mysql_isconnect())
		   {
				   try{
						if($this ->mysql_table_has($tablename))
						{
							  if($cover)
							  {
								   $this ->mysql_delete_table($tablename);
							  }
							  else
							  {
								   return -2; // 数据表存在
							  }
						}

						 $this -> db ->execute("CREATE TABLE `".$this ->config['prefix']."{$tablename}` (id int NOT NULL AUTO_INCREMENT, PRIMARY KEY(id))");
							
						if($this ->mysql_table_has($tablename))
						{
							 return 1;
						}
						else
						{
							 return 0;
						}
						
					}catch(\Exception $e){
						return 0;
					}
		   }
		   else
		   {
			     return -1;
		   }
    }
	
/*************************************************************
	delete_table 删除数据表
	@param  tablename string  数据表名称
	@return  int
*************************************************************/
    public function delete_table($tablename='mkcms')
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_delete_table($tablename);
					break;  
				  default:
					return $this ->mysql_delete_table($tablename);
		   }
    }
	
/*************************************************************
	mysql_delete_table 删除MYSQL数据表
	@param  tablename string  数据表名称
	@return  int 
*************************************************************/
    public function mysql_delete_table($tablename='mkcms')
    {
           if($this->mysql_isconnect())
		   {

                  try{
						$this -> db ->execute("DROP TABLE `".$this ->config['prefix']."{$tablename}`");	
						
						if($this ->mysql_table_has($tablename))
						{
							 return 0;
						}
						else
						{
							 return 1;
						}
						
				   }catch(\Exception $e){
					    return 0;
				   }
	
		   }
		   else
		   {
			     return -1;
		   }
    } 

/*************************************************************
	exe_sql_file 执行sql文件
	@param  filename string|array  执行sql 文件名
	@param  pre array   array('pre'=>placePre) sql数据表前缀  pre为原始前缀  placePre为要替换的前缀
	@param  type int  是否返回创建的数据表，0不返回 1返回
	@return  int 
*************************************************************/
    public function exe_sql_file($filename,$pre=['mkcms_'=>'mkcms_'],$type = 0 )
    {
           switch ($this ->config['type'])
		   {
				  case 'mysql':
					return $this ->mysql_exe_sql_file($filename,$pre,$type);
					break;  
				  default:
					return $this ->mysql_exe_sql_file($filename,$pre,$type);
		   }
    }  
		
/*************************************************************
	执行MYSQL sql文件
	@param  filename string|array  执行sql 文件名
	@param  pre array   array('pre'=>placePre) sql数据表前缀  pre为原始前缀  placePre为要替换的前缀
	@param  type int  是否返回创建的数据表，0不返回 1返回
	@return  int 
*************************************************************/
    public function mysql_exe_sql_file($filename,$pre=['mkcms_'=>'mkcms_'],$type = 0)
    {
		   $sqltotal = 0;//所有文件的总sql条数
		   $sqlnum = 0; //当前sql语句是总sql语句的第几条
		   $sqlfiles = [];//sql文件名数组
		   if(!is_array($filename)) $filename = [$filename];
           if($this->mysql_isconnect())
		   {
			      if(count($pre) > 0 )
				  {
					  $pre_place = current($pre); //要替换的前缀值
			          $pre_original = current(array_flip($pre)); //被替换的原始前缀
				  }
				  else
				  {
					  $pre_place = $this ->config['prefix']; //要替换的前缀值
					  $pre_original ="mkcms_"; //被替换的原始前缀
				  }
				  
				  $sqlList = [];
				  $engines = $this -> mysql_get_engine();

				  foreach ($filename as $key => $val)
				  {
					    if(is_file($val))
						{
							  $pathinfo = pathinfo($val);
		                      $file_name = $pathinfo['filename'];
							  
							  $sql = file_get_contents($val);
							  
                              preg_match("/ENGINE=([a-zA-Z]+)/i", $sql,$sqlEngine);
							  
							  if($sqlEngine && $sqlEngine[1])
							  {
								   //$sql = str_replace('ENGINE='.$sqlEngine[1],'ENGINE='.$engines['default'],$sql);
								   
								   if(!in_array($sqlEngine[1],$engines['engine']))
								   {
									     $sql = str_replace('ENGINE='.$sqlEngine[1],'ENGINE='.$engines['default'],$sql);
								   }
							  }
							  
							  $sqlList[$file_name] = array_filter($this->reg_sql($sql,[$pre_original =>$pre_place ]));
							  $sqlfiles[$file_name] = count($sqlList[$file_name]);
							  
							  $sqltotal = $sqltotal + count($sqlList[$file_name]);
						}
						
						
				  }

				  try {
					         $params = ['files'=>$sqlfiles,'database'=>$this ->config['database'],'sqltotal'=>$sqltotal];
					         Hook::listen('sql_begin',$params);
							 foreach($sqlList as $sqlfile => $sql_list)
							 {
									$tables = [];
									$inserts = [];
			
									if (!$sql_list) continue;
									
									$file_total = count($sql_list); // 当前文件的sql条数
					  
									foreach ($sql_list as $key => $val) 
									{
										  $sign = false;
										  /*获取创建的数据表*/
										  $patterns[]="/CREATE TABLE IF NOT EXISTS `".$pre_place."([\S]+)`/i";
										  $patterns[]="/CREATE TABLE `".$pre_place."([\S]+)`/i";
										  foreach($patterns as $k=>$pattern)
										  {
											   if(preg_match_all($pattern,$val,$matches))
											   {		
													  $tables[] = $matches[1][0];
													  $params = ['files'=>$sqlfiles,'file'=>$sqlfile,'database'=>$this ->config['database'],'table'=>$matches[1][0],'progress'=> ($sqlnum+1) / $sqltotal,'sqltotal'=>$sqltotal,'sqlnum'=>($sqlnum+1),'filenum'=>$key+1];			 
													  Hook::listen('sqlcreate_begin',$params);
													  $sign = "CREATE";
													  break;
											   }
										  }
										   /*获取创建的数据表完成*/
										   
										   
										  /*插入记录*/
										  $pattern="/INSERT INTO `".$pre_place."([\S]+)`/i";
										  
										   if(!$sign && preg_match_all($pattern,$val,$matches))
										   {							 
												  $params = ['files'=>$sqlfiles,'file'=>$sqlfile,'database'=>$this ->config['database'],'table'=>$matches[1][0],'progress'=> ($sqlnum+1) / $sqltotal,'sqltotal'=>$sqltotal,'sqlnum'=>($sqlnum+1),'filenum'=>$key+1];
												  Hook::listen('sqlinsert_begin',$params);	
												  $sign = "INSERT";
										   }
										   /*插入记录完成*/
										  $this -> db ->execute($val);
										  
										  if($sign == "CREATE")
										  {
													  $params = ['files'=>$sqlfiles,'file'=>$sqlfile,'database'=>$this ->config['database'],'table'=>$matches[1][0],'progress'=> ($sqlnum+1) / $sqltotal,'sqltotal'=>$sqltotal,'sqlnum'=>($sqlnum+1),'filenum'=>$key+1];		 
													  Hook::listen('sqlcreate_end',$params);
										  }
										  
										  if($sign == "INSERT")
										  {
													  $params = ['files'=>$sqlfiles,'file'=>$sqlfile,'database'=>$this ->config['database'],'table'=>$matches[1][0],'progress'=> ($sqlnum+1) / $sqltotal,'sqltotal'=>$sqltotal,'sqlnum'=>($sqlnum+1),'filenum'=>$key+1];			 
													  Hook::listen('sqlinsert_end',$params);
										  } 
										  
										  $sqlnum= $sqlnum + 1;
									}
									
									
							  }
							  
							  $params = ['file'=>$sqlfiles,'database'=>$this ->config['database'],'sqltotal'=>$sqltotal];
					          Hook::listen('sql_end',$params);
							  
							  return $type ? array_unique($tables) : 1;
							
						} catch(\Exception $e) {
							  Hook::listen('sql_err',$e);
							  return 0;
						}

		   }
		   else
		   {
			     return -1;
		   }
    } 
	
	
/*************************************************************
	mysql_get_engine 获取mysql数据库引擎
	@return  array(); 
*************************************************************/
    public function mysql_get_engine()
    {
             $engine = $this -> db ->query('SHOW  ENGINES');
			 $returnData =[];
			 
			 if($engine)
			 {
				  foreach($engine as $k => $v)
				  {
					   if(strtolower(trim($v['Support'])) != "no")
					   {
						    if(strtolower(trim($v['Support'])) == "default")
							{
								 $returnData['default'] = trim($v["Engine"]);
							}
						    $returnData['engine'][] = trim($v["Engine"]);
					   }
				  }
			 }	
			 else
			 {
				  return [];
			 }
			 
			 return $returnData;
				  
    }
	
/*************************************************************
	reg_sql 对sql语句正则处理，并放到数组中 环境检测
	@param $sql string sql字符串
	@param $pre array 数组 表前缀
    @return array
*************************************************************/	
	function reg_sql($sql,$pre=['mkcms_'=>'mkcms_'])
    {
		  if(trim($sql)=="") return [];
		  $returnData = [];
		  
		  if(count($pre) > 0 )
		  {
			  $pre_place = current($pre); //要替换的前缀值
			  $pre_original = current(array_flip($pre)); //被替换的原始前缀
		  }
		  
		  // 多行注释标记
          $comment = false;
		  
		  // 按行分割，兼容多个平台
		  $sql = str_replace(["\r\n", "\r"], "\n", $sql);
		  $sql = explode("\n", trim($sql));	
		  
		  // 循环处理每一行
		  foreach ($sql as $key => $line) {
			  // 跳过空行
			  if ($line == '') continue;

			  // 跳过以#或者--开头的单行注释
			  if (preg_match("/^(#|--)/", $line)) continue;

			  // 跳过以/**/包裹起来的单行注释
			  if (preg_match("/^\/\*(.*?)\*\//", $line)) continue;

			  // 多行注释开始
			  if (substr($line, 0, 2) == '/*') {
				  $comment = true;
				  continue;
			  }

			  // 多行注释结束
			  if (substr($line, -2) == '*/') {
				  $comment = false;
				  continue;
			  }

			  // 多行注释没有结束，继续跳过
			  if ($comment) continue;

			  // 替换表前缀
			  if ($pre_original != '') {
				  $line = str_replace('`'.$pre_original, '`'.$pre_place, $line);
			  }
			  if ($line == 'BEGIN;' || $line =='COMMIT;') {
				  continue;
			  }
			  // sql语句
			  array_push($returnData, $line);
		  }	 
		  
		  $returnData = implode($returnData, "\n");
          $returnData = explode(";\n", $returnData); 
		  return $returnData;
    }
    
}  	

?>