//防抖函数示例
function debounce(func, wait) {
    var timeout;

    return function() {
        var context = this,
            args = arguments;

        clearTimeout(timeout);
        timeout = setTimeout(function() {
            func.apply(context, args);
        }, wait);
    };
}

// 定义显示提醒框的函数
function showAlert(message, type) {
    // 移除已有的提醒框，防止重复
    $('.custom-alert').remove();

    // 根据类型设置相应的类名
    var alertTypeClass = '';
    if(type === 'success') {
        alertTypeClass = 'custom-alert-success';
    } else if(type === 'error') {
        alertTypeClass = 'custom-alert-error';
    }

    // 创建提醒框元素，并添加相应的类名
    var alertDiv = $('<div class="custom-alert ' + alertTypeClass + '"></div>');

    // 设置提醒消息
    alertDiv.text(message);

    // 将提醒框添加到页面中
    $('body').append(alertDiv);
    alertDiv.hide().fadeIn(300);  // 动态淡入效果

    // 3 秒后自动移除提醒框
    setTimeout(function() {
        alertDiv.fadeOut(300, function() {
            $(this).remove();
        });
    }, 3000);
}
// 数据库验证按钮
$('#database_verification_Button').on('click', function(){
    var content = `
                <p>非常好，您完成了安装过程中重要的一步<br>鲸鱼博客CMS系统 现在已经可以连接数据库了</p>
                <div class="button-ok"><a href="/initial?p=3">运行安装程序</a></div>
            `;
    var content2 = `
                <div class="jiazai-donghua"></div>
                <p>请稍等，正在安装中</p>
            `;
    //这个地方动画开始 加载 要求 不关闭页面
    $('.TanChuang-wrap .con').html(content2);
    $('.TanChuang-wrap').fadeIn(100);
    $.ajax({
        url:"/initialMysql",
        type:"post",
        data:{
            'db_name':$("#database-name").val(),
            'db_user':$("#username").val(),
            'db_pass':$("#password").val(),
            'db_host':$("#host").val(),
            'db_port':$("#host_port").val(),
            'table_prefix':$("#host222").val(),
        },
        success:function(res){
            console.log(res)
            //停止动画
            if(res.code == 0){
                $('.TanChuang-wrap .con').html(content);
            }else{
                //$('.TanChuang-wrap').fadeOut(100);
                //showAlert(res.msg, 'error');
                var errorText = '<p>' + res.msg + '</p><button>重新尝试</button>';
                $('.TanChuang-wrap .con').html(errorText);


            }
            // showAlert("请检查数据库配置！", 'error');
        },
    });
    // if(false){
    //     showAlert('Your server is running PHP version 5.6.40 but WordPress 6.6.1 requires at least 7.2.24.！', 'error');
    // }else {
    //     $('.TanChuang-wrap').fadeIn(100);
    // }

});
$('.TanChuang-wrap').on('click', '.con button', function(){
    $('.TanChuang-wrap').fadeOut(100);
});
function setAdmin(){
    $.ajax({
        url:"/initialSetAdmin",
        type:"post",
        data:{
            'site_name':$("#database-name").val(),
            'username':$("#username").val(),
            'admin_password':$("#admin_password").val(),
            'email':$("#host").val(),
        },
        success:function(res){
            console.log(res)
            if(res.code == 0){
                window.location.href='/initial?p=4'
            }else{
                showAlert(res.msg, 'error');
            }
            // showAlert("请检查数据库配置！", 'error');
        },
    });
    // if(false){
    //     showAlert('Your server is running PHP version 5.6.40 but WordPress 6.6.1 requires at least 7.2.24.！', 'error');
    // }else {
    //     $('.TanChuang-wrap').fadeIn(100);
    // }

};


//检测密码强度
// Function to generate a strong random password
function generateStrongPassword(length) {
    const uppercase = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    const lowercase = 'abcdefghijklmnopqrstuvwxyz';
    const numbers = '0123456789';
    //const symbols = '!@#$%^&*()_+~`|}{[]:\\;?><,./-=';
    const symbols = '.';
    const allChars = uppercase + lowercase + numbers + symbols;

    let password = '';

    // Ensure password has more than 5 English letters
    for (let i = 0; i < 6; i++) {
        const letter = uppercase + lowercase;
        password += letter.charAt(Math.floor(Math.random() * letter.length));
    }

    // Fill the rest of the password
    for (let i = 6; i < length; i++) {
        password += allChars.charAt(Math.floor(Math.random() * allChars.length));
    }

    // Shuffle the password to avoid predictable sequences
    password = password.split('').sort(() => 0.5 - Math.random()).join('');

    return password;
}

// Function to check password strength
function checkPasswordStrength(password) {
    let strength = '';

    // Count English letters in password
    const englishLettersCount = (password.match(/[A-Za-z]/g) || []).length;

    // Determine the strength
    $('#strength_labels li').removeClass('active');

    if (password.length > 10 && englishLettersCount > 5) {
        strength = 'very-strong';
    } else if (password.length > 10) {
        strength = 'strong';
    } else if (password.length > 5) {
        strength = 'medium';
    } else {
        strength = 'weak';
    }

    $('#strength_labels .' + strength).addClass('active');
}

function setRandomPassword() {
    // Generate and set a random password
    const randomPassword = generateStrongPassword(24);
    $('#admin_password').val(randomPassword);
    checkPasswordStrength(randomPassword);
}

// On page load, generate a random strong password and populate the input
setRandomPassword();

// Real-time password strength checking
$('#admin_password').on('input', function(){
    const password = $(this).val();
    checkPasswordStrength(password);
});

// Generate random password on button click
$('#generate_password').on('click', function(){
    setRandomPassword();
});














