/**

 @Name：layuiAdmin 内容系统
 @Author：star1029
 
 @License：LPPL
    
 */


layui.define(['table', 'form'], function(exports){
  var $ = layui.$
  ,table = layui.table
  ,form = layui.form;

  //文章管理
  table.render({
    elem: '#LAY-app-content-list'
    ,url: '/admin/order/list.html' //模拟接口
    ,method:'post'
    ,cols: [[
      {type: 'checkbox', fixed: 'left'}
      ,{field: 'order_id', width: 100, title: '订单id', sort: true}
      ,{field: 'ac_id', title: '用户id'}
      ,{field: 'account_name', title: '用户名'}
      ,{field: 'name', title: '商品名称'}
      ,{field: 'total_amount', title: '金额'}
      ,{field: 'order_type_name', title: '订单类型', minWidth: 100}
      ,{field: 'order_date', title: '订单时间', sort: true}
      ,{field: 'status', title: '状态', templet: '#buttonTpl', minWidth: 80, align: 'center'}
      // ,{title: '操作', minWidth: 150, align: 'center', fixed: 'right', toolbar: '#table-content-list'}
    ]]
    ,page: true
    ,limit: 10
    ,limits: [10, 15, 20, 25, 30]
    ,text: '对不起，加载出现异常！'
  });
  
  //监听工具条
  table.on('tool(LAY-app-content-list)', function(obj){
    var data = obj.data;
    if(obj.event === 'del'){
      layer.confirm('确定删除此文章？', function(index){
        console.log("删除文章")
        console.log(data.id)
        $.ajax({
          url: '/admin/article/del.html',
          method: 'post',
          data: data,
          dataType: 'JSON',
          success: function(res) {
            if (res.code == '0') {
              layui.table.reload('LAY-app-content-list'); //重载表格
              parent.layer.close(index); //再执行关闭
              layer.alert(res.msg);
            } else
              layer.alert(res.msg);
          },
          error: function(data) {}
        });
        obj.del();
        layer.close(index);
      });
    } else if(obj.event === 'edit'){
      layer.open({
        type: 2
        ,title: '编辑文章'
        ,content: '/admin/article/edit.html?id='+ data.id
        ,maxmin: true
        ,area: ['550px', '550px']
        ,btn: ['确定', '取消']
        ,yes: function(index, layero){

          //点击确认触发 iframe 内容中的按钮提交
          var submit = layero.find('iframe').contents().find("#layuiadmin-app-form-submit");
          submit.click();

          // var iframeWindow = window['layui-layer-iframe'+ index]
          // ,submit = layero.find('iframe').contents().find("#layuiadmin-app-form-edit");
          //
          // //监听提交
          // iframeWindow.layui.form.on('submit(layuiadmin-app-form-edit)', function(data){
          //   var field = data.field; //获取提交的字段
          //
          //   console.log(data)
          //   //提交 Ajax 成功后，静态更新表格中的数据
          //   //$.ajax({});
          //   // data.field.content = editorMarkdown.getMarkdown()
          //
          //   $.ajax({
          //     url: '/admin/article/add.html',
          //     method: 'post',
          //     data: data.field,
          //     dataType: 'JSON',
          //     success: function(res) {
          //       if (res.code == '0') {
          //         parent.layui.table.reload('LAY-app-content-list'); //重载表格
          //         parent.layer.close(index); //再执行关闭
          //         layer.alert(res.msg);
          //       } else
          //         layer.alert(res.msg);
          //     },
          //     error: function(data) {}
          //   });
          //
          //
          //   // obj.update({
          //   //   label: field.label
          //   //   ,title: field.title
          //   //   ,author: field.author
          //   //   ,status: field.status
          //   // }); //数据更新
          //
          //   form.render();
          //   layer.close(index); //关闭弹层
          // });
          //
          // submit.trigger('click');
        }
      });
    }
  });

  //分类管理
  table.render({
    elem: '#LAY-app-content-tags'
    ,url: layui.setter.base + 'json/content/tags.js' //模拟接口
    ,cols: [[
      {type: 'numbers', fixed: 'left'}
      ,{field: 'id', width: 100, title: 'ID', sort: true}
      ,{field: 'tags', title: '分类名', minWidth: 100}
      ,{title: '操作', width: 150, align: 'center', fixed: 'right', toolbar: '#layuiadmin-app-cont-tagsbar'}
    ]]
    ,text: '对不起，加载出现异常！'
  });
  
  //监听工具条
  table.on('tool(LAY-app-content-tags)', function(obj){
    var data = obj.data;
    if(obj.event === 'del'){
      layer.confirm('确定删除此分类？', function(index){
        obj.del();
        layer.close(index);
      });
    } else if(obj.event === 'edit'){
      var tr = $(obj.tr);
      layer.open({
        type: 2
        ,title: '编辑分类'
        ,content: '../../../views/app/content/tagsform.html?id='+ data.id
        ,area: ['450px', '200px']
        ,btn: ['确定', '取消']
        ,yes: function(index, layero){
          //获取iframe元素的值
          var othis = layero.find('iframe').contents().find("#layuiadmin-app-form-tags")
          ,tags = othis.find('input[name="tags"]').val();
          
          if(!tags.replace(/\s/g, '')) return;
          
          obj.update({
            tags: tags
          });
          layer.close(index);
        }
        ,success: function(layero, index){
          //给iframe元素赋值
          var othis = layero.find('iframe').contents().find("#layuiadmin-app-form-tags").click();
          var iframeWin = window[layero.find('iframe')[0]['name']];
          
          iframeWin.layui.use('form', function(form){
            form.val('layuiadmin-form-tags', {
              tags: data.tags
            })
          });
          //othis.find('input[name="tags"]').val(data.tags);
        }
      });
    }
  });

  //评论管理
  table.render({
    elem: '#LAY-app-content-comm'
    ,url: layui.setter.base + 'json/content/comment.js' //模拟接口
    ,cols: [[
      {type: 'checkbox', fixed: 'left'}
      ,{field: 'id', width: 100, title: 'ID', sort: true}
      ,{field: 'reviewers', title: '评论者', minWidth: 100}
      ,{field: 'content', title: '评论内容', minWidth: 100}
      ,{field: 'commtime', title: '评论时间', minWidth: 100, sort: true}
      ,{title: '操作', width: 150, align: 'center', fixed: 'right', toolbar: '#table-content-com'}
    ]]
    ,page: true
    ,limit: 10
    ,limits: [10, 15, 20, 25, 30]
    ,text: '对不起，加载出现异常！'
  });
  
  //监听工具条
  table.on('tool(LAY-app-content-comm)', function(obj){
    var data = obj.data;
    if(obj.event === 'del'){
      layer.confirm('确定删除此条评论？', function(index){
        obj.del();
        layer.close(index);
      });
    } else if(obj.event === 'edit') {
      layer.open({
        type: 2
        ,title: '编辑评论'
        ,content: '../../../views/app/content/contform.html'
        ,area: ['450px', '300px']
        ,btn: ['确定', '取消']
        ,yes: function(index, layero){
          var iframeWindow = window['layui-layer-iframe'+ index]
          ,submitID = 'layuiadmin-app-comm-submit'
          ,submit = layero.find('iframe').contents().find('#'+ submitID);

          //监听提交
          iframeWindow.layui.form.on('submit('+ submitID +')', function(data){
            var field = data.field; //获取提交的字段
            
            //提交 Ajax 成功后，静态更新表格中的数据
            //$.ajax({});
            table.reload('LAY-app-content-comm'); //数据刷新
            layer.close(index); //关闭弹层
          });  
          
          submit.trigger('click');
        }
        ,success: function(layero, index){
          
        }
      });
    }
  });

  exports('orderlist', {})
});