/**
 @Name：slide 单品分类
 @Author：star1029
 @Site：http://www.layui.com/admin/
 @License：LPPL
    
 */

layui.define(['table', 'form'], function(exports){
  var $ = layui.$
  ,table = layui.table
  ,form = layui.form;

	//站点管理
	table.render({
	  elem: '#LAY-slide-back'
	  ,url: '/admin/slide/getlist.html'
	  ,cols: [[
	  	{type: 'checkbox', fixed: 'left'}
	    ,{field: 'id', title: 'ID', sort: true}
		,{field: 'title',title: '名称'}
		,{field: 'thumb',title: '缩略图', templet: '#thumbTpl', align: 'center'}
		,{field: 'sort', title: '排序'}
		,{field: 'link', title: '链接'}
	    ,{title: '操作', align: 'center', fixed: 'right', toolbar: '#table-slide-admin'}
	  ]]
	  ,text:{ none:'暂无相关数据'}
	});
	
	//监听工具条
	table.on('tool(LAY-slide-back)', function(obj){
	  var data = obj.data;
	  if(obj.event === 'del'){
			
			layer.confirm('确定删除？', function(index){
				$.ajax({
						url:'/admin/slide/delete.html',
						method:'post',
						data:{'id':data['id']},
						dataType:'JSON',
						success:function(res){
								if(res.code == '0'){
										obj.del();
										layer.close(index);
										layer.alert(res.msg);
								}
								else
										layer.alert(res.msg);
						},
						error:function (data) {
						}
				});
	
			}); 
			
	  }else if(obj.event === 'edit'){
	    var tr = $(obj.tr);
	
	    layer.open({
	      type: 2
	      ,title: '编辑'
	      ,content: '/admin/slide/edit/id/'+data['id']+'.html'
				,maxmin: true
	      ,area: ['600px', '630px']
	      ,btn: ['确定', '取消']
	      ,yes: function(index, layero){
	        var iframeWindow = window['layui-layer-iframe'+ index]
	        ,submit = layero.find('iframe').contents().find("#LAY-slide-back-submit");
	
	        //监听提交
	        iframeWindow.layui.form.on('submit(LAY-slide-back-submit)', function(data){
	          //提交 Ajax 成功后，静态更新表格中的数据
	          $.ajax({
	          		url:'/admin/slide/edit.html',
	          		method:'post',
	          		data:data.field,
	          		dataType:'JSON',
	          		success:function(res){
	          				if(res.code == '0'){
	          						table.reload('LAY-slide-back'); //数据刷新
	          						layer.close(index); //关闭弹层
												layer.alert(res.msg);
	          				}
	          				else
	          						layer.alert(res.msg);
	          		},
	          		error:function (data) {
	          		}
	          });
	        });  
	        
	        submit.trigger('click');
	      }
	      ,success: function(layero, index){
	      
	      }
	    })
	  }
	});

  exports('slide', {})
});