/*
 Navicat Premium Dump SQL

 Source Server         : test_ai888_site
 Source Server Type    : MySQL
 Source Server Version : 50744 (5.7.44-log)
 Source Host           : 103.8.70.31:3306
 Source Schema         : test_ai888_site

 Target Server Type    : MySQL
 Target Server Version : 50744 (5.7.44-log)
 File Encoding         : 65001

 Date: 13/12/2024 20:32:09
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for PREFIX_account
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_account`;
CREATE TABLE `PREFIX_account`  (
  `id` bigint(25) NOT NULL DEFAULT 0,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '用户名',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '邮箱',
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '密码',
  `remember_token` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '记住token',
  `login_ip` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '登录IP',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  `login_time` datetime NULL DEFAULT NULL COMMENT '最近登录时间',
  `phone` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '手机号',
  `create_time` datetime NULL DEFAULT NULL COMMENT '注册时间',
  `create_ip` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '注册ip',
  `avatar` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '头像',
  `current_level_id` bigint(22) UNSIGNED NULL DEFAULT 1,
  `current_package_id` bigint(22) UNSIGNED NULL DEFAULT NULL,
  `package_expiry_date` int(11) NULL DEFAULT 0 COMMENT '-1永久 0时间无 ',
  `author_permissions` int(5) UNSIGNED NULL DEFAULT 0,
  `admin_id` bigint(22) UNSIGNED NULL DEFAULT 0 COMMENT '0无关联 其他关联',
  UNIQUE INDEX `name`(`name`, `email`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '注册用户表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_account
-- ----------------------------
INSERT INTO `PREFIX_account` VALUES (1, 'admin', '2206691630@qq.com', '21232f297a57a5a743894a0e4a801fc3', '57cc6a662051324a55298c4131038aa7', '119.123.238.223', '2024-12-09 10:54:40', '2024-12-13 20:12:29', NULL, NULL, NULL, '/public/sysImg/chushiTouXiang.png', 1, NULL, 0, 1, 1);

-- ----------------------------
-- Table structure for PREFIX_account_level
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_account_level`;
CREATE TABLE `PREFIX_account_level`  (
  `level_id` bigint(22) NOT NULL,
  `level_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `benefits` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '等级描述',
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `icon` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `is_show_icon` tinyint(2) NULL DEFAULT 1 COMMENT '1显示  0 不显示',
  PRIMARY KEY (`level_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_account_level
-- ----------------------------
INSERT INTO `PREFIX_account_level` VALUES (1, '注册用户', '333', '2024-01-03 00:00:00', '2024-02-03 00:00:00', NULL, 0);
INSERT INTO `PREFIX_account_level` VALUES (2, '会员', '付费的会员', '2024-01-03 00:00:00', '2024-01-03 00:00:00', '/template/default/skin/images/VIP-ICO.png', 1);

-- ----------------------------
-- Table structure for PREFIX_account_level_package
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_account_level_package`;
CREATE TABLE `PREFIX_account_level_package`  (
  `package_id` bigint(22) UNSIGNED NOT NULL COMMENT '套餐的唯一标识',
  `package_name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '套餐名称，例如“年度白金套餐”',
  `price` decimal(10, 2) NOT NULL COMMENT '套餐价格',
  `duration` int(11) NOT NULL COMMENT '套餐有效期（天）',
  `features` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '套餐的具体权益描述',
  `level_id` bigint(22) NULL DEFAULT NULL COMMENT '关联到会员等级表的外键，以指明该套餐适用的会员等级',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `updated_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`package_id`) USING BTREE,
  INDEX `level_id`(`level_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_account_level_package
-- ----------------------------
INSERT INTO `PREFIX_account_level_package` VALUES (1, '月度会员', 10.00, 30, '一个月', 2, '2024-11-20 18:41:33', '2024-11-26 18:50:50');
INSERT INTO `PREFIX_account_level_package` VALUES (2, '季度会员(3个月)', 30.00, 90, '3个月', 2, '2024-11-20 18:41:33', '2024-11-20 18:42:57');
INSERT INTO `PREFIX_account_level_package` VALUES (3, '年度会员', 120.00, 365, '12个月', 2, '2024-11-20 18:41:33', '2024-11-23 01:07:31');
INSERT INTO `PREFIX_account_level_package` VALUES (4, '永久会员', 300.00, -1, '12个月', 2, '2024-11-20 18:41:33', '2024-11-25 22:48:23');

-- ----------------------------
-- Table structure for PREFIX_article
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article`;
CREATE TABLE `PREFIX_article`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '文章id',
  `title` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '标题',
  `intro` varchar(1024) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '简介',
  `content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容',
  `content_html` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容html',
  `cate_id` bigint(20) NULL DEFAULT NULL COMMENT '分类id',
  `num_views` int(8) NULL DEFAULT 0 COMMENT '观看次数',
  `sort` int(8) NULL DEFAULT 0 COMMENT '排序',
  `create_time` datetime NULL DEFAULT NULL COMMENT '创建时间',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  `status` tinyint(4) NULL DEFAULT NULL COMMENT '1正常 0无效',
  `is_download` tinyint(4) NULL DEFAULT NULL COMMENT '1有下载  2没下载 是否下载链接 ',
  `netdisk_name` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '网盘名',
  `download_href` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '下载链接',
  `netdisk_passwd` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '网盘密码',
  `pic` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '主图',
  `author` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '作者',
  `is_directory` tinyint(4) UNSIGNED NULL DEFAULT 0 COMMENT '1开启 0关闭',
  `html_script` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '自定义代码',
  `ac_id` bigint(22) NULL DEFAULT 0 COMMENT '用户id',
  `original_link` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NULL DEFAULT '1' COMMENT '是否原创 原创链接',
  `permission` json NULL,
  `num_download` int(8) UNSIGNED NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 120 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_unicode_ci COMMENT = '文章表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article
-- ----------------------------
INSERT INTO `PREFIX_article` VALUES (115, '欢迎使用WhaleCMS-鲸鱼博客CMS系统，这是您的第一篇初始文章', '欢迎使用WhaleCMS-鲸鱼博客CMS系统，本系统所有功能全部免费开放，后续会持续更新更多功能，敬请期待。', '\n鲸鱼博客CMS系统-文章发布功能，采用腾讯开源的cherry-markdown，功能强大的富文本编辑器，专注于 Markdown 格式的文本编辑。它提供了直观的用户界面和丰富的编辑功能，适合需要高效撰写和管理 Markdown 文档的用户。Markdown是一种轻量级的标记语言，使用纯文本格式编写文档，易读易写且格式美观。本文将介绍Markdown的基本语法，帮助您在**鲸鱼博客CMS系统**中开始创作。\n\n## 字体样式\n\n**说明**\n\n- 使用`*(或_)` 和 `**(或__)` 表示*斜体*和 **粗体**\n- 使用 `/` 表示 /下划线/ ,使用`~~` 表示~~删除线~~\n- 使用`^(或^^)`表示^上标^或^^下标^^\n- 使用 ! 号+数字 表示字体 !24 大! !12 小! [^专有语法提醒]\n- 使用两个(三个)!号+RGB 颜色 表示!!#ff0000 字体颜色!!(!!!#f9cb9c 背景颜色!!!)[^专有语法提醒]\n\n**示例**\n\n```markdown\n[!!#ff0000 红色超链接!!](http://www.qq.com)\n[!!#ffffff !!!#000000 黑底白字超链接!!!!!](http://www.qq.com)\n[新窗口打开](http://www.qq.com){target=_blank}\n鞋子 !32 特大号!\n大头 ^`儿子`^ 和小头 ^^`爸爸`^^\n爱在~~西元前~~**当下**\n```\n\n**效果**\n[!!#ff0000 红色超链接!!](http://www.qq.com)\n[!!#ffffff !!!#000000 黑底白字超链接!!!!!](http://www.qq.com)\n[新窗口打开](http://www.qq.com){target=_blank}\n鞋子 !32 特大号!\n大头 ^`儿子`^ 和小头 ^^`爸爸`^^\n爱在~~西元前~~**当下**\n\n---\n\n## 标题设置\n\n**说明**\n\n- 在文字下方加 === 可使上一行文字变成一级标题\n- 在文字下方加 --- 可使上一行文字变成二级标题\n- 在行首加井号（#）表示不同级别的标题，例如：# H1, ##H2, ###H3\n\n---\n\n## 超链接\n\n**说明**\n\n- 使用 `[描述](URL)` 为文字增加外链接\n- 使用`&lt;URL&gt;`插入一个链接\n- URL 会自动转成链接\n\n**示例**\n\n```markdown\n这是 [腾讯网](https://www.qq.com) 的链接。\n这是 [一个引用的][引用一个链接] 的链接。\n这是一个包含中文的链接&lt;https://www.qq.com?param=中文&gt;，中文\n直接识别成链接：https://www.qq.com?param=中文，中文 用空格结束\n[引用一个链接]\n[引用一个链接]: https://www.qq.com\n```\n\n**效果**\n这是 [腾讯网](https://www.qq.com) 的链接。\n这是 [一个引用的][引用一个链接] 的链接。\n这是一个包含中文的链接&lt;https://www.qq.com?param=中文&gt;，中文\n直接识别成链接：&lt;https://www.qq.com?param=中文，中文&gt; 用空格结束\n[引用一个链接]\n[引用一个链接]: &lt;https://www.qq.com&gt;\n\n---\n\n## 无序列表\n\n**说明**\n\n- 在行首使用 \\*，+，- 表示无序列表\n\n**示例**\n\n```markdown\n- 无序列表项 一`默认`\n- 无序列表项 二\n  - 无序列表2.1\n  - 无序列表2.2\n- 无序列表项 三\n  + 无序列表3.1`空心圆`\n  + 无序列表3.1\n- 无序列表四\n  * 无序列表4.1`实心方块`\n  * 无序列表4.2\n```\n\n**效果**\n\n- 无序列表项 一`默认`\n- 无序列表项 二\n  - 无序列表2.1\n  - 无序列表2.2\n- 无序列表项 三\n  - 无序列表3.1`空心圆`\n  - 无序列表3.1\n- 无序列表四\n  - 无序列表4.1`实心方块`\n  - 无序列表4.2\n\n---\n\n## 有序列表\n\n**说明**\n\n- 在行首使用数字、字母、汉字和点表示有序列表\n\n**示例**\n\n```markdown\n1. 有序列表项 一`阿拉伯数字`\n1. 有序列表项 二\n  I. 有序列表项 2.1`罗马数字`\n  I. 有序列表项 2.2\n  I. 有序列表项 2.3\n1. 有序列表 三\n  a. 有序列表3.1`希腊字母`\n  a. 有序列表3.2\n  a. 有序列表3.3\n1. 有序列表 四\n  一. 有序列表4.1`中文数字`\n  一. 有序列表4.2\n  一. 有序列表4.3\n```\n\n**效果**\n\n1. 有序列表项 一`阿拉伯数字`\n1. 有序列表项 二\n  I. 有序列表项 2.1`罗马数字`\n  I. 有序列表项 2.2\n  I. 有序列表项 2.3\n1. 有序列表 三\n  a. 有序列表3.1`希腊字母`\n  a. 有序列表3.2\n  a. 有序列表3.3\n1. 有序列表 四\n  一. 有序列表4.1`中文数字`\n  一. 有序列表4.2\n  一. 有序列表4.3\n\n---\n\n## 引用\n\n**说明**\n\n- 在行首使用 &gt; 表示文字引用\n\n**示例**\n\n```markdown\n&gt; 野火烧不尽，春风吹又生\n```\n\n**效果**\n\n&gt; 野火烧不尽，春风吹又生\n\n---\n\n## 行内代码\n\n**说明**\n\n- 使用 \\`代码` 表示行内代码\n\n**示例**\n\n```\n让我们聊聊 `html`\n```\n\n**效果**\n让我们聊聊 `html`\n\n---\n\n## 代码块\n\n**说明**\n\n- 使用 三个` 表示代码块\n\n**效果**\n\n```markdown\n    这是一个代码块\n    有两行\n```\n---\n\n# 高阶语法手册\n\n---\n\n## 目录\n\n**说明**\n\n- 使用`[[toc]]`，会自动生成一个页面目录，目录内容由一级、二级、三级标题组成\n\n---\n\n## 信息面板\n\n**说明**\n使用连续三个冒号`:::`和关键字（`[primary | info | warning | danger | success]`）来声明\n\n```markdown\n:::primary // [primary | info | warning | danger | success] 标题\n内容\n:::\n```\n\n**效果**\n:::p 标题\n内容\n:::\n:::success\n内容\n:::\n\n---\n\n## 手风琴\n\n**说明**\n使用连续三个加号`+++`和关键字（`[ + | - ]`）来声明，关键字`+`表示默认收起，关键字`-`表示默认展开\n\n```markdown\n+++ 点击展开更多\n内容\n++- 默认展开\n内容\n++ 默认收起\n内容\n+++\n```\n\n**效果**\n+++ 点击展开更多\n内容\n++- 默认展开\n内容\n++ 默认收起\n内容\n+++\n\n---\n\n## 语法高亮\n\n**说明**\n\n- 在```后面指明语法名\n- 加强的代码块，支持四十一种编程语言的语法高亮的显示\n\n**效果**\n非代码示例：\n\n```bash\nsudo apt-get install vim-gnome\n```\n\nPython 示例：\n\n```python\n@requires_authorization\ndef somefunc(param1=&amp;#039;&amp;#039;, param2=0):\n    &amp;#039;&amp;#039;&amp;#039;A docstring&amp;#039;&amp;#039;&amp;#039;\n    if param1 &gt; param2: # interesting\n        print &amp;#039;Greater&amp;#039;\n    return (param2 - param1 + 1) or None\n\nclass SomeClass:\n    pass\n\n&gt;&gt;&gt; message = &amp;#039;&amp;#039;&amp;#039;interpreter\n... prompt&amp;#039;&amp;#039;&amp;#039;\n```\n\nJavaScript 示例：\n\n```javascript\n/**\n * nth element in the fibonacci series.\n * @param n &gt;= 0\n * @return the nth element, &gt;= 0.\n */\nfunction fib(n) {\n  var a = 1,\n    b = 1;\n  var tmp;\n  while (--n &gt;= 0) {\n    tmp = a;\n    a += b;\n    b = tmp;\n  }\n  return a;\n}\n\ndocument.write(fib(10));\n\n```\n\n---\n\n## checklist[^不通用提醒]\n\n**说明**\n\n- 输入`[ ]`或`[x]`，就会生成一个 checklist\n\n**示例**\n\n```markdown\n- [ ] AAA\n- [x] BBB\n- [ ] CCC\n```\n\n**效果**\n\n- [ ] AAA\n- [x] BBB\n- [ ] CCC\n\n---\n\n## 带对齐功能的表格\n**说明**\n- 一种比较通用的markdown表格语法\n\n**示例**\n\n```markdown\n|项目（居中对齐）|价格（右对齐）|数量（左对齐）|\n|:-:|-:|:-|\n|计算机|￥1600|5|\n|手机机|￥12|50|\n```\n\n**效果**\n\n|项目（居中对齐）|价格（右对齐）|数量（左对齐）|\n|:-:|-:|:-|\n|计算机|￥1600|5|\n|手机机|￥12|50|\n\n-----\n\n## 流程图[^不通用提醒]\n\n**说明**\n- 访问[Mermaid 流程图](https://mermaid-js.github.io/mermaid/#/flowchart)参考具体使用方法。\n\n**效果**\n小明老婆让小明下班时买一斤包子，如果遇到卖西瓜的，买一个。\n\n左右结构\n\n```mermaid\ngraph LR\n    A[公司] --&gt;| 下 班 | B(菜市场)\n    B --&gt; C{看见&lt;br&gt;卖西瓜的}\n    C --&gt;|Yes| D[买一个包子]\n    C --&gt;|No| E[买一斤包子]\n```\n\n上下结构\n\n```mermaid\ngraph TD\n    A[公司] --&gt;| 下 班 | B(菜市场)\n    B --&gt; C{看见&lt;br&gt;卖西瓜的}\n    C --&gt;|Yes| D[买一个包子]\n    C --&gt;|No| E[买一斤包子]\n```\n\n-----\n\n## 时序图[^不通用提醒]\n**说明**\n- 访问[Mermaid 时序图](https://mermaid-js.github.io/mermaid/#/sequenceDiagram)参考具体使用方法\n\n**效果**\n\n```mermaid\nsequenceDiagram\nA--&gt;A: 文本1\nA-&gt;&gt;B: 文本2\nloop 循环1\nloop 循环2\nA-&gt;B: 文本3\nend\nloop 循环3\nB --&gt;&gt;A: 文本4\nend\nB --&gt;&gt; B: 文本5\nend\n```\n\n-----\n\n## 状态图[^不通用提醒]\n**说明**\n- 访问[Mermaid 状态图](https://mermaid-js.github.io/mermaid/#/stateDiagram)参考具体使用方法\n\n**效果**\n\n```mermaid\nstateDiagram\n[*] --&gt; A\nA --&gt; B\nA --&gt; C\nstate A {\n    [*] --&gt; D\n    D --&gt; [*]\n}\nB --&gt; [*]\nC --&gt; [*]\n```\n\n-----\n\n## UML图[^不通用提醒]\n**说明**\n- 访问[Mermaid UML图](https://mermaid-js.github.io/mermaid/#/classDiagram)参考具体使用方法\n\n**效果**\n\n```mermaid\nclassDiagram\nBase &lt;|-- One\nBase &lt;|-- Two\nBase : +String name\nBase: +getName()\nBase: +setName(String name)\nclass One{\n  +String newName\n  +getNewName()\n}\nclass Two{\n  -int id\n  -getId()\n}\n```\n\n-----\n\n## 饼图[^不通用提醒]\n**说明**\n- 访问[Mermaid 饼图](https://mermaid-js.github.io/mermaid/#/pie)参考具体使用方法\n\n**效果**\n\n```mermaid\npie\ntitle 饼图\n&quot;A&quot; : 40\n&quot;B&quot; : 30\n&quot;C&quot; : 20\n&quot;D&quot; : 10\n```\n\n-----\n\n## 注释[^不通用提醒]\n**说明**\n- 使用中括号+冒号（[]:）生成单行注释\n- 使用中括号+尖号+冒号（[^]:）生成多行注释\n- 多行注释以连续两次回车结束\n\n**示例**\n\n```markdown\n下面是一行单行注释\n[注释摘要]: 这是一段注释，不会显示到页面上\n上面面是一行单行注释\n下面是多行注释\n[^注释摘要]: 这是一段多行注释，不会显示到页面上\n可以换行\n    可以缩进\n以两次回车结束\n\n上面是多行注释\n```\n\n**效果**\n下面是一行单行注释\n[注释摘要]: 这是一段注释，不会显示到页面上\n上面面是一行单行注释\n下面是多行注释\n[^注释摘要]: 这是一段多行注释，不会显示到页面上\n可以换行\n    可以缩进\n以两次回车结束\n\n上面是多行注释\n\n-----\n\n## 快捷键\n\n| 功能| 按键(Windows) | 按键(macOS) |\n|--|--|\n|1级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;1&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;1&lt;/kbd&gt;|\n|2级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;2&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;2&lt;/kbd&gt;|\n|3级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;3&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;3&lt;/kbd&gt;|\n|4级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;4&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;4&lt;/kbd&gt;|\n|5级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;5&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;5&lt;/kbd&gt;|\n|6级标题|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;6&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;6&lt;/kbd&gt;|\n|加粗|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;b&lt;/kbd&gt;|    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;b&lt;/kbd&gt;|\n|斜体|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;i&lt;/kbd&gt; |    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;i&lt;/kbd&gt;|\n|插入链接|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;l&lt;/kbd&gt; |    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;l&lt;/kbd&gt;|\n|插入代码块|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;k&lt;/kbd&gt; |    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;k&lt;/kbd&gt;|\n|插入图片|     &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;g&lt;/kbd&gt; |    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;g&lt;/kbd&gt;|\n|插入公式|    &lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;m&lt;/kbd&gt; |    &lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;m&lt;/kbd&gt;|\n\n## 协议\n\n```\n/**\n * Tencent is pleased to support the open source community by making CherryMarkdown available.\n *\n * Copyright (C) 2021 THL A29 Limited, a Tencent company. All rights reserved.\n * The below software in this distribution may have been modified by THL A29 Limited (&quot;Tencent Modifications&quot;).\n *\n * All Tencent Modifications are Copyright (C) THL A29 Limited.\n *\n * CherryMarkdown is licensed under the Apache License, Version 2.0 (the &quot;License&quot;);\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\n```\n\n\n\n\n', '&lt;div data-inline-code-theme=&quot;red&quot; data-code-block-theme=&quot;default&quot;&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;91837be7403e9599d123099fcc2561932&quot; class=&quot;&quot;&gt;鲸鱼博客CMS系统-文章发布功能，采用腾讯开源的cherry-markdown，功能强大的富文本编辑器，专注于 Markdown 格式的文本编辑。它提供了直观的用户界面和丰富的编辑功能，适合需要高效撰写和管理 Markdown 文档的用户。Markdown是一种轻量级的标记语言，使用纯文本格式编写文档，易读易写且格式美观。本文将介绍Markdown的基本语法，帮助您在&lt;strong&gt;鲸鱼博客CMS系统&lt;/strong&gt;中开始创作。&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;b45af2a8be81e06f00644e610a18e1db&quot; id=&quot;%E5%AD%97%E4%BD%93%E6%A0%B7%E5%BC%8F&quot; class=&quot;cherry-highlight-line&quot;&gt;&lt;a href=&quot;#%E5%AD%97%E4%BD%93%E6%A0%B7%E5%BC%8F&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;字体样式&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot; class=&quot;&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;e2831dbc62e4c090ec9d7ed86620bbdc&quot; data-lines=&quot;6&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用&lt;code&gt;*(或_)&lt;/code&gt; 和 &lt;code&gt;**(或__)&lt;/code&gt; 表示&lt;em&gt;斜体&lt;/em&gt;和 &lt;strong&gt;粗体&lt;/strong&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用 &lt;code&gt;/&lt;/code&gt; 表示 &lt;span style=&quot;text-decoration: underline;&quot;&gt;下划线&lt;/span&gt; ,使用&lt;code&gt;~~&lt;/code&gt; 表示&lt;del&gt;删除线&lt;/del&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用&lt;code&gt;^(或^^)&lt;/code&gt;表示&lt;sup&gt;上标&lt;/sup&gt;或&lt;sub&gt;下标&lt;/sub&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用 ! 号+数字 表示字体 &lt;span style=&quot;font-size:24px;line-height:1em;&quot;&gt;大&lt;/span&gt; &lt;span style=&quot;font-size:12px;line-height:1em;&quot;&gt;小&lt;/span&gt; [^专有语法提醒]&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用两个(三个)!号+RGB 颜色 表示&lt;span style=&quot;color:#ff0000&quot;&gt;字体颜色&lt;/span&gt;(&lt;span style=&quot;background-color:#f9cb9c&quot;&gt;背景颜色&lt;/span&gt;)[^专有语法提醒]&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;0d3a074caecf3d070203e9284ca7caa1&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;9&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url&quot;&gt;[&lt;span class=&quot;token content&quot;&gt;!!#ff0000 红色超链接!!&lt;/span&gt;](&lt;span class=&quot;token url&quot;&gt;http://www.qq.com&lt;/span&gt;)&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url&quot;&gt;[&lt;span class=&quot;token content&quot;&gt;!!#ffffff !!!#000000 黑底白字超链接!!!!!&lt;/span&gt;](&lt;span class=&quot;token url&quot;&gt;http://www.qq.com&lt;/span&gt;)&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url&quot;&gt;[&lt;span class=&quot;token content&quot;&gt;新窗口打开&lt;/span&gt;](&lt;span class=&quot;token url&quot;&gt;http://www.qq.com&lt;/span&gt;)&lt;/span&gt;{target=_blank}&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;鞋子 !32 特大号!&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;大头 ^&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`儿子`&lt;/span&gt;^ 和小头 ^^&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`爸爸`&lt;/span&gt;^^&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;爱在&lt;span class=&quot;token strike&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;~~&lt;/span&gt;&lt;span class=&quot;token content&quot;&gt;西元前&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;~~&lt;/span&gt;&lt;/span&gt;&lt;span class=&quot;token bold&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;**&lt;/span&gt;&lt;span class=&quot;token content&quot;&gt;当下&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;**&lt;/span&gt;&lt;/span&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;8&quot; data-type=&quot;p&quot; data-sign=&quot;d86465cd181fffd22f39d59df4be51408&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;&lt;a href=&quot;/goJump.html?type=10&amp;href=http://www.qq.com&quot;&gt;&lt;span style=&quot;color:#ff0000&quot;&gt;红色超链接&lt;/span&gt;&lt;/a&gt;&lt;br&gt;&lt;a href=&quot;/goJump.html?type=10&amp;href=http://www.qq.com&quot;&gt;&lt;span style=&quot;color:#ffffff&quot;&gt;&lt;span style=&quot;background-color:#000000&quot;&gt;黑底白字超链接&lt;/span&gt;&lt;/span&gt;&lt;/a&gt;&lt;br&gt;&lt;a target=&quot;_blank&quot; href=&quot;/goJump.html?type=10&amp;href=http://www.qq.com&quot;&gt;新窗口打开&lt;/a&gt;&lt;br&gt;鞋子 &lt;span style=&quot;font-size:32px;line-height:1em;&quot;&gt;特大号&lt;/span&gt;&lt;br&gt;大头 &lt;sup&gt;&lt;code&gt;儿子&lt;/code&gt;&lt;/sup&gt; 和小头 &lt;sub&gt;&lt;code&gt;爸爸&lt;/code&gt;&lt;/sub&gt;&lt;br&gt;爱在&lt;del&gt;西元前&lt;/del&gt;&lt;strong&gt;当下&lt;/strong&gt;&lt;/p&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;b0b805be3eed5d07ae5cd5d883648a8d&quot; id=&quot;%E6%A0%87%E9%A2%98%E8%AE%BE%E7%BD%AE&quot;&gt;&lt;a href=&quot;#%E6%A0%87%E9%A2%98%E8%AE%BE%E7%BD%AE&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;标题设置&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;61d18f4a2299ed23a3037f887f148c5f&quot; data-lines=&quot;4&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在文字下方加 === 可使上一行文字变成一级标题&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在文字下方加 --- 可使上一行文字变成二级标题&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在行首加井号（#）表示不同级别的标题，例如：# H1, ##H2, ###H3&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;39a552653822d51beb7505bd5164f270&quot; id=&quot;%E8%B6%85%E9%93%BE%E6%8E%A5&quot;&gt;&lt;a href=&quot;#%E8%B6%85%E9%93%BE%E6%8E%A5&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;超链接&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;637b635059761242b28f867f2b9a898f&quot; data-lines=&quot;4&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用 &lt;code&gt;[描述](URL)&lt;/code&gt; 为文字增加外链接&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用&lt;code&gt;&amp;lt;URL&amp;gt;&lt;/code&gt;插入一个链接&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;URL 会自动转成链接&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;a573172dd1d4e14abfd28abe0806c7bd&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;9&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;这是 &lt;span class=&quot;token url&quot;&gt;[&lt;span class=&quot;token content&quot;&gt;腾讯网&lt;/span&gt;](&lt;span class=&quot;token url&quot;&gt;https://www.qq.com&lt;/span&gt;)&lt;/span&gt; 的链接。&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;这是 &lt;span class=&quot;token url&quot;&gt;[&lt;span class=&quot;token content&quot;&gt;一个引用的&lt;/span&gt;][&lt;span class=&quot;token variable&quot;&gt;引用一个链接&lt;/span&gt;]&lt;/span&gt; 的链接。&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;这是一个包含中文的链接&amp;lt;https://www.qq.com?param=中文&amp;gt;，中文&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;直接识别成链接：https://www.qq.com?param=中文，中文 用空格结束&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;[引用一个链接]&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url-reference url&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;[&lt;/span&gt;&lt;span class=&quot;token variable&quot;&gt;引用一个链接&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;]&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;:&lt;/span&gt; https://www.qq.com&lt;/span&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;7&quot; data-type=&quot;p&quot; data-sign=&quot;a18a603b5b8f43c5a81d88ea3104c5dd7&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;这是 &lt;a href=&quot;/goJump.html?type=10&amp;href=https://www.qq.com&quot;&gt;腾讯网&lt;/a&gt; 的链接。&lt;br&gt;这是 &lt;a href=&quot;&lt;https://www.qq.com&gt;&quot;&gt;一个引用的&lt;/a&gt; 的链接。&lt;br&gt;这是一个包含中文的链接&lt;a title=&quot;https://www.qq.com?param=中文&quot; href=&quot;/goJump.html?type=10&amp;href=https://www.qq.com?param=%E4%B8%AD%E6%96%87&quot;&gt;https://www.qq.com?param=中文&lt;/a&gt;，中文&lt;br&gt;直接识别成链接：&lt;a title=&quot;https://www.qq.com?param=中文，中文&quot; href=&quot;/goJump.html?type=10&amp;href=https://www.qq.com?param=%E4%B8%AD%E6%96%87%EF%BC%8C%E4%B8%AD%E6%96%87&quot;&gt;https://www.qq.com?param=中文，中文&lt;/a&gt; 用空格结束&lt;br&gt;&lt;a href=&quot;&lt;https://www.qq.com&gt;&quot;&gt;引用一个链接&lt;/a&gt;&lt;/p&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;br&quot; data-sign=&quot;br2&quot;&gt;&amp;nbsp;&lt;/p&gt;&lt;hr data-lines=&quot;1&quot; data-sign=&quot;hr1&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;f6d2ae9402c9847dda26aebefd9e35ed&quot; id=&quot;%E6%97%A0%E5%BA%8F%E5%88%97%E8%A1%A8&quot;&gt;&lt;a href=&quot;#%E6%97%A0%E5%BA%8F%E5%88%97%E8%A1%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;无序列表&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;587a764897a47ece9c3f241b780162e7&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在行首使用 *，+，- 表示无序列表&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;2e2fab2889b8d7782038601860d209c1&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;13&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表项 一&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`默认`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表项 二&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表2.1&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表2.2&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表项 三&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;+&lt;/span&gt; 无序列表3.1&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`空心圆`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;+&lt;/span&gt; 无序列表3.1&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; 无序列表四&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;*&lt;/span&gt; 无序列表4.1&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`实心方块`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token list punctuation&quot;&gt;*&lt;/span&gt; 无序列表4.2&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;4f07bab02693ce1b70decba5861c01f3&quot; data-lines=&quot;11&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表项 一&lt;code&gt;默认&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表项 二&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表2.1&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表2.2&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表项 三&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表3.1&lt;code&gt;空心圆&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表3.1&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表四&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表4.1&lt;code&gt;实心方块&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;无序列表4.2&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;/ul&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;251bbb896cb67e1fbb6e12ad26b2e73d&quot; id=&quot;%E6%9C%89%E5%BA%8F%E5%88%97%E8%A1%A8&quot;&gt;&lt;a href=&quot;#%E6%9C%89%E5%BA%8F%E5%88%97%E8%A1%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;有序列表&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;890d1cebab210bb9f267d73e9fb0aca4&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在行首使用数字、字母、汉字和点表示有序列表&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;d99c22c47c5d29ee04b635313feb4803&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;16&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-unExpand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;1.&lt;/span&gt; 有序列表项 一&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`阿拉伯数字`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;1.&lt;/span&gt; 有序列表项 二&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  I. 有序列表项 2.1&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`罗马数字`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  I. 有序列表项 2.2&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  I. 有序列表项 2.3&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;1.&lt;/span&gt; 有序列表 三&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  a. 有序列表3.1&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`希腊字母`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  a. 有序列表3.2&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  a. 有序列表3.3&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;1.&lt;/span&gt; 有序列表 四&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  一. 有序列表4.1&lt;span class=&quot;token code-snippet code keyword&quot;&gt;`中文数字`&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  一. 有序列表4.2&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  一. 有序列表4.3&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;div class=&quot;cherry-mask-code-block&quot;&gt;\n        &lt;div class=&quot;expand-btn &quot;&gt;\n          &lt;i class=&quot;ch-icon ch-icon-expand&quot;&gt;&lt;/i&gt;\n        &lt;/div&gt;\n      &lt;/div&gt;&lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;ol class=&quot;cherry-list__default&quot; start=&quot;1&quot; data-sign=&quot;8d549d8fb24e29c856491440a6badae9&quot; data-lines=&quot;14&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表项 一&lt;code&gt;阿拉伯数字&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表项 二&lt;/p&gt;&lt;ol class=&quot;cherry-list__upper-roman&quot; start=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表项 2.1&lt;code&gt;罗马数字&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表项 2.2&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表项 2.3&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表 三&lt;/p&gt;&lt;ol class=&quot;cherry-list__lower-greek&quot; start=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表3.1&lt;code&gt;希腊字母&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表3.2&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表3.3&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表 四&lt;/p&gt;&lt;ol class=&quot;cherry-list__cjk-ideographic&quot; start=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表4.1&lt;code&gt;中文数字&lt;/code&gt;&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表4.2&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;有序列表4.3&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/li&gt;&lt;/ol&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;c9cf49ce217838fd32b70e44a70713c2&quot; id=&quot;%E5%BC%95%E7%94%A8&quot;&gt;&lt;a href=&quot;#%E5%BC%95%E7%94%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;引用&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;bc17c7a8b64b44c365c50359856a28c5&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在行首使用 &amp;gt; 表示文字引用&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;7e903e24fc61f08c40686e6b984d59fb&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;4&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token blockquote punctuation&quot;&gt;&amp;gt;&lt;/span&gt; 野火烧不尽，春风吹又生&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;blockquote data-lines=&quot;2&quot; data-sign=&quot;e036d13d34f848ef263a2c0c7112680d_2&quot;&gt;野火烧不尽，春风吹又生&lt;/blockquote&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;e3d0dc4acea5ca8ebf28f3e15af785d5&quot; id=&quot;%E8%A1%8C%E5%86%85%E4%BB%A3%E7%A0%81&quot;&gt;&lt;a href=&quot;#%E8%A1%8C%E5%86%85%E4%BB%A3%E7%A0%81&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;行内代码&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;5d0763c2d94d1f9b47c3726ab98f9af2&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用 `代码` 表示行内代码&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;56851441a484e7841670f80063c95785&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;4&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-javascript&quot;&gt;&lt;code class=&quot;language-javascript wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;让我们聊聊 &lt;span class=&quot;token template-string&quot;&gt;&lt;span class=&quot;token template-punctuation string&quot;&gt;`&lt;/span&gt;&lt;span class=&quot;token string&quot;&gt;html&lt;/span&gt;&lt;span class=&quot;token template-punctuation string&quot;&gt;`&lt;/span&gt;&lt;/span&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;0c2aec47df02cb2af6d2d4185b71cacd3&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;让我们聊聊 &lt;code&gt;html&lt;/code&gt;&lt;/p&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;4ab8ecec85a02928ff4613072f0233e3&quot; id=&quot;%E4%BB%A3%E7%A0%81%E5%9D%97&quot;&gt;&lt;a href=&quot;#%E4%BB%A3%E7%A0%81%E5%9D%97&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;代码块&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;7878d7fc9fea6d1d1d1a406ed52addf9&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用 三个` 表示代码块&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;6d84eb09131820336a45b74c4465a282&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;5&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;    这是一个代码块&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    有两行&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;hr data-lines=&quot;1&quot; data-sign=&quot;hr1&quot;&gt;&lt;h1 data-lines=&quot;2&quot; data-sign=&quot;d6bfc357d9ceb32efab4c62c0966daf9&quot; id=&quot;%E9%AB%98%E9%98%B6%E8%AF%AD%E6%B3%95%E6%89%8B%E5%86%8C&quot;&gt;&lt;a href=&quot;#%E9%AB%98%E9%98%B6%E8%AF%AD%E6%B3%95%E6%89%8B%E5%86%8C&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;高阶语法手册&lt;/h1&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;078b8dd8952188f585ef587ec29b588b&quot; id=&quot;%E7%9B%AE%E5%BD%95&quot;&gt;&lt;a href=&quot;#%E7%9B%AE%E5%BD%95&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;目录&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;6a6895050d344227e0839ea4bc7fb203&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用&lt;code&gt;[[toc]]&lt;/code&gt;，会自动生成一个页面目录，目录内容由一级、二级、三级标题组成&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;0a64ec186c29b06352237b77609093a4&quot; id=&quot;%E4%BF%A1%E6%81%AF%E9%9D%A2%E6%9D%BF&quot;&gt;&lt;a href=&quot;#%E4%BF%A1%E6%81%AF%E9%9D%A2%E6%9D%BF&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;信息面板&lt;/h2&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;b50f2dfe7aef53a1c52dbc08fa9b99b83&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;br&gt;使用连续三个冒号&lt;code&gt;:::&lt;/code&gt;和关键字（&lt;code&gt;[primary | info | warning | danger | success]&lt;/code&gt;）来声明&lt;/p&gt;&lt;div data-sign=&quot;1cf1cafde88f79282457b8a3f823801f&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;6&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;:::primary // [primary | info | warning | danger | success] 标题&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;内容&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;:::&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;div data-lines=&quot;3&quot; data-sign=&quot;092f24203260473dbc2d56be54c5cc87&quot; class=&quot;cherry-panel cherry-panel__primary&quot;&gt;&lt;div class=&quot;cherry-panel--title cherry-panel--title__not-empty&quot;&gt;标题&lt;/div&gt;&lt;div class=&quot;cherry-panel--body&quot;&gt;&lt;p&gt;内容&lt;/p&gt;&lt;/div&gt;&lt;/div&gt;&lt;div data-lines=&quot;3&quot; data-sign=&quot;88b99eae7b03df69d1db342f22bd9f08&quot; class=&quot;cherry-panel cherry-panel__success&quot;&gt;&lt;div class=&quot;cherry-panel--title&quot;&gt;&lt;/div&gt;&lt;div class=&quot;cherry-panel--body&quot;&gt;&lt;p&gt;内容&lt;/p&gt;&lt;/div&gt;&lt;/div&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;e1531f36a8dad332282870082fdefab0&quot; id=&quot;%E6%89%8B%E9%A3%8E%E7%90%B4&quot;&gt;&lt;a href=&quot;#%E6%89%8B%E9%A3%8E%E7%90%B4&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;手风琴&lt;/h2&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;8a0eea99c6729c00f2cbd73030943bab3&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;br&gt;使用连续三个加号&lt;code&gt;+++&lt;/code&gt;和关键字（&lt;code&gt;[ + | - ]&lt;/code&gt;）来声明，关键字&lt;code&gt;+&lt;/code&gt;表示默认收起，关键字&lt;code&gt;-&lt;/code&gt;表示默认展开&lt;/p&gt;&lt;div data-sign=&quot;33fb9a1610f1e702657b4cff8e518bdd&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;10&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;+++ 点击展开更多&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;内容&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;++- 默认展开&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;内容&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;++ 默认收起&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;内容&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;+++&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;div data-lines=&quot;7&quot; data-sign=&quot;7ddf4817419451f577f537a2d1499423&quot; class=&quot;cherry-detail cherry-detail__multiple&quot;&gt;&lt;details&gt;&lt;summary&gt;点击展开更多&lt;/summary&gt;&lt;div class=&quot;cherry-detail-body&quot;&gt;&lt;p&gt;内容&lt;/p&gt;&lt;/div&gt;&lt;/details&gt;&lt;details open=&quot;&quot;&gt;&lt;summary&gt;默认展开&lt;/summary&gt;&lt;div class=&quot;cherry-detail-body&quot;&gt;&lt;p&gt;内容&lt;/p&gt;&lt;/div&gt;&lt;/details&gt;&lt;details&gt;&lt;summary&gt;默认收起&lt;/summary&gt;&lt;div class=&quot;cherry-detail-body&quot;&gt;&lt;p&gt;内容&lt;/p&gt;&lt;/div&gt;&lt;/details&gt;&lt;/div&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;16667d9726cecdd35764368d1795304b&quot; id=&quot;%E8%AF%AD%E6%B3%95%E9%AB%98%E4%BA%AE&quot;&gt;&lt;a href=&quot;#%E8%AF%AD%E6%B3%95%E9%AB%98%E4%BA%AE&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;语法高亮&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;80725857b91a823767ca4a235585f380&quot; data-lines=&quot;3&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在```后面指明语法名&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;加强的代码块，支持四十一种编程语言的语法高亮的显示&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;ddf9166ed415c95d9122b9c67d5575f93&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;非代码示例：&lt;/p&gt;&lt;div data-sign=&quot;81530a6f72f0230b36b49041c9a3dea6&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;4&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;bash&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-bash&quot;&gt;&lt;code class=&quot;language-bash wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token function&quot;&gt;sudo&lt;/span&gt; &lt;span class=&quot;token function&quot;&gt;apt-get&lt;/span&gt; &lt;span class=&quot;token function&quot;&gt;install&lt;/span&gt; vim-gnome&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;725dd2b6d21bb4fc026f77db960a77922&quot;&gt;Python 示例：&lt;/p&gt;&lt;div data-sign=&quot;6810cea488047757968bda41c4a3a876&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;15&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;python&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-unExpand&quot;&gt;\n      &lt;pre class=&quot;language-python&quot;&gt;&lt;code class=&quot;language-python wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token decorator annotation punctuation&quot;&gt;@requires_authorization&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token keyword&quot;&gt;def&lt;/span&gt; &lt;span class=&quot;token function&quot;&gt;somefunc&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;param1&lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt;&lt;span class=&quot;token operator&quot;&gt;&amp;amp;&lt;/span&gt;&lt;span class=&quot;token comment&quot;&gt;#039;&amp;amp;#039;, param2=0):&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    &lt;span class=&quot;token operator&quot;&gt;&amp;amp;&lt;/span&gt;&lt;span class=&quot;token comment&quot;&gt;#039;&amp;amp;#039;&amp;amp;#039;A docstring&amp;amp;#039;&amp;amp;#039;&amp;amp;#039;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    &lt;span class=&quot;token keyword&quot;&gt;if&lt;/span&gt; param1 &lt;span class=&quot;token operator&quot;&gt;&amp;gt;&lt;/span&gt; param2&lt;span class=&quot;token punctuation&quot;&gt;:&lt;/span&gt; &lt;span class=&quot;token comment&quot;&gt;# interesting&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;        &lt;span class=&quot;token keyword&quot;&gt;print&lt;/span&gt; &lt;span class=&quot;token operator&quot;&gt;&amp;amp;&lt;/span&gt;&lt;span class=&quot;token comment&quot;&gt;#039;Greater&amp;amp;#039;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    &lt;span class=&quot;token keyword&quot;&gt;return&lt;/span&gt; &lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;param2 &lt;span class=&quot;token operator&quot;&gt;-&lt;/span&gt; param1 &lt;span class=&quot;token operator&quot;&gt;+&lt;/span&gt; &lt;span class=&quot;token number&quot;&gt;1&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;)&lt;/span&gt; &lt;span class=&quot;token keyword&quot;&gt;or&lt;/span&gt; &lt;span class=&quot;token boolean&quot;&gt;None&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token keyword&quot;&gt;class&lt;/span&gt; &lt;span class=&quot;token class-name&quot;&gt;SomeClass&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;:&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    &lt;span class=&quot;token keyword&quot;&gt;pass&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token operator&quot;&gt;&amp;gt;&amp;gt;&lt;/span&gt;&lt;span class=&quot;token operator&quot;&gt;&amp;gt;&lt;/span&gt; message &lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt; &lt;span class=&quot;token operator&quot;&gt;&amp;amp;&lt;/span&gt;&lt;span class=&quot;token comment&quot;&gt;#039;&amp;amp;#039;&amp;amp;#039;interpreter&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;.&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;.&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;.&lt;/span&gt; prompt&lt;span class=&quot;token operator&quot;&gt;&amp;amp;&lt;/span&gt;&lt;span class=&quot;token comment&quot;&gt;#039;&amp;amp;#039;&amp;amp;#039;&lt;/span&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;div class=&quot;cherry-mask-code-block&quot;&gt;\n        &lt;div class=&quot;expand-btn &quot;&gt;\n          &lt;i class=&quot;ch-icon ch-icon-expand&quot;&gt;&lt;/i&gt;\n        &lt;/div&gt;\n      &lt;/div&gt;&lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;cd5e7d320d31a0e10db88e8584f952b52&quot;&gt;JavaScript 示例：&lt;/p&gt;&lt;div data-sign=&quot;3e4952d28f894043ae4e683f1b869886&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;22&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;javascript&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-unExpand&quot;&gt;\n      &lt;pre class=&quot;language-javascript&quot;&gt;&lt;code class=&quot;language-javascript wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt;/**&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * nth element in the fibonacci series.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * &lt;span class=&quot;token keyword&quot;&gt;@param&lt;/span&gt; &lt;span class=&quot;token parameter&quot;&gt;n&lt;/span&gt; &amp;gt;= 0&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * &lt;span class=&quot;token keyword&quot;&gt;@return&lt;/span&gt; the nth element, &amp;gt;= 0.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; */&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token keyword&quot;&gt;function&lt;/span&gt; &lt;span class=&quot;token function&quot;&gt;fib&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;&lt;span class=&quot;token parameter&quot;&gt;n&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;)&lt;/span&gt; &lt;span class=&quot;token punctuation&quot;&gt;{&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token keyword&quot;&gt;var&lt;/span&gt; a &lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt; &lt;span class=&quot;token number&quot;&gt;1&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;,&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    b &lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt; &lt;span class=&quot;token number&quot;&gt;1&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token keyword&quot;&gt;var&lt;/span&gt; tmp&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token keyword control-flow&quot;&gt;while&lt;/span&gt; &lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;&lt;span class=&quot;token operator&quot;&gt;--&lt;/span&gt;n &lt;span class=&quot;token operator&quot;&gt;&amp;gt;=&lt;/span&gt; &lt;span class=&quot;token number&quot;&gt;0&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;)&lt;/span&gt; &lt;span class=&quot;token punctuation&quot;&gt;{&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    tmp &lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt; a&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    a &lt;span class=&quot;token operator&quot;&gt;+=&lt;/span&gt; b&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    b &lt;span class=&quot;token operator&quot;&gt;=&lt;/span&gt; tmp&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token punctuation&quot;&gt;}&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;  &lt;span class=&quot;token keyword control-flow&quot;&gt;return&lt;/span&gt; a&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;}&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token dom variable&quot;&gt;document&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;.&lt;/span&gt;&lt;span class=&quot;token method function property-access&quot;&gt;write&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;&lt;span class=&quot;token function&quot;&gt;fib&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;(&lt;/span&gt;&lt;span class=&quot;token number&quot;&gt;10&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;)&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;)&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;;&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;div class=&quot;cherry-mask-code-block&quot;&gt;\n        &lt;div class=&quot;expand-btn &quot;&gt;\n          &lt;i class=&quot;ch-icon ch-icon-expand&quot;&gt;&lt;/i&gt;\n        &lt;/div&gt;\n      &lt;/div&gt;&lt;/div&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;edaff0f857a308a92fa71039a025c889&quot; id=&quot;checklist%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#checklist%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;checklist[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;3b1ed69d908b55a17fc85f85d2550e9f&quot; data-lines=&quot;2&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;输入&lt;code&gt;[ ]&lt;/code&gt;或&lt;code&gt;[x]&lt;/code&gt;，就会生成一个 checklist&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;d89a5ed90b20b6c496984711b28b33cf&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;6&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; [ ] AAA&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; [x] BBB&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token list punctuation&quot;&gt;-&lt;/span&gt; [ ] CCC&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;741afe34ea6b34fe878ef8baf6a360a8&quot; data-lines=&quot;4&quot;&gt;&lt;li class=&quot;cherry-list-item check-list-item&quot;&gt;&lt;p&gt;&lt;span class=&quot;ch-icon ch-icon-square&quot;&gt;&lt;/span&gt; AAA&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item check-list-item&quot;&gt;&lt;p&gt;&lt;span class=&quot;ch-icon ch-icon-check&quot;&gt;&lt;/span&gt; BBB&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item check-list-item&quot;&gt;&lt;p&gt;&lt;span class=&quot;ch-icon ch-icon-square&quot;&gt;&lt;/span&gt; CCC&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;468c40335216485bd5720d106d0a89f8&quot; id=&quot;%E5%B8%A6%E5%AF%B9%E9%BD%90%E5%8A%9F%E8%83%BD%E7%9A%84%E8%A1%A8%E6%A0%BC&quot;&gt;&lt;a href=&quot;#%E5%B8%A6%E5%AF%B9%E9%BD%90%E5%8A%9F%E8%83%BD%E7%9A%84%E8%A1%A8%E6%A0%BC&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;带对齐功能的表格&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;c772e8c60c139d96de5e85291aab79b9&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;一种比较通用的markdown表格语法&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;ec11ecc8514fe10b2a5e345fb21d1da3&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;7&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;|项目（居中对齐）|价格（右对齐）|数量（左对齐）|&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;|:-:|-:|:-|&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;|计算机|￥1600|5|&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;|手机机|￥12|50|&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;div data-lines=&quot;5&quot; data-sign=&quot;772e27d318361aaae68aac2fc71096405&quot; class=&quot;cherry-table-container&quot;&gt;\n        &lt;table class=&quot;cherry-table&quot;&gt;&lt;thead&gt;&lt;tr&gt;&lt;th align=&quot;center&quot;&gt;项目（居中对齐）&lt;/th&gt;&lt;th align=&quot;right&quot;&gt;价格（右对齐）&lt;/th&gt;&lt;th align=&quot;left&quot;&gt;数量（左对齐）&lt;/th&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td align=&quot;center&quot;&gt;计算机&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;￥1600&lt;/td&gt;&lt;td align=&quot;left&quot;&gt;5&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td align=&quot;center&quot;&gt;手机机&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;￥12&lt;/td&gt;&lt;td align=&quot;left&quot;&gt;50&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;/div&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;6516d7d46e99d7474447737b4bd22bb7&quot; id=&quot;%E6%B5%81%E7%A8%8B%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#%E6%B5%81%E7%A8%8B%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;流程图[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9e282dc968b46de399f90a4bd64b17eb2&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;7bbcdfe77094ace42b6da8668f0c007f&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问&lt;a href=&quot;/goJump.html?type=10&amp;href=https://mermaid-js.github.io/mermaid/#/flowchart&quot;&gt;Mermaid 流程图&lt;/a&gt;参考具体使用方法。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;b07c7db4b67ae1b202cd7d1da64a37a83&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;小明老婆让小明下班时买一斤包子，如果遇到卖西瓜的，买一个。&lt;/p&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;b9520beb22670b3443b57c26a447a3242&quot;&gt;左右结构&lt;/p&gt;&lt;figure data-sign=&quot;beb207b7f02f00e58ce96cdd2e09724d&quot; data-type=&quot;mermaid&quot; data-lines=&quot;8&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-roledescription=&quot;flowchart-v2&quot; role=&quot;graphics-document document&quot; viewBox=&quot;-8 -8 553.859375 159.609375&quot; height=&quot;159.609375&quot; width=&quot;553.859375&quot; id=&quot;mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot;&gt;&lt;style&gt;#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .error-icon{fill:#552222;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .error-text{fill:#552222;stroke:#552222;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edge-thickness-normal{stroke-width:2px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .marker{fill:#333333;stroke:#333333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .marker.cross{stroke:#333333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 svg{font-family:sans-serif;font-size:16px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .label{font-family:sans-serif;color:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .cluster-label text{fill:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .cluster-label span{color:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .label text,#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 span{fill:#333;color:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node rect,#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node circle,#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node ellipse,#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node polygon,#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node path{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node .label{text-align:center;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .node.clickable{cursor:pointer;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .arrowheadPath{fill:#333333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edgePath .path{stroke:#333333;stroke-width:2.0px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .flowchart-link{stroke:#333333;fill:none;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edgeLabel{background-color:#e8e8e8;text-align:center;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .edgeLabel rect{opacity:0.5;background-color:#e8e8e8;fill:#e8e8e8;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .cluster rect{fill:#ffffde;stroke:#aaaa33;stroke-width:1px;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .cluster text{fill:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .cluster span{color:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 div.mermaidTooltip{position:absolute;text-align:center;max-width:200px;padding:2px;font-family:sans-serif;font-size:12px;background:hsl(80, 100%, 96.2745098039%);border:1px solid #aaaa33;border-radius:2px;pointer-events:none;z-index:100;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .flowchartTitleText{text-anchor:middle;font-size:18px;fill:#333;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 .label{font-family:sans-serif;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 :root{--mermaid-font-family:sans-serif;}#mermaid-beb207b7f02f00e58ce96cdd2e09724d-1733718752544 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;12&quot; markerWidth=&quot;12&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;10&quot; viewBox=&quot;0 0 12 20&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-pointEnd&quot;&gt;&lt;path style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 0 0 L 10 5 L 0 10 z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;12&quot; markerWidth=&quot;12&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;0&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-pointStart&quot;&gt;&lt;path style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 0 5 L 10 10 L 10 0 z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;11&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-circleEnd&quot;&gt;&lt;circle style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; r=&quot;5&quot; cy=&quot;5&quot; cx=&quot;5&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;-1&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-circleStart&quot;&gt;&lt;circle style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; r=&quot;5&quot; cy=&quot;5&quot; cx=&quot;5&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5.2&quot; refX=&quot;12&quot; viewBox=&quot;0 0 11 11&quot; class=&quot;marker cross flowchart&quot; id=&quot;flowchart-crossEnd&quot;&gt;&lt;path style=&quot;stroke-width: 2; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 1,1 l 9,9 M 10,1 l -9,9&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5.2&quot; refX=&quot;-1&quot; viewBox=&quot;0 0 11 11&quot; class=&quot;marker cross flowchart&quot; id=&quot;flowchart-crossStart&quot;&gt;&lt;path style=&quot;stroke-width: 2; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 1,1 l 9,9 M 10,1 l -9,9&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;g class=&quot;root&quot;&gt;&lt;g class=&quot;clusters&quot;&gt;&lt;/g&gt;&lt;g class=&quot;edgePaths&quot;&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-A LE-B&quot; id=&quot;L-A-B-0&quot; d=&quot;M43.813,71.805L50.734,71.805C57.656,71.805,71.5,71.805,85.344,71.805C99.188,71.805,113.031,71.805,119.953,71.805L126.875,71.805&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-B LE-C&quot; id=&quot;L-B-C-0&quot; d=&quot;M185.078,71.805L189.245,71.805C193.411,71.805,201.745,71.805,210.161,71.888C218.578,71.971,227.078,72.138,231.328,72.221L235.578,72.305&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-C LE-D&quot; id=&quot;L-C-D-0&quot; d=&quot;M357.561,50.678L367.096,46.449C376.632,42.22,395.703,33.763,411.252,29.534C426.802,25.305,438.831,25.305,444.845,25.305L450.859,25.305&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-C LE-E&quot; id=&quot;L-C-E-0&quot; d=&quot;M357.561,93.931L367.096,97.993C376.632,102.056,395.703,110.18,411.252,114.242C426.802,118.305,438.831,118.305,444.845,118.305L450.859,118.305&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabels&quot;&gt;&lt;g transform=&quot;translate(85.34375, 71.8046875)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-16.53125, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;33.0625&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;下 班&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(414.7734375, 25.3046875)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-11.0859375, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;22.171875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;Yes&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(414.7734375, 118.3046875)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-10.4375, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;20.875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;No&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;nodes&quot;&gt;&lt;g transform=&quot;translate(21.90625, 71.8046875)&quot; id=&quot;flowchart-A-16&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;43.8125&quot; y=&quot;-21.5&quot; x=&quot;-21.90625&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-14.40625, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;28.8125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;公司&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(155.9765625, 71.8046875)&quot; id=&quot;flowchart-B-17&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;58.203125&quot; y=&quot;-21.5&quot; x=&quot;-29.1015625&quot; ry=&quot;5&quot; rx=&quot;5&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-21.6015625, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;43.203125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;菜市场&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(306.8828125, 71.8046875)&quot; id=&quot;flowchart-C-19&quot; class=&quot;node default default&quot;&gt;&lt;polygon style=&quot;&quot; transform=&quot;translate(-71.8046875,71.8046875)&quot; class=&quot;label-container&quot; points=&quot;71.8046875,0 143.609375,-71.8046875 71.8046875,-143.609375 0,-71.8046875&quot;&gt;&lt;/polygon&gt;&lt;g transform=&quot;translate(-28.8046875, -28)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;56&quot; width=&quot;57.609375&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;看见&lt;br&gt;卖西瓜的&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(494.359375, 25.3046875)&quot; id=&quot;flowchart-D-21&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;87&quot; y=&quot;-21.5&quot; x=&quot;-43.5&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-36, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;72&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;买一个包子&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(494.359375, 118.3046875)&quot; id=&quot;flowchart-E-23&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;87&quot; y=&quot;-21.5&quot; x=&quot;-43.5&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-36, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;72&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;买一斤包子&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;c12b650d9f16f127704663386c4de75a2&quot;&gt;上下结构&lt;/p&gt;&lt;figure data-sign=&quot;cd62a788e4a96d9b3c58bf84c0bd4464&quot; data-type=&quot;mermaid&quot; data-lines=&quot;8&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-roledescription=&quot;flowchart-v2&quot; role=&quot;graphics-document document&quot; viewBox=&quot;-8 -8 240 494.609375&quot; height=&quot;494.609375&quot; width=&quot;240&quot; id=&quot;mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot;&gt;&lt;style&gt;#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .error-icon{fill:#552222;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .error-text{fill:#552222;stroke:#552222;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edge-thickness-normal{stroke-width:2px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .marker{fill:#333333;stroke:#333333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .marker.cross{stroke:#333333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 svg{font-family:sans-serif;font-size:16px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .label{font-family:sans-serif;color:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .cluster-label text{fill:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .cluster-label span{color:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .label text,#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 span{fill:#333;color:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node rect,#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node circle,#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node ellipse,#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node polygon,#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node path{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node .label{text-align:center;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .node.clickable{cursor:pointer;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .arrowheadPath{fill:#333333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edgePath .path{stroke:#333333;stroke-width:2.0px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .flowchart-link{stroke:#333333;fill:none;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edgeLabel{background-color:#e8e8e8;text-align:center;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .edgeLabel rect{opacity:0.5;background-color:#e8e8e8;fill:#e8e8e8;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .cluster rect{fill:#ffffde;stroke:#aaaa33;stroke-width:1px;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .cluster text{fill:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .cluster span{color:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 div.mermaidTooltip{position:absolute;text-align:center;max-width:200px;padding:2px;font-family:sans-serif;font-size:12px;background:hsl(80, 100%, 96.2745098039%);border:1px solid #aaaa33;border-radius:2px;pointer-events:none;z-index:100;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .flowchartTitleText{text-anchor:middle;font-size:18px;fill:#333;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 .label{font-family:sans-serif;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 :root{--mermaid-font-family:sans-serif;}#mermaid-cd62a788e4a96d9b3c58bf84c0bd4464-1733718752573 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;12&quot; markerWidth=&quot;12&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;10&quot; viewBox=&quot;0 0 12 20&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-pointEnd&quot;&gt;&lt;path style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 0 0 L 10 5 L 0 10 z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;12&quot; markerWidth=&quot;12&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;0&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-pointStart&quot;&gt;&lt;path style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 0 5 L 10 10 L 10 0 z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;11&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-circleEnd&quot;&gt;&lt;circle style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; r=&quot;5&quot; cy=&quot;5&quot; cx=&quot;5&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;-1&quot; viewBox=&quot;0 0 10 10&quot; class=&quot;marker flowchart&quot; id=&quot;flowchart-circleStart&quot;&gt;&lt;circle style=&quot;stroke-width: 1; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; r=&quot;5&quot; cy=&quot;5&quot; cx=&quot;5&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5.2&quot; refX=&quot;12&quot; viewBox=&quot;0 0 11 11&quot; class=&quot;marker cross flowchart&quot; id=&quot;flowchart-crossEnd&quot;&gt;&lt;path style=&quot;stroke-width: 2; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 1,1 l 9,9 M 10,1 l -9,9&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;11&quot; markerWidth=&quot;11&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5.2&quot; refX=&quot;-1&quot; viewBox=&quot;0 0 11 11&quot; class=&quot;marker cross flowchart&quot; id=&quot;flowchart-crossStart&quot;&gt;&lt;path style=&quot;stroke-width: 2; stroke-dasharray: 1, 0;&quot; class=&quot;arrowMarkerPath&quot; d=&quot;M 1,1 l 9,9 M 10,1 l -9,9&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;g class=&quot;root&quot;&gt;&lt;g class=&quot;clusters&quot;&gt;&lt;/g&gt;&lt;g class=&quot;edgePaths&quot;&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-A LE-B&quot; id=&quot;L-A-B-0&quot; d=&quot;M112,43L112,49.5C112,56,112,69,112,82C112,95,112,108,112,114.5L112,121&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-B LE-C&quot; id=&quot;L-B-C-0&quot; d=&quot;M112,164L112,168.167C112,172.333,112,180.667,112.083,189.083C112.167,197.5,112.333,206,112.417,210.25L112.5,214.5&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-C LE-D&quot; id=&quot;L-C-D-0&quot; d=&quot;M85.068,330.678L78.14,341.666C71.212,352.655,57.356,374.632,50.428,392.121C43.5,409.609,43.5,422.609,43.5,429.109L43.5,435.609&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#flowchart-pointEnd)&quot; style=&quot;fill:none;&quot; class=&quot;edge-thickness-normal edge-pattern-solid flowchart-link LS-C LE-E&quot; id=&quot;L-C-E-0&quot; d=&quot;M139.932,330.678L146.693,341.666C153.454,352.655,166.977,374.632,173.739,392.121C180.5,409.609,180.5,422.609,180.5,429.109L180.5,435.609&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabels&quot;&gt;&lt;g transform=&quot;translate(112, 82)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-16.53125, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;33.0625&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;下 班&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(43.5, 396.609375)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-11.0859375, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;22.171875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;Yes&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(180.5, 396.609375)&quot; class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(-10.4375, -14)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;20.875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;No&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;nodes&quot;&gt;&lt;g transform=&quot;translate(112, 21.5)&quot; id=&quot;flowchart-A-40&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;43.8125&quot; y=&quot;-21.5&quot; x=&quot;-21.90625&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-14.40625, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;28.8125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;公司&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(112, 142.5)&quot; id=&quot;flowchart-B-41&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;58.203125&quot; y=&quot;-21.5&quot; x=&quot;-29.1015625&quot; ry=&quot;5&quot; rx=&quot;5&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-21.6015625, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;43.203125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;菜市场&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(112, 285.8046875)&quot; id=&quot;flowchart-C-43&quot; class=&quot;node default default&quot;&gt;&lt;polygon style=&quot;&quot; transform=&quot;translate(-71.8046875,71.8046875)&quot; class=&quot;label-container&quot; points=&quot;71.8046875,0 143.609375,-71.8046875 71.8046875,-143.609375 0,-71.8046875&quot;&gt;&lt;/polygon&gt;&lt;g transform=&quot;translate(-28.8046875, -28)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;56&quot; width=&quot;57.609375&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;看见&lt;br&gt;卖西瓜的&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(43.5, 457.109375)&quot; id=&quot;flowchart-D-45&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;87&quot; y=&quot;-21.5&quot; x=&quot;-43.5&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-36, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;72&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;买一个包子&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(180.5, 457.109375)&quot; id=&quot;flowchart-E-47&quot; class=&quot;node default default&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;87&quot; y=&quot;-21.5&quot; x=&quot;-43.5&quot; ry=&quot;0&quot; rx=&quot;0&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-36, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;72&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;买一斤包子&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;04f0c08c2a5ecfa7e34537584d389868&quot; id=&quot;%E6%97%B6%E5%BA%8F%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#%E6%97%B6%E5%BA%8F%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;时序图[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;2c4f3af8ff7ed7538326618a480b6448&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问&lt;a href=&quot;/goJump.html?type=10&amp;href=https://mermaid-js.github.io/mermaid/#/sequenceDiagram&quot;&gt;Mermaid 时序图&lt;/a&gt;参考具体使用方法&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;figure data-sign=&quot;e69bf755400c38cea72ca7695cd9bc3d&quot; data-type=&quot;mermaid&quot; data-lines=&quot;15&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-roledescription=&quot;sequence&quot; role=&quot;graphics-document document&quot; viewBox=&quot;-50 -10 460 689&quot; height=&quot;689&quot; width=&quot;460&quot; id=&quot;mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot;&gt;&lt;style&gt;#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .error-icon{fill:#552222;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .error-text{fill:#552222;stroke:#552222;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .edge-thickness-normal{stroke-width:2px;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .marker{fill:#333333;stroke:#333333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .marker.cross{stroke:#333333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 svg{font-family:sans-serif;font-size:16px;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actor{stroke:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);fill:#ECECFF;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 text.actor&amp;gt;tspan{fill:black;stroke:none;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actor-line{stroke:grey;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .messageLine0{stroke-width:1.5;stroke-dasharray:none;stroke:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .messageLine1{stroke-width:1.5;stroke-dasharray:2,2;stroke:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 #arrowhead path{fill:#333;stroke:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .sequenceNumber{fill:white;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 #sequencenumber{fill:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 #crosshead path{fill:#333;stroke:#333;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .messageText{fill:#333;stroke:none;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .labelBox{stroke:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);fill:#ECECFF;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .labelText,#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .labelText&amp;gt;tspan{fill:black;stroke:none;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .loopText,#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .loopText&amp;gt;tspan{fill:black;stroke:none;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .loopLine{stroke-width:2px;stroke-dasharray:2,2;stroke:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);fill:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .note{stroke:#aaaa33;fill:#fff5ad;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .noteText,#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .noteText&amp;gt;tspan{fill:black;stroke:none;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .activation0{fill:#f4f4f4;stroke:#666;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .activation1{fill:#f4f4f4;stroke:#666;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .activation2{fill:#f4f4f4;stroke:#666;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actorPopupMenu{position:absolute;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actorPopupMenuPanel{position:absolute;fill:#ECECFF;box-shadow:0px 8px 16px 0px rgba(0,0,0,0.2);filter:drop-shadow(3px 5px 2px rgb(0 0 0 / 0.4));}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actor-man line{stroke:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);fill:#ECECFF;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .actor-man circle,#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 line{stroke:hsl(259.6261682243, 59.7765363128%, 87.9019607843%);fill:#ECECFF;stroke-width:2px;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 .label{font-family:sans-serif;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 :root{--mermaid-font-family:sans-serif;}#mermaid-e69bf755400c38cea72ca7695cd9bc3d-1733718752586 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;/g&gt;&lt;defs&gt;&lt;symbol height=&quot;24&quot; width=&quot;24&quot; id=&quot;computer&quot;&gt;&lt;path d=&quot;M2 2v13h20v-13h-20zm18 11h-16v-9h16v9zm-10.228 6l.466-1h3.524l.467 1h-4.457zm14.228 3h-24l2-6h2.104l-1.33 4h18.45l-1.297-4h2.073l2 6zm-5-10h-14v-7h14v7z&quot; transform=&quot;scale(.5)&quot;&gt;&lt;/path&gt;&lt;/symbol&gt;&lt;/defs&gt;&lt;defs&gt;&lt;symbol clip-rule=&quot;evenodd&quot; fill-rule=&quot;evenodd&quot; id=&quot;database&quot;&gt;&lt;path d=&quot;M12.258.001l.256.004.255.005.253.008.251.01.249.012.247.015.246.016.242.019.241.02.239.023.236.024.233.027.231.028.229.031.225.032.223.034.22.036.217.038.214.04.211.041.208.043.205.045.201.046.198.048.194.05.191.051.187.053.183.054.18.056.175.057.172.059.168.06.163.061.16.063.155.064.15.066.074.033.073.033.071.034.07.034.069.035.068.035.067.035.066.035.064.036.064.036.062.036.06.036.06.037.058.037.058.037.055.038.055.038.053.038.052.038.051.039.05.039.048.039.047.039.045.04.044.04.043.04.041.04.04.041.039.041.037.041.036.041.034.041.033.042.032.042.03.042.029.042.027.042.026.043.024.043.023.043.021.043.02.043.018.044.017.043.015.044.013.044.012.044.011.045.009.044.007.045.006.045.004.045.002.045.001.045v17l-.001.045-.002.045-.004.045-.006.045-.007.045-.009.044-.011.045-.012.044-.013.044-.015.044-.017.043-.018.044-.02.043-.021.043-.023.043-.024.043-.026.043-.027.042-.029.042-.03.042-.032.042-.033.042-.034.041-.036.041-.037.041-.039.041-.04.041-.041.04-.043.04-.044.04-.045.04-.047.039-.048.039-.05.039-.051.039-.052.038-.053.038-.055.038-.055.038-.058.037-.058.037-.06.037-.06.036-.062.036-.064.036-.064.036-.066.035-.067.035-.068.035-.069.035-.07.034-.071.034-.073.033-.074.033-.15.066-.155.064-.16.063-.163.061-.168.06-.172.059-.175.057-.18.056-.183.054-.187.053-.191.051-.194.05-.198.048-.201.046-.205.045-.208.043-.211.041-.214.04-.217.038-.22.036-.223.034-.225.032-.229.031-.231.028-.233.027-.236.024-.239.023-.241.02-.242.019-.246.016-.247.015-.249.012-.251.01-.253.008-.255.005-.256.004-.258.001-.258-.001-.256-.004-.255-.005-.253-.008-.251-.01-.249-.012-.247-.015-.245-.016-.243-.019-.241-.02-.238-.023-.236-.024-.234-.027-.231-.028-.228-.031-.226-.032-.223-.034-.22-.036-.217-.038-.214-.04-.211-.041-.208-.043-.204-.045-.201-.046-.198-.048-.195-.05-.19-.051-.187-.053-.184-.054-.179-.056-.176-.057-.172-.059-.167-.06-.164-.061-.159-.063-.155-.064-.151-.066-.074-.033-.072-.033-.072-.034-.07-.034-.069-.035-.068-.035-.067-.035-.066-.035-.064-.036-.063-.036-.062-.036-.061-.036-.06-.037-.058-.037-.057-.037-.056-.038-.055-.038-.053-.038-.052-.038-.051-.039-.049-.039-.049-.039-.046-.039-.046-.04-.044-.04-.043-.04-.041-.04-.04-.041-.039-.041-.037-.041-.036-.041-.034-.041-.033-.042-.032-.042-.03-.042-.029-.042-.027-.042-.026-.043-.024-.043-.023-.043-.021-.043-.02-.043-.018-.044-.017-.043-.015-.044-.013-.044-.012-.044-.011-.045-.009-.044-.007-.045-.006-.045-.004-.045-.002-.045-.001-.045v-17l.001-.045.002-.045.004-.045.006-.045.007-.045.009-.044.011-.045.012-.044.013-.044.015-.044.017-.043.018-.044.02-.043.021-.043.023-.043.024-.043.026-.043.027-.042.029-.042.03-.042.032-.042.033-.042.034-.041.036-.041.037-.041.039-.041.04-.041.041-.04.043-.04.044-.04.046-.04.046-.039.049-.039.049-.039.051-.039.052-.038.053-.038.055-.038.056-.038.057-.037.058-.037.06-.037.061-.036.062-.036.063-.036.064-.036.066-.035.067-.035.068-.035.069-.035.07-.034.072-.034.072-.033.074-.033.151-.066.155-.064.159-.063.164-.061.167-.06.172-.059.176-.057.179-.056.184-.054.187-.053.19-.051.195-.05.198-.048.201-.046.204-.045.208-.043.211-.041.214-.04.217-.038.22-.036.223-.034.226-.032.228-.031.231-.028.234-.027.236-.024.238-.023.241-.02.243-.019.245-.016.247-.015.249-.012.251-.01.253-.008.255-.005.256-.004.258-.001.258.001zm-9.258 20.499v.01l.001.021.003.021.004.022.005.021.006.022.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.023.018.024.019.024.021.024.022.025.023.024.024.025.052.049.056.05.061.051.066.051.07.051.075.051.079.052.084.052.088.052.092.052.097.052.102.051.105.052.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.048.144.049.147.047.152.047.155.047.16.045.163.045.167.043.171.043.176.041.178.041.183.039.187.039.19.037.194.035.197.035.202.033.204.031.209.03.212.029.216.027.219.025.222.024.226.021.23.02.233.018.236.016.24.015.243.012.246.01.249.008.253.005.256.004.259.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.021.224-.024.22-.026.216-.027.212-.028.21-.031.205-.031.202-.034.198-.034.194-.036.191-.037.187-.039.183-.04.179-.04.175-.042.172-.043.168-.044.163-.045.16-.046.155-.046.152-.047.148-.048.143-.049.139-.049.136-.05.131-.05.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.053.083-.051.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.05.023-.024.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.023.01-.022.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.127l-.077.055-.08.053-.083.054-.085.053-.087.052-.09.052-.093.051-.095.05-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.045-.118.044-.12.043-.122.042-.124.042-.126.041-.128.04-.13.04-.132.038-.134.038-.135.037-.138.037-.139.035-.142.035-.143.034-.144.033-.147.032-.148.031-.15.03-.151.03-.153.029-.154.027-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.01-.179.008-.179.008-.181.006-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.006-.179-.008-.179-.008-.178-.01-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.027-.153-.029-.151-.03-.15-.03-.148-.031-.146-.032-.145-.033-.143-.034-.141-.035-.14-.035-.137-.037-.136-.037-.134-.038-.132-.038-.13-.04-.128-.04-.126-.041-.124-.042-.122-.042-.12-.044-.117-.043-.116-.045-.113-.045-.112-.046-.109-.047-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.05-.093-.052-.09-.051-.087-.052-.085-.053-.083-.054-.08-.054-.077-.054v4.127zm0-5.654v.011l.001.021.003.021.004.021.005.022.006.022.007.022.009.022.01.022.011.023.012.023.013.023.015.024.016.023.017.024.018.024.019.024.021.024.022.024.023.025.024.024.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.052.11.051.114.051.119.052.123.05.127.051.131.05.135.049.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.044.171.042.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.022.23.02.233.018.236.016.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.012.241-.015.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.048.139-.05.136-.049.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.051.051-.049.023-.025.023-.024.021-.025.02-.024.019-.024.018-.024.017-.024.015-.023.014-.023.013-.024.012-.022.01-.023.01-.023.008-.022.006-.022.006-.022.004-.021.004-.022.001-.021.001-.021v-4.139l-.077.054-.08.054-.083.054-.085.052-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.044-.118.044-.12.044-.122.042-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.035-.143.033-.144.033-.147.033-.148.031-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.009-.179.009-.179.007-.181.007-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.007-.179-.007-.179-.009-.178-.009-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.031-.146-.033-.145-.033-.143-.033-.141-.035-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.04-.126-.041-.124-.042-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.051-.093-.051-.09-.051-.087-.053-.085-.052-.083-.054-.08-.054-.077-.054v4.139zm0-5.666v.011l.001.02.003.022.004.021.005.022.006.021.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.024.018.023.019.024.021.025.022.024.023.024.024.025.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.051.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.043.171.043.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.021.23.02.233.018.236.017.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.013.241-.014.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.049.139-.049.136-.049.131-.051.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.049.023-.025.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.022.01-.023.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.153l-.077.054-.08.054-.083.053-.085.053-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.048-.105.048-.106.048-.109.046-.111.046-.114.046-.115.044-.118.044-.12.043-.122.043-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.034-.143.034-.144.033-.147.032-.148.032-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.024-.161.024-.162.023-.163.023-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.01-.178.01-.179.009-.179.007-.181.006-.182.006-.182.004-.184.003-.184.001-.185.001-.185-.001-.184-.001-.184-.003-.182-.004-.182-.006-.181-.006-.179-.007-.179-.009-.178-.01-.176-.01-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.023-.162-.023-.161-.024-.159-.024-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.032-.146-.032-.145-.033-.143-.034-.141-.034-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.041-.126-.041-.124-.041-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.048-.105-.048-.102-.048-.1-.05-.097-.049-.095-.051-.093-.051-.09-.052-.087-.052-.085-.053-.083-.053-.08-.054-.077-.054v4.153zm8.74-8.179l-.257.004-.254.005-.25.008-.247.011-.244.012-.241.014-.237.016-.233.018-.231.021-.226.022-.224.023-.22.026-.216.027-.212.028-.21.031-.205.032-.202.033-.198.034-.194.036-.191.038-.187.038-.183.04-.179.041-.175.042-.172.043-.168.043-.163.045-.16.046-.155.046-.152.048-.148.048-.143.048-.139.049-.136.05-.131.05-.126.051-.123.051-.118.051-.114.052-.11.052-.106.052-.101.052-.096.052-.092.052-.088.052-.083.052-.079.052-.074.051-.07.052-.065.051-.06.05-.056.05-.051.05-.023.025-.023.024-.021.024-.02.025-.019.024-.018.024-.017.023-.015.024-.014.023-.013.023-.012.023-.01.023-.01.022-.008.022-.006.023-.006.021-.004.022-.004.021-.001.021-.001.021.001.021.001.021.004.021.004.022.006.021.006.023.008.022.01.022.01.023.012.023.013.023.014.023.015.024.017.023.018.024.019.024.02.025.021.024.023.024.023.025.051.05.056.05.06.05.065.051.07.052.074.051.079.052.083.052.088.052.092.052.096.052.101.052.106.052.11.052.114.052.118.051.123.051.126.051.131.05.136.05.139.049.143.048.148.048.152.048.155.046.16.046.163.045.168.043.172.043.175.042.179.041.183.04.187.038.191.038.194.036.198.034.202.033.205.032.21.031.212.028.216.027.22.026.224.023.226.022.231.021.233.018.237.016.241.014.244.012.247.011.25.008.254.005.257.004.26.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.022.224-.023.22-.026.216-.027.212-.028.21-.031.205-.032.202-.033.198-.034.194-.036.191-.038.187-.038.183-.04.179-.041.175-.042.172-.043.168-.043.163-.045.16-.046.155-.046.152-.048.148-.048.143-.048.139-.049.136-.05.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.05.051-.05.023-.025.023-.024.021-.024.02-.025.019-.024.018-.024.017-.023.015-.024.014-.023.013-.023.012-.023.01-.023.01-.022.008-.022.006-.023.006-.021.004-.022.004-.021.001-.021.001-.021-.001-.021-.001-.021-.004-.021-.004-.022-.006-.021-.006-.023-.008-.022-.01-.022-.01-.023-.012-.023-.013-.023-.014-.023-.015-.024-.017-.023-.018-.024-.019-.024-.02-.025-.021-.024-.023-.024-.023-.025-.051-.05-.056-.05-.06-.05-.065-.051-.07-.052-.074-.051-.079-.052-.083-.052-.088-.052-.092-.052-.096-.052-.101-.052-.106-.052-.11-.052-.114-.052-.118-.051-.123-.051-.126-.051-.131-.05-.136-.05-.139-.049-.143-.048-.148-.048-.152-.048-.155-.046-.16-.046-.163-.045-.168-.043-.172-.043-.175-.042-.179-.041-.183-.04-.187-.038-.191-.038-.194-.036-.198-.034-.202-.033-.205-.032-.21-.031-.212-.028-.216-.027-.22-.026-.224-.023-.226-.022-.231-.021-.233-.018-.237-.016-.241-.014-.244-.012-.247-.011-.25-.008-.254-.005-.257-.004-.26-.001-.26.001z&quot; transform=&quot;scale(.5)&quot;&gt;&lt;/path&gt;&lt;/symbol&gt;&lt;/defs&gt;&lt;defs&gt;&lt;symbol height=&quot;24&quot; width=&quot;24&quot; id=&quot;clock&quot;&gt;&lt;path d=&quot;M12 2c5.514 0 10 4.486 10 10s-4.486 10-10 10-10-4.486-10-10 4.486-10 10-10zm0-2c-6.627 0-12 5.373-12 12s5.373 12 12 12 12-5.373 12-12-5.373-12-12-12zm5.848 12.459c.202.038.202.333.001.372-1.907.361-6.045 1.111-6.547 1.111-.719 0-1.301-.582-1.301-1.301 0-.512.77-5.447 1.125-7.445.034-.192.312-.181.343.014l.985 6.238 5.394 1.011z&quot; transform=&quot;scale(.5)&quot;&gt;&lt;/path&gt;&lt;/symbol&gt;&lt;/defs&gt;&lt;g&gt;&lt;line stroke=&quot;#999&quot; stroke-width=&quot;0.5px&quot; class=&quot;200&quot; y2=&quot;623&quot; x2=&quot;75&quot; y1=&quot;5&quot; x1=&quot;75&quot; id=&quot;actor0&quot;&gt;&lt;/line&gt;&lt;g id=&quot;root-0&quot;&gt;&lt;rect class=&quot;actor&quot; ry=&quot;3&quot; rx=&quot;3&quot; height=&quot;65&quot; width=&quot;150&quot; stroke=&quot;#666&quot; fill=&quot;#eaeaea&quot; y=&quot;0&quot; x=&quot;0&quot;&gt;&lt;/rect&gt;&lt;text style=&quot;text-anchor: middle; font-size: 16px; font-weight: 400; font-family: sans-serif;&quot; class=&quot;actor&quot; alignment-baseline=&quot;central&quot; dominant-baseline=&quot;central&quot; y=&quot;32.5&quot; x=&quot;75&quot;&gt;&lt;tspan dy=&quot;0&quot; x=&quot;75&quot;&gt;A&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;/g&gt;&lt;g&gt;&lt;line stroke=&quot;#999&quot; stroke-width=&quot;0.5px&quot; class=&quot;200&quot; y2=&quot;623&quot; x2=&quot;275&quot; y1=&quot;5&quot; x1=&quot;275&quot; id=&quot;actor1&quot;&gt;&lt;/line&gt;&lt;g id=&quot;root-1&quot;&gt;&lt;rect class=&quot;actor&quot; ry=&quot;3&quot; rx=&quot;3&quot; height=&quot;65&quot; width=&quot;150&quot; stroke=&quot;#666&quot; fill=&quot;#eaeaea&quot; y=&quot;0&quot; x=&quot;200&quot;&gt;&lt;/rect&gt;&lt;text style=&quot;text-anchor: middle; font-size: 16px; font-weight: 400; font-family: sans-serif;&quot; class=&quot;actor&quot; alignment-baseline=&quot;central&quot; dominant-baseline=&quot;central&quot; y=&quot;32.5&quot; x=&quot;275&quot;&gt;&lt;tspan dy=&quot;0&quot; x=&quot;275&quot;&gt;B&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;/g&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;12&quot; markerWidth=&quot;12&quot; markerUnits=&quot;userSpaceOnUse&quot; refY=&quot;5&quot; refX=&quot;9&quot; id=&quot;arrowhead&quot;&gt;&lt;path d=&quot;M 0 0 L 10 5 L 0 10 z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker refY=&quot;5&quot; refX=&quot;4&quot; orient=&quot;auto&quot; markerHeight=&quot;8&quot; markerWidth=&quot;15&quot; id=&quot;crosshead&quot;&gt;&lt;path style=&quot;stroke-dasharray: 0, 0;&quot; d=&quot;M 1,2 L 6,7 M 6,2 L 1,7&quot; stroke-width=&quot;1pt&quot; stroke=&quot;#000000&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;28&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;18&quot; id=&quot;filled-head&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L14,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;40&quot; markerWidth=&quot;60&quot; refY=&quot;15&quot; refX=&quot;15&quot; id=&quot;sequencenumber&quot;&gt;&lt;circle r=&quot;6&quot; cy=&quot;15&quot; cx=&quot;15&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;g&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;255&quot; x2=&quot;285&quot; y1=&quot;255&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;353&quot; x2=&quot;285&quot; y1=&quot;255&quot; x1=&quot;285&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;353&quot; x2=&quot;285&quot; y1=&quot;353&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;353&quot; x2=&quot;65&quot; y1=&quot;255&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;polygon class=&quot;labelBox&quot; points=&quot;65,255 115,255 115,268 106.6,275 65,275&quot;&gt;&lt;/polygon&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;labelText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;268&quot; x=&quot;90&quot;&gt;loop&lt;/text&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;loopText&quot; text-anchor=&quot;middle&quot; y=&quot;273&quot; x=&quot;200&quot;&gt;&lt;tspan x=&quot;200&quot;&gt;[循环2]&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;g&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;363&quot; x2=&quot;285&quot; y1=&quot;363&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;461&quot; x2=&quot;285&quot; y1=&quot;363&quot; x1=&quot;285&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;461&quot; x2=&quot;285&quot; y1=&quot;461&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;461&quot; x2=&quot;65&quot; y1=&quot;363&quot; x1=&quot;65&quot;&gt;&lt;/line&gt;&lt;polygon class=&quot;labelBox&quot; points=&quot;65,363 115,363 115,376 106.6,383 65,383&quot;&gt;&lt;/polygon&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;labelText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;376&quot; x=&quot;90&quot;&gt;loop&lt;/text&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;loopText&quot; text-anchor=&quot;middle&quot; y=&quot;381&quot; x=&quot;200&quot;&gt;&lt;tspan x=&quot;200&quot;&gt;[循环3]&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;g&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;209&quot; x2=&quot;360&quot; y1=&quot;209&quot; x1=&quot;55&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;583&quot; x2=&quot;360&quot; y1=&quot;209&quot; x1=&quot;360&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;583&quot; x2=&quot;360&quot; y1=&quot;583&quot; x1=&quot;55&quot;&gt;&lt;/line&gt;&lt;line class=&quot;loopLine&quot; y2=&quot;583&quot; x2=&quot;55&quot; y1=&quot;209&quot; x1=&quot;55&quot;&gt;&lt;/line&gt;&lt;polygon class=&quot;labelBox&quot; points=&quot;55,209 105,209 105,222 96.6,229 55,229&quot;&gt;&lt;/polygon&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;labelText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;222&quot; x=&quot;80&quot;&gt;loop&lt;/text&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; class=&quot;loopText&quot; text-anchor=&quot;middle&quot; y=&quot;227&quot; x=&quot;232.5&quot;&gt;&lt;tspan x=&quot;232.5&quot;&gt;[循环1]&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; dy=&quot;1em&quot; class=&quot;messageText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;80&quot; x=&quot;75&quot;&gt;文本1&lt;/text&gt;&lt;path style=&quot;stroke-dasharray: 3, 3; fill: none;&quot; stroke=&quot;none&quot; stroke-width=&quot;2&quot; class=&quot;messageLine1&quot; d=&quot;M 75,117 C 135,107 135,147 75,137&quot;&gt;&lt;/path&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; dy=&quot;1em&quot; class=&quot;messageText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;162&quot; x=&quot;175&quot;&gt;文本2&lt;/text&gt;&lt;line style=&quot;fill: none;&quot; marker-end=&quot;url(#arrowhead)&quot; stroke=&quot;none&quot; stroke-width=&quot;2&quot; class=&quot;messageLine0&quot; y2=&quot;199&quot; x2=&quot;275&quot; y1=&quot;199&quot; x1=&quot;75&quot;&gt;&lt;/line&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; dy=&quot;1em&quot; class=&quot;messageText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;306&quot; x=&quot;175&quot;&gt;文本3&lt;/text&gt;&lt;line style=&quot;fill: none;&quot; stroke=&quot;none&quot; stroke-width=&quot;2&quot; class=&quot;messageLine0&quot; y2=&quot;343&quot; x2=&quot;275&quot; y1=&quot;343&quot; x1=&quot;75&quot;&gt;&lt;/line&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; dy=&quot;1em&quot; class=&quot;messageText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;414&quot; x=&quot;175&quot;&gt;文本4&lt;/text&gt;&lt;line style=&quot;stroke-dasharray: 3, 3; fill: none;&quot; marker-end=&quot;url(#arrowhead)&quot; stroke=&quot;none&quot; stroke-width=&quot;2&quot; class=&quot;messageLine1&quot; y2=&quot;451&quot; x2=&quot;75&quot; y1=&quot;451&quot; x1=&quot;275&quot;&gt;&lt;/line&gt;&lt;text style=&quot;font-family: sans-serif; font-size: 16px; font-weight: 400;&quot; dy=&quot;1em&quot; class=&quot;messageText&quot; alignment-baseline=&quot;middle&quot; dominant-baseline=&quot;middle&quot; text-anchor=&quot;middle&quot; y=&quot;476&quot; x=&quot;275&quot;&gt;文本5&lt;/text&gt;&lt;path style=&quot;stroke-dasharray: 3, 3; fill: none;&quot; marker-end=&quot;url(#arrowhead)&quot; stroke=&quot;none&quot; stroke-width=&quot;2&quot; class=&quot;messageLine1&quot; d=&quot;M 275,513 C 335,503 335,543 275,533&quot;&gt;&lt;/path&gt;&lt;g&gt;&lt;rect class=&quot;actor&quot; ry=&quot;3&quot; rx=&quot;3&quot; height=&quot;65&quot; width=&quot;150&quot; stroke=&quot;#666&quot; fill=&quot;#eaeaea&quot; y=&quot;603&quot; x=&quot;0&quot;&gt;&lt;/rect&gt;&lt;text style=&quot;text-anchor: middle; font-size: 16px; font-weight: 400; font-family: sans-serif;&quot; class=&quot;actor&quot; alignment-baseline=&quot;central&quot; dominant-baseline=&quot;central&quot; y=&quot;635.5&quot; x=&quot;75&quot;&gt;&lt;tspan dy=&quot;0&quot; x=&quot;75&quot;&gt;A&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;g&gt;&lt;rect class=&quot;actor&quot; ry=&quot;3&quot; rx=&quot;3&quot; height=&quot;65&quot; width=&quot;150&quot; stroke=&quot;#666&quot; fill=&quot;#eaeaea&quot; y=&quot;603&quot; x=&quot;200&quot;&gt;&lt;/rect&gt;&lt;text style=&quot;text-anchor: middle; font-size: 16px; font-weight: 400; font-family: sans-serif;&quot; class=&quot;actor&quot; alignment-baseline=&quot;central&quot; dominant-baseline=&quot;central&quot; y=&quot;635.5&quot; x=&quot;275&quot;&gt;&lt;tspan dy=&quot;0&quot; x=&quot;275&quot;&gt;B&lt;/tspan&gt;&lt;/text&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;b843d0c1da9d2dd732fcafcc4672a763&quot; id=&quot;%E7%8A%B6%E6%80%81%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#%E7%8A%B6%E6%80%81%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;状态图[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;5a7cd39ea2e1673454af309ad8ffba9b&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问&lt;a href=&quot;/goJump.html?type=10&amp;href=https://mermaid-js.github.io/mermaid/#/stateDiagram&quot;&gt;Mermaid 状态图&lt;/a&gt;参考具体使用方法&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;figure data-sign=&quot;54a2cc7a77faae81885db4375b9847b8&quot; data-type=&quot;mermaid&quot; data-lines=&quot;13&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-roledescription=&quot;stateDiagram&quot; role=&quot;graphics-document document&quot; viewBox=&quot;0 0 114.6875 458&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot; class=&quot;statediagram&quot; width=&quot;114.6875&quot; id=&quot;mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602&quot;&gt;&lt;style&gt;#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .error-icon{fill:#552222;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .error-text{fill:#552222;stroke:#552222;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edge-thickness-normal{stroke-width:2px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .marker{fill:#333333;stroke:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .marker.cross{stroke:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 svg{font-family:sans-serif;font-size:16px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 defs #statediagram-barbEnd{fill:#333333;stroke:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 g.stateGroup text{fill:#9370DB;stroke:none;font-size:10px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 g.stateGroup text{fill:#333;stroke:none;font-size:10px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 g.stateGroup .state-title{font-weight:bolder;fill:#131300;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 g.stateGroup rect{fill:#ECECFF;stroke:#9370DB;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 g.stateGroup line{stroke:#333333;stroke-width:1;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .transition{stroke:#333333;stroke-width:1;fill:none;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .stateGroup .composit{fill:white;border-bottom:1px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .stateGroup .alt-composit{fill:#e0e0e0;border-bottom:1px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .state-note{stroke:#aaaa33;fill:#fff5ad;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .state-note text{fill:black;stroke:none;font-size:10px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .stateLabel .box{stroke:none;stroke-width:0;fill:#ECECFF;opacity:0.5;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edgeLabel .label rect{fill:#ECECFF;opacity:0.5;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .edgeLabel .label text{fill:#333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .label div .edgeLabel{color:#333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .stateLabel text{fill:#131300;font-size:10px;font-weight:bold;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .node circle.state-start{fill:#333333;stroke:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .node .fork-join{fill:#333333;stroke:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .node circle.state-end{fill:#9370DB;stroke:white;stroke-width:1.5;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .end-state-inner{fill:white;stroke-width:1.5;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .node rect{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .node polygon{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 #statediagram-barbEnd{fill:#333333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-cluster rect{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .cluster-label,#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .nodeLabel{color:#131300;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-cluster rect.outer{rx:5px;ry:5px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-state .divider{stroke:#9370DB;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-state .title-state{rx:5px;ry:5px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-cluster.statediagram-cluster .inner{fill:white;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-cluster.statediagram-cluster-alt .inner{fill:#f0f0f0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-cluster .inner{rx:0;ry:0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-state rect.basic{rx:5px;ry:5px;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-state rect.divider{stroke-dasharray:10,10;fill:#f0f0f0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .note-edge{stroke-dasharray:5;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-note rect{fill:#fff5ad;stroke:#aaaa33;stroke-width:1px;rx:0;ry:0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-note rect{fill:#fff5ad;stroke:#aaaa33;stroke-width:1px;rx:0;ry:0;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-note text{fill:black;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram-note .nodeLabel{color:black;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagram .edgeLabel{color:red;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 #dependencyStart,#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 #dependencyEnd{fill:#333333;stroke:#333333;stroke-width:1;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .statediagramTitleText{text-anchor:middle;font-size:18px;fill:#333;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 .label{font-family:sans-serif;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 :root{--mermaid-font-family:sans-serif;}#mermaid-54a2cc7a77faae81885db4375b9847b8-1733718752602 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerUnits=&quot;strokeWidth&quot; markerHeight=&quot;14&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;19&quot; id=&quot;statediagram-barbEnd&quot;&gt;&lt;path d=&quot;M 19,7 L9,13 L14,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;g class=&quot;root&quot;&gt;&lt;g class=&quot;clusters&quot;&gt;&lt;/g&gt;&lt;g class=&quot;edgePaths&quot;&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge5&quot; d=&quot;M20.023,386L20.023,390.167C20.023,394.333,20.023,402.667,25.335,411.406C30.646,420.144,41.268,429.289,46.579,433.861L51.89,438.433&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge6&quot; d=&quot;M94.367,386L94.367,390.167C94.367,394.333,94.367,402.667,89.056,411.406C83.745,420.144,73.123,429.289,67.811,433.861L62.5,438.433&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge0&quot; d=&quot;M57.195,22L57.195,26.167C57.195,30.333,57.195,38.667,57.195,47C57.195,55.333,57.195,63.667,57.195,67.833L57.195,72&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge1&quot; d=&quot;M26.882,293L25.739,297.167C24.596,301.333,22.31,309.667,21.166,318C20.023,326.333,20.023,334.667,20.023,338.833L20.023,343&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge2&quot; d=&quot;M87.509,293L88.652,297.167C89.795,301.333,92.081,309.667,93.224,318C94.367,326.333,94.367,334.667,94.367,338.833L94.367,343&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabels&quot;&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;nodes&quot;&gt;&lt;g transform=&quot;translate(57.1953125, 15)&quot; id=&quot;state-root_start-0&quot; class=&quot;node default&quot;&gt;&lt;circle height=&quot;14&quot; width=&quot;14&quot; r=&quot;7&quot; class=&quot;state-start&quot;&gt;&lt;/circle&gt;&lt;/g&gt;&lt;g transform=&quot;translate(1.7109375, 64)&quot; class=&quot;root&quot;&gt;&lt;g class=&quot;clusters&quot;&gt;&lt;g id=&quot;A&quot; class=&quot;statediagram-state statediagram-cluster&quot;&gt;&lt;rect height=&quot;221&quot; width=&quot;95.96875&quot; y=&quot;8&quot; x=&quot;8&quot; class=&quot;outer&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(50.3515625, 8)&quot; class=&quot;cluster-label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;11.265625&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;A&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;rect height=&quot;190&quot; width=&quot;95.96875&quot; y=&quot;35&quot; x=&quot;8&quot; class=&quot;inner&quot;&gt;&lt;/rect&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgePaths&quot;&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge3&quot; d=&quot;M55.984,47L55.984,51.167C55.984,55.333,55.984,63.667,55.984,72C55.984,80.333,55.984,88.667,55.984,92.833L55.984,97&quot;&gt;&lt;/path&gt;&lt;path marker-end=&quot;url(#statediagram-barbEnd)&quot; style=&quot;fill:none&quot; class=&quot;edge-thickness-normal transition&quot; id=&quot;edge4&quot; d=&quot;M55.984,140L55.984,144.167C55.984,148.333,55.984,156.667,55.984,165C55.984,173.333,55.984,181.667,55.984,185.833L55.984,190&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabels&quot;&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;rect height=&quot;0&quot; width=&quot;0&quot; ry=&quot;0&quot; rx=&quot;0&quot;&gt;&lt;/rect&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;nodes&quot;&gt;&lt;g transform=&quot;translate(55.984375, 40)&quot; id=&quot;state-A_start-3&quot; class=&quot;node default&quot;&gt;&lt;circle height=&quot;14&quot; width=&quot;14&quot; r=&quot;7&quot; class=&quot;state-start&quot;&gt;&lt;/circle&gt;&lt;/g&gt;&lt;g transform=&quot;translate(55.984375, 118.5)&quot; id=&quot;state-D-4&quot; class=&quot;node  statediagram-state&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;25.96875&quot; y=&quot;-21.5&quot; x=&quot;-12.984375&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-5.484375, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;10.96875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;D&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(55.984375, 197)&quot; id=&quot;state-A_end-4&quot; class=&quot;node default&quot;&gt;&lt;circle height=&quot;14&quot; width=&quot;14&quot; r=&quot;7&quot; class=&quot;state-start&quot;&gt;&lt;/circle&gt;&lt;circle height=&quot;10&quot; width=&quot;10&quot; r=&quot;5&quot; class=&quot;state-end&quot;&gt;&lt;/circle&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(20.0234375, 364.5)&quot; id=&quot;state-B-5&quot; class=&quot;node  statediagram-state&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;24.046875&quot; y=&quot;-21.5&quot; x=&quot;-12.0234375&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-4.5234375, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;9.046875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;B&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(94.3671875, 364.5)&quot; id=&quot;state-C-6&quot; class=&quot;node  statediagram-state&quot;&gt;&lt;rect height=&quot;43&quot; width=&quot;24.640625&quot; y=&quot;-21.5&quot; x=&quot;-12.3203125&quot; style=&quot;&quot; class=&quot;basic label-container&quot;&gt;&lt;/rect&gt;&lt;g transform=&quot;translate(-4.8203125, -14)&quot; style=&quot;&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;28&quot; width=&quot;9.640625&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;C&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(57.1953125, 443)&quot; id=&quot;state-root_end-6&quot; class=&quot;node default&quot;&gt;&lt;circle height=&quot;14&quot; width=&quot;14&quot; r=&quot;7&quot; class=&quot;state-start&quot;&gt;&lt;/circle&gt;&lt;circle height=&quot;10&quot; width=&quot;10&quot; r=&quot;5&quot; class=&quot;state-end&quot;&gt;&lt;/circle&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;5ee7cf7c37c6230959a01ca2d2b35fdf&quot; id=&quot;uml%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#uml%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;UML图[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;94be9be87aa8805f98f51bf9763ca74e&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问&lt;a href=&quot;/goJump.html?type=10&amp;href=https://mermaid-js.github.io/mermaid/#/classDiagram&quot;&gt;Mermaid UML图&lt;/a&gt;参考具体使用方法&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;figure data-sign=&quot;6efb7781a97f2add8e9b52c536847fc3&quot; data-type=&quot;mermaid&quot; data-lines=&quot;17&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-roledescription=&quot;classDiagram&quot; role=&quot;graphics-document document&quot; viewBox=&quot;0 0 273.328125 360&quot; height=&quot;360&quot; width=&quot;273.328125&quot; id=&quot;mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot;&gt;&lt;style&gt;#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .error-icon{fill:#552222;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .error-text{fill:#552222;stroke:#552222;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edge-thickness-normal{stroke-width:2px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .marker{fill:#333333;stroke:#333333;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .marker.cross{stroke:#333333;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 svg{font-family:sans-serif;font-size:16px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 g.classGroup text{fill:#9370DB;fill:#131300;stroke:none;font-family:sans-serif;font-size:10px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 g.classGroup text .title{font-weight:bolder;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .nodeLabel,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edgeLabel{color:#131300;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edgeLabel .label rect{fill:#ECECFF;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .label text{fill:#131300;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edgeLabel .label span{background:#ECECFF;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .classTitle{font-weight:bolder;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .node rect,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .node circle,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .node ellipse,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .node polygon,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .node path{fill:#ECECFF;stroke:#9370DB;stroke-width:1px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .divider{stroke:#9370DB;stroke:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 g.clickable{cursor:pointer;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 g.classGroup rect{fill:#ECECFF;stroke:#9370DB;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 g.classGroup line{stroke:#9370DB;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .classLabel .box{stroke:none;stroke-width:0;fill:#ECECFF;opacity:0.5;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .classLabel .label{fill:#9370DB;font-size:10px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .relation{stroke:#333333;stroke-width:1;fill:none;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .dashed-line{stroke-dasharray:3;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .dotted-line{stroke-dasharray:1 2;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #compositionStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .composition{fill:#333333!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #compositionEnd,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .composition{fill:#333333!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #dependencyStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .dependency{fill:#333333!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #dependencyStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .dependency{fill:#333333!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #extensionStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .extension{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #extensionEnd,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .extension{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #aggregationStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .aggregation{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #aggregationEnd,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .aggregation{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #lollipopStart,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .lollipop{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 #lollipopEnd,#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .lollipop{fill:#ECECFF!important;stroke:#333333!important;stroke-width:1;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .edgeTerminals{font-size:11px;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .classTitleText{text-anchor:middle;font-size:18px;fill:#333;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 .label{font-family:sans-serif;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 :root{--mermaid-font-family:sans-serif;}#mermaid-6efb7781a97f2add8e9b52c536847fc3-1733718752617 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;240&quot; markerWidth=&quot;190&quot; refY=&quot;7&quot; refX=&quot;0&quot; class=&quot;marker aggregation classDiagram&quot; id=&quot;classDiagram-aggregationStart&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L1,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;28&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;19&quot; class=&quot;marker aggregation classDiagram&quot; id=&quot;classDiagram-aggregationEnd&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L1,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;240&quot; markerWidth=&quot;190&quot; refY=&quot;7&quot; refX=&quot;0&quot; class=&quot;marker extension classDiagram&quot; id=&quot;classDiagram-extensionStart&quot;&gt;&lt;path d=&quot;M 1,7 L18,13 V 1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;28&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;19&quot; class=&quot;marker extension classDiagram&quot; id=&quot;classDiagram-extensionEnd&quot;&gt;&lt;path d=&quot;M 1,1 V 13 L18,7 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;240&quot; markerWidth=&quot;190&quot; refY=&quot;7&quot; refX=&quot;0&quot; class=&quot;marker composition classDiagram&quot; id=&quot;classDiagram-compositionStart&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L1,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;28&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;19&quot; class=&quot;marker composition classDiagram&quot; id=&quot;classDiagram-compositionEnd&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L1,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;240&quot; markerWidth=&quot;190&quot; refY=&quot;7&quot; refX=&quot;0&quot; class=&quot;marker dependency classDiagram&quot; id=&quot;classDiagram-dependencyStart&quot;&gt;&lt;path d=&quot;M 5,7 L9,13 L1,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;28&quot; markerWidth=&quot;20&quot; refY=&quot;7&quot; refX=&quot;19&quot; class=&quot;marker dependency classDiagram&quot; id=&quot;classDiagram-dependencyEnd&quot;&gt;&lt;path d=&quot;M 18,7 L9,13 L14,7 L9,1 Z&quot;&gt;&lt;/path&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;defs&gt;&lt;marker orient=&quot;auto&quot; markerHeight=&quot;240&quot; markerWidth=&quot;190&quot; refY=&quot;7&quot; refX=&quot;0&quot; class=&quot;marker lollipop classDiagram&quot; id=&quot;classDiagram-lollipopStart&quot;&gt;&lt;circle r=&quot;6&quot; cy=&quot;7&quot; cx=&quot;6&quot; fill=&quot;white&quot; stroke=&quot;black&quot;&gt;&lt;/circle&gt;&lt;/marker&gt;&lt;/defs&gt;&lt;g class=&quot;root&quot;&gt;&lt;g class=&quot;clusters&quot;&gt;&lt;/g&gt;&lt;g class=&quot;edgePaths&quot;&gt;&lt;path marker-start=&quot;url(#classDiagram-extensionStart)&quot; style=&quot;fill:none&quot; class=&quot;edge-pattern-solid relation&quot; id=&quot;id1&quot; d=&quot;M96.176,171L93.17,175.167C90.164,179.333,84.153,187.667,81.147,196C78.141,204.333,78.141,212.667,78.141,216.833L78.141,221&quot;&gt;&lt;/path&gt;&lt;path marker-start=&quot;url(#classDiagram-extensionStart)&quot; style=&quot;fill:none&quot; class=&quot;edge-pattern-solid relation&quot; id=&quot;id2&quot; d=&quot;M213.769,171L216.775,175.167C219.781,179.333,225.793,187.667,228.799,196C231.805,204.333,231.805,212.667,231.805,216.833L231.805,221&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabels&quot;&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;edgeLabel&quot;&gt;&lt;g transform=&quot;translate(0, 0)&quot; class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;edgeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;g class=&quot;nodes&quot;&gt;&lt;g transform=&quot;translate(154.97265625, 89.5)&quot; id=&quot;classid-Base-0&quot; class=&quot;node default&quot;&gt;&lt;rect height=&quot;163&quot; width=&quot;180.1875&quot; y=&quot;-81.5&quot; x=&quot;-90.09375&quot; class=&quot;outer title-state&quot;&gt;&lt;/rect&gt;&lt;line y2=&quot;-41.5&quot; y1=&quot;-41.5&quot; x2=&quot;90.09375&quot; x1=&quot;-90.09375&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;line y2=&quot;6.5&quot; y1=&quot;6.5&quot; x2=&quot;90.09375&quot; x1=&quot;-90.09375&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;g class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -16.828125, -74)&quot; height=&quot;28&quot; width=&quot;33.65625&quot; class=&quot;classTitle&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;Base&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -82.59375, -30)&quot; height=&quot;28&quot; width=&quot;94.03125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;+String name&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -82.59375, 14)&quot; height=&quot;28&quot; width=&quot;84.375&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;+getName()&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -82.59375, 46)&quot; height=&quot;28&quot; width=&quot;165.1875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;+setName(String name)&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(78.140625, 286.5)&quot; id=&quot;classid-One-1&quot; class=&quot;node default&quot;&gt;&lt;rect height=&quot;131&quot; width=&quot;140.28125&quot; y=&quot;-65.5&quot; x=&quot;-70.140625&quot; class=&quot;outer title-state&quot;&gt;&lt;/rect&gt;&lt;line y2=&quot;-25.5&quot; y1=&quot;-25.5&quot; x2=&quot;70.140625&quot; x1=&quot;-70.140625&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;line y2=&quot;22.5&quot; y1=&quot;22.5&quot; x2=&quot;70.140625&quot; x1=&quot;-70.140625&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;g class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -14.75, -58)&quot; height=&quot;28&quot; width=&quot;29.5&quot; class=&quot;classTitle&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;One&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -62.640625, -14)&quot; height=&quot;28&quot; width=&quot;125.28125&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;+String newName&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -62.640625, 30)&quot; height=&quot;28&quot; width=&quot;115.625&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;+getNewName()&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(231.8046875, 286.5)&quot; id=&quot;classid-Two-2&quot; class=&quot;node default&quot;&gt;&lt;rect height=&quot;131&quot; width=&quot;67.046875&quot; y=&quot;-65.5&quot; x=&quot;-33.5234375&quot; class=&quot;outer title-state&quot;&gt;&lt;/rect&gt;&lt;line y2=&quot;-25.5&quot; y1=&quot;-25.5&quot; x2=&quot;33.5234375&quot; x1=&quot;-33.5234375&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;line y2=&quot;22.5&quot; y1=&quot;22.5&quot; x2=&quot;33.5234375&quot; x1=&quot;-33.5234375&quot; class=&quot;divider&quot;&gt;&lt;/line&gt;&lt;g class=&quot;label&quot;&gt;&lt;foreignObject height=&quot;0&quot; width=&quot;0&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -14.9765625, -58)&quot; height=&quot;28&quot; width=&quot;29.953125&quot; class=&quot;classTitle&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;Two&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -26.0234375, -14)&quot; height=&quot;28&quot; width=&quot;41.609375&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;-int id&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;foreignObject transform=&quot;translate( -26.0234375, 30)&quot; height=&quot;28&quot; width=&quot;52.046875&quot;&gt;&lt;div xmlns=&quot;http://www.w3.org/1999/xhtml&quot; style=&quot;display: inline-block; white-space: nowrap;&quot;&gt;&lt;span class=&quot;nodeLabel&quot;&gt;-getId()&lt;/span&gt;&lt;/div&gt;&lt;/foreignObject&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;c6d7be1aec071cbe9d20f97fecf97a3d&quot; id=&quot;%E9%A5%BC%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#%E9%A5%BC%E5%9B%BE%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;饼图[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;27ac2a5ea1cf4118b8c5007f49dc0f4b&quot; data-lines=&quot;1&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问&lt;a href=&quot;/goJump.html?type=10&amp;href=https://mermaid-js.github.io/mermaid/#/pie&quot;&gt;Mermaid 饼图&lt;/a&gt;参考具体使用方法&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee417a96926faf5a356cff17cb2402ea2&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;/p&gt;&lt;figure data-sign=&quot;858868d5bc047072e4534a63aa28f83f&quot; data-type=&quot;mermaid&quot; data-lines=&quot;9&quot;&gt;&lt;svg xmlns:xlink=&quot;http://www.w3.org/1999/xlink&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; aria-labelledby=&quot;chart-title-mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631&quot; aria-roledescription=&quot;pie&quot; role=&quot;graphics-document document&quot; viewBox=&quot;0 0 1024 450&quot; style=&quot;max-width: 100%; height: auto; font-family: sans-serif;&quot; width=&quot;1024&quot; id=&quot;mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631&quot;&gt;&lt;title id=&quot;chart-title-mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631&quot;&gt;饼图&lt;/title&gt;&lt;style&gt;#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631{font-family:sans-serif;font-size:16px;fill:#333;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .error-icon{fill:#552222;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .error-text{fill:#552222;stroke:#552222;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .edge-thickness-normal{stroke-width:2px;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .edge-thickness-thick{stroke-width:3.5px;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .edge-pattern-solid{stroke-dasharray:0;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .marker{fill:#333333;stroke:#333333;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .marker.cross{stroke:#333333;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 svg{font-family:sans-serif;font-size:16px;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .pieCircle{stroke:black;stroke-width:2px;opacity:0.7;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .pieTitleText{text-anchor:middle;font-size:25px;fill:black;font-family:sans-serif;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .slice{font-family:sans-serif;fill:#333;font-size:17px;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .legend text{fill:black;font-family:sans-serif;font-size:17px;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .label foreignObject{font-size:90%;overflow:visible;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 .label{font-family:sans-serif;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 :root{--mermaid-font-family:sans-serif;}#mermaid-858868d5bc047072e4534a63aa28f83f-1733718752631 :root{--mermaid-alt-font-family:sans-serif;}&lt;/style&gt;&lt;g&gt;&lt;/g&gt;&lt;g transform=&quot;translate(512,225)&quot;&gt;&lt;path class=&quot;pieCircle&quot; fill=&quot;#ECECFF&quot; d=&quot;M0,-185A185,185,0,0,1,108.74,149.668L0,0Z&quot;&gt;&lt;/path&gt;&lt;path class=&quot;pieCircle&quot; fill=&quot;#ffffde&quot; d=&quot;M108.74,149.668A185,185,0,0,1,-175.945,57.168L0,0Z&quot;&gt;&lt;/path&gt;&lt;path class=&quot;pieCircle&quot; fill=&quot;hsl(80, 100%, 56.2745098039%)&quot; d=&quot;M-175.945,57.168A185,185,0,0,1,-108.74,-149.668L0,0Z&quot;&gt;&lt;/path&gt;&lt;path class=&quot;pieCircle&quot; fill=&quot;hsl(240, 100%, 86.2745098039%)&quot; d=&quot;M-108.74,-149.668A185,185,0,0,1,0,-185L0,0Z&quot;&gt;&lt;/path&gt;&lt;text style=&quot;text-anchor: middle;&quot; class=&quot;slice&quot; transform=&quot;translate(87.9727277573017,-28.584071979682633)&quot;&gt;40%&lt;/text&gt;&lt;text style=&quot;text-anchor: middle;&quot; class=&quot;slice&quot; transform=&quot;translate(-28.58407197968263,87.97272775730171)&quot;&gt;30%&lt;/text&gt;&lt;text style=&quot;text-anchor: middle;&quot; class=&quot;slice&quot; transform=&quot;translate(-87.97272775730171,-28.584071979682623)&quot;&gt;20%&lt;/text&gt;&lt;text style=&quot;text-anchor: middle;&quot; class=&quot;slice&quot; transform=&quot;translate(-28.58407197968265,-87.9727277573017)&quot;&gt;10%&lt;/text&gt;&lt;text class=&quot;pieTitleText&quot; y=&quot;-200&quot; x=&quot;0&quot;&gt;饼图&lt;/text&gt;&lt;g transform=&quot;translate(216,-44)&quot; class=&quot;legend&quot;&gt;&lt;rect style=&quot;fill: rgb(236, 236, 255); stroke: rgb(236, 236, 255);&quot; height=&quot;18&quot; width=&quot;18&quot;&gt;&lt;/rect&gt;&lt;text y=&quot;14&quot; x=&quot;22&quot;&gt;A&lt;/text&gt;&lt;/g&gt;&lt;g transform=&quot;translate(216,-22)&quot; class=&quot;legend&quot;&gt;&lt;rect style=&quot;fill: rgb(255, 255, 222); stroke: rgb(255, 255, 222);&quot; height=&quot;18&quot; width=&quot;18&quot;&gt;&lt;/rect&gt;&lt;text y=&quot;14&quot; x=&quot;22&quot;&gt;B&lt;/text&gt;&lt;/g&gt;&lt;g transform=&quot;translate(216,0)&quot; class=&quot;legend&quot;&gt;&lt;rect style=&quot;fill: rgb(181, 255, 32); stroke: rgb(181, 255, 32);&quot; height=&quot;18&quot; width=&quot;18&quot;&gt;&lt;/rect&gt;&lt;text y=&quot;14&quot; x=&quot;22&quot;&gt;C&lt;/text&gt;&lt;/g&gt;&lt;g transform=&quot;translate(216,22)&quot; class=&quot;legend&quot;&gt;&lt;rect style=&quot;fill: rgb(185, 185, 255); stroke: rgb(185, 185, 255);&quot; height=&quot;18&quot; width=&quot;18&quot;&gt;&lt;/rect&gt;&lt;text y=&quot;14&quot; x=&quot;22&quot;&gt;D&lt;/text&gt;&lt;/g&gt;&lt;/g&gt;&lt;/svg&gt;&lt;/figure&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;1ffff3fbb88ac077c0fd7ece65740fc3&quot; id=&quot;%E6%B3%A8%E9%87%8A%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot;&gt;&lt;a href=&quot;#%E6%B3%A8%E9%87%8A%E4%B8%8D%E9%80%9A%E7%94%A8%E6%8F%90%E9%86%92&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;注释[^不通用提醒]&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c6247c0bd51e035939c487df6d2a61cd1&quot;&gt;&lt;strong&gt;说明&lt;/strong&gt;&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;0f88234fa65144fed2e91c804f71333a&quot; data-lines=&quot;3&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用中括号+冒号（[]:）生成单行注释&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;使用中括号+尖号+冒号（[^]:）生成多行注释&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;多行注释以连续两次回车结束&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;36f27fa16ebe87477e8e3ad1cab87cb32&quot;&gt;&lt;strong&gt;示例&lt;/strong&gt;&lt;/p&gt;&lt;div data-sign=&quot;382298559f80399bb2f43bcd47c40ee5&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;13&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;markdown&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-expand&quot;&gt;\n      &lt;pre class=&quot;language-markdown&quot;&gt;&lt;code class=&quot;language-markdown wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;下面是一行单行注释&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url-reference url&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;[&lt;/span&gt;&lt;span class=&quot;token variable&quot;&gt;注释摘要&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;]&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;:&lt;/span&gt; 这是一段注释，不会显示到页面上&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;上面面是一行单行注释&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;下面是多行注释&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token url-reference url&quot;&gt;&lt;span class=&quot;token punctuation&quot;&gt;[&lt;/span&gt;&lt;span class=&quot;token variable&quot;&gt;^注释摘要&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;]&lt;/span&gt;&lt;span class=&quot;token punctuation&quot;&gt;:&lt;/span&gt; 这是一段多行注释，不会显示到页面上&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;可以换行&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;    可以缩进&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;以两次回车结束&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;上面是多行注释&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;/div&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;16da253b10b26ecc17248a3484e499693&quot;&gt;&lt;strong&gt;效果&lt;/strong&gt;&lt;br&gt;下面是一行单行注释&lt;/p&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;a32b818ba80eda59726117373e5d85c83&quot;&gt;上面面是一行单行注释&lt;br&gt;下面是多行注释&lt;/p&gt;&lt;p data-lines=&quot;5&quot; data-type=&quot;br&quot; data-sign=&quot;br5&quot;&gt;&amp;nbsp;&lt;/p&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;a53dd44f69f77e4e466037d48d4427381&quot;&gt;上面是多行注释&lt;/p&gt;&lt;hr data-lines=&quot;2&quot; data-sign=&quot;hr2&quot;&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;d321c617eea7643108171936fa08d91d&quot; id=&quot;%E5%BF%AB%E6%8D%B7%E9%94%AE&quot;&gt;&lt;a href=&quot;#%E5%BF%AB%E6%8D%B7%E9%94%AE&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;快捷键&lt;/h2&gt;&lt;div data-lines=&quot;15&quot; data-sign=&quot;edc9be39fe212860b0438f4e89c86dd915&quot; class=&quot;cherry-table-container&quot;&gt;\n        &lt;table class=&quot;cherry-table&quot;&gt;&lt;thead&gt;&lt;tr&gt;&lt;th&gt;功能&lt;/th&gt;&lt;th&gt;按键(Windows)&lt;/th&gt;&lt;th&gt;按键(macOS)&lt;/th&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&gt;1级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;1&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;1&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;2级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;2&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;2&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;3级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;3&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;3&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;4级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;4&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;4&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;5级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;5&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;5&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;6级标题&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;6&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;6&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;加粗&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;b&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;b&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;斜体&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;i&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;i&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;插入链接&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;l&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;l&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;插入代码块&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;k&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;k&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;插入图片&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;g&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;g&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;插入公式&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;Ctrl&lt;/kbd&gt; + &lt;kbd&gt;m&lt;/kbd&gt;&lt;/td&gt;&lt;td&gt;&lt;kbd&gt;⌘&lt;/kbd&gt; + &lt;kbd&gt;m&lt;/kbd&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;/div&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;b86ebe66e7492109b3dadf0f1b746521&quot; id=&quot;%E5%8D%8F%E8%AE%AE&quot;&gt;&lt;a href=&quot;#%E5%8D%8F%E8%AE%AE&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;协议&lt;/h2&gt;&lt;div data-sign=&quot;f4a7cc4acdd548504655fa72f1c2b9e5&quot; data-type=&quot;codeBlock&quot; data-lines=&quot;23&quot; data-edit-code=&quot;true&quot; data-copy-code=&quot;true&quot; data-expand-code=&quot;true&quot; data-change-lang=&quot;true&quot; data-lang=&quot;&quot; style=&quot;position:relative&quot; class=&quot;cherry-code-unExpand&quot;&gt;\n      &lt;pre class=&quot;language-javascript&quot;&gt;&lt;code class=&quot;language-javascript wrap&quot;&gt;&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt;/**&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * Tencent is pleased to support the open source community by making CherryMarkdown available.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * Copyright (C) 2021 THL A29 Limited, a Tencent company. All rights reserved.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * The below software in this distribution may have been modified by THL A29 Limited (&quot;Tencent Modifications&quot;).&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * All Tencent Modifications are Copyright (C) THL A29 Limited.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * CherryMarkdown is licensed under the Apache License, Version 2.0 (the &quot;License&quot;);&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * you may not use this file except in compliance with the License.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * You may obtain a copy of the License at&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *     http://www.apache.org/licenses/LICENSE-2.0&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; *&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * Unless required by applicable law or agreed to in writing, software&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * See the License for the specific language governing permissions and&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; * limitations under the License.&lt;/span&gt;&lt;/span&gt;\n&lt;span class=&quot;code-line&quot;&gt;&lt;span class=&quot;token doc-comment comment&quot;&gt; */&lt;/span&gt;&lt;/span&gt;&lt;/code&gt;&lt;/pre&gt;\n      &lt;div class=&quot;cherry-mask-code-block&quot;&gt;\n        &lt;div class=&quot;expand-btn &quot;&gt;\n          &lt;i class=&quot;ch-icon ch-icon-expand&quot;&gt;&lt;/i&gt;\n        &lt;/div&gt;\n      &lt;/div&gt;&lt;/div&gt;&lt;p data-lines=&quot;4&quot; data-type=&quot;br&quot; data-sign=&quot;br4&quot;&gt;&amp;nbsp;&lt;/p&gt;&lt;/div&gt;', 1, 25, NULL, '2024-12-09 12:37:12', '2024-12-09 12:37:12', 1, 0, '百度网盘', '', '', '/public/sysImg/Article-Cover-01.png', NULL, NULL, '', 1, 'true', '{\"member_pay\": false, \"permission\": \"full_text\", \"member_price\": 0, \"ordinary_pay\": false, \"ordinary_price\": 0, \"reading_permission\": false}', 2);

-- ----------------------------
-- Table structure for PREFIX_article_cate
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article_cate`;
CREATE TABLE `PREFIX_article_cate`  (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '文章分类id',
  `pid` bigint(20) UNSIGNED NULL DEFAULT 0 COMMENT '分类父级id',
  `sort` int(8) NULL DEFAULT 0 COMMENT '排序',
  `title` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '标题',
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 7 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '文章分类表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article_cate
-- ----------------------------
INSERT INTO `PREFIX_article_cate` VALUES (1, 0, 50, '默认分类', '2024-08-21 05:26:06', '2024-08-21 05:26:06');

-- ----------------------------
-- Table structure for PREFIX_article_collect
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article_collect`;
CREATE TABLE `PREFIX_article_collect`  (
  `id` bigint(25) NOT NULL,
  `ac_id` bigint(25) NOT NULL COMMENT '账号id',
  `article_id` bigint(25) NOT NULL COMMENT '文章id',
  `favorited_at` datetime NULL DEFAULT NULL COMMENT '收藏时间',
  `is_favorite` tinyint(1) NULL DEFAULT 1 COMMENT '是否仍然标记为收藏，方便用户取消收藏而不删除记录',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '文章收藏表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article_collect
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_article_like
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article_like`;
CREATE TABLE `PREFIX_article_like`  (
  `id` bigint(25) NOT NULL,
  `ac_id` bigint(25) NOT NULL COMMENT '账号id',
  `article_id` bigint(25) NOT NULL COMMENT '文章id',
  `like_at` datetime NULL DEFAULT NULL COMMENT '喜欢时间',
  `is_like` tinyint(1) NULL DEFAULT 1 COMMENT '是否仍然标记为喜欢，方便用户取消喜欢而不删除记录',
  `is_read` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT '0' COMMENT '是否 阅读 1 阅读 0 未阅读',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '文章喜欢表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article_like
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_article_tags
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article_tags`;
CREATE TABLE `PREFIX_article_tags`  (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 103 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '文章标签表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article_tags
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_article_tags_rel
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_article_tags_rel`;
CREATE TABLE `PREFIX_article_tags_rel`  (
  `article_id` bigint(20) NULL DEFAULT NULL,
  `tag_id` bigint(20) NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '文章标签关联表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_article_tags_rel
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_attributes
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_attributes`;
CREATE TABLE `PREFIX_attributes`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `field` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `values` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `class` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '1text 2radio 3checkbox 4select',
  `sort` int(11) NULL DEFAULT NULL,
  `default_value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isrequire` tinyint(1) NULL DEFAULT 0,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `maxlength` int(11) NULL DEFAULT 0,
  `siteid` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_attributes
-- ----------------------------
INSERT INTO `PREFIX_attributes` VALUES (1, '行业', 'attr_hangye', '机械制造\n招商加盟\n工程服务\n服务培训', 'checkbox', 50, NULL, 0, NULL, 0, NULL);

-- ----------------------------
-- Table structure for PREFIX_banner
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_banner`;
CREATE TABLE `PREFIX_banner`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT 0,
  `cid` int(11) NULL DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT 0,
  `descript` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 8 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_banner
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_banner_cate
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_banner_cate`;
CREATE TABLE `PREFIX_banner_cate`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `thumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NOT NULL DEFAULT 50,
  `isfirst` tinyint(1) NOT NULL DEFAULT 0,
  `ishot` tinyint(1) NOT NULL DEFAULT 0,
  `pid` int(11) NOT NULL DEFAULT 0,
  `istemplate` tinyint(1) NULL DEFAULT NULL,
  `fthumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `xthumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '小程序图标',
  `formula` tinyint(1) NULL DEFAULT 0 COMMENT '公式标识',
  `collectstatus` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_banner_cate
-- ----------------------------
INSERT INTO `PREFIX_banner_cate` VALUES (1, '首页banner', NULL, 50, 0, 0, 0, NULL, NULL, NULL, 0, 0);

-- ----------------------------
-- Table structure for PREFIX_cate
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_cate`;
CREATE TABLE `PREFIX_cate`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `thumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NOT NULL DEFAULT 50,
  `isfirst` tinyint(1) NOT NULL DEFAULT 0,
  `ishot` tinyint(1) NOT NULL DEFAULT 0,
  `pid` int(11) NOT NULL DEFAULT 0,
  `istemplate` tinyint(1) NULL DEFAULT NULL,
  `fthumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `xthumb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '小程序图标',
  `formula` tinyint(1) NULL DEFAULT 0 COMMENT '公式标识',
  `collectstatus` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 32 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_cate
-- ----------------------------
INSERT INTO `PREFIX_cate` VALUES (4, 'AI绘图提示词', NULL, 50, 0, 0, 3, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (14, '默认分类', NULL, 50, 0, 0, 0, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (20, 'Ai抠图', NULL, 9, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (21, 'Ai工具集', NULL, 10, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (22, 'Ai人像', NULL, 1, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (23, 'AI图片变清晰', NULL, 8, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (24, 'AI修复图片', NULL, 7, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (25, 'AI杂物祛除', NULL, 6, 0, 0, 5, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (26, 'AI图集', NULL, 50, 0, 0, 3, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (27, 'Ai音频工具', NULL, 50, 0, 0, 10, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (28, '大模型&Lora', NULL, 50, 0, 0, 3, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (29, '推荐UP&学习网站', NULL, 50, 0, 0, 3, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (30, '绘图工具', NULL, 60, 0, 0, 3, NULL, NULL, NULL, 0, 0);
INSERT INTO `PREFIX_cate` VALUES (31, 'AI视频工具', NULL, 50, 0, 0, 10, NULL, NULL, NULL, 0, 0);

-- ----------------------------
-- Table structure for PREFIX_category
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_category`;
CREATE TABLE `PREFIX_category`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '分类名称',
  `pid` int(11) NOT NULL DEFAULT 0 COMMENT '上级分类',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `status` int(1) NOT NULL DEFAULT 1 COMMENT '0不显示 1显示',
  `siteid` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '内容栏目' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_category
-- ----------------------------
INSERT INTO `PREFIX_category` VALUES (1, '123123', 0, 9, 1, NULL);

-- ----------------------------
-- Table structure for PREFIX_category_attributes
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_category_attributes`;
CREATE TABLE `PREFIX_category_attributes`  (
  `category_id` int(11) NOT NULL DEFAULT 0,
  `attribute_id` int(11) NOT NULL DEFAULT 0,
  UNIQUE INDEX `cid_aid`(`category_id`, `attribute_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_category_attributes
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_category_types
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_category_types`;
CREATE TABLE `PREFIX_category_types`  (
  `category_id` int(11) NOT NULL DEFAULT 0,
  `type_id` int(11) NOT NULL DEFAULT 0,
  UNIQUE INDEX `cid_tid`(`category_id`, `type_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_category_types
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_check
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_check`;
CREATE TABLE `PREFIX_check`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `client_ip` varchar(20) CHARACTER SET gbk COLLATE gbk_chinese_ci NULL DEFAULT NULL,
  `code` varchar(20) CHARACTER SET gbk COLLATE gbk_chinese_ci NULL DEFAULT NULL,
  `time` bigint(7) NULL DEFAULT NULL,
  `tel` varchar(20) CHARACTER SET gbk COLLATE gbk_chinese_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = MyISAM AUTO_INCREMENT = 86 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '手机验证码表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_check
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_collect
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_collect`;
CREATE TABLE `PREFIX_collect`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `web_id` int(11) NOT NULL,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 63 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_collect
-- ----------------------------
INSERT INTO `PREFIX_collect` VALUES (39, 1, 0, '实现滚动到一', 'https://www.jianshu.com/favicon.ico', 'https://www.jianshu.com', 49);
INSERT INTO `PREFIX_collect` VALUES (42, 1, 0, '我被大姑白嫖了三年恨之入骨，结婚时她居然送了我100万的红包 - 简书', 'https://www.jianshu.com/p/0a3c03c7ce3c/favicon.ico', 'https://www.jianshu.com/p/0a3c03c7ce3c', 41);
INSERT INTO `PREFIX_collect` VALUES (43, 1, 0, 'CSS 文字超出部分显示省略号 - 严格的阿b - 博客园', 'cnblogs.com/favicon.ico', 'https://www.cnblogs.com/hukuangjie/p/12120931.html', 50);
INSERT INTO `PREFIX_collect` VALUES (44, 1, 0, '芦虎导航 - 专业的网站大全分类目录导航网', 'https://www.luhu.co//favicon.ico', 'https://www.luhu.co/', 52);
INSERT INTO `PREFIX_collect` VALUES (47, 1, 0, '我被大姑白嫖了三年恨之入骨，结婚时她居然送了我100万的红包 - 简书', 'jianshu.com/favicon.ico', 'https://www.jianshu.com/p/0a3c03c7ce3c', 45);
INSERT INTO `PREFIX_collect` VALUES (48, 1, 0, 'CSS 文字超出部分显示省略号 - 严格的阿b - 博客园', 'cnblogs.com/favicon.ico', 'https://www.cnblogs.com/hukuangjie/p/12120931.html', 46);
INSERT INTO `PREFIX_collect` VALUES (49, 1, 0, '我被大姑白嫖了三年恨之入骨，结婚时她居然送了我100万的红包 - 简书', 'jianshu.com/favicon.ico', 'https://www.jianshu.com/p/0a3c03c7ce3c', 47);
INSERT INTO `PREFIX_collect` VALUES (50, 1, 0, 'CSS 文字超出部分显示省略号 - 严格的阿b - 博客园', 'cnblogs.com/favicon.ico', 'https://www.cnblogs.com/hukuangjie/p/12120931.html', 48);
INSERT INTO `PREFIX_collect` VALUES (51, 1, 0, '我被大姑白嫖了三年恨之入骨，结婚时她居然送了我100万的红包 - 简书', 'https://www.jianshu.com/p/0a3c03c7ce3c/favicon.ico', 'https://www.jianshu.com/p/0a3c03c7ce3c', 51);
INSERT INTO `PREFIX_collect` VALUES (52, 1, 2, '谷歌', '123', '123', 53);
INSERT INTO `PREFIX_collect` VALUES (53, 1, 0, '花瓣网_陪你做生活的设计师（创意灵感天堂，搜索、发现设计灵感、设计素材）', 'https://huaban.com//favicon.ico', 'https://huaban.com/', 42);
INSERT INTO `PREFIX_collect` VALUES (54, 1, 0, '', 'huaban.com/favicon.ico', 'https://huaban.com/home/', 54);
INSERT INTO `PREFIX_collect` VALUES (55, 1, 0, '', 'huaban.com/favicon.ico', 'https://huaban.com/home/', 55);
INSERT INTO `PREFIX_collect` VALUES (56, 1, 0, '花瓣网_陪你做生活的设计师（创意灵感天堂，搜索、发现设计灵感、设计素材）', 'https://huaban.com//favicon.ico', 'https://huaban.com/', 56);
INSERT INTO `PREFIX_collect` VALUES (57, 1, 0, '站酷 (ZCOOL) - 设计师互动平台 - 打开站酷，发现更好的设计！', 'https://www.zcool.com.cn//favicon.ico', 'https://www.zcool.com.cn/', 57);
INSERT INTO `PREFIX_collect` VALUES (58, 1, 0, '站酷 (ZCOOL) - 设计师互动平台 - 打开站酷，发现更好的设计！', 'https://www.zcool.com.cn//favicon.ico', 'https://www.zcool.com.cn/', 58);
INSERT INTO `PREFIX_collect` VALUES (59, 1, 0, '我被大姑白嫖了三年恨之入骨，结婚时她居然送了我100万的红包 - 简书', 'jianshu.com/favicon.ico', 'https://www.jianshu.com/p/0a3c03c7ce3c', 59);
INSERT INTO `PREFIX_collect` VALUES (60, 1, 0, '', 'https://unsplash.com//favicon.ico', 'https://unsplash.com/', 60);
INSERT INTO `PREFIX_collect` VALUES (61, 1, 0, '', 'https://unsplash.com//favicon.ico', 'https://unsplash.com/', 61);
INSERT INTO `PREFIX_collect` VALUES (62, 1, 0, '花瓣网_陪你做生活的设计师（创意灵感天堂，搜索、发现设计灵感、设计素材）', 'https://huaban.com//favicon.ico', 'https://huaban.com/', 62);

-- ----------------------------
-- Table structure for PREFIX_comments
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_comments`;
CREATE TABLE `PREFIX_comments`  (
  `id` bigint(22) NOT NULL COMMENT '唯一标识每条评论',
  `parent_id` bigint(22) NULL DEFAULT NULL COMMENT '用于支持回复功能。NULL表示顶级评论，否则为回复 用于层级',
  `reply_ac_id` bigint(22) NULL DEFAULT NULL COMMENT '回复账号id',
  `ac_id` bigint(22) NOT NULL COMMENT '关联用户表的用户ID',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '用户输入的原始评论内容',
  `filtered_content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '经过关键词过滤后的评论内容',
  `status` tinyint(2) NULL DEFAULT 0 COMMENT '0等待审批 1 审批通过 2拒绝',
  `created_at` datetime NULL DEFAULT NULL COMMENT '创建',
  `updated_at` datetime NULL DEFAULT NULL COMMENT '更新时间',
  `client_ip` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '客户ip',
  `rel_id` int(22) NULL DEFAULT NULL COMMENT '文章id',
  `type` tinyint(2) NULL DEFAULT 1 COMMENT '1 文章',
  `reply_id` bigint(22) NULL DEFAULT NULL COMMENT '回复记录id',
  `is_read` tinyint(2) NULL DEFAULT 0 COMMENT '0 未阅读 1 已阅读',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `parent_id`(`parent_id`) USING BTREE,
  INDEX `ac_id`(`ac_id`) USING BTREE,
  INDEX `status`(`status`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_comments
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_content
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content`;
CREATE TABLE `PREFIX_content`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT 0 COMMENT '栏目ID',
  `mid` int(11) NOT NULL COMMENT '所属模型ID',
  `content_id` int(11) NOT NULL COMMENT '所属模型内容ID',
  `siteid` int(11) NOT NULL DEFAULT 1 COMMENT '站点id',
  `title` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '内容标题',
  `etitle` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '内容副标题',
  `jumpurl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '外部链接',
  `pic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '缩略图',
  `description` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容简介',
  `seo_title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'SEO标题',
  `seo_keywords` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'SEO关键词',
  `seo_description` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'SEO描述',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `status` int(1) NOT NULL DEFAULT 0 COMMENT '0未发布 1发布',
  `istop` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0' COMMENT '头条 0不推荐 1推荐',
  `tag` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '标签',
  `clicks` int(9) NOT NULL DEFAULT 0 COMMENT '点击次数',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `update_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `target` tinyint(1) NULL DEFAULT 0 COMMENT '1新窗口，0不开新窗口',
  `uid` int(11) NOT NULL DEFAULT 0 COMMENT '创建用户ID',
  `type_id` int(11) NULL DEFAULT 0,
  `selling_price` decimal(10, 2) NULL DEFAULT NULL COMMENT '售价',
  `group` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `related` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '内容主表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content
-- ----------------------------
INSERT INTO `PREFIX_content` VALUES (1, 0, 1, 0, 1, '222', '', '', '', NULL, '', '', '', 9, 0, '0', '', 0, NULL, NULL, 0, 0, 0, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for PREFIX_content_attributes
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content_attributes`;
CREATE TABLE `PREFIX_content_attributes`  (
  `content_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `attr_value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  UNIQUE INDEX `contentid_attrid`(`content_id`, `attr_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content_attributes
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_content_groups
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content_groups`;
CREATE TABLE `PREFIX_content_groups`  (
  `content_id` int(11) NOT NULL DEFAULT 0,
  `group_id` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0',
  UNIQUE INDEX `cgid`(`content_id`, `group_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content_groups
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_content_tags
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content_tags`;
CREATE TABLE `PREFIX_content_tags`  (
  `content_id` int(11) NOT NULL DEFAULT 0,
  `tag` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
  UNIQUE INDEX `ctag`(`content_id`, `tag`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content_tags
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_content_top_types
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content_top_types`;
CREATE TABLE `PREFIX_content_top_types`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content_top_types
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_content_tops
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_content_tops`;
CREATE TABLE `PREFIX_content_tops`  (
  `top_id` int(10) NOT NULL DEFAULT 0,
  `content_id` int(11) NOT NULL DEFAULT 0,
  UNIQUE INDEX `tcid`(`top_id`, `content_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '内容推荐表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_content_tops
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_custom_page
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_custom_page`;
CREATE TABLE `PREFIX_custom_page`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '文章id',
  `title` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '标题',
  `intro` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '简介',
  `content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容',
  `content_html` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容html',
  `num_views` int(8) NULL DEFAULT 0 COMMENT '观看次数',
  `sort` int(8) NULL DEFAULT 0 COMMENT '排序',
  `create_time` datetime NULL DEFAULT NULL COMMENT '创建时间',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  `status` tinyint(4) NULL DEFAULT NULL COMMENT '1正常 0无效',
  `author` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '作者',
  `is_directory` tinyint(4) UNSIGNED NULL DEFAULT 0 COMMENT '1开启 0关闭',
  `ac_id` bigint(22) NULL DEFAULT 0 COMMENT '用户id',
  `alias` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '别名',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 7 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_unicode_ci COMMENT = '文章表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_custom_page
-- ----------------------------
INSERT INTO `PREFIX_custom_page` VALUES (5, '用户协议', NULL, '欢迎您使用鲸鱼CMS系统（以下简称本站）服务，您在使用本服务前请认真阅读以下协议（以下简称本协议）。\n\n## 一、用户协议的接受\n1、当您在注册程序过程中在“已阅读，同意本《用户协议》”处打勾“✓”并按照注册程序成功注册为本站用户，或您以其他本站允许的方式实际使用本站服务时，即表示您已充分阅读、理解并接受本协议的全部内容，并与本站达成协议。**请您务必审慎阅读、充分理解各条款内容，特别是免除或者限制责任的条款，请您重点阅读并理解加粗提示条款。**如您对本协议项下任何条款有异议，请停止使用本站服务。\n2、 您确认您具备民事权利能力和完全民事行为能力，有能力同意并遵守本协议，并对您本协议项下的全部行为独立承担法律责任。若您不具备前述与您行为相适应的民事行为能力，则应获得法定监护人的同意。\n3、如您是未满18周岁的未成年人，在使用本产品或服务前，应在您的父母或其他监护人的监护、指导下共同仔细阅读本协议，并判断是否同意本协议。未成年人行使和履行本协议项下的权利和义务视为已获得法定监护人的同意。\n\n## 二、本协议的变更和修改\n**本站有权随时对本协议进行修改，并且一旦发生协议条款的变动，本站将以适当的方式（包括但不限于弹窗、邮件、站内信、网站公告等）提醒您更新的内容，以便您及时了解本协议的最新版本；用户如果不同意本协议的修改，可以放弃使用或访问本网站或取消已经获得的服务；如果用户选择在本协议变更后继续访问或使用本网站，则视为用户已经接受本协议的修改。**\n\n## 三、用户行为\n用户需要完成账号注册，才能正常使用网站提供的服务。任何机构或个人注册和使用的互联网用户账号，必须符合《互联网用户账号信息管理规定》等相关的法律、法规规定。\n### 1、用户账号、密码和安全\n（1）您在注册账号时必须通过实名认证，才能成为本站的合法用户，得到一个密码和账号。您可以利用账户，通过本服务上传您的作品（需要联系管理员开通发布权限），合法正当地使用平台提供的各项服务功能。\n（2）用户须对在本站的注册信息的真实性、合法性、有效性承担全部责任，用户不得使用他人的名义发布任何信息；当被发现用户冒用他人或机构的名义恶意注册账号，本站有权立即停止提供服务，收回其账号并由该用户承担由此而产生的一切法律及其他责任。\n**（3）您在本站注册和使用的账号信息，不得有如下情形：**\n（一）假冒、仿冒、捏造政党、党政军机关、企事业单位、人民团体和社会组织的名称、标识等； （二）假冒、仿冒、捏造国家（地区）、国际组织的名称、标识等； （三）假冒、仿冒、捏造新闻网站、报刊社、广播电视机构、通讯社等新闻媒体的名称、标识等，或者擅自使用“新闻”、“报道”等具有新闻属性的名称、标识等； （四）假冒、仿冒、恶意关联国家行政区域、机构所在地、标志性建筑物等重要空间的地理名称、标识等； （五）以损害公共利益或者谋取不正当利益等为目的，故意夹带二维码、网址、邮箱、联系方式等，或者使用同音、谐音、相近的文字、数字、符号和字母等； （六）含有名不副实、夸大其词等可能使公众受骗或者产生误解的内容； （七）含有法律、行政法规和国家有关规定禁止的其他内容。\n（4）您理解并同意，根据《中华人民共和国网络安全法》《互联网用户账号信息管理规定》《互联网信息服务管理办法》等法律、行政法规的规定，本站有权采用任何本站认为有必要之措施，对您的账号信息进行审查，并采用包括但不限于屏蔽、删除、修改、等措施以保证信息呈现结果符合法律法规要求，维护清朗网络空间。\n**（5）用户应采取合理措施维护其密码和账号的安全。用户对利用该密码和账号所进行的一切活动负全部责任；由该等活动所导致的任何损失或损害由用户承担，本站不承担任何责任。**\n（6）用户的密码和账号遭到未授权的使用或发生其他任何安全问题，用户可以立即通知本站，并且用户在每次连线结束，应结束账号使用，否则用户可能得不到本站的安全保护。\n（7）对于用户长时间未使用的账号，本站有权予以关闭。\n### 2、用户发布内容的传播\n（1）您同意授权本站，有权通过本服务将您所上传的内容向全世界范围内不特定的网络用户展示。**为提高您内容曝光量及发布效率，本站可能在保留您的账户昵称/作者水印的前提下将您发布的内容同步/分发至本站及其关联的其他客户端及网站上，若您不同意此种曝光方式，请通过本协议公示的方式告知本站；当任何第三方未经本站同意，转载、抓取、盗链包含用户内容在内的本站任何资料等行为时，用户同意并授权本站有权以本站的名义代表自己采取任何法律措施。**\n（2）您理解并同意，根据《中华人民共和国网络安全法》《互联网信息内容生态治理规定》《互联网信息服务管理办法》《移动互联网应用程序信息服务管理规定》等法律法规，本站有权采用任何本站认为有必要之措施，对您上传、分享、评论等行为产生的内容进行审查，并采用包括但不限于屏蔽、删除、修改等措施以保证信息呈现结果符合法律法规要求，维护清朗网络空间。\n**（3）如果您通过本服务分享作品，则您保证：**\n**a 您所分享的作品均由您本人原创或已经依法获得原始权利人合法授权。**\n**b 您有权授权本站依据本服务的相关规则使用您的作品，包括但不限于将您上传的图片向其他用户推荐或推广。**\n**c 您所上传的图片符合国家相关法律法规和公序良俗，不会损害任何他方的合法权益或造成不良社会影响。**\n**d 本站依照本服务的规则使用您的作品，无须另行获得第三方同意或对第三方承担任何责任。**\n### 3、禁止用户制作、复制、发布、评论含有下列内容的违法信息：\n（1）反对宪法所确定的基本原则的；\n（2）危害国家安全，泄露国家秘密，颠覆国家政权，破坏国家统一的；\n（3）损害国家荣誉和利益的；\n（4）歪曲、丑化、亵渎、否定英雄烈士事迹和精神，以侮辱、诽谤或者其他方式侵害英雄烈士的姓名、肖像、名誉、荣誉的；\n（5）宣扬恐怖主义、极端主义或者煽动实施恐怖活动、极端主义活动的；\n（6）煽动民族仇恨、民族歧视，破坏民族团结的；\n（7）破坏国家宗教政策，宣扬邪教和封建迷信的；\n（8）散布谣言，扰乱社会秩序，破坏社会稳定的；\n（9）散布淫秽、赌博、暴力、凶杀、自残、恐怖或者教唆犯罪的；\n（10）侮辱或者诽谤他人，侵害他人合法权益（如名誉权、肖像权等）的；\n（11）侵害未成年人合法权益或者损害未成年人身心健康的\n（12）侵害他人知识产权、商业秘密等合法权利的；\n（13）虚构事实、隐瞒真相以误导、欺骗他人的；\n（14）发布、传送、传播广告信息及垃圾信息的；\n（15）其他法律法规禁止的行为。\n如果您上传、发布或传输的内容含有以上违反法律法规的信息或内容，或者侵犯任何第三方的合法权益，您将直接承担以上导致的一切不利后果。\n\n### 4、用户对经由本网站上载、张贴、发送电子邮件或传送的内容承担全部责任\n（1）对于用户经由本站传送的内容，本站不保证其合法性、正当性、准确性、完整性或品质。用户在接受本网站服务后，在任何情况下，本站均不对任何内容承担任何责任，包括但不限于任何内容发生任何错误或纰漏以及衍生的任何损失或损害。本站有权（但无义务）自行修改、拒绝或删除经由本网站提供的任何内容。\n（2）本站有权利在下述情况下，对内容进行保存或披露：\na 法律程序所规定；\nb 本服务使用协议规定；\nc 被侵害的第三人提出权利主张；\nd 为保护本站、其使用者及社会公众的权利、财产或人身安全；\ne 其他本站认为有必要的情况。\n\n### 5、对用户发布信息的存储和披露\n本站不对用户所发布信息的删除或储存失败承担责任，请用户另行存储备份。本站有权判断用户的行为是否符合本协议规定，如果本站认为用户违背了协议条款规定，有终止向其提供网站服务的权利。\n**6、用户同意遵守本站规则、常见问题解答等本站管理规定。**\n\n## 四、版权声明\n1、本站会员所发布展示的“原创作品”、“原创文章”等原创内容，版权由作者享有和解释，任何商业用途均须联系原作者。临摹作品，同人作品原型版权归原作者所有。\n2、原创内容的发布者必须确保其拥有发布内容的全部完整版权，或已经获得版权所有者的合法授权，不得侵犯他人著作权、肖像权、商标权等合法权益，不违背商业保密协议。本站默认所有原创类的内容的发布者已经获得发表、演绎、信息网络传播等版权授权。若因发布内容产生法律纠纷，由肇事者自行承担相关法律责任。\n3、用户在本站上发布的内容，视为授权其作品使用在本站平台上，并授予本站免费的、全球的、不可撤销的非独家使用许可，本站有权将该内容用于本站各种形态的产品和服务上，包括但不限于本站网站以及本站官方发布的适用于手持终端设备的应用或其他互联网产品。\n4、如果任何第三方侵犯了本站用户相关的权利，用户同意授权本站或其指定的代理人代表本站自身或用户对该第三方提出警告、投诉、发起行政执法、诉讼、进行上诉（但非义务），或谈判和解，并且用户同意在本站认为必要的情况下参与共同维权。\n**5、在未得到著作权人的授权时，请不要将他人的作品全部或部分复制发表到本站，如转载站外信息到本站请署名和注明出处，并取得著作权人许可。用户应自行承担上述行为导致的不利后果。**\n6、如个人或单位发现本站上存在侵犯其自身合法权益的内容，请及时与本站取得联系，并提供具有法律效应的证明材料，以便本站作出处理。本站有权根据实际情况依法删除相关的内容，并追究相关用户的法律责任。给本站或任何第三方造成损失的，侵权用户应负全部责任。\n\n## 五、免责声明\n**1、除本站注明的服务条款外，其它因使用本站而导致任何意外、疏忽、合约毁坏、诽谤、版权或知识产权侵犯及其所造成的各种损失（包括因下载而感染电脑病毒），本站概不负责，亦不承担任何法律责任。**\n**2、本站不保证（包括但不限于）：**\n**（1）本网站适合用户的使用要求；**\n**（2）本网站不受干扰，及时、安全、可靠或不出现错误；**\n**（3）用户经由本网站取得的任何产品、服务或其他材料符合用户的期望。**\n**3、本服务可能会包含与其他网站或资源的链接，即第三方链接。本站对于前述网站或资源的内容、隐私政策和活动，无权控制、审查或修改，因而也不承担任何责任。建议您在离开本站服务，访问其他网站或资源前仔细阅读其服务条款和隐私政策。**\n**4、因用户内容在本网站的上载或发布，而导致任何第三方提出索赔要求或衍生的任何损害或损失，由用户自行承担相应责任。**\n**5、本站内会员所发言论仅代表网友自己，并不反映任何本站之意见及观点。**\n**6、本站认为，一切网民在进入本站主页及各层页面时已经仔细看过本条款并完全同意。**\n**八、法律适用和管辖**\n**1、 本协议的生效、履行、解释及争议的解决均适用中华人民共和国法律。本条款因与中华人民共和国现行法律相抵触而导致部分无效，不影响其他部分的效力。双方同意，解决争议时，应以您同意的最新版本的《用户协议》为准。**\n**2、 如就本协议发生任何争议，应友好协商解决；协商不成，则各方均一致同意将争议提交被告所在地诉讼解决。**', '&lt;div data-inline-code-theme=&quot;red&quot; data-code-block-theme=&quot;default&quot;&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;c5420a1ff603c563f5fe7798051088e11&quot; class=&quot;&quot;&gt;欢迎您使用鲸鱼CMS系统（以下简称本站）服务，您在使用本服务前请认真阅读以下协议（以下简称本协议）。&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;2b59c8809555a223273698f2b7a45f17&quot; id=&quot;%E4%B8%80%E3%80%81%E7%94%A8%E6%88%B7%E5%8D%8F%E8%AE%AE%E7%9A%84%E6%8E%A5%E5%8F%97&quot;&gt;&lt;a href=&quot;#%E4%B8%80%E3%80%81%E7%94%A8%E6%88%B7%E5%8D%8F%E8%AE%AE%E7%9A%84%E6%8E%A5%E5%8F%97&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;一、用户协议的接受&lt;/h2&gt;&lt;p data-lines=&quot;3&quot; data-type=&quot;p&quot; data-sign=&quot;b821f3fb2e7b48459e208c25d8d5393a3&quot;&gt;1、当您在注册程序过程中在“已阅读，同意本《用户协议》”处打勾“✓”并按照注册程序成功注册为本站用户，或您以其他本站允许的方式实际使用本站服务时，即表示您已充分阅读、理解并接受本协议的全部内容，并与本站达成协议。&lt;strong&gt;请您务必审慎阅读、充分理解各条款内容，特别是免除或者限制责任的条款，请您重点阅读并理解加粗提示条款。&lt;/strong&gt;如您对本协议项下任何条款有异议，请停止使用本站服务。&lt;br&gt;2、 您确认您具备民事权利能力和完全民事行为能力，有能力同意并遵守本协议，并对您本协议项下的全部行为独立承担法律责任。若您不具备前述与您行为相适应的民事行为能力，则应获得法定监护人的同意。&lt;br&gt;3、如您是未满18周岁的未成年人，在使用本产品或服务前，应在您的父母或其他监护人的监护、指导下共同仔细阅读本协议，并判断是否同意本协议。未成年人行使和履行本协议项下的权利和义务视为已获得法定监护人的同意。&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;ff07e87c284d11374e928e60776c7567&quot; id=&quot;%E4%BA%8C%E3%80%81%E6%9C%AC%E5%8D%8F%E8%AE%AE%E7%9A%84%E5%8F%98%E6%9B%B4%E5%92%8C%E4%BF%AE%E6%94%B9&quot;&gt;&lt;a href=&quot;#%E4%BA%8C%E3%80%81%E6%9C%AC%E5%8D%8F%E8%AE%AE%E7%9A%84%E5%8F%98%E6%9B%B4%E5%92%8C%E4%BF%AE%E6%94%B9&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;二、本协议的变更和修改&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;faf080e85f07f6543c0f675f662aaac71&quot;&gt;&lt;strong&gt;本站有权随时对本协议进行修改，并且一旦发生协议条款的变动，本站将以适当的方式（包括但不限于弹窗、邮件、站内信、网站公告等）提醒您更新的内容，以便您及时了解本协议的最新版本；用户如果不同意本协议的修改，可以放弃使用或访问本网站或取消已经获得的服务；如果用户选择在本协议变更后继续访问或使用本网站，则视为用户已经接受本协议的修改。&lt;/strong&gt;&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;0c8baebeded2c1fc14f0315613955cdc&quot; id=&quot;%E4%B8%89%E3%80%81%E7%94%A8%E6%88%B7%E8%A1%8C%E4%B8%BA&quot;&gt;&lt;a href=&quot;#%E4%B8%89%E3%80%81%E7%94%A8%E6%88%B7%E8%A1%8C%E4%B8%BA&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;三、用户行为&lt;/h2&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;19dc6bae91493435722f11c2ad1b4b281&quot;&gt;用户需要完成账号注册，才能正常使用网站提供的服务。任何机构或个人注册和使用的互联网用户账号，必须符合《互联网用户账号信息管理规定》等相关的法律、法规规定。&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;3a0bf741541bcdd50c1759af62335105&quot; id=&quot;1%E3%80%81%E7%94%A8%E6%88%B7%E8%B4%A6%E5%8F%B7%E3%80%81%E5%AF%86%E7%A0%81%E5%92%8C%E5%AE%89%E5%85%A8&quot; class=&quot;&quot;&gt;&lt;a href=&quot;#1%E3%80%81%E7%94%A8%E6%88%B7%E8%B4%A6%E5%8F%B7%E3%80%81%E5%AF%86%E7%A0%81%E5%92%8C%E5%AE%89%E5%85%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;1、用户账号、密码和安全&lt;/h3&gt;&lt;p data-lines=&quot;8&quot; data-type=&quot;p&quot; data-sign=&quot;7a8e439c4ef91f7090a6cac25c1c92738&quot;&gt;（1）您在注册账号时必须通过实名认证，才能成为本站的合法用户，得到一个密码和账号。您可以利用账户，通过本服务上传您的作品（需要联系管理员开通发布权限），合法正当地使用平台提供的各项服务功能。&lt;br&gt;（2）用户须对在本站的注册信息的真实性、合法性、有效性承担全部责任，用户不得使用他人的名义发布任何信息；当被发现用户冒用他人或机构的名义恶意注册账号，本站有权立即停止提供服务，收回其账号并由该用户承担由此而产生的一切法律及其他责任。&lt;br&gt;&lt;strong&gt;（3）您在本站注册和使用的账号信息，不得有如下情形：&lt;/strong&gt;&lt;br&gt;（一）假冒、仿冒、捏造政党、党政军机关、企事业单位、人民团体和社会组织的名称、标识等； （二）假冒、仿冒、捏造国家（地区）、国际组织的名称、标识等； （三）假冒、仿冒、捏造新闻网站、报刊社、广播电视机构、通讯社等新闻媒体的名称、标识等，或者擅自使用“新闻”、“报道”等具有新闻属性的名称、标识等； （四）假冒、仿冒、恶意关联国家行政区域、机构所在地、标志性建筑物等重要空间的地理名称、标识等； （五）以损害公共利益或者谋取不正当利益等为目的，故意夹带二维码、网址、邮箱、联系方式等，或者使用同音、谐音、相近的文字、数字、符号和字母等； （六）含有名不副实、夸大其词等可能使公众受骗或者产生误解的内容； （七）含有法律、行政法规和国家有关规定禁止的其他内容。&lt;br&gt;（4）您理解并同意，根据《中华人民共和国网络安全法》《互联网用户账号信息管理规定》《互联网信息服务管理办法》等法律、行政法规的规定，本站有权采用任何本站认为有必要之措施，对您的账号信息进行审查，并采用包括但不限于屏蔽、删除、修改、等措施以保证信息呈现结果符合法律法规要求，维护清朗网络空间。&lt;br&gt;&lt;strong&gt;（5）用户应采取合理措施维护其密码和账号的安全。用户对利用该密码和账号所进行的一切活动负全部责任；由该等活动所导致的任何损失或损害由用户承担，本站不承担任何责任。&lt;/strong&gt;&lt;br&gt;（6）用户的密码和账号遭到未授权的使用或发生其他任何安全问题，用户可以立即通知本站，并且用户在每次连线结束，应结束账号使用，否则用户可能得不到本站的安全保护。&lt;br&gt;（7）对于用户长时间未使用的账号，本站有权予以关闭。&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;f86b750620131724cfe75ac55867e481&quot; id=&quot;2%E3%80%81%E7%94%A8%E6%88%B7%E5%8F%91%E5%B8%83%E5%86%85%E5%AE%B9%E7%9A%84%E4%BC%A0%E6%92%AD&quot; class=&quot;&quot;&gt;&lt;a href=&quot;#2%E3%80%81%E7%94%A8%E6%88%B7%E5%8F%91%E5%B8%83%E5%86%85%E5%AE%B9%E7%9A%84%E4%BC%A0%E6%92%AD&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;2、用户发布内容的传播&lt;/h3&gt;&lt;p data-lines=&quot;7&quot; data-type=&quot;p&quot; data-sign=&quot;8867193958100e919b6f2d33ad0875577&quot;&gt;（1）您同意授权本站，有权通过本服务将您所上传的内容向全世界范围内不特定的网络用户展示。&lt;strong&gt;为提高您内容曝光量及发布效率，本站可能在保留您的账户昵称/作者水印的前提下将您发布的内容同步/分发至本站及其关联的其他客户端及网站上，若您不同意此种曝光方式，请通过本协议公示的方式告知本站；当任何第三方未经本站同意，转载、抓取、盗链包含用户内容在内的本站任何资料等行为时，用户同意并授权本站有权以本站的名义代表自己采取任何法律措施。&lt;/strong&gt;&lt;br&gt;（2）您理解并同意，根据《中华人民共和国网络安全法》《互联网信息内容生态治理规定》《互联网信息服务管理办法》《移动互联网应用程序信息服务管理规定》等法律法规，本站有权采用任何本站认为有必要之措施，对您上传、分享、评论等行为产生的内容进行审查，并采用包括但不限于屏蔽、删除、修改等措施以保证信息呈现结果符合法律法规要求，维护清朗网络空间。&lt;br&gt;&lt;strong&gt;（3）如果您通过本服务分享作品，则您保证：&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;a 您所分享的作品均由您本人原创或已经依法获得原始权利人合法授权。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;b 您有权授权本站依据本服务的相关规则使用您的作品，包括但不限于将您上传的图片向其他用户推荐或推广。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;c 您所上传的图片符合国家相关法律法规和公序良俗，不会损害任何他方的合法权益或造成不良社会影响。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;d 本站依照本服务的规则使用您的作品，无须另行获得第三方同意或对第三方承担任何责任。&lt;/strong&gt;&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;8a67763f0d25ab3564e884563073c767&quot; id=&quot;3%E3%80%81%E7%A6%81%E6%AD%A2%E7%94%A8%E6%88%B7%E5%88%B6%E4%BD%9C%E3%80%81%E5%A4%8D%E5%88%B6%E3%80%81%E5%8F%91%E5%B8%83%E3%80%81%E8%AF%84%E8%AE%BA%E5%90%AB%E6%9C%89%E4%B8%8B%E5%88%97%E5%86%85%E5%AE%B9%E7%9A%84%E8%BF%9D%E6%B3%95%E4%BF%A1%E6%81%AF%EF%BC%9A&quot; class=&quot;&quot;&gt;&lt;a href=&quot;#3%E3%80%81%E7%A6%81%E6%AD%A2%E7%94%A8%E6%88%B7%E5%88%B6%E4%BD%9C%E3%80%81%E5%A4%8D%E5%88%B6%E3%80%81%E5%8F%91%E5%B8%83%E3%80%81%E8%AF%84%E8%AE%BA%E5%90%AB%E6%9C%89%E4%B8%8B%E5%88%97%E5%86%85%E5%AE%B9%E7%9A%84%E8%BF%9D%E6%B3%95%E4%BF%A1%E6%81%AF%EF%BC%9A&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;3、禁止用户制作、复制、发布、评论含有下列内容的违法信息：&lt;/h3&gt;&lt;p data-lines=&quot;16&quot; data-type=&quot;p&quot; data-sign=&quot;139911491fdc3d99e665d32a9171e20516&quot;&gt;（1）反对宪法所确定的基本原则的；&lt;br&gt;（2）危害国家安全，泄露国家秘密，颠覆国家政权，破坏国家统一的；&lt;br&gt;（3）损害国家荣誉和利益的；&lt;br&gt;（4）歪曲、丑化、亵渎、否定英雄烈士事迹和精神，以侮辱、诽谤或者其他方式侵害英雄烈士的姓名、肖像、名誉、荣誉的；&lt;br&gt;（5）宣扬恐怖主义、极端主义或者煽动实施恐怖活动、极端主义活动的；&lt;br&gt;（6）煽动民族仇恨、民族歧视，破坏民族团结的；&lt;br&gt;（7）破坏国家宗教政策，宣扬邪教和封建迷信的；&lt;br&gt;（8）散布谣言，扰乱社会秩序，破坏社会稳定的；&lt;br&gt;（9）散布淫秽、赌博、暴力、凶杀、自残、恐怖或者教唆犯罪的；&lt;br&gt;（10）侮辱或者诽谤他人，侵害他人合法权益（如名誉权、肖像权等）的；&lt;br&gt;（11）侵害未成年人合法权益或者损害未成年人身心健康的&lt;br&gt;（12）侵害他人知识产权、商业秘密等合法权利的；&lt;br&gt;（13）虚构事实、隐瞒真相以误导、欺骗他人的；&lt;br&gt;（14）发布、传送、传播广告信息及垃圾信息的；&lt;br&gt;（15）其他法律法规禁止的行为。&lt;br&gt;如果您上传、发布或传输的内容含有以上违反法律法规的信息或内容，或者侵犯任何第三方的合法权益，您将直接承担以上导致的一切不利后果。&lt;/p&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;80e94ea78f4af0157e92ed836467d7f8&quot; id=&quot;4%E3%80%81%E7%94%A8%E6%88%B7%E5%AF%B9%E7%BB%8F%E7%94%B1%E6%9C%AC%E7%BD%91%E7%AB%99%E4%B8%8A%E8%BD%BD%E3%80%81%E5%BC%A0%E8%B4%B4%E3%80%81%E5%8F%91%E9%80%81%E7%94%B5%E5%AD%90%E9%82%AE%E4%BB%B6%E6%88%96%E4%BC%A0%E9%80%81%E7%9A%84%E5%86%85%E5%AE%B9%E6%89%BF%E6%8B%85%E5%85%A8%E9%83%A8%E8%B4%A3%E4%BB%BB&quot; class=&quot;&quot;&gt;&lt;a href=&quot;#4%E3%80%81%E7%94%A8%E6%88%B7%E5%AF%B9%E7%BB%8F%E7%94%B1%E6%9C%AC%E7%BD%91%E7%AB%99%E4%B8%8A%E8%BD%BD%E3%80%81%E5%BC%A0%E8%B4%B4%E3%80%81%E5%8F%91%E9%80%81%E7%94%B5%E5%AD%90%E9%82%AE%E4%BB%B6%E6%88%96%E4%BC%A0%E9%80%81%E7%9A%84%E5%86%85%E5%AE%B9%E6%89%BF%E6%8B%85%E5%85%A8%E9%83%A8%E8%B4%A3%E4%BB%BB&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;4、用户对经由本网站上载、张贴、发送电子邮件或传送的内容承担全部责任&lt;/h3&gt;&lt;p data-lines=&quot;7&quot; data-type=&quot;p&quot; data-sign=&quot;74c8d460ee875bd07a0d89fb1a0d9a127&quot;&gt;（1）对于用户经由本站传送的内容，本站不保证其合法性、正当性、准确性、完整性或品质。用户在接受本网站服务后，在任何情况下，本站均不对任何内容承担任何责任，包括但不限于任何内容发生任何错误或纰漏以及衍生的任何损失或损害。本站有权（但无义务）自行修改、拒绝或删除经由本网站提供的任何内容。&lt;br&gt;（2）本站有权利在下述情况下，对内容进行保存或披露：&lt;br&gt;a 法律程序所规定；&lt;br&gt;b 本服务使用协议规定；&lt;br&gt;c 被侵害的第三人提出权利主张；&lt;br&gt;d 为保护本站、其使用者及社会公众的权利、财产或人身安全；&lt;br&gt;e 其他本站认为有必要的情况。&lt;/p&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;ced860fa9e387f1a1ad7f21946312917&quot; id=&quot;5%E3%80%81%E5%AF%B9%E7%94%A8%E6%88%B7%E5%8F%91%E5%B8%83%E4%BF%A1%E6%81%AF%E7%9A%84%E5%AD%98%E5%82%A8%E5%92%8C%E6%8A%AB%E9%9C%B2&quot; class=&quot;cherry-highlight-line&quot;&gt;&lt;a href=&quot;#5%E3%80%81%E5%AF%B9%E7%94%A8%E6%88%B7%E5%8F%91%E5%B8%83%E4%BF%A1%E6%81%AF%E7%9A%84%E5%AD%98%E5%82%A8%E5%92%8C%E6%8A%AB%E9%9C%B2&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;5、对用户发布信息的存储和披露&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;9ce46d8c71b364f10afa7c82d6e865a92&quot;&gt;本站不对用户所发布信息的删除或储存失败承担责任，请用户另行存储备份。本站有权判断用户的行为是否符合本协议规定，如果本站认为用户违背了协议条款规定，有终止向其提供网站服务的权利。&lt;br&gt;&lt;strong&gt;6、用户同意遵守本站规则、常见问题解答等本站管理规定。&lt;/strong&gt;&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;ab134c8e35c8ca4c18211cdfc6637f37&quot; id=&quot;%E5%9B%9B%E3%80%81%E7%89%88%E6%9D%83%E5%A3%B0%E6%98%8E&quot;&gt;&lt;a href=&quot;#%E5%9B%9B%E3%80%81%E7%89%88%E6%9D%83%E5%A3%B0%E6%98%8E&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;四、版权声明&lt;/h2&gt;&lt;p data-lines=&quot;6&quot; data-type=&quot;p&quot; data-sign=&quot;af7a74b138ff25a02e25d98d7a0ae1776&quot;&gt;1、本站会员所发布展示的“原创作品”、“原创文章”等原创内容，版权由作者享有和解释，任何商业用途均须联系原作者。临摹作品，同人作品原型版权归原作者所有。&lt;br&gt;2、原创内容的发布者必须确保其拥有发布内容的全部完整版权，或已经获得版权所有者的合法授权，不得侵犯他人著作权、肖像权、商标权等合法权益，不违背商业保密协议。本站默认所有原创类的内容的发布者已经获得发表、演绎、信息网络传播等版权授权。若因发布内容产生法律纠纷，由肇事者自行承担相关法律责任。&lt;br&gt;3、用户在本站上发布的内容，视为授权其作品使用在本站平台上，并授予本站免费的、全球的、不可撤销的非独家使用许可，本站有权将该内容用于本站各种形态的产品和服务上，包括但不限于本站网站以及本站官方发布的适用于手持终端设备的应用或其他互联网产品。&lt;br&gt;4、如果任何第三方侵犯了本站用户相关的权利，用户同意授权本站或其指定的代理人代表本站自身或用户对该第三方提出警告、投诉、发起行政执法、诉讼、进行上诉（但非义务），或谈判和解，并且用户同意在本站认为必要的情况下参与共同维权。&lt;br&gt;&lt;strong&gt;5、在未得到著作权人的授权时，请不要将他人的作品全部或部分复制发表到本站，如转载站外信息到本站请署名和注明出处，并取得著作权人许可。用户应自行承担上述行为导致的不利后果。&lt;/strong&gt;&lt;br&gt;6、如个人或单位发现本站上存在侵犯其自身合法权益的内容，请及时与本站取得联系，并提供具有法律效应的证明材料，以便本站作出处理。本站有权根据实际情况依法删除相关的内容，并追究相关用户的法律责任。给本站或任何第三方造成损失的，侵权用户应负全部责任。&lt;/p&gt;&lt;h2 data-lines=&quot;2&quot; data-sign=&quot;9b70251b61ec9b44f8549e882aab3320&quot; id=&quot;%E4%BA%94%E3%80%81%E5%85%8D%E8%B4%A3%E5%A3%B0%E6%98%8E&quot;&gt;&lt;a href=&quot;#%E4%BA%94%E3%80%81%E5%85%8D%E8%B4%A3%E5%A3%B0%E6%98%8E&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;五、免责声明&lt;/h2&gt;&lt;p data-lines=&quot;12&quot; data-type=&quot;p&quot; data-sign=&quot;698c405ff66ff5a5038c6bacead721c912&quot;&gt;&lt;strong&gt;1、除本站注明的服务条款外，其它因使用本站而导致任何意外、疏忽、合约毁坏、诽谤、版权或知识产权侵犯及其所造成的各种损失（包括因下载而感染电脑病毒），本站概不负责，亦不承担任何法律责任。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;2、本站不保证（包括但不限于）：&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;（1）本网站适合用户的使用要求；&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;（2）本网站不受干扰，及时、安全、可靠或不出现错误；&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;（3）用户经由本网站取得的任何产品、服务或其他材料符合用户的期望。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;3、本服务可能会包含与其他网站或资源的链接，即第三方链接。本站对于前述网站或资源的内容、隐私政策和活动，无权控制、审查或修改，因而也不承担任何责任。建议您在离开本站服务，访问其他网站或资源前仔细阅读其服务条款和隐私政策。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;4、因用户内容在本网站的上载或发布，而导致任何第三方提出索赔要求或衍生的任何损害或损失，由用户自行承担相应责任。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;5、本站内会员所发言论仅代表网友自己，并不反映任何本站之意见及观点。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;6、本站认为，一切网民在进入本站主页及各层页面时已经仔细看过本条款并完全同意。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;八、法律适用和管辖&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;1、 本协议的生效、履行、解释及争议的解决均适用中华人民共和国法律。本条款因与中华人民共和国现行法律相抵触而导致部分无效，不影响其他部分的效力。双方同意，解决争议时，应以您同意的最新版本的《用户协议》为准。&lt;/strong&gt;&lt;br&gt;&lt;strong&gt;2、 如就本协议发生任何争议，应友好协商解决；协商不成，则各方均一致同意将争议提交被告所在地诉讼解决。&lt;/strong&gt;&lt;/p&gt;&lt;/div&gt;', 1, 100, '2024-12-02 23:13:36', '2024-12-02 23:13:36', 1, NULL, 0, 0, 'yonghuxieyi');
INSERT INTO `PREFIX_custom_page` VALUES (6, '隐私政策', NULL, '鲸鱼CMS系统非常重视您的隐私和个人信息保护。请仔细阅读以下隐私政策，了解我们如何收集、使用、存储和保护您的信息。\n### 1. 我们收集的信息\n\n我们可能会根据需要收集以下类型的信息：\n- **您提供的信息**：注册、填写表单、提交订单或与我们联系时提供的姓名、邮箱地址、电话等信息。\n- **自动收集的信息**：包括您的设备信息（如IP地址、浏览器类型、操作系统）、访问记录、Cookies或类似技术收集的相关信息。\n- **第三方来源的信息**：如通过授权获取的社交媒体账号信息。\n\n### 2. 信息的使用\n\n我们收集的信息可能用于以下目的：\n- 提供和维护我们的服务；\n- 个性化和改进您的用户体验；\n- 用于客户支持和沟通；\n- 推送与服务相关的通知和营销信息（在取得您同意的情况下）；\n- 遵守法律法规要求或响应合法的法律请求。\n\n### 3. 信息的共享与披露\n\n除非以下情况，我们不会与第三方共享您的信息：\n- 为提供服务所需，与可信的第三方服务商共享信息（如支付处理、物流服务等）；\n- 遵守法律法规或应法律要求；\n- 在紧急情况下保护您或他人的合法权益；\n- 经您明确同意。\n\n### 4. 信息的存储与保护\n\n- 我们会采取合理的技术和管理措施保护您的个人信息安全，防止丢失、误用、未经授权访问或披露。\n- 您的个人信息将存储在安全的服务器上，保存时间以实现本隐私政策中的目的为限，或法律要求的时限为准。\n\n### 5. 您的权利\n\n根据适用的法律，您可能享有以下权利：\n- 访问、更正或删除您的个人信息；\n- 撤回对特定信息处理活动的同意；\n- 限制或拒绝某些信息处理行为；\n- 数据可携权。\n\n### 6. Cookies的使用\n\n我们可能使用Cookies等技术以提升您的用户体验。您可以通过浏览器设置管理或禁用Cookies，但可能影响部分功能的正常使用。\n### 7. 隐私政策的更新\n\n我们可能会不时更新隐私政策。最新版本将发布于本页面，重大变更会通过适当的方式通知您。\n### 8. 联系我们\n\n如果您对本隐私政策有任何疑问或需要帮助，请联系我们', '&lt;div data-inline-code-theme=&quot;red&quot; data-code-block-theme=&quot;default&quot;&gt;&lt;p data-lines=&quot;1&quot; data-type=&quot;p&quot; data-sign=&quot;bfb44a028dee34e63b7fb887442a93af1&quot; class=&quot;&quot;&gt;鲸鱼CMS系统非常重视您的隐私和个人信息保护。请仔细阅读以下隐私政策，了解我们如何收集、使用、存储和保护您的信息。&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;d51d4a89b1eb2005bf5323124c74bf9c&quot; id=&quot;1-%E6%88%91%E4%BB%AC%E6%94%B6%E9%9B%86%E7%9A%84%E4%BF%A1%E6%81%AF&quot;&gt;&lt;a href=&quot;#1-%E6%88%91%E4%BB%AC%E6%94%B6%E9%9B%86%E7%9A%84%E4%BF%A1%E6%81%AF&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;1. 我们收集的信息&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;196143e33654af5b1d2acc0a4e577aef2&quot;&gt;我们可能会根据需要收集以下类型的信息：&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;8611eae0e9186b7bf1a602e981c5e4a6&quot; data-lines=&quot;3&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;&lt;strong&gt;您提供的信息&lt;/strong&gt;：注册、填写表单、提交订单或与我们联系时提供的姓名、邮箱地址、电话等信息。&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;&lt;strong&gt;自动收集的信息&lt;/strong&gt;：包括您的设备信息（如IP地址、浏览器类型、操作系统）、访问记录、Cookies或类似技术收集的相关信息。&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;&lt;strong&gt;第三方来源的信息&lt;/strong&gt;：如通过授权获取的社交媒体账号信息。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;0cad2b8e9094697741ba376b73a08515&quot; id=&quot;2-%E4%BF%A1%E6%81%AF%E7%9A%84%E4%BD%BF%E7%94%A8&quot;&gt;&lt;a href=&quot;#2-%E4%BF%A1%E6%81%AF%E7%9A%84%E4%BD%BF%E7%94%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;2. 信息的使用&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;fa6ab81beae050444d9feb9809ce235d2&quot;&gt;我们收集的信息可能用于以下目的：&lt;/p&gt;&lt;ul class=&quot;cherry-list__default cherry-highlight-line&quot; data-sign=&quot;e28af7a8b64fc9071d4bdec719e5e4c6&quot; data-lines=&quot;5&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;提供和维护我们的服务；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;个性化和改进您的用户体验；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;用于客户支持和沟通；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;推送与服务相关的通知和营销信息（在取得您同意的情况下）；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;遵守法律法规要求或响应合法的法律请求。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;40302364d27a6b59d7f93fc0eeff09f8&quot; id=&quot;3-%E4%BF%A1%E6%81%AF%E7%9A%84%E5%85%B1%E4%BA%AB%E4%B8%8E%E6%8A%AB%E9%9C%B2&quot;&gt;&lt;a href=&quot;#3-%E4%BF%A1%E6%81%AF%E7%9A%84%E5%85%B1%E4%BA%AB%E4%B8%8E%E6%8A%AB%E9%9C%B2&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;3. 信息的共享与披露&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;73c6e55e227df15a69c17d5e5a4d6cf42&quot;&gt;除非以下情况，我们不会与第三方共享您的信息：&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;8dc35d856771a8b35a46b78f0f273b7d&quot; data-lines=&quot;4&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;为提供服务所需，与可信的第三方服务商共享信息（如支付处理、物流服务等）；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;遵守法律法规或应法律要求；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;在紧急情况下保护您或他人的合法权益；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;经您明确同意。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;d1d4e548dcce9928a7d5e8177db28c24&quot; id=&quot;4-%E4%BF%A1%E6%81%AF%E7%9A%84%E5%AD%98%E5%82%A8%E4%B8%8E%E4%BF%9D%E6%8A%A4&quot;&gt;&lt;a href=&quot;#4-%E4%BF%A1%E6%81%AF%E7%9A%84%E5%AD%98%E5%82%A8%E4%B8%8E%E4%BF%9D%E6%8A%A4&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;4. 信息的存储与保护&lt;/h3&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;704fa1f16feb608b0d61fec12b2ada0d&quot; data-lines=&quot;3&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;我们会采取合理的技术和管理措施保护您的个人信息安全，防止丢失、误用、未经授权访问或披露。&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;您的个人信息将存储在安全的服务器上，保存时间以实现本隐私政策中的目的为限，或法律要求的时限为准。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;f701123bb7ea4dbad3a7c983aeb0b415&quot; id=&quot;5-%E6%82%A8%E7%9A%84%E6%9D%83%E5%88%A9&quot;&gt;&lt;a href=&quot;#5-%E6%82%A8%E7%9A%84%E6%9D%83%E5%88%A9&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;5. 您的权利&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;e533f1275be7fcf064ca0e596f13636e2&quot;&gt;根据适用的法律，您可能享有以下权利：&lt;/p&gt;&lt;ul class=&quot;cherry-list__default&quot; data-sign=&quot;f2e9903229f3478eed432370268fe43c&quot; data-lines=&quot;4&quot;&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;访问、更正或删除您的个人信息；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;撤回对特定信息处理活动的同意；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;限制或拒绝某些信息处理行为；&lt;/p&gt;&lt;/li&gt;&lt;li class=&quot;cherry-list-item&quot;&gt;&lt;p&gt;数据可携权。&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;h3 data-lines=&quot;2&quot; data-sign=&quot;120d2215e37dc600e17be5e8e1cccff9&quot; id=&quot;6-cookies%E7%9A%84%E4%BD%BF%E7%94%A8&quot;&gt;&lt;a href=&quot;#6-cookies%E7%9A%84%E4%BD%BF%E7%94%A8&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;6. Cookies的使用&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;aea2b9cdf036577a71280ea941809f512&quot;&gt;我们可能使用Cookies等技术以提升您的用户体验。您可以通过浏览器设置管理或禁用Cookies，但可能影响部分功能的正常使用。&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;e6e66cf5025ea9b046788a3217b1caaf&quot; id=&quot;7-%E9%9A%90%E7%A7%81%E6%94%BF%E7%AD%96%E7%9A%84%E6%9B%B4%E6%96%B0&quot;&gt;&lt;a href=&quot;#7-%E9%9A%90%E7%A7%81%E6%94%BF%E7%AD%96%E7%9A%84%E6%9B%B4%E6%96%B0&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;7. 隐私政策的更新&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;ee972f28ab923689188e348ec6b8746a2&quot;&gt;我们可能会不时更新隐私政策。最新版本将发布于本页面，重大变更会通过适当的方式通知您。&lt;/p&gt;&lt;h3 data-lines=&quot;1&quot; data-sign=&quot;e104cf4e53ed6396188db7989bf52532&quot; id=&quot;8-%E8%81%94%E7%B3%BB%E6%88%91%E4%BB%AC&quot;&gt;&lt;a href=&quot;#8-%E8%81%94%E7%B3%BB%E6%88%91%E4%BB%AC&quot; class=&quot;anchor&quot;&gt;&lt;/a&gt;8. 联系我们&lt;/h3&gt;&lt;p data-lines=&quot;2&quot; data-type=&quot;p&quot; data-sign=&quot;925df11fe6faeb92ba47d0f67ea163212&quot; class=&quot;&quot;&gt;如果您对本隐私政策有任何疑问或需要帮助，请联系我们&lt;/p&gt;&lt;/div&gt;', 1, 100, '2024-12-02 23:26:14', '2024-12-02 23:26:14', 1, NULL, 0, 0, 'yinsizhengce');

-- ----------------------------
-- Table structure for PREFIX_download
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_download`;
CREATE TABLE `PREFIX_download`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '文章id',
  `title` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '标题',
  `intro` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '简介',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容',
  `content2` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '内容2',
  `cate_id` bigint(20) NULL DEFAULT NULL COMMENT '分类id',
  `num_views` int(8) NULL DEFAULT 0 COMMENT '观看次数',
  `sort` int(8) NULL DEFAULT 0 COMMENT '排序',
  `create_time` datetime NULL DEFAULT NULL COMMENT '创建时间',
  `update_time` datetime NULL DEFAULT NULL COMMENT '更新时间',
  `status` tinyint(4) NULL DEFAULT NULL COMMENT '1正常 0无效',
  `is_download` tinyint(4) NULL DEFAULT NULL COMMENT '1有下载  2没下载 是否下载链接 ',
  `netdisk_name` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '网盘名',
  `download_href` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '下载链接',
  `netdisk_passwd` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '网盘密码',
  `pic` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '主图',
  `author` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '作者',
  `is_directory` tinyint(4) UNSIGNED NULL DEFAULT 0 COMMENT '1开启 0关闭',
  `safety` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT '' COMMENT '安全检测字段',
  `num_download` int(8) NOT NULL DEFAULT 0 COMMENT '下载数量',
  `extend_json` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '扩展信息',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 49 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_download
-- ----------------------------
INSERT INTO `PREFIX_download` VALUES (47, 'FastStone Capture(最强截图工具)', 'FastStone Capture免费版是一款十分优秀的多功能屏幕捕捉工具，FastStone Capture包含了图片浏览、图片颜色提取、标尺等功能于一体。操作简单，功能强悍，深受广大开发设计师的喜爱。FastStone Capture免费版只要点点鼠标就能随心抓取屏幕上的东西。', '## 软件特色\n**1、功能完整**\nFastStone Capture免费版避免随意修改或删减功能，优化参数设置\n**2、安全纯净**\n不集成广告插件或恶意程序，无弹出窗口\n**3、精准智能**\n汉化力求精准完整，智能安装，彻底卸载\n**4、持续更新**\n与原版软件同步更新，FastStone Capture免费版不断提升作品质量\n## 功能介绍\n**取色器**\nFastStone Capture 的取色支持RGB 、Dec 和Hex 三种格式的色值，而且还有一个混色器，取到颜色之后可以再编辑。\n**屏幕放大镜**\n可以设置放大倍率，放大镜的尺寸，外观(圆形，矩形以及圆角矩形)以及是否平滑显示，按ESC 键或单击右键可退出放大镜\n**屏幕录像机**\n屏幕录像机功能可以录制屏幕动作，将窗口/对象、矩形区域或全屏区域的屏幕录制为高清晰 WMV 视频\n**截屏**\n包括了全屏截取，当前活动窗口截取，截取选定区域，多边形截取和截取滚动页面等，基本上常用的都有了，特别是滚动截取\n**图像浏览/ 编辑**\nFS Capture 还包括快速浏览/ 编辑图像的功能，可以点击主窗口的“ 打开” 图标快速打开一幅图片，进行简单的缩放、裁切、旋转、加文字等轻量级的操作。把网页中图片拖到FS Capture 的窗口上，会快速打开图像浏览窗口', '1、本软件采用绿色版，将下载包解压后得到以下文件夹\n![image](/public/sysImg/110630-5d71cd367c04e.jpg)\n2、双击 FSCapture.exe ，即可启动软件开始使用\n![image](/public/sysImg/110823-5d71cda7a3d54.jpg)', 5, 1, 100, '2024-12-08 23:54:14', '2024-12-08 23:54:14', 1, 1, '百度网盘', 'https://pan.baidu.com/s/1lnAY0P_K1IQGU71UTq8jaA', 'g46u', '/public/sysImg/fsjtzb.png', NULL, 0, '安全无毒,亲测可用,安装方法', 0, '{\"file_size\":\"1.3M\",\"supportive_system\":\"win7\\/win10\\/win11\",\"banner\":null}');

-- ----------------------------
-- Table structure for PREFIX_download_cate
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_download_cate`;
CREATE TABLE `PREFIX_download_cate`  (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '文章分类id',
  `pid` bigint(20) UNSIGNED NULL DEFAULT 0 COMMENT '分类父级id',
  `sort` int(8) NULL DEFAULT 0 COMMENT '排序',
  `title` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '标题',
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 9 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_download_cate
-- ----------------------------
INSERT INTO `PREFIX_download_cate` VALUES (5, 0, 50, '默认分类', '2024-08-28 18:56:13', '2024-08-28 18:56:13');

-- ----------------------------
-- Table structure for PREFIX_download_tags
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_download_tags`;
CREATE TABLE `PREFIX_download_tags`  (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 40 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_download_tags
-- ----------------------------
INSERT INTO `PREFIX_download_tags` VALUES (36, 'ps');
INSERT INTO `PREFIX_download_tags` VALUES (37, '');
INSERT INTO `PREFIX_download_tags` VALUES (38, '截图');
INSERT INTO `PREFIX_download_tags` VALUES (39, '博客');

-- ----------------------------
-- Table structure for PREFIX_download_tags_rel
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_download_tags_rel`;
CREATE TABLE `PREFIX_download_tags_rel`  (
  `down_id` bigint(20) NULL DEFAULT NULL,
  `tag_id` bigint(20) NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_download_tags_rel
-- ----------------------------
INSERT INTO `PREFIX_download_tags_rel` VALUES (48, 39);
INSERT INTO `PREFIX_download_tags_rel` VALUES (47, 37);

-- ----------------------------
-- Table structure for PREFIX_field
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_field`;
CREATE TABLE `PREFIX_field`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mid` int(11) NOT NULL COMMENT '所属模型ID',
  `siteid` int(11) NOT NULL DEFAULT 1 COMMENT '站点id',
  `title` varchar(60) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '字段名称',
  `field` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '字段',
  `values` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '字段可选值',
  `class` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '字段类型',
  `default_value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '默认值',
  `isrequire` int(1) NOT NULL DEFAULT 0 COMMENT '0非必填 1必填',
  `type` int(1) NOT NULL DEFAULT 1 COMMENT '1用户字段 2系统字段',
  `maxlength` int(3) NOT NULL COMMENT '字段长度',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0' COMMENT '提示',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 327 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模型字段表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_field
-- ----------------------------
INSERT INTO `PREFIX_field` VALUES (1, 1, 1, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (2, 1, 1, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (3, 2, 1, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (4, 2, 1, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (5, 2, 1, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (6, 3, 1, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (8, 6, 1, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (9, 7, 1, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (10, 7, 1, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (12, 5, 1, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (13, 5, 1, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (14, 5, 1, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (16, 7, 1, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (17, 6, 1, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (18, 6, 1, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (19, 6, 1, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (20, 11, 1, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (21, 12, 1, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (22, 12, 1, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (23, 12, 1, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (24, 12, 1, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (25, 4, 1, '内容', 'content', '', 'editor', '', 0, 2, 1024, 90, '内容');
INSERT INTO `PREFIX_field` VALUES (28, 7, 1, '日询盘数', 'xunpan', '', 'text', '', 0, 2, 255, 6, '');
INSERT INTO `PREFIX_field` VALUES (29, 6, 1, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (31, 6, 1, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (33, 7, 1, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (34, 3, 1, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (35, 4, 1, '图组', 'images', NULL, 'images', NULL, 0, 2, 255, 1, '图组');
INSERT INTO `PREFIX_field` VALUES (36, 4, 1, 'Logo', 'txtLogo', NULL, 'image', NULL, 0, 2, 255, 0, 'Logo');
INSERT INTO `PREFIX_field` VALUES (37, 4, 1, '案例首页大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例首页大图');
INSERT INTO `PREFIX_field` VALUES (38, 21, 2, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (39, 21, 2, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (40, 22, 2, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (41, 22, 2, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (42, 22, 2, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (43, 23, 2, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (44, 26, 2, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (45, 27, 2, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (46, 27, 2, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (47, 27, 2, '联系内容', 'content', '', 'textarea', '', 0, 2, 1024, 7, '请输入联系内容');
INSERT INTO `PREFIX_field` VALUES (48, 25, 2, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (49, 25, 2, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (50, 25, 2, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (51, 27, 2, '回复内容', 'reply', '', 'textarea', '', 0, 2, 512, 9, '请输入回复内容');
INSERT INTO `PREFIX_field` VALUES (52, 27, 2, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (53, 26, 2, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (54, 26, 2, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (55, 26, 2, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (56, 31, 2, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (57, 32, 2, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (58, 32, 2, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (59, 32, 2, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (60, 32, 2, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (61, 24, 2, '店铺详情页', 'content', '', 'editor', '', 0, 2, 1024, 90, '内容');
INSERT INTO `PREFIX_field` VALUES (62, 27, 2, '主题类型', 'subject', '咨询', 'text', '', 0, 2, 50, 3, '主题类型');
INSERT INTO `PREFIX_field` VALUES (63, 27, 2, '公司名称', 'company', '', 'text', '', 0, 2, 255, 2, '公司名称');
INSERT INTO `PREFIX_field` VALUES (64, 27, 2, 'E-mail', 'email', '', 'text', '', 0, 2, 255, 6, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (65, 26, 2, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (66, 27, 2, '附件', 'files', '', 'file', '', 0, 2, 255, 9, '附件');
INSERT INTO `PREFIX_field` VALUES (67, 26, 2, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (68, 27, 2, '联系地址', 'address', NULL, 'text', '', 0, 2, 255, 9, '联系地址');
INSERT INTO `PREFIX_field` VALUES (69, 27, 2, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (70, 23, 2, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (71, 24, 2, '图组', 'images', NULL, 'images', NULL, 0, 2, 255, 1, '图组');
INSERT INTO `PREFIX_field` VALUES (72, 24, 2, 'Logo', 'txtLogo', NULL, 'image', NULL, 0, 2, 255, 0, 'Logo');
INSERT INTO `PREFIX_field` VALUES (73, 24, 2, '案例首页大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例首页大图');
INSERT INTO `PREFIX_field` VALUES (74, 61, 3, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (75, 61, 3, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (76, 62, 3, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (77, 62, 3, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (78, 62, 3, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (79, 63, 3, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (80, 66, 3, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (81, 67, 3, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (82, 67, 3, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (83, 67, 3, '联系内容', 'content', '', 'textarea', '', 0, 2, 1024, 7, '请输入联系内容');
INSERT INTO `PREFIX_field` VALUES (84, 65, 3, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (85, 65, 3, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (86, 65, 3, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (87, 67, 3, '回复内容', 'reply', '', 'textarea', '', 0, 2, 512, 9, '请输入回复内容');
INSERT INTO `PREFIX_field` VALUES (88, 67, 3, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (89, 66, 3, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (90, 66, 3, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (91, 66, 3, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (92, 71, 3, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (93, 72, 3, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (94, 72, 3, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (95, 72, 3, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (96, 72, 3, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (97, 64, 3, '推广效果', 'content', '', 'editor', '', 0, 2, 1024, 90, '内容');
INSERT INTO `PREFIX_field` VALUES (98, 67, 3, '主题类型', 'subject', '咨询', 'text', '', 0, 2, 50, 3, '主题类型');
INSERT INTO `PREFIX_field` VALUES (99, 67, 3, '公司名称', 'company', '', 'text', '', 0, 2, 255, 2, '公司名称');
INSERT INTO `PREFIX_field` VALUES (100, 67, 3, 'E-mail', 'email', '', 'text', '', 0, 2, 255, 6, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (101, 66, 3, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (102, 67, 3, '附件', 'files', '', 'file', '', 0, 2, 255, 9, '附件');
INSERT INTO `PREFIX_field` VALUES (103, 66, 3, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (104, 67, 3, '联系地址', 'address', NULL, 'text', '', 0, 2, 255, 9, '联系地址');
INSERT INTO `PREFIX_field` VALUES (105, 67, 3, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (106, 63, 3, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (107, 64, 3, '图组', 'images', NULL, 'images', NULL, 0, 2, 255, 1, '图组');
INSERT INTO `PREFIX_field` VALUES (108, 64, 3, 'Logo', 'txtLogo', NULL, 'image', NULL, 0, 2, 255, 0, 'Logo');
INSERT INTO `PREFIX_field` VALUES (109, 64, 3, '案例首页大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例首页大图');
INSERT INTO `PREFIX_field` VALUES (110, 141, 4, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (111, 141, 4, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (112, 142, 4, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (113, 142, 4, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (114, 142, 4, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (115, 143, 4, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (116, 146, 4, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (117, 147, 4, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (118, 147, 4, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (119, 147, 4, '联系内容', 'content', '', 'textarea', '', 0, 2, 1024, 7, '请输入联系内容');
INSERT INTO `PREFIX_field` VALUES (120, 145, 4, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (121, 145, 4, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (122, 145, 4, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (123, 147, 4, '回复内容', 'reply', '', 'textarea', '', 0, 2, 512, 9, '请输入回复内容');
INSERT INTO `PREFIX_field` VALUES (124, 147, 4, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (125, 146, 4, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (126, 146, 4, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (127, 146, 4, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (128, 151, 4, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (129, 152, 4, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (130, 152, 4, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (131, 152, 4, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (132, 152, 4, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (133, 144, 4, '内容', 'content', '', 'editor', '', 0, 2, 1024, 90, '内容');
INSERT INTO `PREFIX_field` VALUES (134, 147, 4, '主题类型', 'subject', '咨询', 'text', '', 0, 2, 50, 3, '主题类型');
INSERT INTO `PREFIX_field` VALUES (135, 147, 4, '公司名称', 'company', '', 'text', '', 0, 2, 255, 2, '公司名称');
INSERT INTO `PREFIX_field` VALUES (136, 147, 4, 'E-mail', 'email', '', 'text', '', 0, 2, 255, 6, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (137, 146, 4, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (138, 147, 4, '附件', 'files', '', 'file', '', 0, 2, 255, 9, '附件');
INSERT INTO `PREFIX_field` VALUES (139, 146, 4, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (140, 147, 4, '联系地址', 'address', NULL, 'text', '', 0, 2, 255, 9, '联系地址');
INSERT INTO `PREFIX_field` VALUES (141, 147, 4, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (142, 143, 4, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (143, 144, 4, '图组', 'images', NULL, 'images', NULL, 0, 2, 255, 1, '图组');
INSERT INTO `PREFIX_field` VALUES (144, 144, 4, 'Logo', 'txtLogo', NULL, 'image', NULL, 0, 2, 255, 0, 'Logo');
INSERT INTO `PREFIX_field` VALUES (145, 144, 4, '案例首页大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例首页大图');
INSERT INTO `PREFIX_field` VALUES (146, 301, 5, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (147, 301, 5, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (148, 302, 5, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (149, 302, 5, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (150, 302, 5, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (151, 303, 5, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (152, 306, 5, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (153, 307, 5, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (154, 307, 5, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (155, 307, 5, '联系内容', 'content', '', 'textarea', '', 0, 2, 1024, 7, '请输入联系内容');
INSERT INTO `PREFIX_field` VALUES (156, 305, 5, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (157, 305, 5, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (158, 305, 5, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (159, 307, 5, '回复内容', 'reply', '', 'textarea', '', 0, 2, 512, 9, '请输入回复内容');
INSERT INTO `PREFIX_field` VALUES (160, 307, 5, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (161, 306, 5, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (162, 306, 5, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (163, 306, 5, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (164, 311, 5, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (165, 312, 5, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (166, 312, 5, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (167, 312, 5, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (168, 312, 5, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (169, 304, 5, '内容', 'content', '', 'editor', '', 0, 2, 1024, 90, '内容');
INSERT INTO `PREFIX_field` VALUES (170, 307, 5, '主题类型', 'subject', '咨询', 'text', '', 0, 2, 50, 3, '主题类型');
INSERT INTO `PREFIX_field` VALUES (171, 307, 5, '公司名称', 'company', '', 'text', '', 0, 2, 255, 2, '公司名称');
INSERT INTO `PREFIX_field` VALUES (172, 307, 5, 'E-mail', 'email', '', 'text', '', 0, 2, 255, 6, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (173, 306, 5, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (174, 307, 5, '附件', 'files', '', 'file', '', 0, 2, 255, 9, '附件');
INSERT INTO `PREFIX_field` VALUES (175, 306, 5, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (176, 307, 5, '联系地址', 'address', NULL, 'text', '', 0, 2, 255, 9, '联系地址');
INSERT INTO `PREFIX_field` VALUES (177, 307, 5, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (178, 303, 5, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (179, 304, 5, '图组', 'images', NULL, 'images', NULL, 0, 2, 255, 1, '图组');
INSERT INTO `PREFIX_field` VALUES (180, 304, 5, 'Logo', 'txtLogo', NULL, 'image', NULL, 0, 2, 255, 0, 'Logo');
INSERT INTO `PREFIX_field` VALUES (181, 304, 5, '案例大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例大图');
INSERT INTO `PREFIX_field` VALUES (182, 24, 2, '交易勋章', 'txtNumber', NULL, 'number', '0', 0, 2, 1, 0, '交易勋章');
INSERT INTO `PREFIX_field` VALUES (183, 24, 2, '合作年限', 'txtYear', NULL, 'text', '', 0, 2, 255, 0, '合作年限');
INSERT INTO `PREFIX_field` VALUES (184, 24, 2, 'BSR动态评分', 'txtPingfen', NULL, 'text', '', 0, 2, 10, 0, 'BSR动态评分');
INSERT INTO `PREFIX_field` VALUES (185, 24, 2, '运营目标', 'txtMubiao', NULL, 'text', '', 0, 2, 255, 0, '运营目标');
INSERT INTO `PREFIX_field` VALUES (186, 24, 2, '预算', 'txtYusan', NULL, 'text', '', 0, 2, 255, 0, '预算');
INSERT INTO `PREFIX_field` VALUES (187, 24, 2, '主营产品', 'txtZhuyin', NULL, 'text', '', 0, 2, 255, 0, '主营产品');
INSERT INTO `PREFIX_field` VALUES (188, 64, 3, '合作年限', 'txtYear', NULL, 'text', '', 0, 2, 255, 9, '合作年限');
INSERT INTO `PREFIX_field` VALUES (189, 61, 3, '上词量', 'txtKnumber', NULL, 'number', '0', 0, 2, 5, 1, '上词量');
INSERT INTO `PREFIX_field` VALUES (190, 61, 3, '关键词', 'txtKeywords', NULL, 'text', '', 0, 2, 255, 1, '关键词');
INSERT INTO `PREFIX_field` VALUES (191, 61, 3, '初始排名', 'txtPaimin', NULL, 'number', '0', 0, 2, 8, 1, '初始排名');
INSERT INTO `PREFIX_field` VALUES (192, 61, 3, '当前排名', 'txtCurpaimin', NULL, 'number', '0', 0, 2, 8, 1, '当前排名');
INSERT INTO `PREFIX_field` VALUES (193, 61, 3, '百度首页排名', 'txtBaidu', NULL, 'number', '0', 0, 2, 8, 1, '百度首页排名');
INSERT INTO `PREFIX_field` VALUES (194, 1, 1, '招聘人数', 'txtNumber', NULL, 'text', '', 0, 2, 20, 2, '招聘人数');
INSERT INTO `PREFIX_field` VALUES (195, 10, 1, '应聘人姓名', 'name', NULL, 'text', '', 0, 2, 20, 9, '应聘人姓名');
INSERT INTO `PREFIX_field` VALUES (196, 10, 1, '联系电话', 'phone', NULL, 'text', '', 0, 2, 20, 9, '联系电话');
INSERT INTO `PREFIX_field` VALUES (197, 10, 1, 'E-mail', 'email', NULL, 'text', '', 0, 2, 255, 9, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (198, 10, 1, '学历', 'txtXueli', NULL, 'text', '', 0, 2, 255, 9, '学历');
INSERT INTO `PREFIX_field` VALUES (199, 10, 1, '专业', 'txtZhuanye', NULL, 'text', '', 0, 2, 255, 9, '专业');
INSERT INTO `PREFIX_field` VALUES (200, 10, 1, '学校', 'txtXuexiao', NULL, 'text', '', 0, 2, 255, 9, '学校');
INSERT INTO `PREFIX_field` VALUES (201, 10, 1, '工作经历', 'content', NULL, 'textarea', '', 0, 2, 1024, 9, '工作经历');
INSERT INTO `PREFIX_field` VALUES (202, 10, 1, '申请时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '申请时间');
INSERT INTO `PREFIX_field` VALUES (203, 10, 1, '应聘职位', 'subject', NULL, 'text', '', 0, 2, 255, 0, '应聘职位');
INSERT INTO `PREFIX_field` VALUES (204, 24, 2, '阿里托管效果', 'txtAliContent', NULL, 'editor', '', 0, 2, 2048, 9, '阿里托管效果');
INSERT INTO `PREFIX_field` VALUES (205, 24, 2, '产品/视频拍摄', 'txtPaishe', NULL, 'editor', '', 0, 2, 2048, 9, '产品/视频拍摄');
INSERT INTO `PREFIX_field` VALUES (206, 21, 2, '交易勋章', 'txtNumber', NULL, 'number', '0', 0, 2, 2, 9, '交易勋章');
INSERT INTO `PREFIX_field` VALUES (207, 22, 2, '视频', 'txtVedio', NULL, 'file', NULL, 0, 2, 255, 1, '视频');
INSERT INTO `PREFIX_field` VALUES (208, 30, 2, '应聘职位', 'subject', NULL, 'text', '', 0, 2, 255, 9, '应聘职位');
INSERT INTO `PREFIX_field` VALUES (209, 30, 2, '应聘人姓名', 'name', NULL, 'text', '', 0, 2, 255, 9, '应聘人姓名');
INSERT INTO `PREFIX_field` VALUES (210, 30, 2, '联系电话', 'phone', NULL, 'text', '', 0, 2, 255, 9, '联系电话');
INSERT INTO `PREFIX_field` VALUES (211, 30, 2, 'E-mail', 'email', NULL, 'text', '', 0, 2, 255, 9, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (212, 30, 2, '学历', 'txtXueli', NULL, 'text', '', 0, 2, 255, 9, '学历');
INSERT INTO `PREFIX_field` VALUES (213, 30, 2, '专业', 'txtZhuanye', NULL, 'text', '', 0, 2, 255, 9, '专业');
INSERT INTO `PREFIX_field` VALUES (214, 30, 2, '学校', 'txtXuexiao', NULL, 'text', '', 0, 2, 255, 9, '学校');
INSERT INTO `PREFIX_field` VALUES (215, 30, 2, '工作经历', 'content', NULL, 'textarea', '', 0, 2, 1024, 9, '工作经历');
INSERT INTO `PREFIX_field` VALUES (216, 30, 2, '申请时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 255, 9, '申请时间');
INSERT INTO `PREFIX_field` VALUES (217, 64, 3, '月均咨询', 'txtYuezixun', NULL, 'text', '', 0, 2, 255, 9, '月均咨询');
INSERT INTO `PREFIX_field` VALUES (218, 64, 3, '服务项目', 'txtXiongMu', NULL, 'text', '', 0, 2, 255, 9, '服务项目');
INSERT INTO `PREFIX_field` VALUES (219, 64, 3, '服务效果', 'txtXiaoguo', NULL, 'text', '', 0, 2, 255, 9, '服务效果');
INSERT INTO `PREFIX_field` VALUES (220, 64, 3, '咨询成本', 'txtChenben', NULL, 'text', '', 0, 2, 255, 9, '咨询成本');
INSERT INTO `PREFIX_field` VALUES (221, 64, 3, '案例网址', 'txtUrl', NULL, 'text', '', 0, 2, 255, 9, '案例网址');
INSERT INTO `PREFIX_field` VALUES (222, 64, 3, 'SEM推广', 'txtSEM', NULL, 'editor', '', 0, 2, 2048, 90, 'SEM推广');
INSERT INTO `PREFIX_field` VALUES (223, 64, 3, 'SEO优化', 'txtSEO', NULL, 'editor', '', 0, 2, 2048, 90, 'SEO优化');
INSERT INTO `PREFIX_field` VALUES (224, 64, 3, '名誉管理', 'txtMinyu', NULL, 'editor', '', 0, 2, 2048, 90, '名誉管理');
INSERT INTO `PREFIX_field` VALUES (225, 64, 3, '上词量', 'txtKnumber', NULL, 'text', '', 0, 2, 255, 9, '上词量');
INSERT INTO `PREFIX_field` VALUES (226, 64, 3, '关键词', 'txtKeywords', NULL, 'text', '', 0, 2, 255, 9, '关键词');
INSERT INTO `PREFIX_field` VALUES (227, 64, 3, '初始排名', 'txtPaimin', NULL, 'text', '', 0, 2, 255, 9, '初始排名');
INSERT INTO `PREFIX_field` VALUES (228, 64, 3, '当前排名', 'txtCurpaimin', NULL, 'text', '', 0, 2, 255, 9, '当前排名');
INSERT INTO `PREFIX_field` VALUES (229, 64, 3, '百度首页排名', 'txtBaidu', NULL, 'text', '', 0, 2, 255, 9, '百度首页排名');
INSERT INTO `PREFIX_field` VALUES (230, 64, 3, '公司名称', 'txtCompany', NULL, 'text', '', 0, 2, 255, 1, '公司名称');
INSERT INTO `PREFIX_field` VALUES (231, 64, 3, '主要产品', 'txtCanpin', NULL, 'text', '', 0, 2, 255, 1, '主要产品');
INSERT INTO `PREFIX_field` VALUES (232, 144, 4, '周期', 'txtZhuoqi', NULL, 'text', '', 0, 2, 255, 9, '周期');
INSERT INTO `PREFIX_field` VALUES (233, 144, 4, '服务', 'txtFuwu', NULL, 'text', '', 0, 2, 255, 9, '服务');
INSERT INTO `PREFIX_field` VALUES (234, 144, 4, '类别', 'txtLeibie', NULL, 'text', '', 0, 2, 255, 9, '类别');
INSERT INTO `PREFIX_field` VALUES (235, 144, 4, '网站', 'txtUrl', NULL, 'text', '', 0, 2, 255, 9, '网站');
INSERT INTO `PREFIX_field` VALUES (236, 304, 5, '周期', 'txtZhuoqi', NULL, 'text', '', 0, 2, 255, 9, '周期');
INSERT INTO `PREFIX_field` VALUES (237, 304, 5, '服务', 'txtFuwu', NULL, 'text', '', 0, 2, 255, 9, '服务');
INSERT INTO `PREFIX_field` VALUES (238, 304, 5, '类别', 'txtLeibie', NULL, 'text', '', 0, 2, 255, 9, '类别');
INSERT INTO `PREFIX_field` VALUES (239, 304, 5, '网站', 'txtUrl', NULL, 'text', '', 0, 2, 255, 9, '网站');
INSERT INTO `PREFIX_field` VALUES (240, 304, 5, '营销定位', 'txtYinxiao', NULL, 'textarea', '', 0, 2, 2048, 9, '营销定位');
INSERT INTO `PREFIX_field` VALUES (241, 381, 6, '文章内容', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入文章内容');
INSERT INTO `PREFIX_field` VALUES (242, 381, 6, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 1, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (243, 382, 6, '发布人', 'publisher', '', 'text', '小编', 0, 2, 50, 9, '请输入发布人');
INSERT INTO `PREFIX_field` VALUES (244, 382, 6, '图组', 'images', '', 'images', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (245, 382, 6, '图组说明', 'content', '', 'editor', '', 0, 2, 2048, 9, '');
INSERT INTO `PREFIX_field` VALUES (246, 383, 6, '详情', 'content', '', 'editor', '', 0, 2, 2048, 50, '请输入详情');
INSERT INTO `PREFIX_field` VALUES (247, 386, 6, '内容', 'content', '', 'editor', '', 0, 2, 2048, 2, '请输入内容');
INSERT INTO `PREFIX_field` VALUES (248, 387, 6, '联系人', 'name', '', 'text', '', 0, 2, 50, 1, '请输入联系人');
INSERT INTO `PREFIX_field` VALUES (249, 387, 6, '联系电话', 'phone', '', 'text', '', 0, 2, 20, 5, '请输入联系电话');
INSERT INTO `PREFIX_field` VALUES (250, 387, 6, '联系内容', 'content', '', 'textarea', '', 0, 2, 1024, 7, '请输入联系内容');
INSERT INTO `PREFIX_field` VALUES (251, 385, 6, '资料名称', 'filename', '', 'text', '', 0, 2, 255, 9, '请输入资料名称');
INSERT INTO `PREFIX_field` VALUES (252, 385, 6, '上传资料', 'fileurl', '', 'file', '', 0, 2, 255, 9, '请上传文件');
INSERT INTO `PREFIX_field` VALUES (253, 385, 6, '资料详情', 'content', '', 'editor', '', 0, 2, 2048, 9, '请输入资料详情');
INSERT INTO `PREFIX_field` VALUES (254, 387, 6, '回复内容', 'reply', '', 'textarea', '', 0, 2, 512, 9, '请输入回复内容');
INSERT INTO `PREFIX_field` VALUES (255, 387, 6, '审核', 'ischeck', '通过审核\n审核不通过', 'radio', '', 0, 2, 10, 11, '');
INSERT INTO `PREFIX_field` VALUES (256, 386, 6, '摘要', 'summary', '', 'textarea', '', 0, 2, 512, 1, '输入摘要');
INSERT INTO `PREFIX_field` VALUES (257, 386, 6, '内容二', 'homecontent', '', 'editor', '', 0, 2, 1024, 9, '');
INSERT INTO `PREFIX_field` VALUES (258, 386, 6, '图组', 'images', '', 'images', '', 0, 2, 1024, 15, '');
INSERT INTO `PREFIX_field` VALUES (259, 391, 6, '用户名', 'name', '', 'text', '', 0, 2, 100, 9, '用户名');
INSERT INTO `PREFIX_field` VALUES (260, 392, 6, '问题', 'question', '', 'text', '', 0, 2, 255, 9, '问题');
INSERT INTO `PREFIX_field` VALUES (261, 392, 6, '回答', 'answer', '', 'text', '', 0, 2, 255, 9, '回答');
INSERT INTO `PREFIX_field` VALUES (262, 392, 6, '提问时间', 'createdat', '', 'datetime', '', 0, 2, 20, 9, '提问时间');
INSERT INTO `PREFIX_field` VALUES (263, 392, 6, '回答时间', 'asktime', '', 'datetime', '', 0, 2, 20, 9, '回答时间');
INSERT INTO `PREFIX_field` VALUES (265, 387, 6, '主题类型', 'subject', '咨询', 'text', '', 0, 2, 50, 3, '主题类型');
INSERT INTO `PREFIX_field` VALUES (266, 387, 6, '公司名称', 'company', '', 'text', '', 0, 2, 255, 2, '公司名称');
INSERT INTO `PREFIX_field` VALUES (267, 387, 6, 'E-mail', 'email', '', 'text', '', 0, 2, 255, 6, 'E-mail');
INSERT INTO `PREFIX_field` VALUES (268, 386, 6, '手机端内容', 'mobilecontent', '', 'editor', '', 0, 2, 1024, 9, '手机端内容');
INSERT INTO `PREFIX_field` VALUES (269, 387, 6, '附件', 'files', '', 'file', '', 0, 2, 255, 9, '附件');
INSERT INTO `PREFIX_field` VALUES (270, 386, 6, '视频', 'video', NULL, 'file', NULL, 0, 2, 255, 9, '视频');
INSERT INTO `PREFIX_field` VALUES (271, 387, 6, '联系地址', 'address', NULL, 'text', '', 0, 2, 255, 9, '联系地址');
INSERT INTO `PREFIX_field` VALUES (272, 387, 6, '留言时间', 'createdtime', NULL, 'datetime', NULL, 0, 2, 20, 9, '留言时间');
INSERT INTO `PREFIX_field` VALUES (273, 383, 6, '图组', 'images', NULL, 'images', NULL, 0, 2, 1024, 9, '图组');
INSERT INTO `PREFIX_field` VALUES (276, 384, 6, '案例首页大图', 'txtPic', NULL, 'image', NULL, 0, 2, 255, 0, '案例首页大图');
INSERT INTO `PREFIX_field` VALUES (278, 381, 6, '上词量', 'txtKnumber', NULL, 'number', '0', 0, 2, 5, 1, '上词量');
INSERT INTO `PREFIX_field` VALUES (279, 381, 6, '关键词', 'txtKeywords', NULL, 'text', '', 0, 2, 255, 1, '关键词');
INSERT INTO `PREFIX_field` VALUES (280, 381, 6, '初始排名', 'txtPaimin', NULL, 'number', '0', 0, 2, 8, 1, '初始排名');
INSERT INTO `PREFIX_field` VALUES (281, 381, 6, '当前排名', 'txtCurpaimin', NULL, 'number', '0', 0, 2, 8, 1, '当前排名');
INSERT INTO `PREFIX_field` VALUES (282, 381, 6, '百度首页排名', 'txtBaidu', NULL, 'number', '0', 0, 2, 8, 1, '百度首页排名');
INSERT INTO `PREFIX_field` VALUES (298, 384, 6, '核心关键词', 'txtKeywords', NULL, 'text', '', 0, 2, 255, 9, '核心关键词');
INSERT INTO `PREFIX_field` VALUES (299, 384, 6, '服务项目', 'txtXiangmu', NULL, 'text', '', 0, 2, 255, 9, '服务项目');
INSERT INTO `PREFIX_field` VALUES (300, 384, 6, '服务效果', 'txtXiaoge', NULL, 'text', '', 0, 2, 255, 9, '服务效果');
INSERT INTO `PREFIX_field` VALUES (301, 384, 6, '主要产品', 'txtChanpin', NULL, 'text', '', 0, 2, 255, 9, '主要产品');
INSERT INTO `PREFIX_field` VALUES (302, 384, 6, '案例网址', 'txtUrl', NULL, 'text', '', 0, 2, 255, 9, '案例网址');
INSERT INTO `PREFIX_field` VALUES (303, 384, 6, '关键词指数', 'txtKeyzhishu', NULL, 'text', '', 0, 2, 255, 9, '关键词指数');
INSERT INTO `PREFIX_field` VALUES (304, 384, 6, '百度', 'txtBaidu', NULL, 'text', '', 0, 2, 255, 9, '百度');
INSERT INTO `PREFIX_field` VALUES (305, 384, 6, '360', 'txtSnn', NULL, 'text', '', 0, 2, 255, 9, '360');
INSERT INTO `PREFIX_field` VALUES (306, 384, 6, '搜狗', 'txtSogo', NULL, 'text', '', 0, 2, 255, 9, '搜狗');
INSERT INTO `PREFIX_field` VALUES (307, 384, 6, '公司', 'txtGongsi', NULL, 'text', '', 0, 2, 255, 9, '公司');
INSERT INTO `PREFIX_field` VALUES (308, 384, 6, '核心关键词', 'txtGjc', NULL, 'editor', '', 0, 2, 1024, 9, '核心关键词');
INSERT INTO `PREFIX_field` VALUES (309, 384, 6, '长尾关键词', 'txtCwc', NULL, 'editor', '', 0, 2, 1024, 9, '长尾关键词');
INSERT INTO `PREFIX_field` VALUES (310, 384, 6, '权重等级', 'txtChuanzhong', NULL, 'editor', '', 0, 2, 1024, 9, '权重等级');
INSERT INTO `PREFIX_field` VALUES (311, 384, 6, '百度/360/搜狗排名', 'txtPaiming', NULL, 'editor', '', 0, 2, 1024, 9, '百度/360/搜狗排名');
INSERT INTO `PREFIX_field` VALUES (312, 384, 6, '权重', 'txtPR', NULL, 'text', '', 0, 2, 255, 8, '权重');
INSERT INTO `PREFIX_field` VALUES (313, 387, 6, '目标关键词', 'keynum', NULL, 'text', '', 0, 2, 255, 9, '目标关键词');
INSERT INTO `PREFIX_field` VALUES (314, 7, 1, '问题', 'question', '之前网站太丑\n提升公司品牌\n提升推广效果\n增加网站功能\n之前网站没人维护\n之前网站找不到联系人\n第一次做网站\n定制开发要源码', 'checkbox', NULL, 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (315, 7, 1, '目标关键词', 'keynum', '3~6个\n7~20个\n21~40个', 'radio', NULL, 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (316, 64, 3, '网页设计预览', 'txtSheji', NULL, 'editor', '', 0, 2, 0, 9, '');
INSERT INTO `PREFIX_field` VALUES (317, 64, 3, 'B2B排名', 'txtBtB', NULL, 'editor', '', 0, 2, 0, 9, '');
INSERT INTO `PREFIX_field` VALUES (318, 3, 1, 'fujian', 'fujian', NULL, 'file', NULL, 0, 2, 0, 9, '');
INSERT INTO `PREFIX_field` VALUES (319, 24, 2, '有效询盘', 'yxxp', NULL, 'text', '', 0, 2, 255, 9, '');
INSERT INTO `PREFIX_field` VALUES (320, 7, 1, '进入位置', 'weizhi', NULL, 'text', '', 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (321, 7, 1, '需要做的项目', 'xiangmu', NULL, 'text', '', 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (322, 64, 3, '视频链接', 'txtVedio', NULL, 'text', '', 0, 2, 500, 9, '');
INSERT INTO `PREFIX_field` VALUES (323, 7, 1, '服务内容', 'questions', '保询盘量\n网站建设\n阿里运营\n竞价托管\n关键词排名\n百度爱采购\n抖音/头条运营\n品牌推广', 'checkbox', NULL, 0, 2, 100, 1, '');
INSERT INTO `PREFIX_field` VALUES (324, 7, 1, '阿里服务', 'services', '阿里开户\n店铺诊断\n产品摄影\n店铺装修\n运营托管\n保询盘运营', 'checkbox', NULL, 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (325, 64, 3, '咨询', 'txtZx', NULL, 'text', '', 0, 2, 100, 9, '');
INSERT INTO `PREFIX_field` VALUES (326, 7, 1, '网建服务', 'wangjians', '品牌网站建设\n外贸网站建设\n营销型网站建设\n手机网站建设', 'checkbox', NULL, 0, 2, 100, 9, '');

-- ----------------------------
-- Table structure for PREFIX_form_apply
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_apply`;
CREATE TABLE `PREFIX_form_apply`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_apply
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_articles
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_articles`;
CREATE TABLE `PREFIX_form_articles`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `publisher` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '小编',
  `txtNumber` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_articles
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_ask
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_ask`;
CREATE TABLE `PREFIX_form_ask`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `question` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `answer` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `createdat` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `asktime` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_ask
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_cases
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_cases`;
CREATE TABLE `PREFIX_form_cases`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `images` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `txtLogo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `txtPic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_cases
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_download
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_download`;
CREATE TABLE `PREFIX_form_download`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `fileurl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_download
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_feedback
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_feedback`;
CREATE TABLE `PREFIX_form_feedback`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_feedback
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_guestbook
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_guestbook`;
CREATE TABLE `PREFIX_form_guestbook`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `phone` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `ischeck` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `xunpan` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `createdtime` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `questions` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `keynum` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `weizhi` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `xiangmu` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `question` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `services` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `wangjians` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_guestbook
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_images
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_images`;
CREATE TABLE `PREFIX_form_images`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `publisher` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '小编',
  `images` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_images
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_jobs
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_jobs`;
CREATE TABLE `PREFIX_form_jobs`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `phone` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `txtXueli` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `txtZhuanye` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `txtXuexiao` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `createdtime` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  `subject` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_jobs
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_page
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_page`;
CREATE TABLE `PREFIX_form_page`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `content` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `summary` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `homecontent` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `images` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `mobilecontent` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `video` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_page
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_product
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_product`;
CREATE TABLE `PREFIX_form_product`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `images` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `fujian` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_product
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_form_reservation
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_form_reservation`;
CREATE TABLE `PREFIX_form_reservation`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_form_reservation
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_ip_visit_stats
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_ip_visit_stats`;
CREATE TABLE `PREFIX_ip_visit_stats`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip_address` varbinary(16) NOT NULL COMMENT 'ipv4 ipv6支持二进制储存查询更快',
  `visit_date` date NOT NULL COMMENT '时间',
  `visit_count` int(10) UNSIGNED NULL DEFAULT 1 COMMENT '次数',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `ip_address`(`ip_address`, `visit_date`) USING BTREE,
  INDEX `idx_date`(`visit_date`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 152 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_ip_visit_stats
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_links
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_links`;
CREATE TABLE `PREFIX_links`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` int(1) NOT NULL DEFAULT 1 COMMENT '类型：1=文字链接，2=图片链接',
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '网站Logo',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '网站标题',
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '网站地址',
  `description` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '网站简况',
  `target` int(1) NOT NULL DEFAULT 0 COMMENT '是否开启浏览器新窗口',
  `email` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
  `lang` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'cn' COMMENT '语言标识',
  `siteid` int(11) NOT NULL DEFAULT 0 COMMENT '站点目录',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `status` int(1) NOT NULL DEFAULT 1 COMMENT '状态：1=显示，0=屏蔽',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `update_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `delete_at` timestamp NULL DEFAULT NULL COMMENT '软删除时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '友情链接' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_links
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_member_favorites
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_member_favorites`;
CREATE TABLE `PREFIX_member_favorites`  (
  `member_id` int(11) NOT NULL DEFAULT 0,
  `content_id` int(11) NOT NULL DEFAULT 0,
  `created_at` timestamp NOT NULL DEFAULT '2019-09-01 10:10:10',
  UNIQUE INDEX `cmid`(`member_id`, `content_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_member_favorites
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_members
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_members`;
CREATE TABLE `PREFIX_members`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '用户名',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '邮箱',
  `phone` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '手机',
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '密码',
  `remember_token` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '记住token',
  `login_ip` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '登录IP',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `login_at` timestamp NULL DEFAULT NULL COMMENT '最近登录时间',
  `avatar` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `name`(`name`, `email`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_members
-- ----------------------------
INSERT INTO `PREFIX_members` VALUES (1, '', '123@qq. com', '13827247715', 'e10adc3949ba59abbe56e057f20f883e', '', '', '2021-06-13 22:20:08', NULL, NULL);

-- ----------------------------
-- Table structure for PREFIX_model
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_model`;
CREATE TABLE `PREFIX_model`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `siteid` int(11) NOT NULL DEFAULT 0 COMMENT '站点id',
  `title` varchar(60) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '模型名称',
  `table_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '表名称',
  `description` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '简介',
  `type` tinyint(2) NOT NULL DEFAULT 1 COMMENT '1文章 2单页面 3留言 4图片 5产品 6案例 7下载 8报名 9预约 10招聘',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `issystem` tinyint(1) NULL DEFAULT 1 COMMENT '类别 1系统模型 2用户模型',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 393 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模型表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_model
-- ----------------------------
INSERT INTO `PREFIX_model` VALUES (1, 1, '文章', 'articles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (2, 1, '图组', 'images', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (3, 1, '产品', 'product', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (4, 1, '案例', 'cases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (5, 1, '下载', 'download', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (6, 1, '单页面', 'page', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (7, 1, '留言', 'guestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (8, 1, '报名', 'apply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (9, 1, '预约', 'reservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (10, 1, '招聘', 'jobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (11, 1, '客户反馈', 'feedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (12, 1, '问答', 'ask', '问答', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (21, 2, '文章', 'alibabaarticles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (22, 2, '图组', 'alibabaimages', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (23, 2, '产品', 'alibabaproduct', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (24, 2, '案例', 'alibabacases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (25, 2, '下载', 'alibabadownload', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (26, 2, '单页面', 'alibabapage', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (27, 2, '留言', 'alibabaguestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (28, 2, '报名', 'alibabaapply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (29, 2, '预约', 'alibabareservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (30, 2, '招聘', 'alibabajobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (31, 2, '客户反馈', 'alibabafeedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (32, 2, '问答', 'alibabaask', '问答', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (61, 3, '文章', 'aseoalibabaarticles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (62, 3, '图组', 'aseoalibabaimages', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (63, 3, '产品', 'aseoalibabaproduct', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (64, 3, '案例', 'aseoalibabacases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (65, 3, '下载', 'aseoalibabadownload', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (66, 3, '单页面', 'aseoalibabapage', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (67, 3, '留言', 'aseoalibabaguestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (68, 3, '报名', 'aseoalibabaapply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (69, 3, '预约', 'aseoalibabareservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (70, 3, '招聘', 'aseoalibabajobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (71, 3, '客户反馈', 'aseoalibabafeedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (72, 3, '问答', 'aseoalibabaask', '问答', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (141, 4, '文章', 'wechataseoalibabaarticles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (142, 4, '图组', 'wechataseoalibabaimages', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (143, 4, '产品', 'wechataseoalibabaproduct', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (144, 4, '案例', 'wechataseoalibabacases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (145, 4, '下载', 'wechataseoalibabadownload', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (146, 4, '单页面', 'wechataseoalibabapage', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (147, 4, '留言', 'wechataseoalibabaguestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (148, 4, '报名', 'wechataseoalibabaapply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (149, 4, '预约', 'wechataseoalibabareservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (150, 4, '招聘', 'wechataseoalibabajobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (151, 4, '客户反馈', 'wechataseoalibabafeedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (152, 4, '问答', 'wechataseoalibabaask', '问答', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (301, 5, '文章', 'websitewechataseoalibabaarticles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (302, 5, '图组', 'websitewechataseoalibabaimages', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (303, 5, '产品', 'websitewechataseoalibabaproduct', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (304, 5, '案例', 'websitewechataseoalibabacases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (305, 5, '下载', 'websitewechataseoalibabadownload', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (306, 5, '单页面', 'websitewechataseoalibabapage', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (307, 5, '留言', 'websitewechataseoalibabaguestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (308, 5, '报名', 'websitewechataseoalibabaapply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (309, 5, '预约', 'websitewechataseoalibabareservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (310, 5, '招聘', 'websitewechataseoalibabajobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (311, 5, '客户反馈', 'websitewechataseoalibabafeedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (312, 5, '问答', 'websitewechataseoalibabaask', '问答', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (381, 6, '文章', 'seoaseoalibabaarticles', '图文内容', 1, 1, 2);
INSERT INTO `PREFIX_model` VALUES (382, 6, '图组', 'seoaseoalibabaimages', '', 4, 2, 2);
INSERT INTO `PREFIX_model` VALUES (383, 6, '产品', 'seoaseoalibabaproduct', '', 5, 3, 2);
INSERT INTO `PREFIX_model` VALUES (384, 6, '案例', 'seoaseoalibabacases', '', 6, 4, 2);
INSERT INTO `PREFIX_model` VALUES (385, 6, '下载', 'seoaseoalibabadownload', '', 7, 5, 2);
INSERT INTO `PREFIX_model` VALUES (386, 6, '单页面', 'seoaseoalibabapage', '', 2, 6, 2);
INSERT INTO `PREFIX_model` VALUES (387, 6, '留言', 'seoaseoalibabaguestbook', '', 3, 7, 2);
INSERT INTO `PREFIX_model` VALUES (388, 6, '报名', 'seoaseoalibabaapply', '', 8, 8, 2);
INSERT INTO `PREFIX_model` VALUES (389, 6, '预约', 'seoaseoalibabareservation', '', 9, 9, 2);
INSERT INTO `PREFIX_model` VALUES (390, 6, '招聘', 'seoaseoalibabajobs', '', 10, 10, 2);
INSERT INTO `PREFIX_model` VALUES (391, 6, '客户反馈', 'seoaseoalibabafeedback', '客户反馈', 3, 9, 2);
INSERT INTO `PREFIX_model` VALUES (392, 6, '问答', 'seoaseoalibabaask', '问答', 3, 9, 2);

-- ----------------------------
-- Table structure for PREFIX_nav_config
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_nav_config`;
CREATE TABLE `PREFIX_nav_config`  (
  `id` bigint(22) NULL DEFAULT NULL,
  `name` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '名称',
  `yr_icon` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `icon` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `href` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `pid` bigint(22) NULL DEFAULT NULL COMMENT '父级',
  `is_show` tinyint(2) NULL DEFAULT NULL COMMENT '1 展示 2 不展示',
  `created_at` datetime NULL DEFAULT NULL,
  `updated_at` datetime NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_nav_config
-- ----------------------------
INSERT INTO `PREFIX_nav_config` VALUES (277030455130194148, '首页', '', '', '/', 0, 1, '2024-10-31 11:38:26', '2024-12-08 09:56:54');
INSERT INTO `PREFIX_nav_config` VALUES (277031219131056325, '免费资源', '', '', '/downList', 0, 1, '2024-10-31 11:46:02', '2024-10-31 04:16:26');
INSERT INTO `PREFIX_nav_config` VALUES (277031251259424805, '文章博客', '', '', '/newsList', 0, 1, '2024-10-31 11:46:21', '2024-11-18 10:22:26');

-- ----------------------------
-- Table structure for PREFIX_option_log
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_option_log`;
CREATE TABLE `PREFIX_option_log`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '用户名',
  `user_id` int(11) NOT NULL COMMENT '用户ID',
  `module` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '模块',
  `controller` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '控制器',
  `action` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '方法',
  `option` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '操作',
  `method` varchar(15) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '请求方法',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = MyISAM AUTO_INCREMENT = 285851 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '操作日志表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_option_log
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_order
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_order`;
CREATE TABLE `PREFIX_order`  (
  `order_id` bigint(22) NOT NULL,
  `ac_id` bigint(22) NOT NULL COMMENT '用户ID',
  `order_type` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '订单类型，例如 \'membership\', \'balance_recharge\', \'product_article\'',
  `item_id` bigint(22) NULL DEFAULT NULL COMMENT '购买的具体物品ID（如套餐ID，或产品ID）',
  `order_date` datetime NOT NULL COMMENT '订单时间',
  `total_amount` decimal(10, 2) NOT NULL COMMENT '金额',
  `status` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '订单状态，例如 \'pending\', \'completed\', \'cancelled\'',
  `payment_method` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '支付方式，例如 \'WeChat\', \'Alipay\', \'Other\'',
  `transaction_id` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '第三方支付交易ID',
  PRIMARY KEY (`order_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '订单表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_order
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_permissions
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_permissions`;
CREATE TABLE `PREFIX_permissions`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '菜单名称',
  `icon` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '菜单图标',
  `pid` smallint(6) NOT NULL COMMENT '父级菜单ID',
  `module` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '模块名称',
  `controller` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '控制器名称',
  `action` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '方法名称',
  `is_show` tinyint(4) NOT NULL DEFAULT 1 COMMENT '1 展示 2 隐藏',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `name`(`name`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 202 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_permissions
-- ----------------------------
INSERT INTO `PREFIX_permissions` VALUES (1, '系统管理', 'layui-icon-auz', 0, 'admin', 'admin', 'index', 2, '2019-03-15 00:50:03', '2019-03-15 00:50:03');
INSERT INTO `PREFIX_permissions` VALUES (2, '管理员', '', 1, 'admin', 'user', 'index', 1, '2019-07-03 07:21:13', '2019-07-03 07:21:13');
INSERT INTO `PREFIX_permissions` VALUES (3, '角色管理', '', 1, 'admin', 'role', 'index', 1, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (4, '菜单管理', '', 1, 'admin', 'permission', 'index', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (5, '创建用户', '', 2, 'admin', 'user', 'create', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (6, '编辑用户', '', 2, 'admin', 'user', 'edit', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (7, '删除用户', '', 2, 'admin', 'user', 'delete', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (8, '创建角色', '', 3, 'admin', 'role', 'create', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (9, '编辑角色', '', 3, 'admin', 'role', 'edit', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (10, '删除角色', '', 3, 'admin', 'role', 'delete', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (11, '获取角色权限', '', 3, 'admin', 'role', 'getPermissionsOfRole', 2, '2019-03-08 05:37:22', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (12, '分配权限', '', 3, 'admin', 'role', 'givePermissions', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (13, '分配角色', '', 2, 'admin', 'user', 'giveRoles', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (14, '创建菜单', '', 4, 'admin', 'permission', 'create', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (15, '编辑菜单', '', 4, 'admin', 'permission', 'edit', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (16, '删除菜单', '', 4, 'admin', 'permission', 'delete', 2, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (17, '日志记录', '', 1, 'admin', 'Log', 'index', 1, '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (18, '用户列表', '', 2, 'admin', 'user', 'getList', 2, '2019-03-08 01:18:16', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (19, '角色列表', '', 3, 'admin', 'role', 'getList', 2, '2019-03-08 01:18:04', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (20, '菜单列表', '', 4, 'admin', 'permission', 'getList', 2, '2019-03-08 01:18:09', '2019-03-08 08:47:00');
INSERT INTO `PREFIX_permissions` VALUES (22, '日志列表', '', 17, 'admin', 'log', 'getList', 2, '2019-03-08 05:55:08', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_permissions` VALUES (23, '内容管理', 'layui-icon-app', 0, 'admin', 'content', 'index', 1, '2019-03-14 00:57:28', '2019-03-14 00:57:28');
INSERT INTO `PREFIX_permissions` VALUES (24, '网址导航分类', '', 23, 'admin', 'cate', 'index', 1, '2019-03-12 10:26:37', '2024-12-08 08:47:06');
INSERT INTO `PREFIX_permissions` VALUES (25, '管理内容', '', 23, 'admin', 'content', 'index', 2, '2019-03-12 02:06:14', '2024-08-26 01:20:12');
INSERT INTO `PREFIX_permissions` VALUES (26, '分类列表', '', 24, 'admin', 'cate', 'getList', 2, '2019-03-14 05:49:25', '2021-06-09 06:09:30');
INSERT INTO `PREFIX_permissions` VALUES (27, '创建分类', '', 24, 'admin', 'cate', 'create', 2, '2019-03-14 05:49:34', '2021-06-09 06:09:34');
INSERT INTO `PREFIX_permissions` VALUES (28, '设置', 'layui-icon-set', 0, 'admin', 'upload', '', 1, '2019-03-14 00:55:48', '2019-03-14 00:55:48');
INSERT INTO `PREFIX_permissions` VALUES (29, '图片上传', '', 28, 'admin', 'upload', 'image', 2, '2019-03-14 00:54:33', '2019-03-14 00:54:33');
INSERT INTO `PREFIX_permissions` VALUES (30, '删除分类', '', 24, 'admin', 'cate', 'delete', 2, '2019-03-14 05:49:46', '2021-06-09 06:09:38');
INSERT INTO `PREFIX_permissions` VALUES (31, '编辑分类', '', 24, 'admin', 'cate', 'edit', 2, '2019-03-14 05:50:01', '2021-06-09 06:09:42');
INSERT INTO `PREFIX_permissions` VALUES (32, '模型管理', '', 1, 'admin', 'model', 'index', 1, '2019-03-15 00:48:11', '2019-03-15 00:48:11');
INSERT INTO `PREFIX_permissions` VALUES (33, '模型列表', '', 32, 'admin', 'model', 'getList', 2, '2019-03-15 06:16:03', '2019-03-15 06:16:03');
INSERT INTO `PREFIX_permissions` VALUES (34, '创建模型', '', 32, 'admin', 'model', 'create', 2, '2019-03-15 06:40:49', '2019-03-15 06:40:49');
INSERT INTO `PREFIX_permissions` VALUES (35, '编辑模型', '', 32, 'admin', 'model', 'edit', 2, '2019-03-15 08:03:11', '2019-03-15 08:03:11');
INSERT INTO `PREFIX_permissions` VALUES (36, '删除模型', '', 32, 'admin', 'model', 'delete', 2, '2019-03-15 09:55:36', '2019-03-15 09:55:36');
INSERT INTO `PREFIX_permissions` VALUES (37, '字段管理', '', 1, 'admin', 'field', 'index', 2, '2019-03-19 02:25:10', '2019-03-19 02:25:10');
INSERT INTO `PREFIX_permissions` VALUES (38, '字段列表', '', 37, 'admin', 'field', 'getList', 2, '2019-03-19 02:26:00', '2019-03-19 02:26:00');
INSERT INTO `PREFIX_permissions` VALUES (39, '创建字段', '', 37, 'admin', 'field', 'create', 2, '2019-03-19 02:31:04', '2019-03-19 02:31:04');
INSERT INTO `PREFIX_permissions` VALUES (40, '取字段默认值', '', 37, 'admin', 'field', 'defaultValue', 2, '2019-03-19 03:33:57', '2019-03-19 03:33:57');
INSERT INTO `PREFIX_permissions` VALUES (41, '编辑字段', '', 37, 'admin', 'field', 'edit', 2, '2019-03-20 00:37:20', '2019-03-20 00:37:20');
INSERT INTO `PREFIX_permissions` VALUES (42, '删除字段', '', 37, 'admin', 'field', 'delete', 2, '2019-03-20 00:38:24', '2019-03-20 00:38:24');
INSERT INTO `PREFIX_permissions` VALUES (43, '内容列表', '', 25, 'admin', 'content', 'list', 2, '2019-03-20 07:53:43', '2019-03-20 07:53:43');
INSERT INTO `PREFIX_permissions` VALUES (44, '内容单页面', '', 25, 'admin', 'content', 'page', 2, '2019-03-21 00:38:37', '2019-03-21 00:38:37');
INSERT INTO `PREFIX_permissions` VALUES (45, '发布内容', '', 25, 'admin', 'content', 'create', 2, '2019-03-21 06:53:52', '2019-03-21 06:53:52');
INSERT INTO `PREFIX_permissions` VALUES (46, 'CK上传图片', '', 28, 'admin', 'upload', 'ckimage', 2, '2019-03-22 05:54:59', '2024-12-04 07:04:28');
INSERT INTO `PREFIX_permissions` VALUES (47, '获取内容列表', '', 25, 'admin', 'content', 'getList', 2, '2019-03-25 06:07:43', '2019-03-25 06:07:43');
INSERT INTO `PREFIX_permissions` VALUES (48, '编辑内容', '', 25, 'admin', 'content', 'edit', 2, '2019-03-25 07:27:24', '2019-03-25 07:27:24');
INSERT INTO `PREFIX_permissions` VALUES (49, '删除内容条目', '', 25, 'admin', 'content', 'delete', 2, '2019-03-25 08:59:15', '2019-03-25 08:59:15');
INSERT INTO `PREFIX_permissions` VALUES (50, '分配栏目权限', '', 3, 'admin', 'role', 'giveCategories', 2, '2019-03-27 00:59:08', '2019-03-27 00:59:08');
INSERT INTO `PREFIX_permissions` VALUES (51, '获取角色拥有的栏目', '', 3, 'admin', 'role', 'getCategoriesOfRole', 2, '2019-03-27 01:26:48', '2019-03-27 01:26:48');
INSERT INTO `PREFIX_permissions` VALUES (52, '站点设置', '', 28, 'admin', 'site', 'index', 1, '2019-04-11 01:00:45', '2019-04-11 01:00:45');
INSERT INTO `PREFIX_permissions` VALUES (53, '站点列表', '', 52, 'admin', 'site', 'getList', 2, '2019-04-11 01:02:15', '2019-04-11 01:02:15');
INSERT INTO `PREFIX_permissions` VALUES (54, '创建站点', '', 52, 'admin', 'site', 'create', 2, '2019-04-11 01:03:32', '2019-04-11 01:03:32');
INSERT INTO `PREFIX_permissions` VALUES (55, '编辑站点', '', 52, 'admin', 'site', 'edit', 2, '2019-04-11 01:04:13', '2019-04-11 01:04:13');
INSERT INTO `PREFIX_permissions` VALUES (56, '删除站点', '', 52, 'admin', 'site', 'delete', 2, '2019-04-11 01:04:50', '2019-04-11 01:04:50');
INSERT INTO `PREFIX_permissions` VALUES (57, '编辑我的资料', '', 2, 'admin', 'user', 'info', 2, '2019-04-11 06:34:05', '2019-04-11 06:34:05');
INSERT INTO `PREFIX_permissions` VALUES (58, '友情链接', '', 28, 'admin', 'link', 'index', 1, '2019-04-11 08:42:32', '2019-04-11 08:42:32');
INSERT INTO `PREFIX_permissions` VALUES (59, '友情链接列表', '', 58, 'admin', 'link', 'getList', 2, '2019-04-11 08:43:13', '2019-04-11 08:43:13');
INSERT INTO `PREFIX_permissions` VALUES (60, '创建友情链接', '', 58, 'admin', 'link', 'create', 2, '2019-04-11 08:44:12', '2019-04-11 08:44:12');
INSERT INTO `PREFIX_permissions` VALUES (61, '编辑友情链接', '', 58, 'admin', 'link', 'edit', 2, '2019-04-11 08:44:57', '2019-04-11 08:44:57');
INSERT INTO `PREFIX_permissions` VALUES (62, '删除友情链接', '', 58, 'admin', 'link', 'delete', 2, '2019-04-11 08:45:45', '2019-04-11 08:45:45');
INSERT INTO `PREFIX_permissions` VALUES (68, '留言管理', '', 25, 'admin', 'content', 'diyForm', 2, '2019-07-03 01:09:44', '2019-07-03 01:09:44');
INSERT INTO `PREFIX_permissions` VALUES (69, '获取留言列表', '', 25, 'admin', 'content', 'getDiyList', 2, '2019-07-03 01:50:14', '2019-07-03 01:50:14');
INSERT INTO `PREFIX_permissions` VALUES (70, '删除留言', '', 25, 'admin', 'content', 'delDiyForm', 2, '2019-07-03 02:26:51', '2019-07-03 02:26:51');
INSERT INTO `PREFIX_permissions` VALUES (71, '文件上传', '', 28, 'admin', 'upload', 'file', 2, '2019-07-11 01:15:18', '2019-07-11 01:15:18');
INSERT INTO `PREFIX_permissions` VALUES (72, '编辑留言', '', 25, 'admin', 'content', 'editDiyform', 2, '2019-07-09 08:34:23', '2019-07-09 08:34:23');
INSERT INTO `PREFIX_permissions` VALUES (73, '模板设置', '', 28, 'admin', 'templete', 'index', 1, '2019-07-11 00:56:32', '2019-07-11 00:56:32');
INSERT INTO `PREFIX_permissions` VALUES (74, '模板列表', '', 73, 'admin', 'templete', 'getList', 2, '2019-07-11 00:57:53', '2019-07-11 00:57:53');
INSERT INTO `PREFIX_permissions` VALUES (75, '创建模板', '', 73, 'admin', 'templete', 'create', 2, '2019-07-11 00:59:09', '2019-07-11 00:59:09');
INSERT INTO `PREFIX_permissions` VALUES (76, '编辑模板', '', 73, 'admin', 'templete', 'edit', 2, '2019-07-11 00:59:45', '2019-07-11 00:59:45');
INSERT INTO `PREFIX_permissions` VALUES (77, '删除模板', '', 73, 'admin', 'templete', 'delete', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (78, '清除缓存', '', 28, 'admin', 'system', 'clearCache', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (79, '清除日志文件', '', 28, 'admin', 'system', 'clearLog', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (80, '类型管理', '', 23, 'admin', 'type', 'index', 1, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (81, '类型列表', '', 80, 'admin', 'type', 'getList', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (82, '创建类型', '', 80, 'admin', 'type', 'create', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (83, '编辑类型', '', 80, 'admin', 'type', 'edit', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (84, '删除类型', '', 80, 'admin', 'type', 'delete', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (85, '属性管理', '', 23, 'admin', 'attribute', 'index', 1, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (86, '属性列表', '', 85, 'admin', 'attribute', 'getList', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (87, '创建属性', '', 85, 'admin', 'attribute', 'create', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (88, '编辑属性', '', 85, 'admin', 'attribute', 'edit', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (89, '删除属性', '', 85, 'admin', 'attribute', 'delete', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (90, '数据库管理', '', 1, 'admin', 'database', 'index', 1, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (91, '备份数据库', '', 90, 'admin', 'database', 'backup', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (92, '数据库文件列表', '', 90, 'admin', 'database', 'databaseList', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (93, '数据表文件列表', '', 90, 'admin', 'database', 'tableList', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (94, '删除备份文件', '', 90, 'admin', 'database', 'delete', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (95, '还原数据库', '', 90, 'admin', 'database', 'import', 2, '2019-07-11 01:00:53', '2019-07-11 01:00:53');
INSERT INTO `PREFIX_permissions` VALUES (96, '模板位置管理', '', 73, 'admin', 'position', 'index', 2, '2019-09-05 09:43:15', '2019-09-05 09:49:49');
INSERT INTO `PREFIX_permissions` VALUES (97, '创建模板位置', '', 73, 'admin', 'position', 'create', 2, '2019-09-05 09:44:23', '2019-09-05 09:44:23');
INSERT INTO `PREFIX_permissions` VALUES (98, '编辑模板位置', '', 73, 'admin', 'position', 'edit', 2, '2019-09-05 09:45:05', '2019-09-05 09:45:05');
INSERT INTO `PREFIX_permissions` VALUES (99, '删除模板位置', '', 73, 'admin', 'position', 'delete', 2, '2019-09-05 09:46:32', '2019-09-05 09:46:32');
INSERT INTO `PREFIX_permissions` VALUES (100, '模板位置列表', '', 73, 'admin', 'position', 'getList', 2, '2019-09-05 09:47:26', '2019-09-05 09:49:59');
INSERT INTO `PREFIX_permissions` VALUES (101, '批量操作', '', 25, 'admin', 'content', 'batch', 2, '2019-10-12 09:20:01', '2019-10-12 09:20:01');
INSERT INTO `PREFIX_permissions` VALUES (102, '复制站点', '', 52, 'admin', 'site', 'copy', 2, '2019-10-25 01:51:08', '2019-10-25 01:51:08');
INSERT INTO `PREFIX_permissions` VALUES (103, '导出数据', '', 25, 'admin', 'content', 'export', 2, '2019-12-04 10:31:57', '2019-12-04 10:31:57');
INSERT INTO `PREFIX_permissions` VALUES (104, '价格管理', '', 23, 'admin', 'price', 'index', 2, '2019-12-05 09:11:46', '2019-12-26 04:13:36');
INSERT INTO `PREFIX_permissions` VALUES (105, '产品列表', '', 104, 'admin', 'price', 'getList', 2, '2019-12-05 10:28:18', '2019-12-05 10:28:18');
INSERT INTO `PREFIX_permissions` VALUES (106, '导入价格', '', 104, 'admin', 'price', 'import', 2, '2019-12-05 10:58:13', '2019-12-05 10:58:13');
INSERT INTO `PREFIX_permissions` VALUES (107, '分片上传', '', 28, 'admin', 'upload', 'uploadFile', 2, '2019-12-23 05:59:36', '2019-12-23 05:59:36');
INSERT INTO `PREFIX_permissions` VALUES (108, '生成首页', '', 109, 'admin', 'buildhtml', 'makeIndex', 1, '2019-12-31 05:09:50', '2020-01-02 03:36:10');
INSERT INTO `PREFIX_permissions` VALUES (109, '生成静态文件', '', 28, 'admin', 'buildhtml', 'index', 1, '2020-01-02 03:35:41', '2020-01-02 03:35:41');
INSERT INTO `PREFIX_permissions` VALUES (110, '生成栏目列表', '', 109, 'admin', 'buildhtml', 'makeList', 1, '2020-01-02 03:36:58', '2020-01-02 03:36:58');
INSERT INTO `PREFIX_permissions` VALUES (111, '生成详情页', '', 109, 'admin', 'buildhtml', 'makeDetail', 1, '2020-01-02 03:38:20', '2020-01-02 03:38:20');
INSERT INTO `PREFIX_permissions` VALUES (112, '生成栏目页面', '', 109, 'admin', 'buildhtml', 'buildList', 2, '2020-02-12 10:03:45', '2020-02-12 10:03:45');
INSERT INTO `PREFIX_permissions` VALUES (113, '生成详情页面', '', 109, 'admin', 'buildhtml', 'builddetail', 2, '2020-02-12 04:18:55', '2020-02-12 04:18:55');
INSERT INTO `PREFIX_permissions` VALUES (114, '获取相关内容列表', '', 25, 'admin', 'content', 'getListById', 2, '2020-02-10 11:06:06', '2020-02-10 11:06:06');
INSERT INTO `PREFIX_permissions` VALUES (115, 'getList1', '', 24, 'admin', 'permission', 'getLista', 2, '2020-03-10 06:04:24', '2020-03-12 10:26:36');
INSERT INTO `PREFIX_permissions` VALUES (123, '按栏目生成', '', 109, 'admin', 'buildhtml', 'makecategory', 2, '2020-03-27 09:48:48', '2020-03-27 09:48:48');
INSERT INTO `PREFIX_permissions` VALUES (124, '生成单独栏目', '', 109, 'admin', 'buildhtml', 'makeListt', 2, '2020-08-28 10:46:26', '2020-08-28 10:46:26');
INSERT INTO `PREFIX_permissions` VALUES (125, '网址导航管理', '', 23, 'admin', 'website', 'index', 1, '2021-06-09 08:28:36', '2024-12-08 08:48:07');
INSERT INTO `PREFIX_permissions` VALUES (126, '网站列表', '', 125, 'admin', 'website', 'getList', 2, '2021-06-09 08:29:03', '2021-06-09 08:29:03');
INSERT INTO `PREFIX_permissions` VALUES (127, '添加网站', '', 125, 'admin', 'website', 'create', 2, '2021-06-09 08:33:08', '2021-06-09 08:33:08');
INSERT INTO `PREFIX_permissions` VALUES (128, '编辑网站', '', 125, 'admin', 'website', 'edit', 2, '2021-06-09 08:33:25', '2021-06-09 08:33:25');
INSERT INTO `PREFIX_permissions` VALUES (129, '删除网站', '', 125, 'admin', 'website', 'delete', 2, '2021-06-09 08:33:43', '2021-06-09 08:33:43');
INSERT INTO `PREFIX_permissions` VALUES (130, '一键升级', '', 28, 'admin', 'upgrade', 'index', 1, '2021-06-17 10:29:14', '2021-06-17 10:29:14');
INSERT INTO `PREFIX_permissions` VALUES (132, '文章管理', '', 23, 'admin', 'article', 'list', 1, '2024-08-20 11:25:09', '2024-08-22 04:18:37');
INSERT INTO `PREFIX_permissions` VALUES (133, '文章添加', '', 132, 'admin', 'article', 'add', 2, '2024-08-21 01:08:58', '2024-08-23 03:48:57');
INSERT INTO `PREFIX_permissions` VALUES (134, '文章分类管理', '', 23, 'admin', 'articleCate', 'index', 1, '2024-08-21 03:46:25', '2024-08-22 04:15:21');
INSERT INTO `PREFIX_permissions` VALUES (136, '创建文章分类', '', 134, 'admin', 'articleCate', 'create', 2, '2024-08-21 04:34:35', '2024-08-21 05:14:47');
INSERT INTO `PREFIX_permissions` VALUES (137, '删除文章分类', '', 134, 'admin', 'articleCate', 'delete', 2, '2024-08-21 04:35:20', '2024-08-21 04:35:20');
INSERT INTO `PREFIX_permissions` VALUES (138, '编辑文章分类', '', 134, 'admin', 'articleCate', 'edit', 2, '2024-08-21 04:35:44', '2024-08-21 04:35:44');
INSERT INTO `PREFIX_permissions` VALUES (139, '文章分类列表', '', 134, 'admin', 'articleCate', 'getList', 2, '2024-08-22 04:15:57', '2024-08-22 04:17:56');
INSERT INTO `PREFIX_permissions` VALUES (140, '文章创建', '', 132, 'admin', 'article', 'listform', 2, '2024-08-23 02:40:41', '2024-08-23 02:40:41');
INSERT INTO `PREFIX_permissions` VALUES (141, '文章编辑', '', 132, 'admin', 'article', 'edit', 2, '2024-08-23 07:05:56', '2024-08-23 07:05:56');
INSERT INTO `PREFIX_permissions` VALUES (142, '文章删除', '', 132, 'admin', 'article', 'del', 2, '2024-08-23 07:06:14', '2024-08-23 07:06:14');
INSERT INTO `PREFIX_permissions` VALUES (143, '其他上传接口', '', 0, 'admin', 'upload', 'urlUploadFile', 2, '2024-08-25 08:36:00', '2024-08-25 08:36:00');
INSERT INTO `PREFIX_permissions` VALUES (144, '资源管理', '', 23, 'admin', 'download', 'list', 1, '2024-08-28 09:31:21', '2024-08-28 06:30:28');
INSERT INTO `PREFIX_permissions` VALUES (146, '资源添加', '', 144, 'admin', 'download', 'add', 2, '2024-08-28 06:28:21', '2024-08-28 06:28:21');
INSERT INTO `PREFIX_permissions` VALUES (147, '资源编辑', '', 144, 'admin', 'download', 'edit', 2, '2024-08-28 06:28:41', '2024-08-28 06:28:41');
INSERT INTO `PREFIX_permissions` VALUES (148, '资源删除', '', 144, 'admin', 'download', 'del', 2, '2024-08-28 06:29:05', '2024-08-28 06:29:05');
INSERT INTO `PREFIX_permissions` VALUES (149, '资源分类管理', '', 23, 'admin', 'download', 'cateIndex', 1, '2024-08-28 06:29:46', '2024-08-28 06:40:12');
INSERT INTO `PREFIX_permissions` VALUES (150, '资源分类添加', '', 149, 'admin', 'download', 'cateCreate', 2, '2024-08-28 06:31:00', '2024-08-28 06:31:16');
INSERT INTO `PREFIX_permissions` VALUES (151, '资源分类编辑', '', 149, 'admin', 'download', 'cateEdit', 2, '2024-08-28 06:31:53', '2024-08-28 06:31:53');
INSERT INTO `PREFIX_permissions` VALUES (152, '资源分类删除', '', 149, 'admin', 'download', 'cateDelete', 2, '2024-08-28 06:32:12', '2024-08-28 07:03:00');
INSERT INTO `PREFIX_permissions` VALUES (153, '资源分类列表获取接口', '', 149, 'admin', 'download', 'cateGetList', 2, '2024-08-28 06:38:32', '2024-08-28 06:38:32');
INSERT INTO `PREFIX_permissions` VALUES (154, 'Banner管理', '', 23, 'admin', 'banner', 'index', 1, '2024-09-29 01:52:05', '2024-09-29 01:55:04');
INSERT INTO `PREFIX_permissions` VALUES (155, 'banner创建', '', 154, 'admin', 'banner', 'create', 2, '2024-09-29 01:54:34', '2024-09-29 01:55:13');
INSERT INTO `PREFIX_permissions` VALUES (156, 'banner删除', '', 154, 'admin', 'banner', 'delete', 2, '2024-09-29 01:55:55', '2024-09-29 01:55:55');
INSERT INTO `PREFIX_permissions` VALUES (157, 'banner编辑', '', 154, 'admin', 'banner', 'edit', 2, '2024-09-29 01:56:40', '2024-09-29 01:56:40');
INSERT INTO `PREFIX_permissions` VALUES (158, 'banner列表', '', 154, 'admin', 'banner', 'getList', 2, '2024-09-29 01:58:19', '2024-09-29 01:58:19');
INSERT INTO `PREFIX_permissions` VALUES (159, '用户管理', 'layui-icon-username', 0, 'admin', 'Account', 'index', 1, '2024-10-06 08:44:49', '2024-10-09 12:23:27');
INSERT INTO `PREFIX_permissions` VALUES (160, '注册用户', '', 159, 'admiin', 'account', 'index', 1, '2024-10-06 08:51:39', '2024-10-09 06:08:56');
INSERT INTO `PREFIX_permissions` VALUES (161, '用户等级', '', 159, 'admin', 'accountLevel', 'index', 1, '2024-10-06 08:53:37', '2024-10-09 06:09:58');
INSERT INTO `PREFIX_permissions` VALUES (162, '创建注册用户', '', 160, 'admin', 'account', 'create', 2, '2024-10-09 01:01:49', '2024-10-09 06:09:05');
INSERT INTO `PREFIX_permissions` VALUES (163, '编辑注册用户', '', 160, 'admin', 'account', 'edit', 2, '2024-10-09 01:02:35', '2024-10-09 06:09:26');
INSERT INTO `PREFIX_permissions` VALUES (164, '删除注册用户', '', 160, 'admin', 'account', 'delete', 2, '2024-10-09 01:03:39', '2024-10-09 06:09:30');
INSERT INTO `PREFIX_permissions` VALUES (165, '注册用户列表', '', 160, 'admin', 'account', 'getList', 2, '2024-10-09 01:53:10', '2024-10-09 06:09:35');
INSERT INTO `PREFIX_permissions` VALUES (166, '短信配置', '', 159, 'admin', 'setting', 'smsSetting', 1, '2024-10-09 09:35:12', '2024-12-07 08:03:38');
INSERT INTO `PREFIX_permissions` VALUES (167, '评论管理', 'layui-icon-reply-fill', 0, 'admin', 'Comments', 'aa', 1, '2024-10-17 12:17:19', '2024-10-22 08:22:22');
INSERT INTO `PREFIX_permissions` VALUES (168, '待审评论', '', 167, 'admin', 'comments', 'auditList', 1, '2024-10-17 12:18:55', '2024-10-22 08:26:01');
INSERT INTO `PREFIX_permissions` VALUES (169, '评论列表', '', 167, 'admin', 'comments', 'list', 1, '2024-10-17 12:19:39', '2024-10-22 09:20:00');
INSERT INTO `PREFIX_permissions` VALUES (170, '关键词过滤', '', 167, 'admin', 'comments', 'keywords', 1, '2024-10-17 12:22:40', '2024-10-28 08:24:45');
INSERT INTO `PREFIX_permissions` VALUES (171, '请求列表接口', '', 168, 'admin', 'comments', 'getAuditList', 2, '2024-10-23 04:51:12', '2024-10-23 04:51:12');
INSERT INTO `PREFIX_permissions` VALUES (172, '编辑页面', '', 168, 'admin', 'comments', 'auditListEdit', 2, '2024-10-23 06:57:22', '2024-10-23 06:57:30');
INSERT INTO `PREFIX_permissions` VALUES (173, '评论列表接口', '', 168, 'admin', 'comments', 'getList', 2, '2024-10-27 09:34:02', '2024-10-27 09:34:02');
INSERT INTO `PREFIX_permissions` VALUES (174, '网站设置', '', 28, 'admin', 'Setting', 'websiteSettings', 1, '2024-10-29 05:16:18', '2024-10-29 05:16:37');
INSERT INTO `PREFIX_permissions` VALUES (175, '导航栏配置', '', 28, 'admin', 'navConfig', 'index', 1, '2024-10-30 05:20:02', '2024-10-30 05:20:02');
INSERT INTO `PREFIX_permissions` VALUES (176, '导航配置列表', '', 175, 'admin', 'navConfig', 'getList', 2, '2024-10-30 06:10:35', '2024-10-30 06:10:35');
INSERT INTO `PREFIX_permissions` VALUES (177, '导航栏配置创建', '', 175, 'admin', 'navConfig', 'create', 2, '2024-10-30 07:07:09', '2024-10-30 07:07:09');
INSERT INTO `PREFIX_permissions` VALUES (178, '导航栏配置编辑', '', 175, 'admin', 'navConfig', 'edit', 2, '2024-10-30 07:07:30', '2024-10-30 07:07:30');
INSERT INTO `PREFIX_permissions` VALUES (179, '导航栏配置删除', '', 175, 'admin', 'navConfig', 'delete', 2, '2024-10-30 07:08:12', '2024-10-30 07:08:12');
INSERT INTO `PREFIX_permissions` VALUES (180, '主题管理', '', 185, 'admin', 'theme', 'index', 1, '2024-11-17 10:13:30', '2024-11-17 07:52:00');
INSERT INTO `PREFIX_permissions` VALUES (181, '主题列表', '', 180, 'admin', 'theme', 'getList', 2, '2024-11-17 10:13:51', '2024-11-17 10:13:51');
INSERT INTO `PREFIX_permissions` VALUES (182, '添加主题', '', 180, 'admin', 'theme', 'create', 2, '2024-11-17 10:14:12', '2024-11-17 10:14:12');
INSERT INTO `PREFIX_permissions` VALUES (183, '编辑主题', '', 180, 'admin', 'theme', 'edit', 2, '2024-11-17 10:14:28', '2024-11-17 10:14:28');
INSERT INTO `PREFIX_permissions` VALUES (184, '删除主题', '', 180, 'admin', 'theme', 'delete', 2, '2024-11-17 10:14:47', '2024-11-17 10:14:47');
INSERT INTO `PREFIX_permissions` VALUES (185, '外观', 'layui-icon-template-1', 0, 'admin', 'theme', 'index', 1, '2024-11-17 07:51:47', '2024-11-17 07:52:07');
INSERT INTO `PREFIX_permissions` VALUES (186, '主题包上传', '', 143, 'admin', 'upload', 'filezip', 2, '2024-11-18 02:55:45', '2024-11-18 02:55:45');
INSERT INTO `PREFIX_permissions` VALUES (187, '等级列表接口', '', 161, 'admin', 'accountLevel', 'getList', 2, '2024-11-19 11:27:21', '2024-11-19 11:27:21');
INSERT INTO `PREFIX_permissions` VALUES (188, '订单列表', '', 190, 'admin', 'order', 'list', 1, '2024-11-25 03:20:12', '2024-11-25 02:48:42');
INSERT INTO `PREFIX_permissions` VALUES (189, '订单列表接口', '', 188, 'admin', 'order', 'getList', 2, '2024-11-25 03:21:09', '2024-11-25 03:21:09');
INSERT INTO `PREFIX_permissions` VALUES (190, '财务管理', 'layui-icon-rmb', 0, 'order', 'index', 'aa', 1, '2024-11-25 02:48:19', '2024-11-25 02:48:19');
INSERT INTO `PREFIX_permissions` VALUES (191, '支付配置', '', 190, 'admin', 'setting', 'paySetting', 1, '2024-11-25 02:49:56', '2024-11-26 07:06:14');
INSERT INTO `PREFIX_permissions` VALUES (192, '等级套餐编辑', '', 161, 'admin', 'accountLevel', 'edit', 2, '2024-11-26 06:06:29', '2024-11-26 06:06:29');
INSERT INTO `PREFIX_permissions` VALUES (193, '支付配置列表接口', '', 191, 'admin', 'setting', 'paySettingList', 2, '2024-11-26 07:26:23', '2024-11-26 07:26:23');
INSERT INTO `PREFIX_permissions` VALUES (194, '支付配置编辑', '', 191, 'admin', 'setting', 'paySettingEdit', 2, '2024-11-26 07:27:37', '2024-11-26 07:27:37');
INSERT INTO `PREFIX_permissions` VALUES (195, '自定义页面', '', 23, 'admin', 'customPage', 'list', 1, '2024-11-27 08:11:02', '2024-12-02 01:43:53');
INSERT INTO `PREFIX_permissions` VALUES (196, '自定义页面添加', '', 195, 'admin', 'customPage', 'add', 2, '2024-12-02 01:44:17', '2024-12-02 01:44:17');
INSERT INTO `PREFIX_permissions` VALUES (197, '自定义创建', '', 195, 'admin', 'customPage', 'listform', 2, '2024-12-02 02:06:18', '2024-12-02 02:07:25');
INSERT INTO `PREFIX_permissions` VALUES (198, '自定义编辑', '', 195, 'admin', 'customPage', 'edit', 2, '2024-12-02 02:06:45', '2024-12-02 02:06:45');
INSERT INTO `PREFIX_permissions` VALUES (199, '自定义删除', '', 195, 'admin', 'customPage', 'del', 2, '2024-12-02 02:07:12', '2024-12-02 02:07:12');
INSERT INTO `PREFIX_permissions` VALUES (200, '短信配置列表', '', 166, 'admin', 'setting', 'smsSettingList', 2, '2024-12-07 08:10:54', '2024-12-07 08:16:55');
INSERT INTO `PREFIX_permissions` VALUES (201, '短信配置编辑', '', 166, 'admin', 'setting', 'smsSettingEdit', 2, '2024-12-07 08:11:36', '2024-12-07 08:15:36');

-- ----------------------------
-- Table structure for PREFIX_prices
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_prices`;
CREATE TABLE `PREFIX_prices`  (
  `content_id` int(11) NOT NULL DEFAULT 0,
  `price` decimal(10, 2) NULL DEFAULT 0.00,
  `created_at` date NOT NULL DEFAULT '2019-12-01',
  `year` smallint(4) NOT NULL DEFAULT 2019,
  `month` tinyint(2) NOT NULL DEFAULT 12,
  `day` tinyint(2) NULL DEFAULT 1,
  PRIMARY KEY (`content_id`, `created_at`) USING BTREE
) ENGINE = MyISAM CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = FIXED;

-- ----------------------------
-- Records of PREFIX_prices
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_role_has_categories
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_role_has_categories`;
CREATE TABLE `PREFIX_role_has_categories`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `site_id` int(11) UNSIGNED NOT NULL DEFAULT 1,
  `role_id` int(11) NOT NULL COMMENT '角色ID',
  `category_id` int(11) NOT NULL COMMENT '栏目ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 269 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '角色拥有的栏目权限' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_role_has_categories
-- ----------------------------
INSERT INTO `PREFIX_role_has_categories` VALUES (147, 1, 2, 2);
INSERT INTO `PREFIX_role_has_categories` VALUES (148, 1, 2, 3);
INSERT INTO `PREFIX_role_has_categories` VALUES (149, 1, 2, 4);
INSERT INTO `PREFIX_role_has_categories` VALUES (150, 1, 2, 43);
INSERT INTO `PREFIX_role_has_categories` VALUES (151, 1, 2, 44);
INSERT INTO `PREFIX_role_has_categories` VALUES (152, 1, 2, 45);
INSERT INTO `PREFIX_role_has_categories` VALUES (153, 1, 2, 46);
INSERT INTO `PREFIX_role_has_categories` VALUES (154, 1, 2, 47);
INSERT INTO `PREFIX_role_has_categories` VALUES (155, 1, 2, 48);
INSERT INTO `PREFIX_role_has_categories` VALUES (156, 1, 2, 54);
INSERT INTO `PREFIX_role_has_categories` VALUES (157, 1, 2, 5);
INSERT INTO `PREFIX_role_has_categories` VALUES (158, 1, 2, 8);
INSERT INTO `PREFIX_role_has_categories` VALUES (159, 1, 2, 9);
INSERT INTO `PREFIX_role_has_categories` VALUES (160, 1, 2, 25);
INSERT INTO `PREFIX_role_has_categories` VALUES (161, 1, 2, 26);
INSERT INTO `PREFIX_role_has_categories` VALUES (162, 1, 2, 27);
INSERT INTO `PREFIX_role_has_categories` VALUES (163, 1, 2, 28);
INSERT INTO `PREFIX_role_has_categories` VALUES (164, 1, 2, 13);
INSERT INTO `PREFIX_role_has_categories` VALUES (165, 1, 2, 14);
INSERT INTO `PREFIX_role_has_categories` VALUES (166, 1, 2, 15);
INSERT INTO `PREFIX_role_has_categories` VALUES (167, 1, 2, 16);
INSERT INTO `PREFIX_role_has_categories` VALUES (168, 1, 2, 17);
INSERT INTO `PREFIX_role_has_categories` VALUES (169, 1, 2, 18);
INSERT INTO `PREFIX_role_has_categories` VALUES (170, 1, 2, 19);
INSERT INTO `PREFIX_role_has_categories` VALUES (171, 1, 2, 20);
INSERT INTO `PREFIX_role_has_categories` VALUES (172, 1, 2, 21);
INSERT INTO `PREFIX_role_has_categories` VALUES (173, 1, 2, 22);
INSERT INTO `PREFIX_role_has_categories` VALUES (174, 1, 2, 23);
INSERT INTO `PREFIX_role_has_categories` VALUES (175, 1, 2, 29);
INSERT INTO `PREFIX_role_has_categories` VALUES (176, 1, 2, 30);
INSERT INTO `PREFIX_role_has_categories` VALUES (177, 1, 2, 31);
INSERT INTO `PREFIX_role_has_categories` VALUES (178, 1, 2, 32);
INSERT INTO `PREFIX_role_has_categories` VALUES (179, 1, 2, 33);
INSERT INTO `PREFIX_role_has_categories` VALUES (180, 1, 2, 34);
INSERT INTO `PREFIX_role_has_categories` VALUES (181, 1, 2, 35);
INSERT INTO `PREFIX_role_has_categories` VALUES (182, 1, 2, 36);
INSERT INTO `PREFIX_role_has_categories` VALUES (183, 1, 2, 37);
INSERT INTO `PREFIX_role_has_categories` VALUES (184, 1, 2, 38);
INSERT INTO `PREFIX_role_has_categories` VALUES (185, 1, 2, 39);
INSERT INTO `PREFIX_role_has_categories` VALUES (186, 1, 2, 40);
INSERT INTO `PREFIX_role_has_categories` VALUES (187, 1, 2, 41);
INSERT INTO `PREFIX_role_has_categories` VALUES (188, 1, 2, 42);
INSERT INTO `PREFIX_role_has_categories` VALUES (189, 1, 2, 55);
INSERT INTO `PREFIX_role_has_categories` VALUES (190, 1, 2, 58);
INSERT INTO `PREFIX_role_has_categories` VALUES (191, 1, 2, 59);
INSERT INTO `PREFIX_role_has_categories` VALUES (192, 1, 2, 57);
INSERT INTO `PREFIX_role_has_categories` VALUES (193, 1, 2, 56);
INSERT INTO `PREFIX_role_has_categories` VALUES (194, 1, 2, 0);
INSERT INTO `PREFIX_role_has_categories` VALUES (235, 1, 1, 2);
INSERT INTO `PREFIX_role_has_categories` VALUES (236, 1, 1, 9);
INSERT INTO `PREFIX_role_has_categories` VALUES (237, 1, 1, 10);
INSERT INTO `PREFIX_role_has_categories` VALUES (238, 1, 1, 11);
INSERT INTO `PREFIX_role_has_categories` VALUES (239, 1, 1, 3);
INSERT INTO `PREFIX_role_has_categories` VALUES (240, 1, 1, 12);
INSERT INTO `PREFIX_role_has_categories` VALUES (241, 1, 1, 13);
INSERT INTO `PREFIX_role_has_categories` VALUES (242, 1, 1, 14);
INSERT INTO `PREFIX_role_has_categories` VALUES (243, 1, 1, 15);
INSERT INTO `PREFIX_role_has_categories` VALUES (244, 1, 1, 30);
INSERT INTO `PREFIX_role_has_categories` VALUES (245, 1, 1, 31);
INSERT INTO `PREFIX_role_has_categories` VALUES (246, 1, 1, 4);
INSERT INTO `PREFIX_role_has_categories` VALUES (247, 1, 1, 16);
INSERT INTO `PREFIX_role_has_categories` VALUES (248, 1, 1, 17);
INSERT INTO `PREFIX_role_has_categories` VALUES (249, 1, 1, 18);
INSERT INTO `PREFIX_role_has_categories` VALUES (250, 1, 1, 19);
INSERT INTO `PREFIX_role_has_categories` VALUES (251, 1, 1, 20);
INSERT INTO `PREFIX_role_has_categories` VALUES (252, 1, 1, 5);
INSERT INTO `PREFIX_role_has_categories` VALUES (253, 1, 1, 21);
INSERT INTO `PREFIX_role_has_categories` VALUES (254, 1, 1, 22);
INSERT INTO `PREFIX_role_has_categories` VALUES (255, 1, 1, 23);
INSERT INTO `PREFIX_role_has_categories` VALUES (256, 1, 1, 24);
INSERT INTO `PREFIX_role_has_categories` VALUES (257, 1, 1, 25);
INSERT INTO `PREFIX_role_has_categories` VALUES (258, 1, 1, 26);
INSERT INTO `PREFIX_role_has_categories` VALUES (259, 1, 1, 27);
INSERT INTO `PREFIX_role_has_categories` VALUES (260, 1, 1, 28);
INSERT INTO `PREFIX_role_has_categories` VALUES (261, 1, 1, 29);
INSERT INTO `PREFIX_role_has_categories` VALUES (262, 1, 1, 6);
INSERT INTO `PREFIX_role_has_categories` VALUES (263, 1, 1, 7);
INSERT INTO `PREFIX_role_has_categories` VALUES (264, 1, 1, 8);
INSERT INTO `PREFIX_role_has_categories` VALUES (265, 1, 1, 32);
INSERT INTO `PREFIX_role_has_categories` VALUES (266, 1, 1, 33);
INSERT INTO `PREFIX_role_has_categories` VALUES (267, 1, 1, 34);
INSERT INTO `PREFIX_role_has_categories` VALUES (268, 1, 1, 0);

-- ----------------------------
-- Table structure for PREFIX_role_has_permissions
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_role_has_permissions`;
CREATE TABLE `PREFIX_role_has_permissions`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `role_id` int(11) NOT NULL COMMENT '角色ID',
  `permission_id` int(11) NOT NULL COMMENT '权限ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 9488 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_role_has_permissions
-- ----------------------------
INSERT INTO `PREFIX_role_has_permissions` VALUES (5643, 2, 1);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5644, 2, 90);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5645, 2, 91);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5646, 2, 92);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5647, 2, 93);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5648, 2, 94);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5649, 2, 95);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5650, 2, 23);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5651, 2, 24);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5652, 2, 26);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5653, 2, 27);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5654, 2, 30);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5655, 2, 31);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5656, 2, 115);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5657, 2, 132);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5658, 2, 133);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5659, 2, 28);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5660, 2, 29);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5661, 2, 46);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5662, 2, 52);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5663, 2, 53);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5664, 2, 55);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5665, 2, 71);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5666, 2, 78);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5667, 2, 79);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5668, 2, 159);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5669, 2, 160);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5670, 2, 162);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5671, 2, 163);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5672, 2, 164);
INSERT INTO `PREFIX_role_has_permissions` VALUES (5673, 2, 0);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9342, 1, 1);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9343, 1, 2);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9344, 1, 5);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9345, 1, 6);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9346, 1, 7);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9347, 1, 13);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9348, 1, 18);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9349, 1, 57);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9350, 1, 3);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9351, 1, 8);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9352, 1, 9);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9353, 1, 10);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9354, 1, 11);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9355, 1, 12);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9356, 1, 19);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9357, 1, 50);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9358, 1, 51);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9359, 1, 4);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9360, 1, 14);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9361, 1, 15);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9362, 1, 16);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9363, 1, 20);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9364, 1, 17);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9365, 1, 22);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9366, 1, 32);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9367, 1, 33);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9368, 1, 34);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9369, 1, 35);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9370, 1, 36);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9371, 1, 37);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9372, 1, 38);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9373, 1, 39);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9374, 1, 40);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9375, 1, 41);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9376, 1, 42);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9377, 1, 90);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9378, 1, 91);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9379, 1, 92);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9380, 1, 93);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9381, 1, 94);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9382, 1, 95);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9383, 1, 23);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9384, 1, 24);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9385, 1, 26);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9386, 1, 27);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9387, 1, 30);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9388, 1, 31);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9389, 1, 115);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9390, 1, 25);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9391, 1, 43);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9392, 1, 44);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9393, 1, 45);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9394, 1, 47);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9395, 1, 48);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9396, 1, 49);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9397, 1, 68);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9398, 1, 69);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9399, 1, 70);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9400, 1, 72);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9401, 1, 101);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9402, 1, 103);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9403, 1, 114);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9404, 1, 104);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9405, 1, 105);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9406, 1, 106);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9407, 1, 125);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9408, 1, 126);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9409, 1, 127);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9410, 1, 128);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9411, 1, 129);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9412, 1, 132);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9413, 1, 133);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9414, 1, 140);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9415, 1, 141);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9416, 1, 142);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9417, 1, 134);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9418, 1, 136);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9419, 1, 137);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9420, 1, 138);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9421, 1, 139);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9422, 1, 144);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9423, 1, 146);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9424, 1, 147);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9425, 1, 148);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9426, 1, 149);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9427, 1, 150);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9428, 1, 151);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9429, 1, 152);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9430, 1, 153);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9431, 1, 154);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9432, 1, 155);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9433, 1, 156);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9434, 1, 157);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9435, 1, 158);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9436, 1, 195);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9437, 1, 196);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9438, 1, 197);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9439, 1, 198);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9440, 1, 199);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9441, 1, 28);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9442, 1, 29);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9443, 1, 71);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9444, 1, 78);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9445, 1, 79);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9446, 1, 107);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9447, 1, 130);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9448, 1, 174);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9449, 1, 175);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9450, 1, 176);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9451, 1, 177);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9452, 1, 178);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9453, 1, 179);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9454, 1, 143);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9455, 1, 186);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9456, 1, 159);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9457, 1, 160);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9458, 1, 162);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9459, 1, 163);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9460, 1, 164);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9461, 1, 165);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9462, 1, 161);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9463, 1, 187);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9464, 1, 192);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9465, 1, 166);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9466, 1, 200);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9467, 1, 201);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9468, 1, 167);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9469, 1, 168);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9470, 1, 171);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9471, 1, 172);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9472, 1, 173);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9473, 1, 169);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9474, 1, 170);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9475, 1, 185);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9476, 1, 180);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9477, 1, 181);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9478, 1, 182);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9479, 1, 183);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9480, 1, 184);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9481, 1, 190);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9482, 1, 188);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9483, 1, 189);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9484, 1, 191);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9485, 1, 193);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9486, 1, 194);
INSERT INTO `PREFIX_role_has_permissions` VALUES (9487, 1, 0);

-- ----------------------------
-- Table structure for PREFIX_roles
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_roles`;
CREATE TABLE `PREFIX_roles`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '角色名称',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `name`(`name`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = COMPACT;

-- ----------------------------
-- Records of PREFIX_roles
-- ----------------------------
INSERT INTO `PREFIX_roles` VALUES (1, '超级管理员', '2019-03-07 16:04:41', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_roles` VALUES (2, '管理员', '2019-03-07 08:20:39', '2019-03-07 16:04:41');
INSERT INTO `PREFIX_roles` VALUES (3, '普通管理员', NULL, NULL);

-- ----------------------------
-- Table structure for PREFIX_setting
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_setting`;
CREATE TABLE `PREFIX_setting`  (
  `key` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `value` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL,
  `group` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `val_type` int(11) NULL DEFAULT NULL,
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `is_public` tinyint(2) NULL DEFAULT 1 COMMENT '1 是公共配置 0 不是'
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '网站灵活配置表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_setting
-- ----------------------------
INSERT INTO `PREFIX_setting` VALUES ('dxb_account', '888', 'sms', 1, '短信宝登录账号', 1);
INSERT INTO `PREFIX_setting` VALUES ('dxb_passwd', '888', 'sms', 1, '短信宝登录密码', 1);
INSERT INTO `PREFIX_setting` VALUES ('sms_api_type', 'dxb', 'sms', 1, '短信接口类型', 1);
INSERT INTO `PREFIX_setting` VALUES ('site_name', '鲸鱼博客CMS系统', 'website', 1, '网站标题', 1);
INSERT INTO `PREFIX_setting` VALUES ('comments_audit', '1', 'comments', 1, '是否自动审核', 0);
INSERT INTO `PREFIX_setting` VALUES ('comments_keywords', '爱女人,爱液,按摩棒,拔出来,爆草,包二奶,暴干,暴奸,暴乳,爆乳,暴淫,屄,被操,被插,被干,逼奸,仓井空,插暴,操逼,操黑,操烂,肏你,肏死,操死,操我,厕奴,插比,插b,插逼,插进,插你,插我,插阴,潮吹,潮喷,成人dv,成人电影,成人论坛,成人小说,成人电,成人电影,成人卡通,成人聊,成人片,成人视,成人图,成人文,成人小,成人电影,成人论坛,成人色情,成人网站,成人文学,成人小说,艳情小说,成人游戏,吃精,赤裸,抽插,扌由插,抽一插,春药,大波,大力抽送,大乳,荡妇,荡女,盗撮,多人轮,发浪,放尿,肥逼,粉穴,封面女郎,风月大陆,干死你,干穴,肛交,肛门,龟头,裹本,国产av,好嫩,豪乳,黑逼,后庭,后穴,虎骑,花花公子,换妻俱乐部,黄片,几吧,鸡吧,鸡巴,鸡奸,寂寞男,寂寞女,妓女,激情,集体淫,奸情,叫床,脚交,金鳞岂是池中物,金麟岂是池中物,精液,就去日,巨屌,菊花洞,菊门,巨奶,巨乳,菊穴,开苞,口爆,口活,口交,口射,口淫,裤袜,狂操,狂插,浪逼,浪妇,浪叫,浪女,狼友,聊性,流淫,铃木麻,凌辱,漏乳,露b,乱交,乱伦,轮暴,轮操,轮奸,裸陪,买春,美逼,美少妇,美乳,美腿,美穴,美幼,秘唇,迷奸,密穴,蜜穴,蜜液,摸奶,摸胸,母奸,奈美,奶子,男奴,内射,嫩逼,嫩女,嫩穴,捏弄,女优,炮友,砲友,喷精,屁眼,品香堂,前凸后翘,强jian,强暴,强奸处女,情趣用品,情色,拳交,全裸,群交,惹火身材,人妻,人兽,日逼,日烂,肉棒,肉逼,肉唇,肉洞,肉缝,肉棍,肉茎,肉具,揉乳,肉穴,肉欲,乳爆,乳房,乳沟,乳交,乳头,三级片,骚逼,骚比,骚女,骚水,骚穴,色逼,色界,色猫,色盟,色情网站,色区,色色,色诱,色欲,色b,少年阿宾,少修正,射爽,射颜,食精,释欲,兽奸,兽交,手淫,兽欲,熟妇,熟母,熟女,爽片,爽死我了,双臀,死逼,丝袜,丝诱,松岛枫,酥痒,汤加丽,套弄,体奸,体位,舔脚,舔阴,调教,偷欢,偷拍,推油,脱内裤,文做,我就色,无码,舞女,无修正,吸精,夏川纯,相奸,小逼,校鸡,小穴,小xue,写真,性感妖娆,性感诱惑,性虎,性饥渴,性技巧,性交,性奴,性虐,性息,性欲,胸推,穴口,学生妹,穴图,亚情,颜射,阳具,杨思敏,要射了,夜勤病栋,一本道,一夜欢,一夜情,一ye情,阴部,淫虫,阴唇,淫荡,阴道,淫电影,阴阜,淫妇,淫河,阴核,阴户,淫贱,淫叫,淫教师,阴茎,阴精,淫浪,淫媚,淫糜,淫魔,淫母,淫女,淫虐,淫妻,淫情,淫色,淫声浪语,淫兽学园,淫书,淫术炼金士,淫水,淫娃,淫威,淫亵,淫样,淫液,淫照,阴b,应召,幼交,幼男,幼女,欲火,欲女,玉女心经,玉蒲团,玉乳,欲仙欲死,玉穴,援交,原味内衣,援助交际,张筱雨,招鸡,招妓,中年美妇,抓胸,自拍,自慰,作爱,18禁,99bb,a4u,a4y,adult,amateur,anal,a片,fuck,gay片,g点,g片,hardcore,h动画,h动漫,incest,porn,secom,sexinsex,sm女王,xiao77,xing伴侣,tokyohot,yin荡,贱人,装b,大sb,傻逼,傻b,煞逼,煞笔,刹笔,傻比,沙比,欠干,婊子养的,我日你,我操,我草,卧艹,卧槽,爆你菊,艹你,cao你,你他妈,真他妈,别他吗,草你吗,草你丫,操你妈,擦你妈,操你娘,操他妈,日你妈,干你妈,干你娘,娘西皮,狗操,狗草,狗杂种,狗日的,操你祖宗,操你全家,操你大爷,妈逼,你麻痹,麻痹的,妈了个逼,马勒,狗娘养,贱比,贱b,下贱,死全家,全家死光,全家不得好死,全家死绝,白痴,无耻,sb,杀b,你吗b,你妈的,婊子,贱货,人渣,混蛋,媚外,和弦,兼职,限量,铃声,性伴侣,男公关,火辣,精子,射精,诱奸,强奸,做爱,性爱,发生关系,按摩,快感,处男,猛男,少妇,屌,屁股,下体,a片,内裤,浑圆,咪咪,发情,刺激,白嫩,粉嫩,兽性,风骚,呻吟,sm,阉割,高潮,裸露,不穿,一丝不挂,脱光,干你,干死,我干,裙中性运动,乱奸,乱伦,乱伦类,乱伦小,伦理大,伦理电影,伦理毛,伦理片,裸聊,裸聊网,裸体写真,裸舞视,裸照,美女裸体,美女写真,美女上门,美艳少妇,妹按摩,妹上门,迷幻药,迷幻藥,迷昏口,迷昏药,迷昏藥,迷魂香,迷魂药,迷魂藥,迷奸粉,迷奸药,迷情粉,迷情水,迷情药,迷药,迷藥,谜奸药,骚妇,骚货,骚浪,骚女,骚嘴,色电影,色妹妹,色情表演,色情电影,色情服务,色情图片,色情小说,色情影片,色情表演,色情电影,色情服务,色情片,色视频,色小说,性伴侣,性服务,性福情,性感少,性伙伴,性交,性交视频,性交图片,性奴,性奴集中营,性虐,阴唇,阴道,阴蒂,阴户,阴间来电,阴茎,阴茎增大,阴茎助勃,阴毛,陰唇,陰道,陰戶,淫荡,淫荡美女,淫荡视频,淫荡照片,淫乱,淫靡,淫魔,淫魔舞,淫女,淫情女,淫肉,淫騷妹,淫兽,淫兽学,淫水,淫穴,morphine,摇头丸,迷药,乖乖粉,narcotic,麻醉药,精神药品,爱女人,爱液,按摩棒,拔出来,爆草,包二奶,暴干,暴奸,暴乳,爆乳,暴淫,屄,被操,被插,被干,逼奸,仓井空,插暴,操逼,操黑,操烂,肏你,肏死,操死,操我,厕奴,插比,插b,插逼,插进,插你,插我,插阴,潮吹,潮喷,成人电影,成人论坛,成人色情,成人网站,成人文学,成人小说,艳情小说,成人游戏,吃精,赤裸,抽插,扌由插,抽一插,春药,大波,大力抽送,大乳,荡妇,荡女,盗撮,多人轮,发浪,放尿,肥逼,粉穴,封面女郎,风月大陆,干死你,干穴,肛交,肛门,龟头,裹本,国产av,好嫩,豪乳,黑逼,后庭,后穴,虎骑,花花公子,换妻俱乐部,黄片,几吧,鸡吧,鸡巴,鸡奸,寂寞男,寂寞女,妓女,激情,集体淫,奸情,叫床,脚交,金鳞岂是池中物,金麟岂是池中物,精液,就去日,巨屌,菊花洞,菊门,巨奶,巨乳,菊穴,开苞,口爆,口活,口交,口射,口淫,裤袜,狂操,狂插,浪逼,浪妇,浪叫,浪女,狼友,聊性,流淫,铃木麻,凌辱,漏乳,露b,乱交,乱伦,轮暴,轮操,轮奸,裸陪,买春,美逼,美少妇,美乳,美腿,美穴,美幼,秘唇,迷奸,密穴,蜜穴,蜜液,摸奶,摸胸,母奸,奈美,奶子,男奴,内射,嫩逼,嫩女,嫩穴,捏弄,女优,炮友,砲友,喷精,屁眼,品香堂,前凸后翘,强jian,强暴,强奸处女,情趣用品,情色,拳交,全裸,群交,惹火身材,人妻,人兽,日逼,日烂,肉棒,肉逼,肉唇,肉洞,肉缝,肉棍,肉茎,肉具,揉乳,肉穴,肉欲,乳爆,乳房,乳沟,乳交,乳头,三级片,骚逼,骚比,骚女,骚水,骚穴,色逼,色界,色猫,色盟,色情网站,色区,色色,色诱,色欲,色b,少年阿宾,少修正,射爽,射颜,食精,释欲,兽奸,兽交,手淫,兽欲,熟妇,熟母,熟女,爽片,爽死我了,双臀,死逼,丝袜,丝诱,松岛枫,酥痒,汤加丽,套弄,体奸,体位,舔脚,舔阴,调教,偷欢,偷拍,推油,脱内裤,文做,我就色,无码,舞女,无修正,吸精,夏川纯,相奸,小逼,校鸡,小穴,小xue,写真,性感妖娆,性感诱惑,性虎,性饥渴,性技巧,性交,性奴,性虐,性息,性欲,胸推,穴口,学生妹,穴图,亚情,颜射,阳具,杨思敏,要射了,夜勤病栋,一本道,一夜欢,一夜情,一ye情,阴部,淫虫,阴唇,淫荡,阴道,淫电影,阴阜,淫妇,淫河,阴核,阴户,淫贱,淫叫,淫教师,阴茎,阴精,淫浪,淫媚,淫糜,淫魔,淫母,淫女,淫虐,淫妻,淫情,淫色,淫声浪语,淫兽学园,淫书,淫术炼金士,淫水,淫娃,淫威,淫亵,淫样,淫液,淫照,阴b,应召,幼交,幼男,幼女,欲火,欲女,玉女心经,玉蒲团,玉乳,欲仙欲死,玉穴,援交,原味内衣,援助交际,张筱雨,招鸡,招妓,中年美妇,抓胸,自拍,自慰,作爱,18禁,99bb,a4u,a4y,adult,amateur,anal,a片,fuck,gay片,g点,g片,hardcore,h动画,h动漫,incest,porn,secom,sexinsex,sm女王,xiao77,xing伴侣,tokyohot,yin荡,腐败中国,三个呆婊,你办事我放心,社会主义灭亡,打倒中国,打倒共产党,打倒共产主义,打倒胡锦涛,打倒江泽民,打倒江主席,打倒李鹏,打倒罗干,打倒温家宝,打倒中共,打倒朱镕,抵制共产党,抵制共产主义,抵制胡锦涛,抵制江泽民,抵制江主席,抵制李鹏,抵制罗干,抵制温家宝,抵制中共,抵制朱镕基,灭亡中国,亡党亡国,粉碎四人帮,激流中国,特供,特贡,特共,zf大楼,殃视,贪污腐败,强制拆除,形式主义,政治风波,太子党,上海帮,北京帮,清华帮,红色贵族,权贵集团,河蟹社会,喝血社会,九风,9风,十七大,十7大,17da,九学,9学,四风,4风,双规,南街村,最淫官员,警匪,官匪,独夫民贼,官商勾结,城管暴力执法,强制捐款,毒豺,一党执政,一党专制,一党专政,专制政权,宪法法院,胡平,苏晓康,贺卫方,谭作人,焦国标,万润南,张志新,辛灝年,高勤荣,王炳章,高智晟,司马璐,刘晓竹,刘宾雁,魏京生,寻找林昭的灵魂,别梦成灰,谁是新中国,讨伐中宣部,异议人士,民运人士,启蒙派,选国家主席,民一主,min主,民竹,民珠,民猪,chinesedemocracy,大赦国际,国际特赦,da选,投公,公头,宪政,平反,党章,维权,昝爱宗,宪章,08宪,08xz,抿主,敏主,人拳,人木又,人quan,renquan,中国人权,中国新民党,群体事件,群体性事件,上中央,去中央,讨说法,请愿,请命,公开信,联名上书,万人大签名,万人骚动,截访,上访,shangfang,信访,访民,集合,集会,组织集体,静坐,静zuo,jing坐,示威,示wei,游行,you行,油行,游xing,youxing,官逼民反,反party,反共,抗议,亢议,抵制,低制,底制,di制,抵zhi,dizhi,boycott,血书,焚烧中国国旗,baoluan,流血冲突,出现暴动,发生暴动,引起暴动,baodong,灭共,杀毙,罢工,霸工,罢考,罢餐,霸餐,罢参,罢饭,罢吃,罢食,罢课,罢ke,霸课,ba课,罢教,罢学,罢运,网特,网评员,网络评论员,五毛党,五毛们,5毛党,戒严,jieyan,jie严,戒yan,8的平方事件,知道64,八九年,贰拾年,2o年,20和谐年,贰拾周年,六四,六河蟹四,六百度四,六和谐四,陆四,陆肆,198964,5月35,89年春夏之交,64惨案,64时期,64运动,4事件,四事件,北京风波,学潮,学chao,xuechao,学百度潮,门安天,天按门,坦克压大学生,民主女神,历史的伤口,高自联,北高联,血洗京城,四二六社论,王丹,柴玲,沈彤,封从德,王超华,王维林,吾尔开希,吾尔开西,侯德健,阎明复,方励之,蒋捷连,丁子霖,辛灏年,蒋彦永,严家其,陈一咨,中华局域网,党的喉舌,互联网审查,当局严密封锁,新闻封锁,封锁消息,爱国者同盟,关闭所有论坛,网络封锁,金盾工程,gfw,无界浏览,无界网络,自由门,何清涟,中国的陷阱,汪兆钧,记者无疆界,境外媒体,维基百科,纽约时报,bbc中文网,华盛顿邮报,世界日报,东森新闻网,东森电视,星岛日报,wikipedia,youtube,googleblogger,美国广播公司,英国金融时报,自由亚洲,自由时报,中国时报,反分裂,威胁论,左翼联盟,钓鱼岛,保钓组织,主权,弓单,火乍,木仓,石肖,核蛋,步qiang,bao炸,爆zha,baozha,zha药,zha弹,炸dan,炸yao,zhadan,zhayao,hmtd,三硝基甲苯,六氟化铀,炸药配方,弹药配方,炸弹配方,皮箱炸弹,火药配方,人体炸弹,人肉炸弹,解放军,兵力部署,军转,军事社,8341部队,第21集团军,七大军区,7大军区,北京军区,沈阳军区,济南军区,成都军区,广州军区,南京军区,兰州军区,颜色革命,规模冲突,塔利班,基地组织,恐怖分子,恐怖份子,三股势力,印尼屠华,印尼事件,蒋公纪念歌,马英九,mayingjiu,李天羽,苏贞昌,林文漪,陈水扁,陈s扁,陈随便,阿扁,a扁,告全国同胞书,台百度湾,台完,台wan,taiwan,台弯,湾台,台湾国,台湾共和国,台军,台独,台毒,台du,taidu,twdl,一中一台,打台湾,两岸战争,攻占台湾,支持台湾,进攻台湾,占领台湾,统一台湾,收复台湾,登陆台湾,解放台湾,解放tw,解决台湾,光复民国,台湾独立,台湾问题,台海问题,台海危机,台海统一,台海大战,台海战争,台海局势,入联,入耳关,中华联邦,国民党,x民党,民进党,青天白日,闹独立,duli,fenlie,日本万岁,小泽一郎,劣等民族,汉人,汉维,维汉,维吾,吾尔,热比娅,伊力哈木,疆独,东突厥斯坦解放组织,东突解放组织,蒙古分裂分子,列确,阿旺晋美,藏人,臧人,zang人,藏民,藏m,达赖,赖达,dalai,哒赖,dl喇嘛,丹增嘉措,打砸抢,西独,藏独,葬独,臧独,藏毒,藏du,zangdu,支持zd,藏暴乱,藏青会,雪山狮子旗,拉萨,啦萨,啦沙,啦撒,拉sa,lasa,la萨,西藏,藏西,藏春阁,藏獨,藏独,藏独立,藏妇会,藏青会,藏字石,xizang,xi藏,x藏,西z,tibet,希葬,希藏,硒藏,稀藏,西脏,西奘,西葬,西臧,援藏,bjork,王千源,安拉,回教,回族,回回,回民,穆斯林,穆罕穆德,穆罕默德,默罕默德,伊斯兰,圣战组织,清真,清zhen,qingzhen,真主,阿拉伯,高丽棒子,韩国狗,满洲第三帝国,满狗,鞑子,江丑闻,江嫡系,江毒,江独裁,江蛤蟆,江核心,江黑心,江胡内斗,江祸心,江家帮,江绵恒,江派和胡派,江派人马,江泉集团,江人马,江三条腿,江氏集团,江氏家族,江氏政治局,江氏政治委员,江梳头,江太上,江戏子,江系人,江系人马,江宰民,江贼,江贼民,江主席,麻果丸,麻将透,麻醉弹,麻醉狗,麻醉枪,麻醉槍,麻醉药,麻醉藥,台独,台湾版假币,台湾独立,台湾国,台湾应该独立,台湾有权独立,天灭中共,中共帮凶,中共保命,中共裁,中共党文化,中共腐败,中共的血旗,中共的罪恶,中共帝国,中共独裁,中共封锁,中共封网,中共腐败,中共黑,中共黑帮,中共解体,中共近期权力斗争,中共恐惧,中共权力斗争,中共任用,中共退党,中共洗脑,中共邪教,中共邪毒素,中共政治游戏,福音会,中国教徒,统一教,观音法门,清海无上师,盘古,李洪志,志洪李,李宏志,轮功,法轮,轮法功,三去车仑,氵去车仑,发论工,法x功,法o功,法0功,法一轮一功,轮子功,车仑工力,法lun,fa轮,法lg,flg,fl功,falungong,大法弟子,大纪元,dajiyuan,明慧网,明慧周报,正见网,新唐人,伪火,退党,tuidang,退dang,超越红墙,自fen,真善忍,九评,9评,9ping,九ping,jiuping,藏字石,集体自杀,自sha,zi杀,suicide,titor,逢8必灾,逢八必灾,逢9必乱,逢九必乱,朱瑟里诺,根达亚文明,诺查丹玛斯,人类灭亡进程表,按照马雅历法,推背图,推bei图,济世灵文,诸世纪,电狗,电话定位器,电话拦截器,电话窃听,电话监,电话交友,电话追杀系统,电击枪,电鸡,电警棒,枪出售,枪的制,枪货到,枪决女犯,枪模,枪手,枪销售,枪械制,枪子弹,售步枪,售纯度,售单管,售弹簧刀,售防身,售狗子,售虎头,售火药,售假币,售健卫,售军用,售猎枪,售氯胺,售麻醉,售枪支,售热武,售三棱,售手枪,售五四,售一元硬,售子弹,售左轮,亚砷（酸）酐,亚砷酸钾,亚砷酸钠,亚硒酸,亚硒酸二钠,亚硒酸镁,亚硒酸钠,亚硒酸氢钠,亚硝酸乙酯,亚硝酰乙氧,氧化二丁基锡,氧化汞,氧化铊,氧化亚铊,氧氯化磷,原装弹,原子弹方法,原子弹清单,安眠酮,代血浆,普萘洛尔,呋塞米,西布曲明,testosterone,胰岛素样生长因子,促红细胞生成素,地西泮,尼可刹米,甲睾酮,adrenaline,erythropoietin,地奈德,莫达非尼,氯噻嗪,苯巴比妥,促性腺激素,泼尼松,麻黄草,雄烯二醇,地塞米松,tamoxifen,strychnine,androst,新型毒品,杜冷丁,兴奋剂,mdma,海洛因,海luo因,heroin,diamorphine,diacetylmorphine,鸦片,阿芙蓉,咖啡因,cocain,三唑仑,美沙酮,麻古,k粉,凯他敏,ketamine,冰毒,苯丙胺,cannabis,大麻,爱他死,氯胺酮,benzodiazepines,甲基安非他明,安非他命,吗啡,打人,打人,拆迁,拆迁,纠纷,纠纷,盗窃,盗窃,安眠酮,代药物毒品类：血浆,普萘洛尔,呋塞米,西布曲明,testosterone,胰岛素样生长因子,促红细胞生成素,地西泮,尼可刹米,甲睾酮,adrenaline,erythropoietin,地奈德,莫达非尼,氯噻嗪,苯巴比妥,促性腺激素,泼尼松,麻黄草,雄烯二醇,地塞米松,tamoxifen,strychnine,androst,新型毒品,杜冷丁,兴奋剂,mdma,海洛因,海luo因,heroin,diamorphine,diacetylmorphine,鸦片,阿芙蓉,咖啡因,cocain,三唑仑,美沙酮,麻古,k粉,凯他敏,ketamine,冰毒,苯丙胺,cannabis,大麻,爱他死,氯胺酮,benzodiazepines,甲基安非他明,安非他命,吗啡,morphine,摇头丸,迷药,乖乖粉,narcotic,麻醉药,精神药品,专业代理,帮忙点一下,帮忙点下,请点击进入,详情请进入,私人侦探,私家侦探,针孔摄象,调查婚外情,信用卡提现,无抵押贷款,广告代理,原音铃声,借腹生子,找个妈妈,找个爸爸,代孕妈妈,代生孩子,代开发票,腾讯客服电话,销售热线,免费订购热线,低价出售,款到发货,回复可见,连锁加盟,加盟连锁,免费二级域名,免费使用,免费索取,蚁力神,婴儿汤,售肾,刻章办,买小车,套牌车,玛雅网,电脑传讯,视频来源,下载速度,高清在线,全集在线,在线播放,txt下载,六位qq,6位qq,位的qq,个qb,送qb,用刀横向切腹,完全自杀手册,四海帮,足球投注,地下钱庄,中国复兴党,阿波罗网,曾道人,六合彩,改卷内幕,替考试,隐形耳机,出售答案,考中答案,答an,da案,资金周转,救市,股市圈钱,崩盘,资金短缺,证监会,质押贷款,小额贷款,周小川,刘明康,尚福林,孔丹,汉芯造假,杨树宽,中印边界谈判结果,喂奶门,摸nai门,酒瓶门,脱裤门,75事件,乌鲁木齐,新疆骚乱,针刺,打针,食堂涨价,饭菜涨价,h1n1,瘟疫爆发,yangjia,y佳,yang佳,杨佳,杨j,袭警,杀警,武侯祠,川b26931,贺立旗,周正毅,px项目,骂四川,家l福,家le福,加了服,麦当劳被砸,豆腐渣,这不是天灾,龙小霞,震其国土,yuce,提前预测,地震预测,隐瞒地震,李四光预测,蟾蜍迁徙,地震来得更猛烈,八级地震毫无预报,踩踏事故,聂树斌,万里大造林,陈相贵,张丹红,尹方明,李树菲,王奉友,零八奥运艰,惨奥,奥晕,凹晕,懊运,懊孕,奥孕,奥你妈的运,反奥,628事件,weng安,wengan,翁安,瓮安事件,化工厂爆炸,讨回工资,代办发票,代办各,代办文,代办学,代办制,代辦,代表烦,代开发票,代開,代考,代理发票,代理票据,代您考,代讨债,代写毕,代写论文,代孕,代追债,考后付款,考机构,考考邓,考联盟,考前答案,考前付,考前密卷,考前预测,考试,答案,考试,作弊器,考试包过,考试保,考试答案,考试机构,考试联盟,考试枪,考试作弊,考试作弊器,考研考中,考中答案,透视功能,透视镜,透视扑,透视器,透视眼睛,透视眼镜,透视药,透视仪,打死经过,打死人,打砸办公,打砸抢,安眠酮,代血浆,普萘洛尔,呋塞米,西布曲明,testosterone,胰岛素样生长因子,促红细胞生成素,地西泮,尼可刹米,甲睾酮,adrenaline,erythropoietin,地奈德,莫达非尼,氯噻嗪,苯巴比妥,促性腺激素,泼尼松,麻黄草,雄烯二醇,地塞米松,tamoxifen,strychnine,androst,新型毒品,杜冷丁,兴奋剂,mdma,海洛因,海luo因,heroin,diamorphine,diacetylmorphine,鸦片,阿芙蓉,咖啡因,cocain,三唑仑,美沙酮,麻古,k粉,凯他敏,ketamine,冰毒,苯丙胺,cannabis,大麻,爱他死,氯胺酮,benzodiazepines,甲基安非他明,安非他命,吗啡,KC短信,KC嘉年华,短信广告,短信群发,短信群发器,小6灵通,短信商务广告,段录定,无界浏览,无界浏览器,无界,无网界,无网界浏览,无帮国,KC提示,KC网站,UP8新势力,白皮书,UP新势力,移民,易达网络卡,安魂网,罢工,罢课,纽崔莱七折,手机复制,手机铃声,网关,神通加持法,全1球通,如6意通,清仓,灵动卡,答案卫星接收机,高薪养廉,考后付款,佳静安定片,航空母舰,航空售票,号码百事通,考前发放,成本价,诚信通手机商城,高利贷,联4通,黑庄,黑手党,黑车,联通贵宾卡,联总,联总这声传单,联总之声传单,高息贷款,高干子弟,恭喜你的号码,恭喜您的号码,高干子女,各个银行全称,各种发票,高官,高官互调,高官子女,喝一送一,卡号,复制,监听王,传单,旦科,钓鱼岛,钓鱼台,当官靠后台,党校安插亲信,传九促三,客户端非法字符,刻章,大麻树脂,大麻油,大法,大法弟子,dpp大法,fa lun,falu,发抡,发抡功,洗脑,下法轮,发轮,发伦,发伦功,发仑,发沦,发纶,发论,发论功,发论公,发正念,发囵,发愣,发瞟,罚抡,罚伦,罚仑,罚沦,罚纶,罚囵,筏抡,筏轮,筏伦,筏仑,筏沦,筏纶,筏论,筏囵,伐抡,伐轮,伐伦,伐仑,伐沦,伐论,伐囵,乏抡,乏轮,乏伦,乏仑,乏沦,乏纶,乏论,乏囵,阀抡,阀伦,阀仑,阀沦,阀纶,阀论,阀囵,法 轮 功,法*功,法.轮.功,法L功,法lun功,法功,法会,法抡,法抡功,法轮,法轮大法,法轮佛法,法轮功,法伦,法仑,法沦,法纶,法论,法十轮十功,法西斯,法院,法正,法谪,法谪功,法輪,法囵,法愣,珐.輪功,珐抡,珐轮,珐伦,珐仑,珐沦,五不,五不争鸣论坛,五出三进,五套功法,邝锦文,垡抡,垡轮,垡伦,垡仑,垡沦,垡纶,垡论,垡囵,茳澤民,荭志,闳志,闵维方,氵去,氵去车仑工力,转法轮,砝抡,砝轮,砝伦,砝仑,砝沦,砝纶,真、善、忍,真理教,真善美,真善忍,砝论,砝囵,泓志,屙民,珐纶,珐论,珐囵,falun,Falundafa,fa轮,Flg,弟子,地下教会,炼功,梦网洪志,轮大,抡功,轮功,伦功,摩门教,三水法轮,三唑仑,天皇,天怒,天葬,车臣,达赖,功法,讲法,基督,基督教,护法,回教,教徒,功友,大师,达赖喇嘛,虹志,鸿志,洪传,贯通两极法,光祖,洪吟,洪哲胜,洪志,宏法,观世音,宏志,弘志,古兰经,红志,车库,车仑,经文,腐败,贪污,gcd,共贪党,gongchandang,阿共,共一产一党,产党共,公产党,工产党,共c党,共x党,共铲,供产,共惨,供铲党,供铲谠,供铲裆,共残党,共残主义,共产主义的幽灵,拱铲,老共,中珙,中gong,gc党,贡挡,gong党,g产,狗产蛋,共残裆,恶党,邪党,共产专制,共产王朝,裆中央,土共,土g,共狗,g匪,共匪,仇共,共产党腐败,共产党专制,共产党的报应,共产党的末日,共产党专制,communistparty,症腐,政腐,政付,正府,政俯,政f,zhengfu,政zhi,挡中央,档中央,中国zf,中央zf,国wu院,中华帝国,gong和,大陆官方,北京政权,刘志军,张曙,刘志军,买别墅,玩女人,贪20亿,许宗衡,贪财物,李启红,贪腐财富,落马,高官名单,陈希同,贪污,玩忽职守,有期徒刑,陈良宇,受贿罪,滥用职权,有期徒刑,没收个人财产,成克杰,死刑,程维高,严重违纪,开除党籍,撤销职务,刘方仁,无期徒刑,倪献策,徇私舞弊,梁湘,以权谋私,撤职。,李嘉廷,死刑缓期,张国光,韩桂芝,宋平顺,自杀,黄瑶,双规,陈绍基,判处死刑,剥夺政治权利终身,没收个人全部财产,石兆彬,侯伍杰,王昭耀,剥夺政治权利,杜世成,沈图,叛逃美国,罗云光,起诉,张辛泰,李效时,边少斌,徐鹏航,违纪,收受股票,王乐毅,李纪周,郑光迪,田凤山。,邱晓华,郑筱萸,孙鹤龄,蓝田造假案,于幼军,留党察看,何洪达,朱志刚,杨汇泉,官僚主义,徐炳松,托乎提沙比尔,王宝森,经济犯罪,畏罪自杀。,陈水文,孟庆平,胡长清,朱川,许运鸿,丘广钟,刘知炳,丛福奎,王怀忠,巨额财产,来源不明罪,李达昌,刘长贵,王钟麓,阿曼哈吉,付晓光,自动辞,刘克田,吕德彬,刘维明,双开,刘志华,孙瑜,李堂堂,韩福才 青海,欧阳德 广东,韦泽芳 海南,铁英 北京,辛业江 海南,于飞 广东,姜殿武 河北,秦昌典 重庆,范广举 黑龙江,张凯广东,王厚宏海南,陈维席安徽,王有杰河南,王武龙江苏,米凤君吉林,宋勇辽宁,张家盟浙江,马烈孙宁夏,黄纪诚北京,常征贵州,王式惠重庆,周文吉,王庆录广西,潘广田山东,朱作勇甘肃,孙善武河南,宋晨光江西,梁春禄广西政协,鲁家善 中国交通,金德琴 中信,李大强 神华,吴文英 纺织,查克明 华能,朱小华光大,高严 国家电力,王雪冰,林孔兴,刘金宝,张恩照,陈同海,康日新,王益,张春江,洪清源,平义杰,李恩潮,孙小虹,陈忠,慕绥新,田凤岐,麦崇楷,柴王群,吴振汉,张秋阳,徐衍东,徐发 黑龙江,张宗海,丁鑫发,徐国健,李宝金,单平,段义和,荆福生,陈少勇,黄松有,皮黔生,王华元,王守业,刘连昆,孙晋美,邵松高,肖怀枢,刘广智 空军,姬胜德 总参,廖伯年 北京,《动向》,《争鸣》,《中国民主》,322攻台作战计划,38集团军,3D轮盘,64大屠杀,6合彩,70天大事记,89学潮大屠杀,89学潮血腥屠杀,BB弹,BB枪,fa轮,FL大法,jiuping,SIM卡复制器,SM用品,t牌车,阿宾,阿凡提机,挨了一炮,爱国运动正名,爱国者同盟网站,爱液横流,安眠藥,案的准确,暗访包,八九民,八九学,八九政治,把病人整,把邓小平,把学生整,罢工门,白黄牙签,白小姐,百家乐,百乐二呓,败培训,拜大哥,斑蝥,办本科,办理本科,办理各种,办理票据,办理文凭,办理真实,办理证件,办理证书,办理资格,办文凭,办怔,办证,半刺刀,辦毕业,辦證,帮人怀孕,谤罪获刑,磅解码器,磅遥控器,包办色情娱乐服务,包青天机,包养,宝在甘肃修,保过答案,报复执法,报码,暴菊,暴力袭警,暴力执法,爆发骚,爆菊,北姑,北京帮,北京独立,北京风波,北京黑幕,北京市委黑幕,北京政坛清华名人,北美巡回讲法,北省委门,被指抄袭,被中共,本无码,避孕膜,鞭满,变牌,变牌绝,辩词与梦,冰毒,冰火毒,冰火佳,冰火九重,冰火漫,冰淫传,冰在火上,波胆,波推龙,博彩,博彩娱,博会暂停,博园区伪,不查都,不查全,布卖淫女,部忙组阁,部是这样,才知道只生,财众科技,采花堂,彩宝,彩票,彩票选号机,彩票预测,踩踏事,苍山兰,苍蝇水,操了嫂,操你妈,操嫂子,厕奴,策没有不,插屁屁,察象蚂,拆迁灭,禅密功,长狗,车仑大法,车牌隐,车用电子狗,成佛做主,城管灭,惩公安,惩贪难,持枪证,充气娃,冲凉死,抽着大中,抽着芙蓉,出成绩付,出售发票,出售假币,出售军,出售器官,出售肾,穿透仪器,传九退三,传送答案,吹箭,春宫,春宫图,春水横溢,春药,纯度白,纯度黄,慈悲功,次通过考,催眠水,催情粉,催情药,催情藥,挫仑,达毕业证,达赖,达米宣教会,答案包,答案提供,打标语,打错门,打飞机专,大法弟子,大法轮,大法修炼者,大鸡巴,大雞巴,大纪元,大妓院,大揭露,大奶子,大批贪官,大肉棒,大学暴动,大圆满法,大庄,大嘴歌,贷借款,贷开,戴海静,弹种,当代七整,当官要精,当官在于,党风日下,党棍,党后萎,党禁,党内权力,党内权争,党内危机,党内言事潮,党前干劲,荡妇,刀架保安,导爆索,导的情人,导叫失,导人的最,导人最,导小商,到花心,盗号,盗取qq,盗取密码,得财兼,的同修,灯草和,等级證,等人老百,等人是老,等人手术,邓爷爷转,邓颖超日记,邓玉娇,抵制北京奥运,地磅解码器,地磅遥控器,地产之歌,地下先烈,帝国之梦,递进民主,递纸死,第二首都,第三次世界大战,第五代红人,第五代接班梯队,颠覆,共产党,颠覆,共产主义,颠覆,胡锦涛,颠覆,温家宝,颠覆,中共,颠覆,朱镕基,点金商务,点数优惠,电子狗导航手机,甸果敢,蝶舞按,丁香社,丁子霖,顶花心,顶贴机,顶帖器,东北独立,东方闪电,东复活,东京热,东突,东伊运,東京熱,董元辰,洞小口紧,都当警,都当小姐,都进中央,毒蛇钻,独夫民贼,独立台湾,赌博机,赌恒指,赌具,赌球,赌球网,短信截,短信猫,短信群发,短信投票业务,段桂清,对共产党清算,对日强硬,多党执政,多美康,躲猫猫,俄罗斯轮盘,俄羅斯,恶党,恶搞人民币,恶警,恶势力操,恶势力插,恩氟烷,儿园惨,儿园砍,儿园杀,儿园凶,二奶大,二十四事件,发仑da发,发伦工,发轮功,发轮功陈果,发牌绝,发票出,发票代,发票代开,发票销,发贴工具,发贴机,發票,法0功,法O功,法车仑,法功,法拉盛,法拉盛缅街,法力像佛,法仑功,法伦,法伦功,法轮,法论功,法能功,法维权,法西藏主义,法一轮,法院给废,法正乾,珐(工力)学,反测速雷,反对共产党,反对共产主义,反腐总攻,反攻大陆,反共传单,反共言论,反雷达测,反雷达测速,反屏蔽,反社会主义,反中共黑色暴力,范燕琼,方迷香,芳香型智悟气功,防电子眼,防身枪,防身药水,房贷给废,仿真枪,仿真手枪,仿真证,费私服,封锁消,佛怀煽仇录,佛同修,夫妻交换,福尔马林,福娃的預,福娃頭上,福香巴,府包庇,府集中领,妇销魂,附送枪,复印件生,复印件制,赴港生子,富民穷,富婆给废,改号软件,干扰器,感扑克,冈本真,肛交,肛门是邻,岡本真,钢针狗,钢珠枪,港澳博球,港馬會,港鑫華,高就在政,高考,答案,高考黑,高莺莺,搞媛交,告长期,告洋状,格证考试,蛤蟆转世,个人圆满说,个四小码,个邪的党,各类考试,各类文凭,根浴,跟帖器,跟踪器,工程吞得,工力人,弓弩,公安错打,公开小姐,攻官小姐,供应发票,共产主义黑皮书,共狗,共和国2049,共青背景,共青团派,共王储,共字玄机,狗粮,狗娘养的,狗屁专家,狗日的,狗友,古方迷香,鼓动一些,乖乖粉,观音法门,官匪一家,官商勾,官也不容,官因发帖,光学真题,广安事件,广场事件,跪真相,滚圆大乳,国办发,国际投注,国家妓,国家软弱,国家吞得,国库折,国统纲领,国统会,国一九五七,國內美,哈狗帮,哈药直销,海访民,海洛因,豪圈钱,号屏蔽器,合彩,和狗交,和狗性,和狗做,黑火药的,黑社会,红病历,红床,红客联盟,红色恐怖,红外,透视,红外透视,洪志,紅色恐,胡的接班人,胡江风云,胡江关系,胡江内斗,胡江曾,胡江争斗,胡紧掏,胡紧套,胡锦涛,腐败,胡錦濤,胡进涛,胡派军委,胡派人马,胡适眼,胡下台,胡耀邦,湖淫娘,虎头猎,护卫团,华藏功,华国锋,华门开,华闻,化学扫盲,划老公,话在肉身显现,还会吹萧,还看锦涛,环球证件,换妻,皇冠投注,皇家轮盘,黄冰,黄菊遗孀,黄色,电影,黄色电影,黄色小电影,回汉冲突,回民暴动,回民猪,回忆六四,昏药,浑圆豪乳,活不起,活体取肾,活摘器官,火车也疯,机定位器,机号定,机号卫,机卡密,机屏蔽器,鸡巴,积克馆,基本靠吼,基督灵恩布道团,绩过后付,激光气,激光汽,激流中国,激情,电影,激情,图片,激情电,激情电话,激情电影,激情短,激情交友,激情妹,激情炮,激情视频,激情小电影,级办理,级答案,急需嫖,疾病业债说,集体打砸,集体腐,集体抗议,挤乳汁,擠乳汁,记号扑克,纪念达赖喇嘛流亡49周年,纪念文革,妓女,妓女的口号,寂寞少妇,加油机干扰器,佳静安定,佳静安定片,家一样饱,家属被打,甲虫跳,甲流了,假币出售,假发票,假文凭,假证件,奸成瘾,奸杀,兼职上门,监听器,监听头,监听王,监狱管理局,监狱里的斗争,简易炸,贱货,贱人,江z民,疆獨,疆独,讲法传功,蒋彦永,叫鸡,叫自慰,揭贪难,姐包夜,姐服务,姐兼职,姐上门,解码开锁,解密软件,解体的命运,解体中共,金扎金,金钟气,津大地震,津地震,津人治津,进来的罪,禁书,禁网禁片,京地震,京夫子,京要地震,经典谎言,精子射在,警察被,警察的幌,警察殴打,警察说保,警车雷达,警方包庇,警匪一家,警徽,警民冲突,警用品,径步枪,敬请忍,靖国神社,究生答案,九龙论坛,九评共,九十三运动,酒象喝汤,酒像喝汤,救度众生说,就爱插,就要色,菊暴,菊爆,菊花洞,举国体,巨乳,据说全民,绝食声,军长发威,军刺,军品特,军用手,军转,卡辛纳大道和三福大道交界处,开苞,开邓选,开平,轮奸,开平,受辱,开锁工具,开天目,開碼,開票,砍杀幼,砍伤儿,看JJ,康没有不,康生丹,康跳楼,抗议磁悬浮,抗议中共当局,磕彰,克分析,克千术,克透视,嗑药,空和雅典,空中民主墙,孔摄像,恐共,控诉世博,控制媒,口交,口手枪,口淫,骷髅死,矿难不公,昆仑女神功,拉帮游说,拉登说,拉开水晶,拉票贿选,拉萨僧人接连抗议,拉线飞机,来福猎,拦截器,狼全部跪,浪穴,老虎机,乐透码,雷管,雷人女官,类准确答,黎阳平,李大轮子,李红痔,李洪X,李洪志,李鹏,李伟信的笔供,李晓英,李咏曰,理各种证,理是影帝,理证件,理做帐报,力骗中央,力月西,历史的伤口,丽媛离,利他林,连发手,联盟党,聯繫電,练功群众,炼大法,两岸才子,两会代,两会又三,聊斋艳,了件渔袍,猎好帮手,猎枪,猎枪销,临震预报,领导忽悠百姓叫号召,领土拿,流亡藏人,流血事件,留四进三,六HE彩,六代接班人,六合采,六合彩,六死,六四内部日记,六四事,六四事件,六四受难者家属证辞,六四信息,六四资料馆,六月联盟,龙虎斗,龙湾事件,隆手指,漏题,陆封锁,陆同修,旅游新报,氯胺酮,轮手枪,轮子小报,论文代,罗干,罗斯小姐,落霞缀,妈了个逼,麻古,麻果配,麻醉乙醚,蟆叫专家,买春,买断,买官卖官,买枪,买肾,买真枪,卖QQ号码,卖春,卖地财政,卖发票,卖枪,卖身,卖肾,卖血,卖银行卡,卖自考,漫步丝,忙爱国,猫眼工具,毛时代大饥荒揭秘,毛一鲜,毛泽东复活,毛泽东侄子,毛贼,毛主席的嫡孙,媒体封锁,每周一死,门按摩,门保健,门徒会,門服務,氓培训,蒙古回归,蒙汗药,蒙汗药粉,蜜穴,免电灯,免费电影,灭共,灭绝罪,灭中共,民储害,民九亿商,民抗议,民殇,民运,民运分子,民主不能等待,民主还专政,民主女神,民族问题,明hui,明慧网,明镜出版社,铭记印尼,摩小姐,魔难论,末世劫难,末世论,牟新生,母乳家,母子乱伦,木齐针,幕没有不,幕前戲,内射,内争人权,男妓,男奴,南充针,嫩逼,嫩穴,嫩阴,泥马之歌,你的西域,拟涛哥,娘两腿之间,鸟巢最少死,妞上门,纽扣摄像机,浓精,怒的志愿,女被人家搞,女激情,女技师,女奴,女人费,女人和狗,女任职名,女上门,女神教,女士服务,女伟哥,女優,鸥之歌,拍肩,药,拍肩神,拍肩神药,拍肩型,拍肩醉迷药,牌技网,派系斗争,盘古乐队,盘口,炮的小蜜,跑官要官,泡友,陪考枪,陪聊,赔率,配有消,喷尿,嫖俄罗,嫖鸡,嫖妓,平惨案,平反六四,平叫到床,仆不怕饮,普提功,普通嘌,期货配,奇迹的黄,奇淫散,骑单车出,气狗,气枪,汽车解码器,汽车走表器,汽狗,汽枪,氣槍,器官贩卖,千禧弘法,铅弹,钱三字经,强权政府,强效失忆药,强硬发言,抢其火炬,切听器,窃听,窃听器,亲共,亲共分子,亲共媒体,侵犯国外专利,钦点接班人,禽流感了,勤捞致,沁园春血,青海无上师,氢弹手,清场内幕,清除负面,清純壆,清官团,清海师父,清海无上师,清华帮,情聊天室,情妹妹,情色,论坛,情色论坛,情杀,情视频,情自拍,氰化钾,氰化钠,请集会,请示威,琼花问,区的雷人,娶韩国,全范围教会,全真证,全自动开锁器,犬交,群发广告机,群发软件,群奸暴,群交,群起抗暴,群体灭绝,群体性事,群众冲击,绕过封锁,惹的国,人弹,人祸,人类灭亡时间表,人类罪恶论,人民币恶搞,人权保护,人宇特能功,人在云上,人真钱,认牌绝,任于斯国,日你妈,日月气功,容弹量,柔胸粉,肉棒,肉洞,肉棍,如厕死,乳交,软弱的国,软弱外交,瑞安事件,萨斯病,赛后骚,赛克网,三班仆人派,三挫,三股势力,三级,电影,三级,影片,三级电影,三级片,三陪,三三九乘元功,三网友,三唑,三唑仑,扫了爷爷,杀害学生,杀指南,沙皇李长春,傻逼,山涉黑,煽动不明,煽动群众,商务短信,商务快车,上海帮,上海独立,上门激,上网文凭,烧公安局,烧瓶的,韶关斗,韶关玩,韶关旭,少妇自拍,社会混,社会主义灭亡,射网枪,涉台政局,涉嫌抄袭,身份证生成器,深喉冰,神的教会,神七假,神韵艺术,神州忏悔录,沈昌功,沈昌人体科技,肾源,升达毕业证,生被砍,生踩踏,生孩子没屁眼,生命树的分叉,生肖中特,生意宝,圣殿教,圣火护卫,圣灵重建教会,圣战不息,盛行在舞,剩火,尸博,失身水,失意药,师涛,狮子旗,十八大接班人,十八等,十大独裁,十大谎,十大禁,十个预言,十类人不,十七大幕,十七大权力争霸战,十七大人事安排,十七位老部长,实毕业证,实际神,实体娃,实学历文,士的年,士的宁,士康事件,独裁者,世界之门,式粉推,视解密,手变牌,手狗,手机,定位器,手机,窃听,手机复制,手机跟,手机跟踪定位器,手机监,手机监听,手机监听器,手机卡复制器,手机魔卡,手机窃听器,手机追,手木仓,手枪,守所死法,兽交,书办理,熟妇,术牌具,双管立,双管平,双筒,谁是胡的接班人,谁是新中国,谁为腐败晚餐买单,水阎王,税务总局致歉,丝护士,丝情侣,丝袜保,丝袜恋,丝袜美,丝袜妹,丝袜网,丝足按,司长期有,司法黑,司考答案,司马璐回忆录,私房写真,私服,私家侦探服务,死法分布,死刑现场,死要见毛,四博会,四川大地震异象揭密,四川朱昱,四大扯,四二六社论,四六级,答案,饲养基地,苏家屯,苏家屯集,诉讼集团,素女,自拍,素女心,速代办,速取证,酸羟亚胺,缩阴,蹋纳税,太王四神,太王四神记,泰兴幼,泰兴镇中,泰州幼,贪官也辛,探测狗,涛共产,涛一样胡,讨厌中国,套牌车,特别党费,特工资,特码,特上门,特务机构,体透视镜,替考,替人体,天安门事件,天朝特,天鹅之旅,天推广歌,天要灭,天音功,田罢工,田田桑,田停工,铁血师,庭审直播,通钢总经,同盟党,统一教,统治术,偷電器,偷啪,dv,偷肃贪,偷听器,偷偷贪,头双管,投毒杀人,投注站,骰子,秃鹰汽,突破封锁,突破网路,屠杀学生,土炮,土枪,推翻独裁,推油按,脱衣舞,脱衣艳,瓦斯手,袜按摩,外蒙回归,外透视镜,外围赌球,万法归一功,万能钥匙,万人骚动,王立军,王益案,网络封锁,网络警察,网民案,网民获刑,网民诬,网站推广软件,微型,监控,微型摄像,为党不为国,围攻上海,维汉员,维权基,维权人,维权谈,伪基百科,伪政府,委坐船,卫星高频头,卫星广播器材,谓的和谐,魏京生,温加饱,温家宝,腐败,温家堡,温切斯特,温休曾退,温影帝,溫家寶,瘟加饱,瘟家宝,瘟假饱,文凭证,纹了毛,闻被控制,闻封锁,瓮安,我的西域,我搞台独,我们自杀吧,我虽死去,乌蝇水,乌云其木格,无帮国,无耻语录,无官正,无界浏览器,无码,无人性的政权,无网界,无线,监听,吾爾開希,五套功,五月天,午夜电,午夜极,武警暴,武警殴,武警已增,武力镇压,武装镇压,务员答案,务员考试,雾型迷,西藏,独立,西藏独立,西藏国家民主党,西藏人民大起义,西藏限,西藏作家组织,西服进去,希脏,习进平,习晋平,席复活,席临终前,席指着护,洗澡死,喜贪赃,先烈纷纷,现大地震,现金投注,现在的党,现在的公安,现在的共产党,现在的警察,现在的社会,现在的政府,线透视镜,限制言,陷害案,陷害罪,霰弹,香港彩,香港独立,香港马会,香港一类,香港总彩,向巴平措,消防灭火枪,消防枪,消业之说,硝化甘,小电影,小活佛,小姐按摩,小姐上门,小穴,肖中特,校骚乱,写两会,泄漏的内,新疆暴乱,新疆独立,新疆叛,新疆限,新金瓶,新生网,新唐人,新搪人,态度蛮横,新中华战记,信访专班,信用卡套现,兴华论谈,兴中心幼,行长王益,形透视镜,性推广歌,性息,胸主席,修炼大法,徐玉元,学骚乱,学生领袖,学位證,血溅人民天堂,血染的风采,血色京机,血色京畿,血腥清场,循环轮回论,丫与王益,严晓玲,言被劳教,言论罪,盐酸曲,颜射,眼镜,透视,燕玲论坛,恙虫病,摇头丸,遥控信号拦截器,要射精了,要射了,要泄了,业力回报,业力轮,夜半加税,夜激情,液体炸,一党独裁,一党私利,一党执政,一党专政,一卡多号,一氯丙酮,一氯乙醛,一码中特,一通功,一通健康法,一小撮别,一肖,一氧化二氟,一氧化汞,一夜激情,伊皮恩,遗情书,乙酰替硫脲,乙酰亚砷酸铜,异硫氰酸烯丙酯,异氰酸苯酯,异氰酸甲酯,因毒磷,因毒硫磷,银氰化钾,银行卡复制设备,隐蔽式摄像机,隐形,耳机,隐形,摄像机,隐形耳,隐形耳机,隐形喷剂,隐形摄像机,应子弹,婴儿命,婴儿汤,罂粟壳,罂粟籽,蝇毒,影子政府,雍战胜,永伏虫,咏妓,用手枪,优化官员,幽谷三,游精佑,游戏机破解,有偿服务,有偿捐献,有偿肾,有码,有奶不一,右转是政,幼齿类,幼交,娱乐透视,愚民同,愚民政,与狗性,宇宙大法,宇宙毁灭,宇宙主佛,玉蒲团,育部女官,预测答案,冤民大,鸳鸯洗,渊盖苏文,元极功,原砷酸,原一九五七,袁伟民,援藏网,援交,晕倒型,韵徐娘,赞成,西藏,独立,脏毒,脏独,遭便衣,遭到警,遭警察,遭武警,择油录,曾道人,炸弹教,炸弹遥控,炸广州,炸立交,炸药的制,炸药配,炸药制,粘氯酸,张春桥,张宏宝,张宏堡,张文中,张志新,找枪手,找援交,找政法委副,赵紫阳,针刺案,针刺伤,针刺事,针刺死,针孔摄象机,针孔摄像机,侦探设备,真钱,百家乐,真钱斗地,真钱投注,真善忍,真实文凭,震惊一个民,震其国土,证到付款,证件公司,证件集团,证生成器,证书办,政府无能,政论区,政治风波,政治局十七,政治人祸的源头,支那,支那猪,植物冰,指纹考勤,指纹膜,指纹套,制服诱,制手枪,制证定金,制作证件,治疗红斑狼疮,治疗性病,治疗乙肝,治疗肿瘤,中办发,中的班禅,中国不强,中国复兴党,中国高层权力斗争,中国共和党,中国官场情杀案,中国过渡政府,中国海外腐败兵团,中国没有自由,中国人民党,中国实行血腥教育,中国贪官在海外,中国网络审查,中国舆论监督网周洪,中国正义党,中国政府封锁消息,中国支配下的朝鲜经济,中国猪,中华昆仑女神功,中华养生益智功,中华养生益智气,中南海的权力游戏,中南海斗争,中南海恩仇录,中南海黑幕,中南海权力斗争,中石油国家电网倒数,中特,中央黑幕,中正纪念歌,中组部前部长直言,种公务员,种学历证,众像羔,重亚硒酸钠,重阳兵变,州惨案,州大批贪,州三箭,宙最高法,昼将近,朱镕基,腐败,主神教,主席忏,属灵教,住英国房,助考,助考网,转法轮,转法论,转是政府,赚钱资料,庄家,装弹甲,装枪套,装消音,追债公司,追踪,定位,梓健特药,自动群发,自己找枪,自杀手册,自杀指南,自慰用,自由门,自由圣,自由西藏,自由西藏学生运动,总会美女,走私车,足交,足球,博彩,足球玩法,最后圆满,醉钢枪,醉迷药,醉乙醚,尊爵粉,左棍,左转是政,作弊器,作各种证,作硝化甘,唑仑,福音会,中国教徒,统一教,观音法门,清海无上师,盘古,李洪志,志洪李,李宏志,轮功,法轮,轮法功,三去车仑,氵去车仑,发论工,法x功,法o功,法0功,法一轮一功,轮子功,车仑工力,法lun,fa轮,法lg,flg,fl功,falungong,大法弟子,大纪元,dajiyuan,明慧网,明慧周报,正见网,新唐人,伪火,退党,tuidang,退dang,超越红墙,自fen,真善忍,九评,9评,9ping,九ping,jiuping,藏字石,集体自杀,自sha,zi杀,suicide,titor,逢8必灾,逢八必灾,逢9必乱,逢九必乱,朱瑟里诺,根达亚文明,诺查丹玛斯,人类灭亡进程表,按照马雅历法,推背图,推bei图,济世灵文,诸世纪,电狗,电话定位器,电话拦截器,电话窃听,电话监,电话交友,电话追杀系统,电击枪,电鸡,电警棒,枪出售,枪的制,枪货到,枪决女犯,枪模,枪手,枪销售,枪械制,枪子弹,售步枪,售纯度,售单管,售弹簧刀,售防身,售狗子,售虎头,售火药,售假币,售健卫,售军用,售猎枪,售氯胺,售麻醉,售枪支,售热武,售三棱,售手枪,售五四,售一元硬,售子弹,售左轮,亚砷（酸）酐,亚砷酸钾,亚砷酸钠,亚硒酸,亚硒酸二钠,亚硒酸镁,亚硒酸钠,亚硒酸氢钠,亚硝酸乙酯,亚硝酰乙氧,氧化二丁基锡,氧化汞,氧化铊,氧化亚铊,氧氯化磷,原装弹,原子弹方法,原子弹清单,安眠酮,代血浆,普萘洛尔,呋塞米,西布曲明,testosterone,胰岛素样生长因子,促红细胞生成素,地西泮,尼可刹米,甲睾酮,adrenaline,erythropoietin,地奈德,莫达非尼,氯噻嗪,苯巴比妥,促性腺激素,泼尼松,麻黄草,雄烯二醇,地塞米松,tamoxifen,strychnine,androst,新型毒品,杜冷丁,兴奋剂,mdma,海洛因,海luo因,heroin,diamorphine,diacetylmorphine,鸦片,阿芙蓉,咖啡因,cocain,三唑仑,美沙酮,麻古,k粉,凯他敏,ketamine,冰毒,苯丙胺,cannabis,大麻,爱他死,氯胺酮,benzodiazepines,甲基安非他明,安非他命,吗啡,腐败中国,三个呆婊,你办事我放心,社会主义灭亡,打倒中国,打倒共产党,打倒共产主义,打倒胡锦涛,打倒江泽民,打倒江主席,打倒李鹏,打倒罗干,打倒温家宝,打倒中共,打倒朱镕,抵制共产党,抵制共产主义,抵制胡锦涛,抵制江泽民,抵制江主席,抵制李鹏,抵制罗干,抵制温家宝,抵制中共,抵制朱镕基,灭亡中国,亡党亡国,粉碎四人帮,激流中国,特供,特贡,特共,zf大楼,殃视,贪污腐败,强制拆除,形式主义,政治风波,太子党,上海帮,北京帮,清华帮,红色贵族,权贵集团,河蟹社会,喝血社会,九风,9风,十七大,十7大,17da,九学,9学,四风,4风,双规,南街村,最淫官员,警匪,官匪,独夫民贼,官商勾结,城管暴力执法,强制捐款,毒豺,一党执政,一党专制,一党专政,专制政权,宪法法院,胡平,苏晓康,贺卫方,谭作人,焦国标,万润南,张志新,辛灝年,高勤荣,王炳章,高智晟,司马璐,刘晓竹,刘宾雁,魏京生,寻找林昭的灵魂,别梦成灰,谁是新中国,讨伐中宣部,异议人士,民运人士,启蒙派,选国家主席,民一主,min主,民竹,民珠,民猪,chinesedemocracy,大赦国际,国际特赦,da选,投公,公头,宪政,平反,党章,维权,昝爱宗,宪章,08宪,08xz,抿主,敏主,人拳,人木又,人quan,renquan,中国人权,中国新民党,群体事件,群体性事件,上中央,去中央,讨说法,请愿,请命,公开信,联名上书,万人大签名,万人骚动,截访,上访,shangfang,信访,访民,集合,集会,组织集体,静坐,静zuo,jing坐,示威,示wei,游行,you行,油行,游xing,youxing,官逼民反,反party,反共,抗议,亢议,抵制,低制,底制,di制,抵zhi,dizhi,boycott,血书,焚烧中国国旗,baoluan,流血冲突,出现暴动,发生暴动,引起暴动,baodong,灭共,杀毙,罢工,霸工,罢考,罢餐,霸餐,罢参,罢饭,罢吃,罢食,罢课,罢ke,霸课,ba课,罢教,罢学,罢运,网特,网评员,网络评论员,五毛党,五毛们,5毛党,戒严,jieyan,jie严,戒yan,8的平方事件,知道64,八九年,贰拾年,2o年,20和谐年,贰拾周年,六四,六河蟹四,六百度四,六和谐四,陆四,陆肆,198964,5月35,89年春夏之交,64惨案,64时期,64运动,4事件,四事件,北京风波,学潮,学chao,xuechao,学百度潮,门安天,天按门,坦克压大学生,民主女神,历史的伤口,高自联,北高联,血洗京城,四二六社论,王丹,柴玲,沈彤,封从德,王超华,王维林,吾尔开希,吾尔开西,侯德健,阎明复,方励之,蒋捷连,丁子霖,辛灏年,蒋彦永,严家其,陈一咨,中华局域网,党的喉舌,互联网审查,当局严密封锁,新闻封锁,封锁消息,爱国者同盟,关闭所有论坛,网络封锁,金盾工程,gfw,无界浏览,无界网络,自由门,何清涟,中国的陷阱,汪兆钧,记者无疆界,境外媒体,维基百科,纽约时报,bbc中文网,华盛顿邮报,世界日报,东森新闻网,东森电视,星岛日报,wikipedia,youtube,googleblogger,美国广播公司,英国金融时报,自由亚洲,自由时报,中国时报,反分裂,威胁论,左翼联盟,钓鱼岛,保钓组织,主权,弓单,火乍,木仓,石肖,核蛋,步qiang,bao炸,爆zha,baozha,zha药,zha弹,炸dan,炸yao,zhadan,zhayao,hmtd,三硝基甲苯,六氟化铀,炸药配方,弹药配方,炸弹配方,皮箱炸弹,火药配方,人体炸弹,人肉炸弹,解放军,兵力部署,军转,军事社,8341部队,第21集团军,七大军区,7大军区,北京军区,沈阳军区,济南军区,成都军区,广州军区,南京军区,兰州军区,颜色革命,规模冲突,塔利班,基地组织,恐怖分子,恐怖份子,三股势力,印尼屠华,印尼事件,蒋公纪念歌,马英九,mayingjiu,李天羽,苏贞昌,林文漪,陈水扁,陈s扁,陈随便,阿扁,a扁,告全国同胞书,台百度湾,台完,台wan,taiwan,台弯,湾台,台湾国,台湾共和国,台军,台独,台毒,台du,taidu,twdl,一中一台,打台湾,两岸战争,攻占台湾,支持台湾,进攻台湾,占领台湾,统一台湾,收复台湾,登陆台湾,解放台湾,解放tw,解决台湾,光复民国,台湾独立,台湾问题,台海问题,台海危机,台海统一,台海大战,台海战争,台海局势,入联,入耳关,中华联邦,国民党,x民党,民进党,青天白日,闹独立,duli,fenlie,日本万岁,小泽一郎,劣等民族,汉人,汉维,维汉,维吾,吾尔,热比娅,伊力哈木,疆独,东突厥斯坦解放组织,东突解放组织,蒙古分裂分子,列确,阿旺晋美,藏人,臧人,zang人,藏民,藏m,达赖,赖达,dalai,哒赖,dl喇嘛,丹增嘉措,打砸抢,西独,藏独,葬独,臧独,藏毒,藏du,zangdu,支持zd,藏暴乱,藏青会,雪山狮子旗,拉萨,啦萨,啦沙,啦撒,拉sa,lasa,la萨,西藏,藏西,藏春阁,藏獨,藏独,藏独立,藏妇会,藏青会,藏字石,xizang,xi藏,x藏,西z,tibet,希葬,希藏,硒藏,稀藏,西脏,西奘,西葬,西臧,援藏,bjork,王千源,安拉,回教,回族,回回,回民,穆斯林,穆罕穆德,穆罕默德,默罕默德,伊斯兰,圣战组织,清真,清zhen,qingzhen,真主,阿拉伯,高丽棒子,韩国狗,满洲第三帝国,满狗,鞑子,江丑闻,江嫡系,江毒,江独裁,江蛤蟆,江核心,江黑心,江胡内斗,江祸心,江家帮,江绵恒,江派和胡派,江派人马,江泉集团,江人马,江三条腿,江氏集团,江氏家族,江氏政治局,江氏政治委员,江梳头,江太上,江戏子,江系人,江系人马,江宰民,江贼,江贼民,江主席,麻果丸,麻将透,麻醉弹,麻醉狗,麻醉枪,麻醉槍,麻醉药,麻醉藥,台独,台湾版假币,台湾独立,台湾国,台湾应该独立,台湾有权独立,天灭中共,中共帮凶,中共保命,中共裁,中共党文化,中共腐败,中共的血旗,中共的罪恶,中共帝国,中共独裁,中共封锁,中共封网,中共腐败,中共黑,中共黑帮,中共解体,中共近期权力斗争,中共恐惧,中共权力斗争,中共任用,中共退党,中共洗脑,中共邪教,中共邪毒素,中共政治游戏,爱女人,爱液,按摩棒,拔出来,爆草,包二奶,暴干,暴奸,暴乳,爆乳,暴淫,屄,被操,被插,被干,逼奸,仓井空,插暴,操逼,操黑,操烂,肏你,肏死,操死,操我,厕奴,插比,插b,插逼,插进,插你,插我,插阴,潮吹,潮喷,成人dv,成人电影,成人论坛,成人小说,成人电,成人电影,成人卡通,成人聊,成人片,成人视,成人图,成人文,成人小,成人电影,成人论坛,成人色情,成人网站,成人文学,成人小说,艳情小说,成人游戏,吃精,赤裸,抽插,扌由插,抽一插,春药,大波,大力抽送,大乳,荡妇,荡女,盗撮,多人轮,发浪,放尿,肥逼,粉穴,封面女郎,风月大陆,干死你,干穴,肛交,肛门,龟头,裹本,国产av,好嫩,豪乳,黑逼,后庭,后穴,虎骑,花花公子,换妻俱乐部,黄片,几吧,鸡吧,鸡巴,鸡奸,寂寞男,寂寞女,妓女,激情,集体淫,奸情,叫床,脚交,金鳞岂是池中物,金麟岂是池中物,精液,就去日,巨屌,菊花洞,菊门,巨奶,巨乳,菊穴,开苞,口爆,口活,口交,口射,口淫,裤袜,狂操,狂插,浪逼,浪妇,浪叫,浪女,狼友,聊性,流淫,铃木麻,凌辱,漏乳,露b,乱交,乱伦,轮暴,轮操,轮奸,裸陪,买春,美逼,美少妇,美乳,美腿,美穴,美幼,秘唇,迷奸,密穴,蜜穴,蜜液,摸奶,摸胸,母奸,奈美,奶子,男奴,内射,嫩逼,嫩女,嫩穴,捏弄,女优,炮友,砲友,喷精,屁眼,品香堂,前凸后翘,强jian,强暴,强奸处女,情趣用品,情色,拳交,全裸,群交,惹火身材,人妻,人兽,日逼,日烂,肉棒,肉逼,肉唇,肉洞,肉缝,肉棍,肉茎,肉具,揉乳,肉穴,肉欲,乳爆,乳房,乳沟,乳交,乳头,三级片,骚逼,骚比,骚女,骚水,骚穴,色逼,色界,色猫,色盟,色情网站,色区,色色,色诱,色欲,色b,少年阿宾,少修正,射爽,射颜,食精,释欲,兽奸,兽交,手淫,兽欲,熟妇,熟母,熟女,爽片,爽死我了,双臀,死逼,丝袜,丝诱,松岛枫,酥痒,汤加丽,套弄,体奸,体位,舔脚,舔阴,调教,偷欢,偷拍,推油,脱内裤,文做,我就色,无码,舞女,无修正,吸精,夏川纯,相奸,小逼,校鸡,小穴,小xue,写真,性感妖娆,性感诱惑,性虎,性饥渴,性技巧,性交,性奴,性虐,性息,性欲,胸推,穴口,学生妹,穴图,亚情,颜射,阳具,杨思敏,要射了,夜勤病栋,一本道,一夜欢,一夜情,一ye情,阴部,淫虫,阴唇,淫荡,阴道,淫电影,阴阜,淫妇,淫河,阴核,阴户,淫贱,淫叫,淫教师,阴茎,阴精,淫浪,淫媚,淫糜,淫魔,淫母,淫女,淫虐,淫妻,淫情,淫色,淫声浪语,淫兽学园,淫书,淫术炼金士,淫水,淫娃,淫威,淫亵,淫样,淫液,淫照,阴b,应召,幼交,幼男,幼女,欲火,欲女,玉女心经,玉蒲团,玉乳,欲仙欲死,玉穴,援交,原味内衣,援助交际,张筱雨,招鸡,招妓,中年美妇,抓胸,自拍,自慰,作爱,18禁,99bb,a4u,a4y,adult,amateur,anal,a片,fuck,gay片,g点,g片,hardcore,h动画,h动漫,incest,porn,secom,sexinsex,sm女王,xiao77,xing伴侣,tokyohot,yin荡,贱人,装b,大sb,傻逼,傻b,煞逼,煞笔,刹笔,傻比,沙比,欠干,婊子养的,我日你,我操,我草,卧艹,卧槽,爆你菊,艹你,cao你,你他妈,真他妈,别他吗,草你吗,草你丫,操你妈,擦你妈,操你娘,操他妈,日你妈,干你妈,干你娘,娘西皮,狗操,狗草,狗杂种,狗日的,操你祖宗,操你全家,操你大爷,妈逼,你麻痹,麻痹的,妈了个逼,马勒,狗娘养,贱比,贱b,下贱,死全家,全家死光,全家不得好死,全家死绝,白痴,无耻,sb,杀b,你吗b,你妈的,婊子,贱货,人渣,混蛋,媚外,和弦,兼职,限量,铃声,性伴侣,男公关,火辣,精子,射精,诱奸,强奸,做爱,性爱,发生关系,按摩,快感,处男,猛男,少妇,屌,屁股,下体,a片,内裤,浑圆,咪咪,发情,刺激,白嫩,粉嫩,兽性,风骚,呻吟,sm,阉割,高潮,裸露,不穿,一丝不挂,脱光,干你,干死,我干,裙中性运动,乱奸,乱伦,乱伦类,乱伦小,伦理大,伦理电影,伦理毛,伦理片,裸聊,裸聊网,裸体写真,裸舞视,裸照,美女裸体,美女写真,美女上门,美艳少妇,妹按摩,妹上门,迷幻药,迷幻藥,迷昏口,迷昏药,迷昏藥,迷魂香,迷魂药,迷魂藥,迷奸粉,迷奸药,迷情粉,迷情水,迷情药,迷药,迷藥,谜奸药,骚妇,骚货,骚浪,骚女,骚嘴,色电影,色妹妹,色情表演,色情电影,色情服务,色情图片,色情小说,色情影片,色情表演,色情电影,色情服务,色情片,色视频,色小说,性伴侣,性服务,性福情,性感少,性伙伴,性交,性交视频,性交图片,性奴,性奴集中营,性虐,阴唇,阴道,阴蒂,阴户,阴间来电,阴茎,阴茎增大,阴茎助勃,阴毛,陰唇,陰道,陰戶,淫荡,淫荡美女,淫荡视频,淫荡照片,淫乱,淫靡,淫魔,淫魔舞,淫女,淫情女,淫肉,淫騷妹,淫兽,淫兽学,淫水,淫穴,morphine,摇头丸,迷药,乖乖粉,narcotic,麻醉药,精神药品,爱女人,爱液,按摩棒,拔出来,爆草,包二奶,暴干,暴奸,暴乳,爆乳,暴淫,屄,被操,被插,被干,逼奸,仓井空,插暴,操逼,操黑,操烂,肏你,肏死,操死,操我,厕奴,插比,插b,插逼,插进,插你,插我,插阴,潮吹,潮喷,成人电影,成人论坛,成人色情,成人网站,成人文学,成人小说,艳情小说,成人游戏,吃精,赤裸,抽插,扌由插,抽一插,春药,大波,大力抽送,大乳,荡妇,荡女,盗撮,多人轮,发浪,放尿,肥逼,粉穴,封面女郎,风月大陆,干死你,干穴,肛交,肛门,龟头,裹本,国产av,好嫩,豪乳,黑逼,后庭,后穴,虎骑,花花公子,换妻俱乐部,黄片,几吧,鸡吧,鸡巴,鸡奸,寂寞男,寂寞女,妓女,激情,集体淫,奸情,叫床,脚交,金鳞岂是池中物,金麟岂是池中物,精液,就去日,巨屌,菊花洞,菊门,巨奶,巨乳,菊穴,开苞,口爆,口活,口交,口射,口淫,裤袜,狂操,狂插,浪逼,浪妇,浪叫,浪女,狼友,聊性,流淫,铃木麻,凌辱,漏乳,露b,乱交,乱伦,轮暴,轮操,轮奸,裸陪,买春,美逼,美少妇,美乳,美腿,美穴,美幼,秘唇,迷奸,密穴,蜜穴,蜜液,摸奶,摸胸,母奸,奈美,奶子,男奴,内射,嫩逼,嫩女,嫩穴,捏弄,女优,炮友,砲友,喷精,屁眼,品香堂,前凸后翘,强jian,强暴,强奸处女,情趣用品,情色,拳交,全裸,群交,惹火身材,人妻,人兽,日逼,日烂,肉棒,肉逼,肉唇,肉洞,肉缝,肉棍,肉茎,肉具,揉乳,肉穴,肉欲,乳爆,乳房,乳沟,乳交,乳头,三级片,骚逼,骚比,骚女,骚水,骚穴,色逼,色界,色猫,色盟,色情网站,色区,色色,色诱,色欲,色b,少年阿宾,少修正,射爽,射颜,食精,释欲,兽奸,兽交,手淫,兽欲,熟妇,熟母,熟女,爽片,爽死我了,双臀,死逼,丝袜,丝诱,松岛枫,酥痒,汤加丽,套弄,体奸,体位,舔脚,舔阴,调教,偷欢,偷拍,推油,脱内裤,文做,我就色,无码,舞女,无修正,吸精,夏川纯,相奸,小逼,校鸡,小穴,小xue,写真,性感妖娆,性感诱惑,性虎,性饥渴,性技巧,性交,性奴,性虐,性息,性欲,胸推,穴口,学生妹,穴图,亚情,颜射,阳具,杨思敏,要射了,夜勤病栋,一本道,一夜欢,一夜情,一ye情,阴部,淫虫,阴唇,淫荡,阴道,淫电影,阴阜,淫妇,淫河,阴核,阴户,淫贱,淫叫,淫教师,阴茎,阴精,淫浪,淫媚,淫糜,淫魔,淫母,淫女,淫虐,淫妻,淫情,淫色,淫声浪语,淫兽学园,淫书,淫术炼金士,淫水,淫娃,淫威,淫亵,淫样,淫液,淫照,阴b,应召,幼交,幼男,幼女,欲火,欲女,玉女心经,玉蒲团,玉乳,欲仙欲死,玉穴,援交,原味内衣,援助交际,张筱雨,招鸡,招妓,中年美妇,抓胸,自拍,自慰,作爱,18禁,99bb,a4u,a4y,adult,amateur,anal,a片,fuck,gay片,g点,g片,hardcore,h动画,h动漫,incest,porn,secom,sexinsex,sm女王,xiao77,xing伴侣,tokyohot,yin荡,出售雷管,炸药,炸药,出售炸药,出售炸药 电话,制作火药配方,炸药出售 ,出售雷管炸药,火药配方,在家里做原子弹,硝酸甘油炸弹制作,TNT 炸弹的制作,硝铵炸药配方,硝酸甘油制作,炸弹配方,简易炸药,火药制作简易炸弹,炸弹制作,硝酸甘油,硝酸甘油炸弹制作方法,手把手教你做炸弹,恐怖分子傻瓜手册,氢弹手工制作方法,起爆器,自制燃烧弹,燃烧弹,弹药制造方法,液体炸药配方,炸药配方与制作,自制炸药配方,tnt炸药成分,炸药的制作,tnt炸药配方,各种炸药配方大全,炸药的成分,燃烧弹的制作方 ,黑火药的配方,黑火药的制作,黑火药比例,燃烧弹 制作,黑火药配方比例,黑火药的成分,原子弹配方,原子弹DIY教程,C4炸药,雷管出售,制作硝化甘油,DIY核弹,核弹制作方法,原子弹制作手册,简易原子弹教程,黑火药配方,自制炸药方法,教你怎么用土办法做武器,莫洛托夫鸡尾酒的配方,zz炸弹的制作方法,C4炸药的成分,炸药制造生产工艺,原子弹制造完全手册,「红烧兔子」大餐,汽车炸弹制作,人体炸弹制作流程,炸弹制作从入门,鸡尾酒炸弹制作,集束炸弹制作,硝酸铵的简便制取方法,莫洛托夫燃烧弹,塑胶炸弹,用火药混合塑料,高性能爆炸物质混合,原子弹 制作方法,手教你制作原子弹,轻型巡航导弹的制作,黑索金的制造过程,Zha药制造进程,购买自爆材料,可塑炸弹制作方法,C4塑胶炸药,水浴法制TNT,简易核弹头的制造,高爆炸药的基本配方,如何制硝化甘油,燃烧剂的简易制备,简易大威力炸弹,炸弹制作入门,硝酸甘油炸药制作,基本配方是硝酸甘,燃烧剂的简易制作,制作性能优良的燃烧弹,酸甘油炸药,简易导弹制作,核弹头的制造,可塑炸弹制作,炸药硝酸甘油制法,原子弹制作方法,火药的配方,手教你做原子弹,怎么用土办法做武器,手把手教你制作原子弹,燃烧弹的制作方法,怎么自制燃烧弹,TNT炸弹制作,高爆炸药基本配方,爆破和杀伤燃烧弹,炸弹制作从入门到精,写的炸弹制作教程,原子弹制作 方法,教你制作原子弹,下硝化甘油的制作方法,DIY原子弹,原子弹制作,炸药及其制造方法,ATOM弹制造,三分钟教你原子弹,火药原理,简易炸弹,简易燃烧弹,土炸药成份,你怎么用土办法做武器,燃烧弹制作,燃烧瓶的制作方法,炸弹制作手册 硫酸,原子弹制作方法DIY,汽油三分之一白糖混合,炸药的制作配方,燃烧弹的制作方,炸药的配方,如何自制燃烧弹,标准炸弹教程,黑火药和硝酸钾农药混合,恐怖分子自己制造炸弹,手柄制作炸弹引爆器,制作炸弹首先要,燃烧瓶制作,出售炸药QQ,出售气枪,出售气枪 QQ,出售气枪 电话,出售手枪,出售手枪 QQ,出售手枪 电话,出售猎枪,出售猎枪 QQ,出售猎枪 电话,出售汽枪,出售步枪,出售狙击枪,出售手狗,出售气狗,出售猎狗,【手枪出售】联系电话,64式手枪出售,92式手枪出售,出售:高仿真枪,出售54式手枪,出售M1911,出售各类猎狗,出售国产军用54手枪,出售火枪 –游戏,出售进口金属枪模,出售仿真枪,出售麻醉枪免收任何定金,出售手枪=货到付款,出售外国枪模,出售袖珍手枪,娥眉气枪出售,防身手枪QQ,防身武器手枪,仿真枪QQ,钢珠枪小口径步枪,高压狗QQ,高压气枪,气枪子弹,高压气枪|电狗专卖,高压气枪|气枪货到付款,高压气枪专卖店,各类军用枪,各类军用枪支,各式气枪出售,工字牌气枪出售专卖,气枪,工字汽狗麻醉枪,供应军用手枪,供应汽枪,购买枪支QQ,国产汽狗专卖|气枪货,集团出售手枪,集团出售手枪气枪,进口气枪,气枪子弹,军用54出售,军用77出售,军用手枪钢珠枪,里有汽枪出售,猎枪出售/枪,猎枪仿真枪QQ,猎枪麻醉枪钢珠枪,猎枪哪里有卖,猎枪手枪买卖,猎枪销售手枪销售气枪,猎枪专卖店,猎枪子弹底火专卖,麻醉枪出售可验货,麻醉枪猎枪军用,买卖54狗,买卖64狗,买卖警察枪支,买卖军狗,买卖军用枪支,卖64手枪,卖92手枪,卖钢珠枪QQ,哪里能买到自制手枪  ,哪里有钢珠枪,哪里有连发猎枪买卖,哪里有卖双管猎,哪里有气枪卖,哪里有枪出售,哪里有真枪出售,哪里有真枪卖买,哪能买到真枪,期出售手枪气枪猎,气狗 高压气枪,气狗出售 进口气狗,气枪专卖网,气枪/出售/专卖网,气枪/猎枪/钢珠枪,气枪仿真枪出售,气枪购买|气枪组装,气枪货到付款,汽狗出售,气枪价格 仿真气枪,气枪价格，气枪专卖店,气枪看货加QQ,气枪联系QQ,气枪猎枪麻醉枪,气枪迷魂药,汽狗高压汽枪,铅弹 上海工字气枪,全金属仿真枪专卖,热武器QQ,三箭气枪出售,手枪气* 枪猎,手槍买卖自制手枪,售枪购买手枪,售手枪QQ,司马仿真枪模型QQ,淘宝气枪货到付款,提供气狗专卖店,提供专业及时的气狗,秃鹰气枪货到付款,锡峰气枪出售,仙鹤气枪出售,销售/专卖/买卖77式手枪,销售电手狗,销售气手狗,销售小口径步枪,销售运动步枪,小口径秃鹰沙漠,有军用枪支出售,长期出 售手枪,折叠狗QQ,转让 猎枪,子弹货到付款,自制手枪哪里买  ,自制手枪哪里有卖,阻击枪/汽枪/高压气枪,组装手枪  ,最新销售汽狗,出售警用手铐|仿真枪,猎枪|真枪,手枪|阻击枪,弓弩专营,弓弩专卖网货到付款,弓弩专卖网,弓弩专卖货到付款,弓弩专卖店网,弓弩专卖店,弓弩专卖,弓弩制作,弓弩直销,弓弩有限公司,弓弩营销中心,弓弩一百专卖店,弓弩销售,弓弩网 ,弓弩网,弓弩图纸,弓弩特许经销,弓弩狩猎网,自制手弩,追风弓弩麻醉箭专卖,专业弓弩网,中国战神军用弓弩,中国弩弓专卖,中国弓弩专卖网,中国弓弩直销,中国弓弩网,中国弓弩狩猎网,中国弓驽网,制作简易弓弩 ,郑州弓弩专卖,赵氏弓弩专卖网,赵氏弓弩专卖店,赵氏弓弩专卖,赵氏弓弩销售,小型弓弩专卖店,小猎人弓弩网,狩猎器材弓弩专卖,狩猎器材弓弩,狩猎弓弩专卖网,狩猎弓弩专卖,狩猎弓弩麻醉箭,手枪式折叠三用弩,三利达弓弩专卖网,三利达弓弩直营,三利达弓弩配件,三步倒药箭批发,三步倒弩箭专卖,三步倒麻醉弩箭销售,三步倒麻醉箭专卖,三步倒麻醉箭,三步倒捕狗药,军用弓弩专卖网,军用弓弩专卖店,军用弓弩批发,军用弓弩公司,供应三利达弓弩麻醉箭,供应三步倒麻醉箭,供应秦氏弓弩,供应弩用麻醉箭,供应弩捕狗箭,供应麻醉箭三步倒,供应麻醉箭批发,供应麻醉箭,供应军用弩折叠弩,供应军用弓弩专卖,供应精品弓弩,供应弓弩麻醉箭,供应弓弩,供应钢珠弓弩,弓弩商城专卖,弓弩商城,弓弩亲兄弟货到付款,弓弩批发,弓弩免定金货到付款,弓弩麻醉箭,弓弩麻醉镖,弓弩论坛 ,钢珠弓弩专卖网,钢珠弓弩专卖店,打狗弓弩三步倒,麻醉弓弩专卖店,出售军刀,出售军刺,出售弹簧刀,出售三棱刀,出售跳刀,军刀网,南方军刀网,户外军刀网,三棱军刺专卖,出售开山刀军刺,西点军刀网,军刀专 卖,戈博军刀,阿兰德龙户外,出售军品军刀,勃朗宁军刀,军刀军品网,阿兰得龙野营刀具网,出售军刺军刀,警用刀具出售,折刀专卖网,阳江军品军刀网,野营刀专卖,砍刀精品折刀专卖,匕首蝴蝶甩刀专卖,军刀专卖军刺,军刀专卖刀具批发,军刀图片砍刀,军刀网军刀专卖,军刀价格军用刀具,军品军刺网,军刀军刺甩棍,阳江刀具批发网,北方先锋军刀,正品军刺出售,野营军刀出售,开山刀砍刀出售,仿品军刺出售,军刀直刀专卖,手工猎刀专卖,自动跳刀专卖,军刀电棍销售,军刀甩棍销售,美国军刀出售,极端武力折刀,防卫棍刀户外刀具,阿兰德龙野营刀,仿品军刺网,野营砍刀户外军刀,手工猎刀户外刀具,中国户外刀具网,西点军品军刀网,野营开山刀军刺,三利达弓弩军刀,尼泊尔军刀出售,防卫野营砍刀出售,防卫著名军刀出售,防卫棍刀出售,防卫甩棍出售,防卫电棍出售,军刺野营砍刀出售,著名精品折刀出售,战术军刀出售,刺刀专卖网,户外军刀出售,阳江刀具直销网,冷钢刀具直销网,防卫刀具直销网,极端武力直销网,刀具直销网,军刀直销网,直刀匕首直销网,军刀匕首直销网,折刀砍刀军品网,野营刀具军品网,阳江刀具军品网,冷钢刀具军品网,防卫刀具军品网,极端武力军品网,军用刀具军品网,军刀直刀军品网,折刀砍刀专卖,野营刀具专卖,阳江刀具专卖,冷钢刀具专卖,防卫刀具专卖,出售美军现役军刀,习近平,平近习,xjp,习太子,习明泽,老习,温家宝,温加宝,温x,温jia宝,温宝宝,温加饱,温加保,张培莉,温云松,温如春,温jb,胡温,胡x,胡jt,胡boss,胡总,胡王八,hujintao,胡jintao,胡j涛,胡惊涛,胡景涛,胡紧掏,湖紧掏,胡紧套,锦涛,hjt,胡派,胡主席,刘永清,胡海峰,胡海清,江泽民,民泽江,江胡,江哥,江主席,江书记,江浙闽,江沢民,江浙民,择民,则民,茳泽民,zemin,ze民,老江,老j,江core,江x,江派,江zm,jzm,江戏子,江蛤蟆,江某某,江贼,江猪,江氏集团,江绵恒,江绵康,王冶坪,江泽慧,邓小平,平小邓,xiao平,邓xp,邓晓平,邓朴方,邓榕,邓质方,毛泽东,猫泽东,猫则东,猫贼洞,毛zd,毛zx,z东,ze东,泽d,zedong,毛太祖,毛相,主席画像,改革历程,朱镕基,朱容基,朱镕鸡,朱容鸡,朱云来,李鹏,李peng,里鹏,李月月鸟,李小鹏,李小琳,华主席,华国,国锋,国峰,锋同志,白春礼,薄熙来,薄一波,蔡赴朝,蔡武,曹刚川,常万全,陈炳德,陈德铭,陈建国,陈良宇,陈绍基,陈同海,陈至立,戴秉国,丁一平,董建华,杜德印,杜世成,傅锐,郭伯雄,郭金龙,贺国强,胡春华,耀邦,华建敏,黄华华,黄丽满,黄兴国,回良玉,贾庆林,贾廷安,靖志远,李长春,李春城,李建国,李克强,李岚清,李沛瑶,李荣融,李瑞环,李铁映,李先念,李学举,李源潮,栗智,梁光烈,廖锡龙,林树森,林炎志,林左鸣,令计划,柳斌杰,刘奇葆,刘少奇,刘延东,刘云山,刘志军,龙新民,路甬祥,罗箭,吕祖善,马飚,马恺,孟建柱,欧广源,强卫,沈跃跃,宋平顺,粟戎生,苏树林,孙家正,铁凝,屠光绍,王东明,汪东兴,王鸿举,王沪宁,王乐泉,王洛林,王岐山,王胜俊,王太华,王学军,王兆国,王振华,吴邦国,吴定富,吴官正,无官正,吴胜利,吴仪,奚国华,习仲勋,徐才厚,许其亮,徐绍史,杨洁篪,叶剑英,由喜贵,于幼军,俞正声,袁纯清,曾培炎,曾庆红,曾宪梓,曾荫权,张德江,张定发,张高丽,张立昌,张荣坤,张志国,赵洪祝,紫阳,周生贤,周永康,朱海仑,中南海,大陆当局,中国当局,北京当局,共产党,党产共,共贪党,阿共,产党共,公产党,工产党,共c党,共x党,共铲,供产,共惨,供铲党,供铲谠,供铲裆,共残党,共残主义,共产主义的幽灵,拱铲,老共,中共,中珙,中gong,gc党,贡挡,gong党,g产,狗产蛋,共残裆,恶党,邪党,共产专制,共产王朝,裆中央,土共,土g,共狗,g匪,共匪,仇共,政府,症腐,政腐,政付,正府,政俯,政f,zhengfu,政zhi,挡中央,档中央,中央领导,中国zf,中央zf,国wu院,中华帝国,gong和,大陆官方,北京政权,江泽民,胡锦涛,温家宝,习近平,习仲勋,贺国强,贺子珍,周永康,李长春,李德生,王岐山,姚依林,回良玉,李源潮,李干成,戴秉国,黄镇,刘延东,刘瑞龙,俞正声,黄敬,薄熙,薄一波,周小川,周建南,温云松,徐明,江泽慧,江绵恒,江绵康,李小鹏,李鹏,李小琳,朱云来,朱容基,法轮功,李洪志,新疆骚乱,', 'comments', 1, '过滤关键词', 0);
INSERT INTO `PREFIX_setting` VALUES ('comments_keywords_count', '6507', 'comments', 1, NULL, 0);
INSERT INTO `PREFIX_setting` VALUES ('website_name', '鲸鱼博客CMS系统', 'website', 1, '网站名称', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_mark', NULL, 'website', 1, '网站标识', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_default_style', 'default', 'website', 1, '网站默认风格', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_domain', NULL, 'website', 1, '网站绑定域名', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_logo', '/public/sysImg/LOGO.png', 'website', 1, '网站站点Logo', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_status', '1', 'website', 1, '网站开启站点', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_telephone', '', 'website', 1, '网站服务热线', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_contact', '', 'website', 1, '网站联系人', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_mobile', '18888888888', 'website', 1, '网站联系电话', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_fax', '', 'website', 1, '网站传真', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_company', '', 'website', 1, '网站公司名称', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_email', '88888@qq.com', 'website', 1, '网站E-mail', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_qq', '88888', 'website', 1, '网站QQ', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_wechat', '18888888888', 'website', 1, '网站微信', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_wx_img', '/public/sysImg/erweima.png', 'website', 1, '网站微信图片', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_address', '', 'website', 1, '网站联系地址', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_code', '', 'website', 1, '网站统计代码', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_notice', '网站因升级，需要关闭网站一段时间，大概2088年12月12日恢复，请耐心等待，感谢您的支持！！！', 'website', 1, '网站站点公告', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_seo_title', '鲸鱼博客CMS系统', 'website', 1, '网站SEO标题', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_seo_keywords', '博客CMS系统,CMS,博客', 'website', 1, '网站SEO关键词', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_seo_description', 'SEO描述（元描述）是网页的简短摘要，出现在搜索引擎结果页面中。它能提高点击率，提供内容预览，并传达品牌信息，间接提升SEO效果。', 'website', 1, '网站SEO描述', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_favicon', '/public/sysImg/favicon.ico', NULL, NULL, NULL, 1);
INSERT INTO `PREFIX_setting` VALUES ('website_favicon', '/public/sysImg/favicon.ico', 'website', 1, '网站favicon图标', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_icp', '', 'website', 1, '网站ICP备案码', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_icp_gongan', '', 'website', 1, '网站公网安备号', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_footer_code', '代码片段', 'website', 1, '网站代码片段', 0);
INSERT INTO `PREFIX_setting` VALUES ('hpj_wx_appid', '888', 'hpjpay', 1, '虎皮椒微信appid', 0);
INSERT INTO `PREFIX_setting` VALUES ('hpj_wx_appsecret', '888', 'hpjpay', 1, '虎皮椒微信appsecret', 0);
INSERT INTO `PREFIX_setting` VALUES ('hpj_alipay_appid', '888', 'hpjpay', 1, '虎皮椒支付宝appid', 0);
INSERT INTO `PREFIX_setting` VALUES ('hpj_alipay_appsecret', '888', 'hpjpay', 1, '虎皮椒支付宝appsecret', 0);
INSERT INTO `PREFIX_setting` VALUES ('pay_payment_pay', 'hpj', 'pay', 1, '支付方式', 0);
INSERT INTO `PREFIX_setting` VALUES ('system_version', '1.0.4', 'system_version', 1, '系统当前版本', 0);
INSERT INTO `PREFIX_setting` VALUES ('system_progress_bar', '100', 'system_version', 1, '进度条', 0);
INSERT INTO `PREFIX_setting` VALUES ('system_progress_bar_title', '', 'system_version', 1, '进度条标题', 0);
INSERT INTO `PREFIX_setting` VALUES ('website_avatar', '/public/sysImg/chushiTouXiang.png', 'website', 1, '网站站长头像', 0);

-- ----------------------------
-- Table structure for PREFIX_site
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_site`;
CREATE TABLE `PREFIX_site`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '站点名称',
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '站点Logo',
  `seo_title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT 'SEO标题',
  `seo_keywords` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT 'SEO关键词',
  `seo_description` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT 'SEO描述',
  `domain` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '绑定域名',
  `mark` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'en、zh、cn、guangzhou',
  `default_style` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '站点风格',
  `dirname` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '站点目录',
  `code` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '统计代码',
  `notice` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '站点公告',
  `setting` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '其他配置',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `status` int(1) NOT NULL DEFAULT 1 COMMENT '0关闭站点 1启用站点',
  `isdefault` tinyint(1) NULL DEFAULT 0,
  `telephone` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fax` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `qq` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `wechat` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `address` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `mobile` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `contact` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `footer_code` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `company` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `point_x` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `point_y` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `iswatermark` tinyint(1) NULL DEFAULT 0,
  `wk_type` tinyint(1) NULL DEFAULT 0,
  `wk_text` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `wk_img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `wx_img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `mark`(`mark`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '站点设置' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_site
-- ----------------------------
INSERT INTO `PREFIX_site` VALUES (1, 'WhaleCMS ', '/public/uploads/images/20200413/2c318fc9dc9ccb66252877cd6a2fb586.png', 'WhaleCMS', 'WhaleCMS', 'WhaleCMS', 'WhaleCMS', 'chs', 'default', '/', 'WhaleCMS', 'WhaleCMS', '', 1, 1, 1, '0  ', '', '0', '0', '0', '0', '0 ', '0', '0', '0司', '', '', 0, 0, '', '', '/public/uploads/images/20201023/6ea9ab933fe7e69896f26616fca2e2bf.png');

-- ----------------------------
-- Table structure for PREFIX_sms_log
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_sms_log`;
CREATE TABLE `PREFIX_sms_log`  (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sms_type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信供应商 如 dysms',
  `type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信类型 如 register',
  `mobile` char(11) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '手机号码',
  `params` varchar(3000) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '参数(json)',
  `out_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '返回的第三方id',
  `create_time` int(10) UNSIGNED NOT NULL DEFAULT 0 COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `mobile`(`mobile`) USING BTREE,
  INDEX `type`(`type`) USING BTREE
) ENGINE = MyISAM AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '短信日志表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_sms_log
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_sms_send_log
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_sms_send_log`;
CREATE TABLE `PREFIX_sms_send_log`  (
  `id` bigint(20) NULL DEFAULT NULL,
  `phone` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '手机号',
  `code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '验证码',
  `content` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '完全内容',
  `send_time` datetime NULL DEFAULT NULL COMMENT '发送时间',
  `ret_str` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '发送api接口结果',
  `status` int(11) NULL DEFAULT 1 COMMENT '1 发送成功 0 发送失败'
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_sms_send_log
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_sms_template
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_sms_template`;
CREATE TABLE `PREFIX_sms_template`  (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sms_type` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'local' COMMENT '短信类型 local | qcloudsms | dysms | clsms | htsms',
  `type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '业务类型(如register | find_password)',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信标题',
  `template_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信模板ID',
  `params` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信参数（\'code\', \'time\' | {1}, {2}）',
  `template` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '短信模板内容',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `sms_type`(`sms_type`) USING BTREE,
  INDEX `type`(`type`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '短信模板' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_sms_template
-- ----------------------------
INSERT INTO `PREFIX_sms_template` VALUES (1, 'local', 'register', '用户注册', 'local_register', 'code', '您好，欢迎注册，您的手机验证码是：${code}，若非本人操作，请忽略！');
INSERT INTO `PREFIX_sms_template` VALUES (2, 'dysms', 'register', '用户注册', 'SMS_13092xxxx', 'code', '您好，欢迎注册，您的手机验证码是：${code}，若非本人操作，请忽略！');
INSERT INTO `PREFIX_sms_template` VALUES (3, 'qcloudsms', 'register', '用户注册', '158xxx', '{1}', '您好，欢迎注册，您的手机验证码是：{1}，若非本人操作，请忽略！');

-- ----------------------------
-- Table structure for PREFIX_templete_positions
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_templete_positions`;
CREATE TABLE `PREFIX_templete_positions`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `siteid` int(11) NULL DEFAULT 0,
  `param_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '模板调用变量名',
  `type` tinyint(1) NULL DEFAULT 1 COMMENT '调用数据类型: 1模板 2栏目 3单页 4列表',
  `sort` int(5) NULL DEFAULT 9 COMMENT '排序',
  `status` tinyint(1) NULL DEFAULT 1 COMMENT '状态 0停用 1启用',
  `class` tinyint(1) NULL DEFAULT 1 COMMENT '1电脑 2手机',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = COMPACT;

-- ----------------------------
-- Records of PREFIX_templete_positions
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_templetes
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_templetes`;
CREATE TABLE `PREFIX_templetes`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0',
  `pic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '幻灯片',
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '链接地址',
  `description` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '备注',
  `target` int(1) NOT NULL DEFAULT 0 COMMENT '是否开启浏览器新窗口',
  `siteid` int(11) NOT NULL DEFAULT 1 COMMENT '站点ID',
  `sort` int(6) NOT NULL DEFAULT 9 COMMENT '排序',
  `status` int(1) NOT NULL DEFAULT 1 COMMENT '状态：1=显示，0=屏蔽',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `update_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `position_id` int(11) NULL DEFAULT 0,
  `cid` int(11) NULL DEFAULT NULL COMMENT '推荐栏目',
  `type` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '0默认 1推荐 2新品 3精品 4热门',
  `iscat` tinyint(1) NULL DEFAULT NULL COMMENT '是否分栏目展示',
  `limit` int(11) NULL DEFAULT NULL COMMENT '数据条数',
  `thumpic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `subtitle` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '首页幻灯片' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_templetes
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_theme
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_theme`;
CREATE TABLE `PREFIX_theme`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '主题名称',
  `thumb` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '主题缩略图',
  `template_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '模板名称',
  `siteid` int(11) NOT NULL DEFAULT 0 COMMENT '站点id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '创建时间',
  `update_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `delete_at` timestamp NULL DEFAULT NULL COMMENT '软删除时间',
  `author` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '主题附件',
  `version` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `abstract` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 30 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_theme
-- ----------------------------
INSERT INTO `PREFIX_theme` VALUES (1, '默认主题', '/public/sysImg/theme-001.png', 'default', 1, '2024-11-17 11:09:46', '2024-11-17 11:09:52', '2024-11-17 11:09:52', NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for PREFIX_types
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_types`;
CREATE TABLE `PREFIX_types`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `attributes` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `istop` tinyint(3) NULL DEFAULT 0,
  `pic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `group` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `siteid` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '类型' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_types
-- ----------------------------

-- ----------------------------
-- Table structure for PREFIX_user_has_roles
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_user_has_roles`;
CREATE TABLE `PREFIX_user_has_roles`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL COMMENT '用户ID',
  `role_id` int(11) NOT NULL COMMENT '角色ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 108 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_user_has_roles
-- ----------------------------
INSERT INTO `PREFIX_user_has_roles` VALUES (68, 3, 1);
INSERT INTO `PREFIX_user_has_roles` VALUES (81, 4, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (82, 5, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (83, 6, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (84, 7, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (85, 8, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (86, 9, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (87, 10, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (88, 11, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (89, 12, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (90, 13, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (97, 2, 1);
INSERT INTO `PREFIX_user_has_roles` VALUES (98, 2, 2);
INSERT INTO `PREFIX_user_has_roles` VALUES (107, 1, 1);

-- ----------------------------
-- Table structure for PREFIX_users
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_users`;
CREATE TABLE `PREFIX_users`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '用户名',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '邮箱',
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '密码',
  `remember_token` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '记住token',
  `login_ip` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '登录IP',
  `created_at` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `login_at` timestamp NULL DEFAULT NULL COMMENT '最近登录时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `name`(`name`, `email`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 3 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户表' ROW_FORMAT = COMPACT;

-- ----------------------------
-- Records of PREFIX_users
-- ----------------------------
INSERT INTO `PREFIX_users` VALUES (1, 'admin', '2206691630@qq.com', '$2y$10$thhVYWzoBRLdesZ7Fm/K4uNUaaZLnHUZFoatKl0HTJw.CyTpgi7MS', 'null', '113.89.52.46', '2019-03-07 16:04:41', '2024-12-11 12:14:37');

-- ----------------------------
-- Table structure for PREFIX_website
-- ----------------------------
DROP TABLE IF EXISTS `PREFIX_website`;
CREATE TABLE `PREFIX_website`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT 0,
  `cid` int(11) NULL DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT 0,
  `descript` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 149 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Records of PREFIX_website
-- ----------------------------
INSERT INTO `PREFIX_website` VALUES (1, 'ChatGPT', '/public/uploads/images/20240727/7bd52dab04089d526377112dcfea73e0.png', 'https://chatgpt.com/', 50, 1, 1, '最强智能AI，文本/语音/文生图/多模态无所不能');
INSERT INTO `PREFIX_website` VALUES (2, 'Claude', '/public/uploads/images/20240727/b7d7bb0aeefeae2f78d31e1e9ac8a0af.png', 'https://www.anthropic.com/', 50, 1, 1, 'claude AI 聊天机器人,ChatGPT免费平替');
INSERT INTO `PREFIX_website` VALUES (3, 'midjourney', '/public/uploads/images/20240727/d4073d79968a2150049fc0f1965eba00.png', 'https://www.midjourney.com/', 50, 1, 1, '最好用的付费AI绘图工具');
INSERT INTO `PREFIX_website` VALUES (4, '文心一言', '/public/uploads/images/20240809/20b2ade33c3c3050d3b0fe0c0746c2d0.png', 'https://yiyan.baidu.com/', 50, 2, 1, '百度开发的免费ai模型');
INSERT INTO `PREFIX_website` VALUES (5, 'Kimi', '/public/uploads/images/20240809/5c102f1aafcf93640ce4e3430a4a2d6e.png', 'https://kimi.moonshot.cn/', 50, 2, 1, 'Kimi智能Ai助手');

SET FOREIGN_KEY_CHECKS = 1;
